      SUBROUTINE FDATIO
     I          (NSTR,DLCSB,ISB,
     M           HT,VELOC,TH,INDRS,ITMITM,TIME,
     O           H,  TSOSFH,SOSFH,ISTYPH, TWSSFH,WSSFH,IWTYPH,
     O           TQCBF,QCBF,ICTYPH,ISCH, TQNBF,QNBF,INTYPH,ISNH,DLCSNH,
     O           TRF,RF,IRTYP,ISR,DLCSR,RSVAB, THDBF,HDBF,IDTYPH)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO READ AND PRINT INPUT DATA NEEDED FOR HYDROLOGY SIMULATION,
C ------- INCLUDING INITIAL CONDITIONS, ELEMENT AND WELL SOURCE/SINKS,
C ------- AND FOUR TYPES OF BOUNDARY CONDITIONS
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER*1 DATNAM
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
C
      COMMON /HICNT/ NCYL,NITERH,NPITERH,KSTRH,KSSH,KSP,KGRAV
      COMMON /HRCNT/ TOLAH,TOLBH,WF ,OMEH,OMIH,CNSTKR
C
      COMMON /HELS/ MXSELH,MXSPRH,MXSDPH,NSELH,NSPRH,NSDPH,KSAIH
      COMMON /HNPS/ MXWNPH,MXWPRH,MXWDPH,NWNPH,NWPRH,NWDPH,KWAIH
C
      COMMON /HCBC/ MXCNPH,MXCESH,MXCPRH,MXCDPH,NCNPH,NCESH,NCPRH,
     >              NCDPH,KCAIH
      COMMON /HNBC/ MXNNPH,MXNESH,MXNPRH,MXNDPH,NNNPH,NNESH,NNPRH,
     >              NNDPH,KNAIH
      COMMON /HRBC/ MXRES,MXRNP,MXRPR,MXRDP,NRES,NRNP,NRPR,NRDP,KRAIH
      COMMON /HDBC/ MXDNPH,MXDPRH,MXDDPH,NDNPH,NDPRH,NDDPH,KDAIH
C
      DIMENSION DLCSB(3,MAXBES),ISB(5,MAXBES),H(MAXNP),HT(MAXNP)
      DIMENSION VELOC(MAXNP,2),TH(MAXEL,4),INDRS(MXRNP,3)
C
      DIMENSION TSOSFH(MXSDPH,MXSPRH),SOSFH(MXSDPH,MXSPRH),
     >          ISTYPH(MXSELH,2)
      DIMENSION WSSFH(MXWDPH,MXWPRH),TWSSFH(MXWDPH,MXWPRH),
     >          IWTYPH(MXWNPH,2)
C
      DIMENSION QCBF(MXCDPH,MXCPRH),TQCBF(MXCDPH,MXCPRH),
     >          ICTYPH(MXCNPH,2),ISCH(5,MXCESH)
      DIMENSION TQNBF(MXNDPH,MXNPRH),QNBF(MXNDPH,MXNPRH),
     >          INTYPH(MXNNPH,2),ISNH(5,MXNESH), DLCSNH(3,MXNESH)
      DIMENSION TRF(MXRDP,MXRPR),RF(MXRDP,MXRPR), IRTYP(MXRNP,2),
     >          ISR(5,MXRES),DLCSR(3,MXRES),RSVAB(MXRNP,4)
      DIMENSION THDBF(MXDDPH,MXDPRH),HDBF(MXDDPH,MXDPRH),
     >          IDTYPH(MXDNPH,2)
C
C ******* DATA SET 9: HYDROLOGICAL INTEGER AND REAL NUMBER CONTROL
C
      READ(15,5)DATNAM
      PRINT *, 'DATNAM in FDATIO =', DATNAM
      READ(15,*) NCYL,NITERH,NPITERH,KSTRH,KSSH,KGRAV
      WRITE(16,1000) NCYL,NITERH,NPITERH,KSTRH,KSSH,KGRAV
      READ(15,*) TOLAH,TOLBH,WF,OMEH,OMIH,CNSTKR
      WRITE(16,1100) TOLAH,TOLBH,WF,OMEH,OMIH,CNSTKR
C
C ******* DATA SET 10: HYDROLOGY INITIAL CONDITIONS
C
      IF(NSTR.GT.0)THEN
        DO 440 II=1,NSTR
          READ(11)ITMITM,TIME,(H(N),N=1,NNP),(HT(N),N=1,NNP),((TH(M,I),
     >            I=1,4),M=1,NEL),((VELOC(N,I),I=1,2),N=1,NNP),
     >            ((INDRS(N,I),I=1,3),N=1,NRNP)
  440   CONTINUE
      ELSE
        READ(15,5)DATNAM
        CALL READR(H,MAXNP,NNP)
      ENDIF
C
C ******* DATA SET 11: ELEMENT(DISTRIBUTED) SOURCE/SINK
C
C ------- READ AND PRINT SOURCE/SINK PROFILE AS FUNCTION OF TIME
C
      READ(15,5)DATNAM
      READ(15,*) NSELH,NSPRH,NSDPH,KSAIH
      IF(NSELH.EQ.0) GO TO 550
      WRITE(16,5100) NSELH,NSPRH,NSDPH
      DO 510 I=1,NSPRH
      READ(15,*) (TSOSFH(J,I),SOSFH(J,I),J=1,NSDPH)
      WRITE(16,5110) I
      WRITE(16,5120) (TSOSFH(J,I),SOSFH(J,I),J=1,NSDPH)
  510 CONTINUE
C
C ------- READ AND PRINT GLOBAL ELEMENT NUMBER AND TYPE OF PROFILES
C         ASSIGNED TO EACH OF NSEL ELEMENT
C
      CALL READN(ISTYPH(1,2),MXSELH,NSELH)
      CALL READN(ISTYPH(1,1),MXSELH,NSELH)
C
      WRITE(16,5200)
      LINE=0
      DO 520 I=1,NSELH,4
      LINE=LINE+1
      NJMN=I
      NJMX=MIN0(I+3,NSELH)
      WRITE(16,5210) (J,ISTYPH(J,2),ISTYPH(J,1),J=NJMN,NJMX)
  520 CONTINUE
C
C ******* DATA SET 12: WELL (POINT) SOURCE/SINK
C
C -------  READ AND PRINT SOURCE/SINK PROFILES AS FUNCTION OF TIME
C
  550 CONTINUE
      READ(15,5)DATNAM
      READ(15,*) NWNPH,NWPRH,NWDPH,KWAIH
      IF(NWNPH.EQ.0) GO TO 600
      WRITE(16,5600) NWNPH,NWPRH,NWDPH
      DO 560 I=1,NWPRH
      READ(15,*) (TWSSFH(J,I),WSSFH(J,I),J=1,NWDPH)
      WRITE(16,5110) I
      WRITE(16,5120) (TWSSFH(J,I),WSSFH(J,I),J=1,NWDPH)
  560 CONTINUE
C
C ------- READ AND PRINT GLOBAL NODE NUMBER AND TYPE OF PROFILES
C ------- ASSIGNED TO EACH OF NWNP NODES.
C
      CALL READN(IWTYPH(1,2),MXWNPH,NWNPH)
      CALL READN(IWTYPH(1,1),MXWNPH,NWNPH)
C
      WRITE(16,5700)
      LINE=0
      DO 570 I=1,NWNPH,4
      LINE=LINE+1
      NJMN=I
      NJMX=MIN0(I+3,NWNPH)
      WRITE(16,5210) (J,IWTYPH(J,2),IWTYPH(J,1),J=NJMN,NJMX)
  570 CONTINUE
C
C ******* DATA SET 13: RAINFALL/EVAPORATION-SEEPAGE BOUNDARY CONDITIONS
C
  600 CONTINUE
      READ(15,5)DATNAM
      READ(15,*) NRES,NRNP,NRPR,NRDP,KRAIH
      IF(NRES.EQ.0) GO TO 700
      WRITE(16,6000) NRES,NRNP,NRPR,NRDP
C
C ------- READ AND WRITE RAINFALL (+)/EVAPORATION (-) PROFILES
C
      WRITE(16,6100)
      DO 610 I=1,NRPR
      READ(15,*) (TRF(J,I),RF(J,I),J=1,NRDP)
      WRITE(16,6150) I
      WRITE(16,5120) (TRF(J,I),RF(J,I),J=1,NRDP)
  610 CONTINUE
C
C ------- READ AND WRITE GLOBAL NODAL NUMBER OF RS NODES
C
      CALL READN(IRTYP(1,2),MXRNP,NRNP)
      WRITE(16,6200) (IRTYP(I,2),I=1,NRNP)
C
C ------- READ RAINFALL/EVAPORATION TYPE ASSIGNED TO EACH RS NODE
C
      CALL READN(IRTYP(1,1),MXRNP,NRNP)
C
C ------- READ PONDING DEPTH AND MINIMUM HEAD FOR EACH OF ALL RS NODES
C
      CALL READR(RSVAB(1,1),MXRNP,NRNP)
      CALL READR(RSVAB(1,2),MXRNP,NRNP)
C
C ------- PRINT GLOBAL NODAL NUMBER, RAINFALL/EVAPORATION TYPE, PONDING
C         DEPTH, AND MINIMUM PRESSURE HEAD FOR ALL RS NODES
C
      LINE=0
      DO 620 I=1,NRNP,2
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,6220)
      NJMN=I
      NJMX=MIN0(I+1,NRNP)
      WRITE(16,6250) (J,IRTYP(J,2),IRTYP(J,1),(RSVAB(J,K),K=1,2),J=NJMN,
     1 NJMX)
  620 CONTINUE
C
C ------- READ RAINFALL/EVAPORATION-SEEPAGE (RS) ELEMENT SIDES
C
      MPI=0
  630 READ(15,*) MI,NSEQ,M,IS1,IS2,MIAD,MAD,IS1AD,IS2AD
      IF(MI.EQ.0) GO TO 640
      MJ=MI+NSEQ
      DO 635 MP=MI,MJ
      I=MI+(MP-MI)*MIAD
      ISR(5,I)=M+(MP-MI)*MAD
      ISR(1,I)=IS1+(MP-MI)*IS1AD
      ISR(2,I)=IS2+(MP-MI)*IS2AD
      MPI=MPI+1
  635 CONTINUE
      GO TO 630
  640 IF(MPI.EQ.NRES) GO TO 650
      WRITE(16,6500)
      STOP
C
  650 CONTINUE
C
C ------- PRINT THE READ-IN RS ELEMENT SIDES
C
      LINE=0
      DO 660 MP=1,NRES,3
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,6600)
      NJMN=MP
      NJMX=MIN0(MP+2,NRES)
      WRITE(16,6650) (J,ISR(5,J),ISR(1,J),ISR(2,J),J=NJMN,NJMX)
  660 CONTINUE
C
C ------- COMPUTE LENGTH AND DIRECTIONAL COSINES OF ALL RAINFALL/
C         EVAPORATION-SEEPAGE ELEMENT SIDES
C
      DO 690 MPI=1,NRES
      MI=ISR(5,MPI)
      DO 680 MPJ=1,NBES
      MJ=ISB(5,MPJ)
      IF(MJ.NE.MI) GO TO 680
      I=ISR(1,MPI)
      NI=IRTYP(I,2)
      J=ISR(2,MPI)
      NJ=IRTYP(J,2)
      NIB=ISB(1,MPJ)
      NJB=ISB(2,MPJ)
      IF(NIB.EQ.NI .AND. NJB.EQ.NJ) GO TO 670
      IF(NIB.EQ.NJ .AND. NJB.EQ.NI) GO TO 665
      GO TO 680
C
  665 ISR(1,MPI)=J
      ISR(2,MPI)=I
  670 DO 675 JJ=3,4
  675 ISR(JJ,MPI)=ISB(JJ,MPJ)
      DLCSR(1,MPI)=DLCSB(1,MPJ)
      DLCSR(2,MPI)=DLCSB(2,MPJ)
      DLCSR(3,MPI)=DLCSB(3,MPJ)
      GO TO 690
C
  680 CONTINUE
C
      WRITE(16,6800) MPI,I,J,NI,NJ,MI
C
  690 CONTINUE
C
C ------- PRINT COMPUTED RS ELEMENT SIDES
C
      LINE=0
      DO 695 MP=1,NRES
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,6900)
      WRITE(16,6950) MP,IRTYP(MP,2),(ISR(I,MP),I=1,4),DLCSR(3,MP),
     1 (DLCSR(I,MP),I=1,2)
  695 CONTINUE
C
C ******* DATA SET 14: DIRICHLET BOUNDARY CONDITIONS
C
C ------- READ AND PRINT TOTAL DIRICHLET HEAD PROFILES
C
  700 CONTINUE
      READ(15,5)DATNAM
      READ(15,*) NDNPH,NDPRH,NDDPH,KDAIH
      IF(NDNPH.EQ.0) GO TO 800
C
      WRITE(16,7000) NDNPH,NDPRH,NDDPH
      DO 710 I=1,NDPRH
      READ(15,*) (THDBF(J,I),HDBF(J,I),J=1,NDDPH)
      WRITE(16,7100) I
      WRITE(16,5120) (THDBF(J,I),HDBF(J,I),J=1,NDDPH)
  710 CONTINUE
C
C ------- READ GLOBAL NODAL NUMBER OF ALL DIRICHLET NODES AND THE TYPE
C ------- OF TOTAL HEAD PROFILE ASSIGNED TO EACH OF THEM
C
      CALL READN(IDTYPH(1,2),MXDNPH,NDNPH)
      CALL READN(IDTYPH(1,1),MXDNPH,NDNPH)
C
C ------- PRINT GLOBAL NODAL NUMBERS AND PROFILE TYPE OF DIRICHLET NODES
C
      LINE=0
      DO 720 I=1,NDNPH,4
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,7200)
      NJMN=I
      NJMX=MIN0(I+3,NDNPH)
      WRITE(16,7250) (J,IDTYPH(J,2),IDTYPH(J,1),J=NJMN,NJMX)
  720 CONTINUE
C
C ******* DATA SET 15: CAUCHY BOUNDARY CONDITIONS
C
C ------- READ AND PRINT CAUCHY FLUX PROFILES
C
  800 CONTINUE
      READ(15,5)DATNAM
      READ(15,*) NCESH,NCNPH,NCPRH,NCDPH,KCAIH
      IF(NCESH.EQ.0) GO TO 900
C
      WRITE(16,8000) NCESH,NCNPH,NCPRH,NCDPH
      DO 810 I=1,NCPRH
      READ(15,*) (TQCBF(J,I),QCBF(J,I),J=1,NCDPH)
      WRITE(16,8100) I
      WRITE(16,5120) (TQCBF(J,I),QCBF(J,I),J=1,NCDPH)
  810 CONTINUE
C
C ------- READ GLOBAL NODAL NUMBER OF ALL CAUCHY NODES AND TYPE OF
C ------- CAUCHY FLUX PROFILE ASSIGNED TO EACH OF THEM
C
      CALL READN(ICTYPH(1,2),MXCNPH,NCNPH)
      CALL READN(ICTYPH(1,1),MXCNPH,NCNPH)
C
C ------- PRINT GLOBAL NODAL NUMBER AND PROFILE TYPE OF ALL CAUCHY NODES
C
      LINE=0
      DO 820 I=1,NCNPH,4
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,8200)
      NJMN=I
      NJMX=MIN0(I+3,NCNPH)
      WRITE(16,7250) (J,ICTYPH(J,2),ICTYPH(J,1),J=NJMN,NJMX)
  820 CONTINUE
C
C ------- READ CAUCHY BOUNDARY ELEMENT SIDES
C
      MPI=0
  830 READ(15,*)MI,NSEQ,M,IS1,IS2,MIAD,MAD,IS1AD,IS2AD
      IF(MI.EQ.0) GO TO 840
      MJ=MI+NSEQ
      DO 835 MP=MI,MJ
      I=MI+(MP-MI)*MIAD
      ISCH(5,I)=M+(MP-MI)*MAD
      ISCH(1,I)=IS1+(MP-MI)*IS1AD
      ISCH(2,I)=IS2+(MP-MI)*IS2AD
      MPI=MPI+1
  835 CONTINUE
      GO TO 830
  840 IF(MPI.EQ.NCESH) GO TO 850
      WRITE(16,8300)
      STOP
C
  850 CONTINUE
C
C ----- FIND OUT THE LOCAL NODES OF CAUCHY POINTS
C
      DO 880 MPI=1,NCESH
        IDON=0
        MI=ISCH(5,MPI)
        DO 870 MPJ=1,NBES
          MJ=ISB(5,MPJ)
          IF(MJ.NE.MI)GOTO 870
          I=ISCH(1,MPI)
          NI=ICTYPH(I,2)
          J=ISCH(2,MPI)
          NJ=ICTYPH(J,2)
          NIB=ISB(1,MPJ)
          NJB=ISB(2,MPJ)
          IF(NIB.EQ.NJ .AND. NJB.EQ.NI)THEN
            ISCH(1,MPI)=J
            ISCH(2,MPI)=I
            IDON=1
          ENDIF
          IF(IDON.EQ.1 .OR. (NIB.EQ.NI .AND. NJB.EQ.NJ))THEN
            DO JJ=3,4
              ISCH(JJ,MPI)=ISB(JJ,MPJ)
            ENDDO
            GOTO 880
          ENDIF
  870   CONTINUE
  880 CONTINUE
C
C ------- PRINT THE READ-IN CAUCHY BOUNDARY ELEMENT SIDES
C
      LINE=0
      DO 890 MP=1,NCESH,4
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,8900)
      NJMN=MP
      NJMX=MIN0(MP+3,NCESH)
      WRITE(16,8950) (J,ISCH(1,J),ISCH(2,J),J=NJMN,NJMX)
  890 CONTINUE
C
C ******* DATA SET 16:  NEUMANN BOUNDARY CONDITIONS
C
C ------- READ AND PRINT NEUMANN FLUX PROFILES
C
  900 CONTINUE
      READ(15,5)DATNAM
      READ(15,*) NNESH,NNNPH,NNPRH,NNDPH,KNAIH
      IF(NNNPH.EQ.0) GO TO 999
C
      WRITE(16,9000) NNESH,NNNPH,NNPRH,NNDPH
      DO 910 I=1,NNPRH
      READ(15,*) (TQNBF(J,I),QNBF(J,I),J=1,NNDPH)
      WRITE(16,9100) I
      WRITE(16,5120) (TQNBF(J,I),QNBF(J,I),J=1,NNDPH)
  910 CONTINUE
C
C ------- READ GLOBAL NODAL NUMBER OF ALL NEUMANN NODES AND TYPE OF
C ------- NEUMANN FLUX PROFILE ASSIGNED TO EACH OF THEM
C
      CALL READN(INTYPH(1,2),MXNNPH,NNNPH)
      CALL READN(INTYPH(1,1),MXNNPH,NNNPH)
C
C ------- PRINT GLOBAL NODAL NUMBERS AND PROFILE TYPES OF NEUMANN NODES
C
      LINE=0
      DO 920 I=1,NNNPH,4
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,9200)
      NJMN=I
      NJMX=MIN0(I+3,NNNPH)
      WRITE(16,7250) (J,INTYPH(J,2),INTYPH(J,1),J=NJMN,NJMX)
  920 CONTINUE
C
C ------- READ NEUMANN BOUNDARY ELEMENT SIDES
C
      MPI=0
  930 READ(15,*) MI,NSEQ,M,IS1,IS2,MIAD,MAD,IS1AD,IS2AD
      IF(MI.EQ.0) GO TO 940
      MJ=MI+NSEQ
      DO 935 MP=MI,MJ
      I=MI+(MP-MI)*MIAD
      ISNH(5,I)=M+(MP-MI)*MAD
      ISNH(1,I)=IS1+(MP-MI)*IS1AD
      ISNH(2,I)=IS2+(MP-MI)*IS2AD
      MPI=MPI+1
  935 CONTINUE
      GO TO 930
  940 IF(MPI.EQ.NNESH) GO TO 950
      WRITE(16,9300)
      STOP
C
  950 CONTINUE
C
C ------- PRINT THE READ-IN NEUMANN BOUNDARY ELEMENT SIDES
C
      LINE=0
      DO 960 MP=1,NNESH,3
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,9600)
      NJMN=MP
      NJMX=MIN0(MP+2,NNESH)
      WRITE(16,9650) (J,ISNH(5,J),ISNH(1,J),ISNH(2,J),J=NJMN,NJMX)
  960 CONTINUE
C
C ------- COMPUTE LENGTH AND DIRECTIONAL COSINES OF ALL NEUMANN
C ------- BOUNDARY ELEMENT SIDES
C
      DO 990 MPI=1,NNESH
      MI=ISNH(5,MPI)
      DO 980 MPJ=1,NBES
      MJ=ISB(5,MPJ)
      IF(MJ.NE.MI) GO TO 980
      I=ISNH(1,MPI)
      NI=INTYPH(I,2)
      J=ISNH(2,MPI)
      NJ=INTYPH(J,2)
      NIB=ISB(1,MPJ)
      NJB=ISB(2,MPJ)
      IF(NIB.EQ.NI .AND. NJB.EQ.NJ) GO TO 970
      IF(NIB.EQ.NJ .AND. NJB.EQ.NI) GO TO 965
      GO TO 980
C
  965 ISNH(1,MPI)=J
      ISNH(2,MPI)=I
  970 DO 975 JJ=3,4
  975 ISNH(JJ,MPI)=ISB(JJ,MPJ)
      DLCSNH(1,MPI)=DLCSB(1,MPJ)
      DLCSNH(2,MPI)=DLCSB(2,MPJ)
      DLCSNH(3,MPI)=DLCSB(3,MPJ)
      GO TO 990
C
  980 CONTINUE
      WRITE(16,9800) MPI,I,J,NI,NJ,MI
  990 CONTINUE
C
C ------- PRINT THE COMPUTED NEUMANN BOUNDARY ELEMENT SIDE INFORMATION
C
      LINE=0
      DO 995 MP=1,NNESH
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,9900)
      WRITE(16,6950) MP,ISNH(5,MP),(ISNH(I,MP),I=1,4),DLCSNH(3,MP),
     1 DLCSNH(1,MP),DLCSNH(2,MP)
  995 CONTINUE
C
  999 CONTINUE
C
      RETURN
C
    5 FORMAT(A1)
   10 FORMAT(16I5)
   20 FORMAT(8D10.3)
C
 1000 FORMAT('1'//5X,'**** CONTROL INTEGERS AND REAL NUMBERS FOR',
     1 ' HYDROLOGICAL SIMULATIONS ***'/5X,
     2 'NO. OF CYCLES ALLOWED FOR ITERATING B. C. . . . . . .',I5/5X,
     3 'NO. OF ITERATIONS ALLOWED FOR SOLVING NONLINEAR EQ. .',I5/5X,
     4 'NO. FO ITERATIONS ALLOWED FOR POINTWISE ITERATIONS  .',I5/5X,
     5 'STORE INDICATOR, KSTR . . . . . . . . . . . . . . . .',I5/5X,
     6 'STEADY STATE SIMULATION INDICATOR . . . . . . . . . .',I5/5X,
     8 'IS GRAVITY TERM INCLUDED? . . . . . . . . . . . . . . ',I5/)
 1100 FORMAT(1H0/5X,
     1 'TOTERANCE FOR STEADY STATE SOLUTION . . . . . . . .',1PD15.6/5X,
     2 'TOLERANCE FOR TRANSIENT SOLUTION . . . . . . . . . ',1PD15.6/5X,
     3 'TIME INTEGRATION WEIGHTING FACTOR . . . . . . . . .',1PD15.6/5X,
     4 'RELAXATION FACTOR FOR SOLVING NONLINEAR EQ. . . . .',1PD15.6/5X,
     5 'RELAXATION FACTOR FOR POINTWISE SOLUTION . . . . . ',1PD15.6/5X,
     6 'CONSTRAINT ON HYDRAULIC CONDUCTIVITY, CNSTKR . . . ',1PD15.6/)
 5100 FORMAT('1'/5X,'*** ELEMENT (DISTRIBUTED) SOURCE/SINK ',
     1 'INFORMATION:','  NSEL =',I5,',   NSPR =',I5,',   NSDP =',I5/)
 5110 FORMAT('0'/5X,' PROFILE NO.',I2,/ 4(4X,'TIME',4X,'SOURCE',2X)/
     1 4(4X,'----',4X,'------',2X))
 5120 FORMAT(' ',8(1PD10.2))
 5200 FORMAT(' '//10X,' GLOBAL ELEMENT NUMBER AND PROFILE TYPE OF',
     1 'ELEMENT SOURCE/SINK'//5X,4('   MP  LES STYP   ')/
     > 5X,4('   --  --- ----   '))
 5210 FORMAT(' ',4X,4(3I5,3X))
 5600 FORMAT('1'///5X,'*** WELL (POINT) SOURCE/SINK INFORMATION',
     1 '  NWNP =',I3,'  NWPR =',I3,'  NWDP =',I3/)
 5700 FORMAT('0'//10X,' GLOBAL NODAL NUMBER AND PROFILE TYPE OF WELL',
     1 ' SOURCE/SINK'//5X,4('   NP  NPW WTYP   ')/5X,
     > 4('   --  --- ----   '))
 6000 FORMAT('1'/5X,' **** RAINFALL-SEEPAGE BOUNDARY CONDITIONS',
     1 '  NRES =',I3,',  NRNP =',I3,/47X,'  NRPR =',I3,', NRDP =',I3)
 6100 FORMAT('0'///10X,' --- RAINFALL PROFILE ---')
 6150 FORMAT('0'/5X,' PROFILE NO.',I2,/ 4(4X,'TIME',4X,' RAINS',2X)/
     1 4(4X,'----',4X,'------',2X))
 6200 FORMAT('0'/10X,' --- LIST OF RS-NODAL POINTS ---'//(10X,14I5))
 6220 FORMAT('0'/10X,' --- RAINFALL TYPE AND PONDING DEPTH ---'//5X,
     1 2('    I',' NPRS',' RTYP','   HCON(I) ','   HMIN(I) ',2X)/
     > 2('    -',' ----',' ----','   ------- ','   ------- '))
 6250 FORMAT(' ',4X,2(3I5,1PD10.3,1PD10.3,2X))
 6500 FORMAT('0',10X,' *** ERROR IN READING RAINFALL-SEEPAGE ELEMENT',
     1 ' SIDE STOP ***')
 6600 FORMAT('0'//10X,' --- RAINFALL-SEEPAGE ELEMENT SIDE DATA --- '
     1   //5X,3('   MP    M CNP1 CNP2  ')/5X,
     >   3('   --    - ---- ----  '))
 6650 FORMAT(' ',4X,3(4I5,2X))
 6800 FORMAT('0',5X,I5,'-TH RS SIDE IS NOT ONE OF THE BOUNDARY SIDES;',
     1 'I,J,NI,NJ,MI =',5I5)
 6900 FORMAT('1'//10X,' *** COMPUTED RAINFALL SEEPAGE ELEMENT SIDE INF',
     1 'ORMATION ***'//5X,'   MP   M   NP1  NP2   L1  L2   DL(MP)  ',
     2 ' DCOSX(MP)  DCOSZ(MP)  '/5X,'   --   -   ---  ---   --  --   ',
     > '------   ---------  ---------')
 6950 FORMAT(' ',4X,4I5,2X,2I3,3(1PD11.3),3X)
 7000 FORMAT('1'/5X,' **** DIRICHLET BOUNDARY CONDITIONS:  NDNP =',
     1 I3,',  NDPR =',I3,',  NDDP =',I3)
 7100 FORMAT('0'/5X,' PROFILE NO.',I2,/ 4(4X,'TIME',4X,' HEAD ',2X)/
     1 4(4X,'----',4X,' ---- ',2X))
 7200 FORMAT('0'//10X,'GLOBAL NODAL NUMBER AND PROFILE TYPE OF DIRICH',
     1 'LET BOUNDARY NODES'//5X,4('    I NPDB DTYP   ')/5X,
     > 4('    - ---- ----   '))
 7250 FORMAT(' ',4X,4(3I5,3X))
 8000 FORMAT('1'/5X,'**** CAUCHY  BOUNDARY CONDITIONS:  NCES =',I5,
     1 ',   NCNP =',I5/40X,',   NCPR =',I5,',   NCDP =',I5)
 8100 FORMAT('0'/5X,' PROFILE NO.',I2/ 4(4X,'TIME',4X,' FLUX ',2X)/
     1 4(4X,'----',4X,' ---- ',2X))
 8200 FORMAT('0'//10X,'GLOBAL NODAL NUMBER AND PROFILE TYPE OF CAUCHY',
     1 'BOUNDARY NODES'//5X,4('    I NPCB CTYP   ')/5X,
     > 4('    - ---- ----   '))
 8300 FORMAT(///' ERROR IN READING CAUCHY  ELEMENT SIDE'//)
 8900 FORMAT('0'//10X,' CAUCHY ELEMENT SIDE DATA'//5X,
     1 4('   MP CNP1 CNP2   ')/5X,4('   -- ---- ----   '))
 8950 FORMAT(' ',4X,4(3I5,3X))
 9000 FORMAT('1'/5X,' **** NEUMANN BOUNDARY CONDITIONS:  NNES =',I5,
     1 ',   NNNP =',I5/41X,',   NNPR =',I5,',   NNDP =',I5)
 9100 FORMAT('0'/5X,' PROFILE NO.',I2/ 4('    TIME       FLUX   ')/
     1 4('    ----       ----   '))
 9200 FORMAT('0'//10X,'GLOBAL NODAL NUMBER AND PROFILE TYPE OF NEUMANN',
     1 ' BOUNDARY NODES'//5X,4('    I NPNB NTYP   ')
     > /5X,4('    - ---- ----   '))
 9300 FORMAT(/// 'ERROR IN READING NEUMANN ELEMENT SIDE'//)
 9600 FORMAT('0'//10X,' NEUMANN ELEMENT SIDE DATA'//5X,
     1 3('   MP    M CNP1 CNP2  ')/5X,3('   --    - ---- ----  '))
 9650 FORMAT(' ',4X,3(4I5,2X))
 9800 FORMAT('0',5X,I5,'-TH NEUMANN SIDE IS NOT ONE OF THE BOUNDARY SI',
     1 'DES; I,J,NI,NJ,MI =',5I5)
 9900 FORMAT('1'//10X,'*** COMPUTED NEUMANN ELEMENT SIDE INFORMATION',
     1 ' ***'//5X,'   MP    M CNP1 CNP2 L1 L2  DL(MP)   DCOSXN(MP)',
     2 ' DCOSZN(MP) '/5X,'   --    - ---- ---- -- --  ------   ',
     > '---------- ---------- ')
C
      END
      SUBROUTINE LNDGEN
     I    (IE,IGEOM,
     O     NLRL,LRL,NLRN,LRN,ND)
C
C $$$$$ TO OBTAIN THE GLOBAL STENCIL, I. E., THE NODE CONNECTIVITY.
C
C ----- INPUT: IE.
C
C ----- OUTPUT: NLRN,LRN,NLRL,LRL
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
C
      DIMENSION IE(MAXEL,9)
      DIMENSION NLRL(MAXNP),LRL(MXKBD,MAXNP)
      DIMENSION NLRN(MAXNP),LRN(MXJBD,MXADNP),ND(MXADNP)
C
C ----- CONSIDER ARRAYS NLRL,LRL,NLRN,LRN
C
      DO 50 I=1,NNP
        NLRL(I)=0
        NLRN(I)=0
        DO 20 J=1,MXKBD
          LRL(J,I)=0
  20    CONTINUE
        DO 30 J=1,MXJBD
          LRN(J,I)=0
  30    CONTINUE
  50  CONTINUE
      DO 400 M=1,NEL
        IF(IE(M,4).EQ.0)THEN
          NODE=3
        ELSE
          NODE=4
        ENDIF
        DO 200 I=1,NODE
          IEM=IE(M,I)
          NLRLN=NLRL(IEM)+1
          NLRL(IEM)=NLRLN
          LRL(NLRLN,IEM)=M
          DO 100 J=1,NODE
            IEMJ=IE(M,J)
            IF(NLRN(IEM).EQ.0)THEN
              NLRN(IEM)=NLRN(IEM)+1
              LRN(1,IEM)=IEMJ
            ELSE
              DO K=1,NLRN(IEM)
                N=LRN(K,IEM)
                IF(N.EQ.IEMJ)GOTO 100
              ENDDO
              NLRN(IEM)=NLRN(IEM)+1
              NLRNN=NLRN(IEM)
              LRN(NLRNN,IEM)=IEMJ
            ENDIF
 100      CONTINUE
 200    CONTINUE
 400  CONTINUE
C
C ***** GENERATE ND ARRAY
C
      DO NP=1,NNP
        DO I=1,NLRN(NP)
          IF(LRN(I,NP).EQ.NP)ND(NP)=I
        ENDDO
      ENDDO
C
C ***** PRINT GENERATED ARRAY LRN
C
      IF(MOD(IGEOM,2).NE.0)THEN
        LINE=0
        DO 510 NP=1,NNP
          LINE=LINE+1
          IF(MOD(LINE-1,50).EQ.0)WRITE(16,5000)
          WRITE(16,5100) NP,(LRN(I,NP),I=1,NLRN(NP))
  510   CONTINUE
      ENDIF
C
C ***** PRINT GENERATED ARRAY LRL
C
      IF(MOD(IGEOM,2).NE.0)THEN
        LINE=0
        DO 530 NP=1,NNP,3
          LINE=LINE+1
          IF(MOD(LINE-1,50).EQ.0)WRITE(16,6000)
          NJMN=NP
          NJMX=MIN0(NP+2,NNP)
          WRITE(16,6100)(NJ,(LRL(I,NJ),I=1,NLRL(NJ)),NJ=NJMN,NJMX)
  530   CONTINUE
      ENDIF
C
 5000 FORMAT(1H1/5X,' ** GENERATED SURROUNDING NODES OF ALL NODES **',/
     1 2X,'   NP    1    2    3    4    5    6    7    8    9   10',
     2 '   11'/ 2X,'   --    -    -    -    -    -    -    -    -',
     3 '    -   --   --'/)
 5100 FORMAT(1H ,1X,12I5)
 6000 FORMAT(1H1/1X,' ** GENERATED CONNECTING ELEMENTS OF ALL NODES *'
     1 //1X,3('   NP    1    2    3    4')/1X,
     2      3('  ---    -    -    -    -'))
 6100 FORMAT(1H ,3(5I5))
C
      RETURN
      END
      SUBROUTINE IBE2D
     I    (IE,IB,NLRL,LRL,
     O     IBE)
C
C $$$$$ TO GENERATE ARRAY IBE(M), WHICH REPRESENTS THE INDEX OF
C       BOUNDARY ELEMENT M
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ISHAPE
C
      DIMENSION IE(MAXEL,9),IB(MXADNP),IBE(MAXEL)
      DIMENSION NLRL(MAXNP),LRL(MXKBD,MAXNP)
C
      DO 200 M=1,NEL
        IB1=0
        IB2=0
        IBE(M)=0
        IF(IE(M,4).EQ.0)THEN
          NODE=3
        ELSE
          NODE=4
        ENDIF
        DO 100 I=1,NODE
          I1=I+1
          IF(I1.GT.NODE)I1=1
          N1=IE(M,I)
          N2=IE(M,I1)
          IF(IB(N1)*IB(N2).EQ.0)GOTO 100
C ----- CHECK IF THIS SIDE IS A BOUNDARY SIDE
          DO 50 J=1,NLRL(N1)
            M1=LRL(J,N1)
            DO K=1,NLRL(N2)
              M2=LRL(K,N2)
              IF(M1.EQ.M2 .AND. M1.NE.M)GOTO 100
            ENDDO
  50      CONTINUE
C ----- ELEMENT M IS  A BOUNDARY ELEMENT
          IF(IB1.EQ.0)then
            IB1=I
          ELSE
            IB2=I
          ENDIF
          IF(IB2.NE.0)GOTO 150
 100    CONTINUE
 150    CONTINUE
        IF(IB1.NE.0)THEN
          IF(IB2.EQ.0)THEN
            IBE(M)=IB1
          ELSE
            IF(IB1.EQ.1 .AND. IB2.EQ.2)IBE(M)=12
            IF(IB1.EQ.2 .AND. IB2.EQ.3)IBE(M)=23
            IF(NODE.EQ.3)THEN
              IF(IB1.EQ.1 .AND. IB2.EQ.2)IBE(M)=13
            ELSE
              IF(IB1.EQ.3 .AND. IB2.EQ.4)IBE(M)=34
              IF(IB1.EQ.1 .AND. IB2.EQ.4)IBE(M)=14
            ENDIF
          ENDIF
        ENDIF
 200  CONTINUE
      RETURN
      END
      SUBROUTINE RDATIO
     I          (IGEOM,
     O           COORD,IE,LRN,LRL,NLRN,NLRL,ND,DLCSB,ISB,NPBB, PROP,SPP,
     O           RKD,TRANC,RHOMU,DINTS,IRXN)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO READ AND PRINT GEOMETRY, MATERIAL PROPERTIES, AND SOIL
C ------- CHARACTERISTICS
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER PMAT*12,DATNAM*1
      CHARACTER*10 THPAR,AKPAR
      CHARACTER*72 TITLE
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /HICNT/ NCYL,NITERH,NPITERH,KSTRH,KSSH,KSP,KGRAV
      COMMON /NINTR/ KPR0,KDSK0,NSTRH,NSTRT
      COMMON /SCMTL/ MAXMAT,MXSPPM,MXMPPM,NMAT,NSPPM,NMPPM
      COMMON /HRBC/ MXRES,MXRNP,MXRPR,MXRDP,NRES,NRNP,NRPR,NRDP,KRAIH
      COMMON /CHEM/ MXNCC,NCC
C
      DIMENSION COORD(MAXNP,2),IE(MAXEL,9),LRN(MXJBD,MXADNP),
     >          LRL(MXKBD,MAXNP),NLRL(MAXNP),NLRN(MAXNP),ND(MXADNP)
      DIMENSION DLCSB(3,MAXBES),ISB(5,MAXBES), NPBB(MAXBNP)
      DIMENSION PROP(MAXMAT,MXMPPM),SPP(MXSPPM,MAXMAT,4),DINTS(MXNCC)
      DIMENSION RKD(MAXMAT,MXNCC),TRANC(MAXMAT,MXNCC),RHOMU(MXNCC)
C
      DIMENSION PMAT(10),AKPAR(10),THPAR(10)
C
      DATA PMAT/'   Sxx/Pxx  ','   Szz/Pzz  ','   Sxz/Pxz  ',
     1 '   RHO      ','     GRAV   ','     AL     ','     AT     ',
     2 '   TAU*DM   ','     VISC   ','    ROUB.   '/
C
      DATA THPAR/'    TH1   ','    TH2   ','    TH3   ',
     1 '    TH4   ','    TH5   ','    TH6   ','    TH7   ',
     2 '    TH8   ','    TH9   ','    TH10  '/
C
      DATA AKPAR/'    AK1   ','    AK2   ','    AK3   ',
     1 '    AK4   ','    AK5   ','    AK6   ','    AK7   ',
     2 '    AK8   ','    AK9   ','    AK10  '/
C
C
C ******* DATA SET 3: NODE COORDINATES
C
C ------- READ NODAL POINT COORDINATES
C
      IF(NSTRH.GT.0)THEN
        REWIND 11
        READ(11)TITLE,NPROB,NNP,NEL,NBNP,NBES,NTI,NRNP
        PRINT *, 'TITLE in RDATIO =', TITLE
        PRINT *, 'NPROB in RDATIO =', NPROB
        PRINT *, 'NTI in RDATIO =', NTI
        READ(11) ((COORD(N,I),I=1,2),N=1,NNP),((IE(M,I),M=1,NEL),
     >           I=1,5),((DLCSB(I,M),I=1,4),M=1,NBES),(NPBB(N),
     >           N=1,NBNP)
      ENDIF
      IF(NSTRT.GT.0)THEN
        REWIND 12
        READ(12)TITLE,NPROB,NNP,NEL,NTI
        READ(12)((COORD(N,I),I=1,2),N=1,NNP),((IE(M,I),M=1,NEL),
     >          I=1,9)
      ENDIF
      IF(NSTRH.EQ.0 .AND. NSTRT.EQ.0)THEN
        READ(15,5)DATNAM
        PRINT *, 'DATNAM in RDATIO =', DATNAM
        READ(15,*) NNP
        CALL READR(COORD(1,1),MAXNP,NNP)
        CALL READR(COORD(1,2),MAXNP,NNP)
      ENDIF
C
C ------- PRINT NODAL POINT COORDINATES
C
      IF(MOD(IGEOM,2).NE.0)THEN
        LINE=0
        DO 290 NP=1,NNP,2
          NJMN=NP
          NJMX=MIN0(NP+1,NNP)
          LINE=LINE+1
          IF(MOD(LINE-1,50).EQ.0) WRITE(16,2900) NNP
          WRITE(16,2910) (NJ,(COORD(NJ,I),I=1,2),NJ=NJMN,NJMX)
  290   CONTINUE
      ENDIF
C
C ******* DATA SET 4: ELEMENT DATA
C
C ------- READ ELEMENT INDICES AND COMPUTE MAXIMUM NODAL DIFFERENCE FOR
C ------- EACH ELEMENT
C
      READ(15,5)DATNAM
      READ(15,*) NEL,NMAT,KCP
C
      IF(NSTRH.EQ.0 .AND. NSTRT.EQ.0)THEN
        MAXDIF=0
        MJ=0
C ***** set the number of element shape to zero
  300   READ(15,*) MI,(IE(MI,I),I=1,5),MODL,NLAY
C
        NQ=4
        NQ1=3
        IEM4=IE(MI,4)
        IF(IEM4.EQ.0) NQ=3
        IF(IEM4.EQ.0) NQ1=2
C
        DO 305 IQ=1,NQ1
          IQ1=IQ+1
          DO 305 JQ=IQ1,NQ
          NDIF=IABS(IE(MI,IQ)-IE(MI,JQ))
          MAXDIF=MAX0(NDIF,MAXDIF)
  305   CONTINUE
C
  310   MJ=MJ + 1
C
        IF(MI-MJ) 315,330,320
C
  315   WRITE(16,3000)  MI
        STOP
C
  320   DO 325 IQ=1,NQ
  325   IE(MJ,IQ)=IE(MJ-1,IQ) + 1
        IE(MJ,5)=IE(MJ-1,5)
C
  330   IF(MJ.LT.MI) GO TO 310
        IF(MJ.EQ.NEL) GO TO 370
        IF(MODL.LE.0) GO TO 300
C
        DO 360 I=1,NLAY
          LL=2
          DO 360 J=1,MODL
          IF(MJ.EQ.MI) GO TO 350
C
          DO 340 KQ=1,NQ
  340     IE(MJ,KQ)=IE(MJ-1,KQ) + LL
          IE(MJ,5)=IE(MJ-1,5)
C
  350     LL=1
  360   MJ=MJ + 1
        MJ=MJ - 1
        IF(MJ.LT.NEL) GO TO 300
  370   CONTINUE
      ENDIF
C
C ----- INITIALIZE IE(M,6..9)
C
      ISHAP4=0
      ISHAP3=0
      IF(NSTRH.GT.0 .OR. NSTRT.GT.0)THEN
        MAXDIF=0
        DO 374 M=1,NEL
          IF(IE(M,4).EQ.0)THEN
            NQ=3
          ELSE
            NQ=4
          ENDIF
          DO 373 IQ=1,NQ-1
            IQ1=IQ+1
            DO 373 JQ=IQ1,NQ
              NDIF=IABS(IE(M,IQ)-IE(M,JQ))
              MAXDIF=MAX0(NDIF,MAXDIF)
 373      CONTINUE
 374    CONTINUE
      ENDIF
      DO 375 M=1,NEL
        if(ie(m,4).eq.0)then
          ishap3=ishap3+1
        else
          ishap4=ishap4+1
        endif
        DO I=6,9
          IE(M,I)=0
        ENDDO
 375  CONTINUE
C
C ----- DETERMINE ISHAPE VALUE
C
      if(ishap3.NE.0 .AND. ishap4.NE.0)then
c       mixed elements
        ishape=0
      elseif(ishap3.ne.0)then
c       triangular elements
        ishape=3
      elseif(ishap4.ne.0)then
        ishape=4
      endif
C
C ******* DATA SET 5: MATERIAL TYPES
C
      IF(NSTRH.EQ.0 .AND. NSTRT.EQ.0)THEN
        READ(15,5)DATNAM
        READ(15,*) NCM
        IF(NCM.LE.0) GO TO 380
        CALL READN(IE(1,5),MAXEL,NCM)
C
C ------- PRINT ELEMENT INCIDENCE AND MATERIAL TYPES FOR EACH ELEMENT
C
  380   CONTINUE
      ENDIF
C
      IF(MOD(IGEOM,2).NE.0)THEN
        LINE=0
        DO 385 NI=1,NEL,2
          NJMN=NI
          NJMX=MIN0(NI+1,NEL)
          LINE=LINE+1
          IF(MOD(LINE-1,50).EQ.0) WRITE(16,3800) NEL,NMAT
          WRITE(16,3810) (NJ,(IE(NJ,K),K=1,5),NJ=NJMN,NJMX)
  385   CONTINUE
      ENDIF
C
      IHALFB=MAXDIF
      IBAND=2*IHALFB+1
      IHBP=IHALFB+1
      WRITE(16,3850) IHALFB,IBAND,IHBP
C
C ------- CHECK IF MATERIAL TYPE FOR EACH ELEMENT IS CORRECT
C
      DO 390 M=1,NEL
      MTYP=IE(M,5)
      IF(MTYP.GT.0 .AND. MTYP.LE.NMAT) GO TO 390
      WRITE(16,3900) M,MTYP
      STOP
  390 CONTINUE
C
C ******* DATA SET 6: MATERIAL PROPERTIES
C
      READ(15,5)DATNAM
      READ(15,*) NMPPM,NCC,IRXN
      WRITE(16,4000) NMAT,NMPPM,NCC,IRXN
      DO 410 I=1,NMAT
        WRITE(16,4050)I,(PMAT(J),J=1,NMPPM)
        READ(15,*) (PROP(I,J),J=1,NMPPM)
        WRITE(16,4100) (PROP(I,J),J=1,NMPPM)
        WRITE(16,4080)
        READ(15,*) (RKD(I,J),J=1,NCC)
        WRITE(16,4200)(RKD(I,J),J=1,NCC)
C
C ----- read transformation rate constant
C
        READ(15,*) (TRANC(I,J),J=1,NCC)
        WRITE(16,4300)(TRANC(I,J),J=1,NCC)
  410 CONTINUE
C
C ***** READ DENSITY AND VISCOSITY FUNCTION COEFF'S ****
C
      READ(15,*) (DINTS(I),I=1,NCC)
      WRITE(16,4230)(DINTS(I),I=1,NCC)
      READ(15,*) (RHOMU(I),I=1,NCC)
      WRITE(16,4250)(RHOMU(I),I=1,NCC)
C
C ******* DATA SET 7: SOIL PROPERTIES
C
      READ(15,5)DATNAM
      READ(15,*) KSP,NSPPM
      WRITE(16,5000) KSP,NMAT,NSPPM
      IF (KSP.EQ.1) GO TO 550
C
C ------- SOIL PROPERTIES ARE TO BE REPRESENTED BY ANALYTIC FUNCTIONS
C
C ------- READ AND PRINT PARAMETERS REQUIRED TO COMPUTE MOISTURE
C
      WRITE(16,5100) (THPAR(J),J=1,NSPPM)
      DO 510 I=1,NMAT
      READ(15,*) (SPP(J,I,1),J=1,NSPPM)
      WRITE(16,5110) I,(SPP(J,I,1),J=1,NSPPM)
  510 CONTINUE
C
C ------- READ AND PRINT PARAMETERS REQUIRED TO COMPUTE RELATIVE
C ------- PERMEABILITY
C
      WRITE(16,5200) (AKPAR(J),J=1,NSPPM)
      DO 520 I=1,NMAT
      READ(15,*) (SPP(J,I,2),J=1,NSPPM)
      WRITE(16,5110) I,(SPP(J,I,2),J=1,NSPPM)
  520 CONTINUE
      GO TO 600
C
C ------- SOIL PROPERTIES ARE TO BE GIVEN IN TABULAR FORM
C
  550 CONTINUE
C
C ------- PRESSURE
C
      DO 560 I=1,NMAT
      READ(15,*) (SPP(J,I,4),J=1,NSPPM)
  560 CONTINUE
C
C ------- WATER CONTENT
C
      DO 570 I=1,NMAT
      READ(15,*) (SPP(J,I,1),J=1,NSPPM)
  570 CONTINUE
C
C ------- RELATIVE PERMEABILITY
C
      DO 580 I=1,NMAT
      READ(15,*) (SPP(J,I,2),J=1,NSPPM)
  580 CONTINUE
C
C ------- WATER CAPACITY
C
      DO 590 I=1,NMAT
      READ(15,*) (SPP(J,I,3),J=1,NSPPM)
  590 CONTINUE
C
      WRITE(16,5900)
      DO 595 I=1,NMAT
      WRITE(16,5910) I,(SPP(J,I,4),(SPP(J,I,K),K=1,3),J=1,NSPPM)
  595 CONTINUE
C
  600 CONTINUE
C
C     CONVERT FROM SATURATED PERMEABILITY TO SATURATED CONDUCTIVITY
C
      IF(KCP.NE.0)THEN
        DO I=1,NMAT
          GAMAMU=PROP(I,4)*PROP(I,5)/PROP(I,9)
          PROP(I,1)=PROP(I,1)*GAMAMU
          PROP(I,2)=PROP(I,2)*GAMAMU
          PROP(I,3)=PROP(I,3)*GAMAMU
        ENDDO
      ENDIF
C
C ------- IDENTIFY BOUNDARY ELEMENTS AND COMPUTE DIRECTIONAL COSINES
C ------- OF ALL BOUNDARY ELEMENT SIDES
C
C ------- CONSTRUCT THE GLOBAL STENCIL, I.E. THE NODE CONNECTIVITY
C
      REWIND 13
      REWIND 14
      IF(IGEOM.LE.3)THEN
        CALL LNDGEN
     I             (IE,IGEOM,
     O              NLRL,LRL,NLRN,LRN,ND)
        WRITE(14)((LRN(J,I),J=1,MXJBD),I=1,NNP),((LRL(J,I),J=1,MXKBD),
     >    I=1,NNP),(NLRN(I),I=1,NNP),(NLRL(I),I=1,NNP)
      ELSE
        READ(14)((LRN(J,I),J=1,MXJBD),I=1,NNP),((LRL(J,I),J=1,MXKBD),
     >    I=1,NNP),(NLRN(I),I=1,NNP),(NLRL(I),I=1,NNP)
      ENDIF
C
      IF(IGEOM.LE.1)THEN
        CALL SURF(IGEOM,LRL,COORD,IE,DLCSB,ISB,NPBB)
        WRITE(13)NBES,NBNP,((DLCSB(J,I),J=1,3),I=1,NBES),((ISB(J,I),
     >    J=1,5),I=1,NBES),(NPBB(I),I=1,NBNP)
      ELSE
        READ(13)NBES,NBNP,((DLCSB(J,I),J=1,3),I=1,NBES),((ISB(J,I),
     >    J=1,5),I=1,NBES),(NPBB(I),I=1,NBNP)
      ENDIF
C
      RETURN
C
    5 FORMAT(A1)
   10 FORMAT(16I5)
   20 FORMAT(3I5,5X,6D10.3)
   30 FORMAT(8D10.3)
C
 2900 FORMAT(/'1     **** NODAL COORDINATE:  NNP =',I5,'   ****'/1X,
     1 2(' NODE       X         Z       ')/1X,
     2 2(' ---- ---------- ----------   '))
 2910 FORMAT(' ',2(I5,2(1PD11.3),3X))
C
 3000 FORMAT('1'///' ERROR IN ELEMENT CARD NO.',I5,'  ****: STOP')
 3800 FORMAT('1'///'    **** ELEMENT CONNECTIVITY AND MATERIAL TYPE',
     1 ': NEL =',I5,'  NMAT =',I5,' ****'///1X,
     2 2('       ELM NOD1 NOD2 NOD3 NOD4 MTYP')/1X,
     3 2('       --- ---- ---- ---- ---- ----'))
 3810 FORMAT(1X,2(5X,6I5))
 3850 FORMAT('0'/5X,' *** MATRIX BAND SIZE: IHAFLB =',I3,'   IBAND =',
     1 I3,'    IHBP =',I3,'   ***')
 3900 FORMAT('1'/' ERROR IN MATERIAL TYPE CODE FOR ELEMENT',I5,
     1 '  WITH TYPE =',I5)
C
 4000 FORMAT(' *** MATERIAL PROPERTIES *** '/5X,
     > ' NUMBER OF DIFFERENT MATERIALS, NMAT. . . . . . . . .',I5/5X,
     > ' NUMBER OF MATERIAL PROPERTIES PER MATERIAL, NMPPM  .',I5/5X,
     > ' NUMBER OF COMPONENTS, NCC  . . . . . . . . . . . . .',I5/5X,
     > ' INDEX OF TYPE OF KINETIC REACTION, IRXN. . . . . . .',I5/)
 4050 FORMAT(/1X,'   **** MATERIAL TYPE NO. ',I5,' ****'//6A12/4A12/
     >       6('----------  ')/4('----------  '))
 4080 FORMAT(/5X,'SUBSTRATE   OXYGEN     NITRATE   NUTRIENT  ',
     >            'MICROBE#1  MICROBE#2  MICROBE#3'/5X,
     >            '---------  ---------  ---------  ---------',
     >            '  ---------  ---------  ---------')
 4100 FORMAT(1X,6(1PD12.4)/1X,4(1PD12.4))
 4200 FORMAT(1X,'Kd',2X,7(1PD9.3,2X))
 4230 FORMAT(/' *** INTRINSIC DENSITY OF EACH CHEMICAL ***'/
     > '   RHO1   ','   RHO2   ','   RHO3   ','  RHO4  ',
     > '   RHO5   ','   RHO6   ','   RHO7   '/7('----------')/7G10.4)
 4250 FORMAT(//' *** VISCOSITY FUNCTION COEFF.S ***'/
     > '  B1    ','   B2    ',
     > '  B3    ','   Bs   ','   Bo   ','   Bn    ',
     > '  Bp    '/7(' ------ ')/7D8.2)
 4300 FORMAT('LAMDA',7(1PD9.3,2X))
 5000 FORMAT('1'///1X,'   **** SOIL PROPERTIES:  KSP =',I2,
     1 ',  NMAT =',I5,',   NSPPM =',I5//)
 5100 FORMAT('0','   --- MOISTURE CONTENT PARAMETER ---'//1X,
     1 'MAT. NO.',7A10/1X,'--------',7(' -------- '))
 5110 FORMAT(' ',I8,1X,7(1PD10.3))
 5200 FORMAT('0',/'   --- RELATIVE PERMEABILITY PARAMTER ---'//1X,
     2 'MAT. NO.',7A10/1X,'--------',7(' -------- '))
 5900 FORMAT('0','   --- SOIL PROPERTY INTERPOLATION VALUES ---'//1X,
     1 'MAT. NO.    PRESSURE     MOIST. CONT.   REL. CONDUCT.',
     2 '   WATER CAP.  '/1X,
     > '--------    --------     ------------   -------------',
     > '   ----------')
 5910 FORMAT(' ',I7,4(1PD15.6))
C
      END
      SUBROUTINE READN(INDTYP,MXTYP,NTYPE)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO READ AND AUTOMATIC GENERATE INTEGERS
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION INDTYP(MXTYP)
C
      NTYPES=0
  110 READ(15,*) NI,NSEQ,NAD,NITYP,NTYPAD
      IF(NI.EQ.0) GO TO 130
      NJ=NI+NSEQ
      DO 120 N=NI,NJ
      I=NI+(N-NI)*NAD
      INDTYP(I)=NITYP + (N-NI)*NTYPAD
      NTYPES=NTYPES+1
  120 CONTINUE
      GO TO 110
  130 IF(NTYPES.EQ.NTYPE) GO TO 140
      WRITE(16,1100)
      STOP
  140 IF(NTYPE.LE.MXTYP) GO TO 150
      WRITE(16,1200)
      STOP
  150 CONTINUE
C
   30 FORMAT(5I5)
 1100 FORMAT('1'/' ','*** ERROR IN EXECUTING READN SINCE NTYPES .NE. ',
     1 'NTYPE: STOP ***')
 1200 FORMAT('1'/' ',' *** NTYPE .GT. MXTYP IN EXECUTING READN: STOP')
C
      RETURN
      END
      SUBROUTINE READR(F,MAXNOD,NNP)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------ TO READ AND AUTOMATIC GENERATE REAL NUMBERS.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION F(MAXNOD)
C
      NODES=0
  150 READ(15,*) NI,NSEQ,NAD,FNI,FAD,FRD
      IF(NI.EQ.0) GO TO 170
      NJ=NI+NSEQ
      DO 160 N=NI,NJ
      NODES=NODES+1
      I=NI+(N-NI)*NAD
      IF(FRD.NE.0.0) GO TO 155
      F(I)=FNI+FAD*DBLE(N-NI)
      GO TO 160
  155 I1=I-NAD
      IF(N.EQ.NI) F(I)=FNI
      IF(N.EQ.NI) DINC=1.0D0
      IF(N.GT.NI) DINC=DINC*(1.0D0+FRD)
      IF(N.GT.NI) F(I)=F(I1)+FAD*DINC
  160 CONTINUE
      GO TO 150
  170 IF(NODES.EQ.NNP) GO TO 180
      WRITE(16,1100)
      STOP
  180 IF(NNP.LE.MAXNOD) GO TO 190
      WRITE(16,1200)
      STOP
  190 CONTINUE
C
   40 FORMAT(3I5,5X,4D10.3)
 1100 FORMAT('1'/' ','*** ERROR IN EXECUTING READR SINCE NODES  .NE. ',
     1 'NNP:   STOP ***')
 1200 FORMAT('1'/' ','*** NNP .GT. MAXNOD  IN EXECUTING READR: STOP')
C
      RETURN
      END
      SUBROUTINE SURF(IGEOM,LRL,COORD,IE,DLCSB,ISB,NPBB)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO LOCATE BOUNDARY ELEMENT SIDES AND BOUNDARY NODAL POINTS
C ------- AND TO COMPUTE DIRECTIONAL COSINES AND LENGTH OF EACH
C ------- BOUNDARY ELEMENT SIDE.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /COUTP/ IITR,ICHNG,INTER,IBUG
C
      DIMENSION COORD(MAXNP,2),IE(MAXEL,9),LRL(MXKBD,MAXNP)
      DIMENSION DLCSB(3,MAXBES),ISB(5,MAXBES),NPBB(MAXBNP)
C
C ------- FIND SURFACE SIDES BY LOCATING NONDUPLICATED SIDES
C
      NBES=0
      NBNP=0
      DO 400 MI=1,NEL
      NQ=4
      IEM4=IE(MI,4)
      IF(IEM4.EQ.0) NQ=3
      DO 300 IQ=1,NQ
      IQ1=IQ+1
      IF(IQ.EQ.NQ) IQ1=1
      NI=IE(MI,IQ)
      NJ=IE(MI,IQ1)
      DO 120 MJ1=1,MXKBD
        MM1=LRL(MJ1,NI)
        IF(MM1.EQ.0)GOTO 120
        DO 110 MJ2=1,MXKBD
          MM2=LRL(MJ2,NJ)
          IF(MM2.EQ.0)GOTO 110
          IF(MM1.NE.MM2)GOTO 110
          IF(MM1.EQ.MI)GOTO 110
          IF(MM2.NE.MI)GOTO 300
  110   CONTINUE
  120 CONTINUE
C
      NBES=NBES+1
      ISB(5,NBES)=MI
      ISB(1,NBES)=NI
      ISB(2,NBES)=NJ
      ISB(3,NBES)=IQ
      ISB(4,NBES)=IQ1
      IF(NBES.EQ.1) THEN
        NBNP=NBNP+1
        NPBB(NBNP)=NI
        NBNP=NBNP+1
        NPBB(NBNP)=NJ
        GOTO 300
      ENDIF
      DO 230 I=1,NBNP
        IJ=NPBB(I)
        IF(IJ.EQ.NI) GO TO 260
  230 CONTINUE
      NBNP=NBNP+1
      NPBB(NBNP)=NI
  260 DO 280 J=1,NBNP
        IJ=NPBB(J)
        IF(IJ.EQ.NJ) GO TO 290
  280 CONTINUE
      NBNP=NBNP+1
      NPBB(NBNP)=NJ
  290 CONTINUE
  300 CONTINUE
  400 CONTINUE
C
C ------- CALCULATE SIDE LENGTH AND DIRECTION COSINES
C
      DO 590 MP=1,NBES
      NI=ISB(1,MP)
      NJ=ISB(2,MP)
      DX=COORD(NJ,1)-COORD(NI,1)
      DZ=COORD(NJ,2)-COORD(NI,2)
      DLCSB(3,MP)=DSQRT(DX*DX+DZ*DZ)
C
      BETA=DATAN2(DZ,DX)
      DLCSB(1,MP)=DSIN(BETA)
      DLCSB(2,MP)=-DCOS(BETA)
  590 CONTINUE
C
C ------- PRINT BOUNDARY SIDE INFORMATION
C
      IF(MOD(IGEOM,2).NE.0)THEN
        LINE=0
        DO 695 MP=1,NBES
          LINE=LINE+1
          IF(MOD(LINE-1,50).EQ.0) WRITE(16,6900)
          WRITE(16,6950) MP,ISB(5,MP),(ISB(I,MP),I=1,4),DLCSB(3,MP),
     1                   (DLCSB(I,MP),I=1,2)
  695   CONTINUE
      ENDIF
C
 6900 FORMAT('1'//10X,' *** COMPUTED BOUNDARY ELEMENT SIDE INFORMATIONS
     1 ***'//5X,
     2 '   MP    M  NP1  NP2 L1 L2  DLB(MP)   DCOSXB(MP) DCOSZB(MP) '/
     > 5X,' -----  --- ---  --- -- --  -------   ---------- ----------')
 6950 FORMAT(' ',4X,4I5,2I3,3(1PD11.3))
C
      RETURN
      END
      SUBROUTINE TDATIO
     I      (NSTR,DLCSB,ISB,IB,
     M       ITMITM,TIME,NPFG,NEFG,F,XPFG,YPFG,CPFG,MPLOC,ISE,NFGMB,
     O       CP, TSOSF,SOSF,ISTYP,LES,TWSSF,WSSF,IWTYP,NPW, TCCBF,CCBF,
     O       ICTYP,ISC,DLCSC,NPCB, TCNBF,CNBF,INTYP,ISN,DLCSN,NPNB,
     O       TCVBF,CVBF,IVTYP,ISV,DLCSV,NPVB,TCDBF,CDBF,IDTYP,NPDB)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO READ AND PRINT INPUT DATA NEEDED FOR TRANSPORT SIMULATION,
C ------- INCLUDING CONTROL INTEGER AND REAL NUMBERS, I.C. AND PRE-I.C.,
C ------- MICROBE-CHEMICAL INTERACTION CONSTANTS, ELEMENT AND WELL
C ------- SOURCE/SINKDS, AND FOUR TYPES OF BOUNDARY CONDITIONS, V.B.,
C ------- D.B., C.B., AND N.B.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      CHARACTER*1 DATNAM
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /SAZFM/ MXNPFG,MXKGL,MXKGLD,MXNEP,MXEPW,MXNPW,MXELW,MXNDB,
     >               mxnpww,mxelww
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
C
      COMMON /TICNT/ NITERt,NPITERt,KSTRt,KSSt,KVIT,MICONF
      COMMON /TRCNT/ TOLAt,TOLBt,Wt,WV,OMEt,OMIt,APHAG
      COMMON /TADP/ ADPEPS,ADPARM,DLINP,NXG,NYG,NXD,NYD,NXW,NYW,IZOOM,
     >              IDZOOM,IEPC,IDETQ
C
      COMMON /TELS/ MXSEL,MXSPR,MXSDP,NSEL,NSPR,NSDP,KSAI
      COMMON /TNPS/ MXWNP,MXWPR,MXWDP,NWNP,NWPR,NWDP,KWAI
C
      COMMON /TVBC/ MXVES,MXVNP,MXVPR,MXVDP,NVES,NVNP,NVPR,NVDP,KVAI
      COMMON /TCBC/ MXCNP,MXCES,MXCPR,MXCDP,NCNP,NCES,NCPR,NCDP,KCAI
      COMMON /TNBC/ MXNNP,MXNES,MXNPR,MXNDP,NNNP,NNES,NNPR,NNDP,KNAI
      COMMON /TDBC/ MXDNP,MXDPR,MXDDP,NDNP,NDPR,NDDP,KDAI
C
      COMMON /CHEM/ MXNCC,NCC
      COMMON /MICROB/ GRATE,YCOEFF,RTARDS,RTARDO,RTARDN,SCOEFF,
     >                ECOEFF,DCOEFF,SATURC,PCOEFF,COFK
C
      DIMENSION DLCSB(3,MAXBES),ISB(5,MAXBES),IB(MXADNP)
C
      DIMENSION F(MAXNP,2,MXNCC),XPFG(MXNPFG),YPFG(MXNPFG)
      DIMENSION CPFG(MXNPFG,MXNCC),MPLOC(MXNPFG),ISE(MXKGL,4)
      DIMENSION NFGMB(MAXEL)
C
      DIMENSION GRATE(4),YCOEFF(4),RTARDS(4),RTARDO(4),
     >          RTARDN(4),SCOEFF(4),ECOEFF(4),DCOEFF(4),SATURC(4),
     >          PCOEFF(4)
C
      DIMENSION TSOSF(MXSDP,MXSPR),SOSF(MXSDP,MXSPR,2)
      DIMENSION ISTYP(MXSEL,MXNCC),LES(MXSEL)
      DIMENSION TWSSF(MXWDP,MXWPR),WSSF(MXWDP,MXWPR,2)
      DIMENSION IWTYP(MXWNP,MXNCC),NPW(MXWNP)
C
      DIMENSION TCDBF(MXDDP,MXDPR),CDBF(MXDDP,MXDPR)
      DIMENSION IDTYP(MXDNP,MXNCC),NPDB(MXDNP)
C
      DIMENSION TCCBF(MXCDP,MXCPR),CCBF(MXCDP,MXCPR)
      DIMENSION ICTYP(MXCNP,MXNCC),ISC(5,MXCES),NPCB(MXCNP)
      DIMENSION DLCSC(3,MXCES)
C
      DIMENSION TCNBF(MXNDP,MXNPR),CNBF(MXNDP,MXNPR)
      DIMENSION INTYP(MXNNP,MXNCC),ISN(5,MXNES), DLCSN(3,MXNES)
      DIMENSION NPNB(MXNNP)
C
      DIMENSION TCVBF(MXVDP,MXVPR),CVBF(MXVDP,MXVPR)
      DIMENSION IVTYP(MXVES,MXNCC),NPVB(MXVNP)
      DIMENSION DLCSV(3,MXVES), ISV(5,MXVES)
      DIMENSION CP(MAXNP,MXNCC)
C
C ******* DATA SET 17: TRANSPORT INTEGER AND REAL NUMBER CONTROL
C
      READ(15,5)DATNAM
      PRINT *, 'DATNAM in TDATIO =', DATNAM
      READ(15,*) NITERt,NPITERt,KSTRt,KSSt,KVIT,MICONF
      WRITE(16,1000) NITERt,NPITERt,KSTRt,KSSt,KVIT,MICONF
      READ(15,*) TOLAt,TOLBt,Wt,WV,OMEt,OMIt,APHAG
      WRITE(16,1100) TOLAt,TOLBt,Wt,WV,OMEt,OMIt,APHAG
      READ(15,*)IZOOM,IDZOOM,IEPC,NXG,NYG,NXD,NYD,NXW,NYW,IDETQ
      WRITE(16,1150)IZOOM,IDZOOM,IEPC,NXG,NYG,NXD,NYD,NXW,NYW,IDETQ
      READ(15,*) ADPEPS,ADPARM
      DLINP=1.0D0
      WRITE(16,1200) ADPEPS,ADPARM,DLINP
C
C ******* DATA SET 18: INITIAL OR PRE-INITIAL CONDITIONS
C
      IF(NSTR.GT.0)THEN
        DO II=1,NSTR
          READ(12)ITMITM,TIME,NPFG,NEFG,((CP(N,K),N=1,NNP),((F(N,I,K),
     >            I=1,2),N=1,NNP),K=1,NCC)
          READ(12)(XPFG(N),YPFG(N),(CPFG(N,K),K=1,NCC),MPLOC(N),N=1,
     >             NPFG)
          READ(12)((ISE(N,J),J=1,4),N=1,NEFG),(NFGMB(N),N=1,NEL)
        ENDDO
      ELSE
        READ(15,5)DATNAM
        DO 420 K=1,NCC
          CALL READR(CP(1,K),MAXNP,NNP)
  420   CONTINUE
      ENDIF
C
C ******* DATA SET 19: MICROBE-CHEMICAL INTERACTION CONSTANTS
C
      READ(15,5)DATNAM
C
C ----- read maximum specific oxygen-based growth rate for microbe #1,
C -----      maximum specific nitrate-based growth rate for microbe #2,
C -----      maximum specific oxygen-based growth rate for microbe #3,
C ----- and  maximum specific nitrate-based growth rate for microbe #3
C
      READ(15,*) (GRATE(I),I=1,4)
C
C ----- read yield coefficient for microbe #1 utilizing oxygen,
C -----      yield coefficient for microbe #2 utilizing nitrate,
C -----      yield coefficient for microbe #3 utilizing oxygen,
C ----- and  yield coefficient for microbe #3 utilizing nitrate
C
      READ(15,*) (YCOEFF(I),I=1,4)
C
C ----- read retarded substrate saturation constant under aerobic
C            conditions w.r.t. microbes #1,
C            retarded substrate saturation constane under anaerobic
C            conditions w.r.t. microbes #2,
C            retarded substrate saturation constant under aerobic
C            conditions w.r.t. microbes #3,
C       and  retarded substrate saturation constant under anaerobic
C            conditions w.r.t. microbes #3
C
      READ(15,*) (RTARDS(I),I=1,4)
C
C ----- read retarded oxygen saturation constant under aerobic
C            conditions w.r.t. microbes #1,
C -----      retarded oxygen saturation constant under anaerobic
C            conditions w.r.t. microbes #2,
C -----      retarded oxygen saturation constant under aerobic
C            conditions w.r.t. microbes #3,
C ----- and  retarded oxygen saturation constant under anaerobic
C            conditions w.r.t. microbes #3
C
      READ(15,*) (RTARDO(I),I=1,4)
C
C ----- read retarded nutrient saturation constant under aerobic
C            conditions w.r.t. microbes #1,
C -----      retarded nutrient saturation constant under anaerobic
C            conditions w.r.t. microbes #2,
C -----      retarded nutrient saturation constant under aerobic
C            conditions w.r.t. microbes #3,
C ----- and  retarded nutrient saturation constant under anaerobic
C            conditions w.r.t. microbes #3
C
      READ(15,*) (RTARDN(I),I=1,4)
C
C ----- read oxygen-use coefficient for syntheses by microbes #1,
C -----      nitrate-use coefficient for syntheses by microbes #2,
C -----      oxygen-use coefficient for syntheses by microbes #3,
C ----- and  nitrate-use coefficient for syntheses by microbes #3
C
      READ(15,*) (SCOEFF(I),I=1,4)
C
C ----- read oxygen-use coefficient for energy by microbes #1,
C -----      nitrate-use coefficient for energy by microbes #2,
C -----      oxygen-use coefficient for energy by microbes #3,
C ----- and  nitrate-use coefficient for energy by microbes #3
C
      READ(15,*) (ECOEFF(I),I=1,4)
C
C ----- read microbial decay coefficient of aerobic respiration of
C            microbe #1,
C -----      microbial decay coefficient of anaerobic respiration of
C            microbe #2,
C -----      microbial decay coefficient of aerobic respiration of
C            microbe #3,
C ----- and  microbial decay coefficient of anaerobic respiration of
C            microbe #3
C
      READ(15,*) (DCOEFF(I),I=1,4)
C
C ----- read oxygen saturation constant for decay w.r.t. microbe #1,
C -----      nitrate saturation constant for decay w.r.t. microbe #2,
C -----      oxygen saturation constant for decay w.r.t. microbe #3,
C ----- and  nitrate saturation constant for decay w.r.t. microbe #3
C
      READ(15,*) (SATURC(I),I=1,4)
C
C ----- read nutrien-use coefficient for the production of microbe #1
C -----      with aerobic respiration,
C -----      nutrien-use coefficient for the production of microbe #2
C -----      with anaerobic respiration,
C -----      nutrien-use coefficient for the production of microbe #3
C -----      with aerobic respiration,
C ----- and  nutrien-use coefficient for the production of microbe #3
C -----      with anaerobic respiration
C
      READ(15,*) (PCOEFF(I),I=1,4)
C
C ----- read inhibition coefficint
C
      READ(15,*) COFK
C
C ----- write microbe-chemical interaction constant
C
      WRITE(16,4000)(GRATE(I),I=1,4),(YCOEFF(I),I=1,4),(RTARDS(I),
     >              I=1,4),(RTARDO(I),I=1,4),(RTARDN(I),I=1,4),
     >              (SCOEFF(I),I=1,4),(ECOEFF(I),I=1,4),(DCOEFF(I),
     >              I=1,4),(SATURC(I),I=1,4),(PCOEFF(I),I=1,4),COFK
C
C ******* DATA SET 20: ELEMENT (DISTRIBUTED) SOURCE/SINK
C
      READ(15,5)DATNAM
      READ(15,*) NSEL,NSPR,NSDP,KSAI
      IF(NSEL.NE.0) THEN
C
        WRITE(16,5300) NSEL,NSPR,NSDP
C
C ------- READ AND PRINT ELEMENTAL SOURCE PROFILES
C
          WRITE(16,5500)
          DO 510 I=1,NSPR
            READ(15,*) (TSOSF(J,I),(SOSF(J,I,II),II=1,2),J=1,NSDP)
            WRITE(16,5550) I
            WRITE(16,5560) (TSOSF(J,I),(SOSF(J,I,II),II=1,2),J=1,NSDP)
  510     CONTINUE
C
C ------- READ AND PRINT SOURCE ELEMENTS
C ------- READ SOURCE TYPE ASSIGNED TO EACH SOURCE ELEMENT.
C
        READ(15,*) (LES(MP),MP=1,NSEL)
        WRITE(16,5310)
        WRITE(16,5320) (MP,LES(MP),MP=1,NSEL)
C
        DO 520 K=1,NCC
          WRITE(16,5400) K
          CALL READN(ISTYP(1,K),MXSEL,NSEL)
          WRITE(16,5600)
          WRITE(16,5320) (MP,ISTYP(MP,K),MP=1,NSEL)
  520   CONTINUE
C
      ENDIF
C
C ******* DATA SET 21: WELL (POINT) SOURCE/SINK
C
      READ(15,5)DATNAM
      READ(15,*) NWNP,NWPR,NWDP,KWAI
      IF(NWNP.NE.0) THEN
        WRITE(16,5700) NWNP,NWPR,NWDP
C
C -------  READ AND WRITE WELL SOURCE/SINK PROFILES
C
          WRITE(16,5800)
          DO 580 I=1,NWPR
            READ(15,*) (TWSSF(J,I),(WSSF(J,I,II),II=1,2),J=1,NWDP)
            WRITE(16,5550) I
            WRITE(16,5560) (TWSSF(J,I),(WSSF(J,I,II),II=1,2),
     >                      J=1,NWDP)
  580     CONTINUE
C
C ------- READ AND PRINT WELL SOURCE/SINK NODES
C
        READ(15,*)(NPW(NP),NP=1,NWNP)
        WRITE(16,5710)
        WRITE(16,5320) (NP,NPW(NP),NP=1,NWNP)
C
C ------- PRINT WELL SOURCE/SINK TYPE ASSEIGNED TO EACH OF NWNP NODES
C
        DO 590 K=1,NCC
          CALL READN(IWTYP(1,K),MXWNP,NWNP)
          WRITE(16,5400) K
          WRITE(16,5900)
          WRITE(16,5320) (I,IWTYP(I,K),I=1,NWNP)
  590   CONTINUE
      ENDIF
C
C ******* DATA SET 22: VARIABLE BOUNDARY CONDITIONS
C
      READ(15,5)DATNAM
      READ(15,*) NVES,NVNP,NVPR,NVDP,KVAI
      IF(NVNP.GT.0) THEN
C
C ------- READ AND WRITE RUNIN CONCENTRATION PROFILES
C
        WRITE(16,6000) NVNP,NVES,NVPR,NVDP
          WRITE(16,6100)
          DO 610 I=1,NVPR
            READ(15,*) (TCVBF(J,I),CVBF(J,I),J=1,NVDP)
            WRITE(16,6150) I
            WRITE(16,5560) (TCVBF(J,I),CVBF(J,I),J=1,NVDP)
  610     CONTINUE
C
C ------- READ INCOMING CONCENTRATION TYPE ASSIGNED TO EACH OF VB SIDES
C
        DO 620 K=1,NCC
          WRITE(16,5400) K
          CALL READN(IVTYP(1,K),MXVES,NVES)
C
C ------- PRINT INCOMING CONCENTRATION TYPE ASSEIGNED TO EACH VB SIDES
C
          WRITE(16,6200)
          WRITE(16,5320) (I,IVTYP(I,K),I=1,NVES)
  620   CONTINUE
C
C ------- READ AND WRITE GLOBAL NODE NUMBER OF VB NODES
C
        CALL READN(NPVB,MXVNP,NVNP)
        WRITE(16,6300)
        WRITE(16,5320) (I,NPVB(I),I=1,NVNP)
C ------ ASSIGN BOUNDARY NODE INFORMATION TO IB ARRAY
        DO I=1,NVNP
          NP=NPVB(I)
          IB(NP)=2
        ENDDO
C
C ------- READ VARIABLE BOUNDARY ELEMENT SIDES
C
        MPI=0
  630   READ(15,*) MI,NSEQ,M,IS1,IS2,MIAD,MAD,IS1AD,IS2AD
        IF(MI.NE.0) THEN
          MJ=MI+NSEQ
          DO 635 MP=MI,MJ
            I=MI+(MP-MI)*MIAD
            ISV(5,I)=M+(MP-MI)*MAD
            ISV(1,I)=IS1+(MP-MI)*IS1AD
            ISV(2,I)=IS2+(MP-MI)*IS2AD
            MPI=MPI+1
  635     CONTINUE
          GO TO 630
        ENDIF
        IF(MPI.NE.NVES)  THEN
          WRITE(16,6500)
          STOP
        ENDIF
C
C ------- WRITE VARIABLE ELEMENT SIDES
C
        WRITE(16,6600)
        DO 660 MP=1,NVES,2
          NJMN=MP
          NJMX=MIN0(MP+1,NVES)
          WRITE(16,6650) (J,ISV(5,J),ISV(1,J),ISV(2,J),J=NJMN,NJMX)
  660   CONTINUE
C
C ------- DETERMINE DIRECTION COSINES DCOSXV(MP) AND DCOSZV(MP) FOR THE
C ------- VB BOUNDARY SIDES
C
        DO 690 MPI=1,NVES
          MI=ISV(5,MPI)
          DO 680 MPJ=1,NBES
            MJ=ISB(5,MPJ)
            IF(MJ.NE.MI) GO TO 680
            I=ISV(1,MPI)
            NI=NPVB(I)
            J=ISV(2,MPI)
            NJ=NPVB(J)
            NIB=ISB(1,MPJ)
            NJB=ISB(2,MPJ)
            IF((NIB.EQ.NI .AND. NJB.EQ.NJ) .OR.
     >         (NIB.EQ.NJ .AND. NJB.EQ.NI)) THEN
              IF(NIB.EQ.NJ .AND. NJB.EQ.NI) THEN
                ISV(1,MPI)=J
                ISV(2,MPI)=I
              ENDIF
              DO 675 JJ=3,4
                ISV(JJ,MPI)=ISB(JJ,MPJ)
  675         CONTINUE
              DLCSV(1,MPI)=DLCSB(1,MPJ)
              DLCSV(2,MPI)=DLCSB(2,MPJ)
              DLCSV(3,MPI)=DLCSB(3,MPJ)
              GO TO 690
            ENDIF
C
  680     CONTINUE
C
          WRITE(16,6800) MPI,I,J,NI,NJ,MI
C
  690   CONTINUE
C
C ------- PRINT COMPUTED VARIABLE ELEMENT SIDE INFORMATION
C
        LINE=0
        DO 695 MP=1,NVES
          LINE=LINE+1
          IF(MOD(LINE-1,50).EQ.0) WRITE(16,6900)
          WRITE(16,6950) MP,ISV(5,MP),(ISV(I,MP),I=1,4),DLCSV(3,MP),
     1                   DLCSV(1,MP),DLCSV(2,MP)
  695   CONTINUE
C
      ENDIF
C
C ******* DATA SET 23: DIRICHLET BOUNDARY CONDITIONS
C
      READ(15,5)DATNAM
      READ(15,*) NDNP,NDPR,NDDP,KDAI
      IF(NDNP.NE.0) THEN
C
C ------- READ AND PRINT DIRICHLET CONCENTRATION PROFILE
C
        WRITE(16,7000) NDNP,NDPR,NDDP
          WRITE(16,7100)
          DO 710 I=1,NDPR
            READ(15,*) (TCDBF(J,I),CDBF(J,I),J=1,NDDP)
            WRITE(16,7150) I
            WRITE(16,5560) (TCDBF(J,I),CDBF(J,I),J=1,NDDP)
  710     CONTINUE
C
C ------- READ TYPE OF DIRICHLET CONCENTRATION PROFILE ASSIGNED TO
C ------- TO DIRICHLET NODES.
C
        DO 730 K=1,NCC
          WRITE(16,5400) K
           CALL READN(IDTYP(1,K),MXDNP,NDNP)
C
C ------- PRINT PROFILE TYPES OF DIRICHLET NODES
C
          WRITE(16,7200)
          WRITE(16,5320) (J,IDTYP(J,K),J=1,NDNP)
  730   CONTINUE
C
C ------- READ AND PRINT GLOBAL NODE NUMBER OF DIRICHLET NODES
C
        CALL READN(NPDB,MXDNP,NDNP)
        WRITE(16,7300)
        WRITE(16,5320) (NP,NPDB(NP),NP=1,NDNP)
C
C ------ ASSIGN BOUNDARY NODE INFORMATION TO IB ARRAY
        DO I=1,NDNP
          NP=NPDB(I)
          IB(NP)=1
        ENDDO
C
      ENDIF
C
C ******* DATA SET 24: CAUCHY BOUNDARY CONDITIONS
C
      READ(15,5)DATNAM
      READ(15,*) NCES,NCNP,NCPR,NCDP,KCAI
      IF(NCES.NE.0) THEN
C
        WRITE(16,8000) NCES,NCNP,NCPR,NCDP
          WRITE(16,8100)
          DO I=1,NCPR
            READ(15,*) (TCCBF(J,I),CCBF(J,I),J=1,NCDP)
            WRITE(16,7150) I
            WRITE(16,5560) (TCCBF(J,I),CCBF(J,I),J=1,NCDP)
          ENDDO
C
        DO 810 K=1,NCC
          WRITE(16,5400) K
          CALL READN(ICTYP(1,K),MXCNP,NCNP)
C
C ------- PRINT PROFILE TYPE OF ALL CAUCHY NODES
C
          LINE=0
          DO 820 I=1,NCNP,3
          LINE=LINE+1
          IF(MOD(LINE-1,50).EQ.0) WRITE(16,8900)
          NJMN=I
          NJMX=MIN0(I+2,NCNP)
          WRITE(16,5320) (J,ICTYP(J,K),J=NJMN,NJMX)
  820     CONTINUE
  810   CONTINUE
C
C ------- READ GLOBAL NODAL NUMBER OF ALL CAUCHY NODES AND TYPE OF
C ------- CAUCHY FLUX PROFILE ASSIGNED TO EACH OF THEM
C
        CALL READN(NPCB,MXCNP,NCNP)
        WRITE(16,8300)
        WRITE(16,5320) (NP,NPCB(NP),NP=1,NCNP)
C
C ------ ASSIGN BOUNDARY NODE INFORMATION TO IB ARRAY
        DO I=1,NCNP
          NP=NPCB(I)
          IB(NP)=3
        ENDDO
C
C ------- READ CAUCHY BOUNDARY ELEMENT SIDES
C
        MPI=0
  830   READ(15,*) MI,NSEQ,M,IS1,IS2,MIAD,MAD,IS1AD,IS2AD
        IF(MI.EQ.0) GO TO 840
        MJ=MI+NSEQ
        DO 835 MP=MI,MJ
          I=MI+(MP-MI)*MIAD
          ISC(5,I)=M+(MP-MI)*MAD
          ISC(1,I)=IS1+(MP-MI)*IS1AD
          ISC(2,I)=IS2+(MP-MI)*IS2AD
          MPI=MPI+1
  835   CONTINUE
        GO TO 830
  840   IF(MPI.EQ.NCES) GO TO 850
        WRITE(16,8300)
        STOP
C
  850   CONTINUE
C
C ------- DETERMINE DIRECTION COSINES DCOSXV(MP) AND DCOSZV(MP) FOR THE
C ------- CB BOUNDARY SIDES
C
        DO 790 MPI=1,NCES
          MI=ISC(5,MPI)
          DO 780 MPJ=1,NBES
            MJ=ISB(5,MPJ)
            IF(MJ.NE.MI) GO TO 780
            I=ISC(1,MPI)
            NI=NPCB(I)
            J=ISC(2,MPI)
            NJ=NPCB(J)
            NIB=ISB(1,MPJ)
            NJB=ISB(2,MPJ)
            IF((NIB.EQ.NI .AND. NJB.EQ.NJ) .OR.
     >         (NIB.EQ.NJ .AND. NJB.EQ.NI)) THEN
              IF(NIB.EQ.NJ .AND. NJB.EQ.NI) THEN
                ISC(1,MPI)=J
                ISC(2,MPI)=I
              ENDIF
              DO 775 JJ=3,4
                ISC(JJ,MPI)=ISB(JJ,MPJ)
  775         CONTINUE
              DLCSC(1,MPI)=DLCSB(1,MPJ)
              DLCSC(2,MPI)=DLCSB(2,MPJ)
              DLCSC(3,MPI)=DLCSB(3,MPJ)
              GO TO 790
            ENDIF
C
  780     CONTINUE
C
          WRITE(16,7800) MPI,I,J,NI,NJ,MI
C
  790   CONTINUE
C
C ------- PRINT COMPUTED CAUCHY ELEMENT SIDE INFORMATION
C
        LINE=0
        DO 890 MP=1,NCES
          LINE=LINE+1
          IF(MOD(LINE-1,50).EQ.0) WRITE(16,8200)
          WRITE(16,6950) MP,ISC(5,MP),(ISC(I,MP),I=1,4),DLCSC(3,MP),
     1                   DLCSC(1,MP),DLCSC(2,MP)
  890   CONTINUE
      ENDIF
C
C ******* DATA SET 25:  NEUMANN BOUNDARY CONDITIONS
C
C ------- READ AND PRINT NEUMANN FLUX PROFILES
C
      READ(15,5)DATNAM
      READ(15,*) NNES,NNNP,NNPR,NNDP,KNAI
      IF(NNNP.NE.0) THEN
C
        WRITE(16,9000) NNES,NNNP,NNPR,NNDP
          WRITE(16,9100)
          DO I=1,NNPR
            READ(15,*) (TCNBF(J,I),CNBF(J,I),J=1,NNDP)
            WRITE(16,7150) I
            WRITE(16,5560) (TCNBF(J,I),CNBF(J,I),J=1,NNDP)
          ENDDO
C
C ------- ASSIGN TYPE OF NEUMANN FLUX PROFILE TO ALL NEUMANN NODES
C
        DO 910 K=1,NCC
          WRITE(16,5400) K
          CALL READN(INTYP(1,K),MXNNP,NNNP)
C
C ------- PRINT PROFILE TYPES OF NEUMANN NODES
C
          LINE=0
          DO 920 I=1,NNNP,3
            LINE=LINE+1
            IF(MOD(LINE-1,50).EQ.0) WRITE(16,9200)
            NJMN=I
            NJMX=MIN0(I+2,NNNP)
            WRITE(16,5320) (J,INTYP(J,K),J=NJMN,NJMX)
  920     CONTINUE
  910   CONTINUE
C
C ------- READ GLOBAL NODAL NUMBER OF ALL NEUMANN NODES
C
        CALL READN(NPNB,MXNNP,NNNP)
        WRITE(16,9300)
        WRITE(16,5320) (NP,NPNB(NP),NP=1,NNNP)
C
        DO NP=1,NNNP
          NPN=NPNB(NP)
          IB(NPN)=4
        ENDDO
C
C ------- READ NEUMANN BOUNDARY ELEMENT SIDES
C
        MPI=0
  930   READ(15,*) MI,NSEQ,M,IS1,IS2,MIAD,MAD,IS1AD,IS2AD
        IF(MI.EQ.0) GO TO 940
        MJ=MI+NSEQ
        DO 935 MP=MI,MJ
          I=MI+(MP-MI)*MIAD
          ISN(5,I)=M+(MP-MI)*MAD
          ISN(1,I)=IS1+(MP-MI)*IS1AD
          ISN(2,I)=IS2+(MP-MI)*IS2AD
          MPI=MPI+1
  935   CONTINUE
        GO TO 930
  940   IF(MPI.EQ.NNES) GO TO 950
        WRITE(16,9300)
        STOP
C
  950   CONTINUE
C
C ------- COMPUTE LENGTH AND DIRECTIONAL COSINES OF ALL NEUMANN
C ------- BOUNDARY ELEMENT SIDES
C
        DO 990 MPI=1,NNES
          MI=ISN(5,MPI)
          DO 980 MPJ=1,NBES
            MJ=ISB(5,MPJ)
            IF(MJ.NE.MI) GO TO 980
            I=ISN(1,MPI)
            NI=NPNB(I)
            J=ISN(2,MPI)
            NJ=NPNB(J)
            NIB=ISB(1,MPJ)
            NJB=ISB(2,MPJ)
            IF(NIB.EQ.NI .AND. NJB.EQ.NJ) GO TO 970
            IF(NIB.EQ.NJ .AND. NJB.EQ.NI) GO TO 965
            GO TO 980
C
  965       ISN(1,MPI)=J
            ISN(2,MPI)=I
  970       DO 975 JJ=3,4
  975       ISN(JJ,MPI)=ISB(JJ,MPJ)
            DLCSN(1,MPI)=DLCSB(1,MPJ)
            DLCSN(2,MPI)=DLCSB(2,MPJ)
            DLCSN(3,MPI)=DLCSB(3,MPJ)
            GO TO 990
C
  980     CONTINUE
          WRITE(16,9800) MPI,I,J,NI,NJ,MI
  990   CONTINUE
C
C ------- PRINT THE COMPUTED NEUMANN BOUNDARY ELEMENT SIDE INFORMATION
C
        LINE=0
        DO 995 MP=1,NNES
          LINE=LINE+1
          IF(MOD(LINE-1,50).EQ.0) WRITE(16,9900)
           WRITE(16,6950) MP,ISN(5,MP),(ISN(I,MP),I=1,4),DLCSN(3,MP),
     >                    DLCSN(1,MP),DLCSN(2,MP)
  995   CONTINUE
      ENDIF
      RETURN
C
    5 FORMAT(A1)
   10 FORMAT(16I5)
   20 FORMAT(8D10.0)
C
 1000 FORMAT(//'1   **** CHEMICAL INTEGER AND REAL NUMBER CONTROL ****',
     1 /5X,' NO. OF ITERATIONS TO SOLVE NONLINEAR EQ',I5/ 5X,
     2 ' NO. OF POINTWISE ITERATIONS ALLOWED .  ',I5/ 5X,
     3 ' AUXILIARY STORAGE CONTROL . . . . . . .',I5/ 5X,
     4 ' STEADY-STATE CONTROL. . . . . . . . . .',I5/ 5X,
     5 ' VELOCITY INPUT CONTROL. . . . . . . . .',I5/ 5X,
     6 ' INDEX OF MICRO. CONFIGURATION . . . . .',I5/)
 1100 FORMAT('0'//5X,
     1 ' ERROR ALLOWANCE FOR STEADY STATE SOL. .',1PD15.6/ 5X,
     2 ' ERROR ALLOWANCE FOR TRANSIENT SOL. . . ',1PD15.6/ 5X,
     3 ' TIME-INTEGRATION PARAMETER  . . . . . .',1PD15.6/ 5X,
     4 ' TIME-INTEGRATION PARAMETER FOR V-TERM  ',1PD15.6/ 5X,
     5 ' RELAXATION PARAMETER FOR NONLINEAR EQ..',1PD15.6/ 5X,
     6 ' RELAXATION PARAMETER FOR POINTWISE SOL.',1PD15.6/ 5X,
     7 ' GIVEN UPSTREAM WEIGHTING FACTOR . . . .',1PD15.6/)
 1150 FORMAT('0'//5X,
     > 'INCOORPERATING FINE GRIDS? IZOOM . . . . . . . . . ',I3/5X,
     > 'USING FINE GRIDS TO SOLVE MATRIX EQ.? IDZOOM . . . ',I3/5X,
     > 'CAPTURING EPCOF POINTS? IEPC . . . . . . . . . . . ',I3/5X,
     > 'THE NUMBER OF REFINED GRIDS IN X-DIRECTION, NXG. . ',I3/5X,
     > 'THE NUMBER OF REFINED GRIDS IN Y-DIRECTION, NYG  . ',I3/5X,
     > 'THE NUMBER OF REF. DIFF. GRIDS IN X-DIRECTION,NXD .',I3/5X,
     > 'THE NUMBER OF REF. DIFF. GRIDS IN Y-DIRECTION,NYD .',I3/5X,
     > 'THE NUMBER OF REF. WORKING GRIDS IN X-DIRECTION,NXW',I3/5X,
     > 'THE NUMBER OF REF. WORKING GRIDS IN Y-DIRECTION,NYW',I3/5X,
     > 'THE INDEX FOR TRACKING VELOCITY, IDETQ  . . . . . .',I3/)
 1200 FORMAT('0'//5X,
     > 'ADAPTATION EPSILON, ADPEPS  . . . . . . . . . . . .',1PD11.4/5X,
     > 'ADAPTATION PARAMETER, ADPARM  . . . . . . . . . . .',1PD11.4/5X,
     > 'THE REFERENCE LENGTH FOR REGULAR REFINEMENT, DLINP ',1PD11.4)
 1600 FORMAT('1'//5X,'****  LIST OF NODE PRINT INDICATOR ****'//5X,
     1 10(' NODE IP  ')/5X,10(' ---- --  ')/)
 4000 FORMAT(//'1  **** MICROBE-CHEMICAL INTERACTION CONSTANTS ****'/
     >     10X,'MICROBE#1   MICROBE#2   MICROBE#3   MICROBE#3'/
     >     10X,'---------   ---------   ---------   ---------'/
     >     ' GRATE',4X,4(1PD9.3,3X)/' YCOEFF',3X,4(1PD9.3,3X)/
     >     ' RTARDS',3X,4(1PD9.3,3X)/' RTARDO',3X,4(1PD9.3,3X)/
     >     ' RTARDN',3X,4(1PD9.3,3X)/' SCOEFF',3X,4(1PD9.3,3X)/
     >     ' ECOEFF',3X,4(1PD9.3,3X)/' DCOEFF',3X,4(1PD9.3,3X)/
     >     ' SATURC',3X,4(1PD9.3,3X)/' PCOEFF',3X,4(1PD9.3,3X)/
     >     ' COFK',5X,1PD9.3)
 5300 FORMAT('1'/1X,' *** ELEMENT SOURCE INFORMATION:  NSEL =',I3,
     1 ',  NSPR =',I3,',  NSDP =',I3)
 5310 FORMAT('0'/5X,' --- ELEMENT NUMBER OF SOURCE/SINK ELEMENT ---'//
     1 5X,8('   MP MSEL  ')/5X,8('   -- ----  '))
 5320 FORMAT(5X,2I5,2X,2I5,2X,2I5,2X,2I5,2X,2I5,2X,2I5)
 5400 FORMAT('0'//' ',' *** FOR CHEMICAL NO.',I2,' ***')
 5500 FORMAT('0'/5X,' --- ELEMENT SOURCE/SINK PROFILES ---')
 5550 FORMAT('0',10X,' PROFILE NO.',I2,//15X,
     1 3(4X,'TIME',4X,'SOURCE',2X)/15X,3(4X,'----',4X,'------',2X))
 5560 FORMAT(' ',15X,6(1PD10.3))
 5600 FORMAT('0'/5X,' --- SOURCE TYPE ASSIGNED TO ELEMENT ---'//5X,
     1 6('   MP STYP  ')/5X,6('   -- ----  '))
 5700 FORMAT('1'///5X,' *** WELL SOURCE/SINK INFORMATION:  NWNP =',I5,
     1 ','/40x,' NWPR =',I5,',   NWDP =',I5)
 5710 FORMAT('0'/5X,' --- NODE NUMBER OF WELL SOURCE/SINK ---'//5X,
     1 6('   NP  NPW  ')/5X,6('   --  ---  '))
 5800 FORMAT('0'//5X,' --- WELL SOURCE/SINK PROFILES ---')
 5900 FORMAT('0'//5X,' --- SOURCE/SINK TYPE ASSIGNED TO WELL NODES'//
     1 5X,6('   NP STYP  ')/5X,6('   -- ----  '))
 6000 FORMAT('1'/1X,' **** VARIABLE BOUNDARY CONDITIONS:  NVNP =',I5,
     1 ',   NVES =',I5,',   NVPR =',I5/35X,'   NVDP =',I5)
 6100 FORMAT('0'//5X,
     1 ' --- INCOMING FLUID CONCENTRATION PROFILE ---')
 6150 FORMAT('0'/5X,' PROFILE NO.',I2//15X,
     1 3(4X,'TIME',4X,'  CIN ',2X)/15X,3(4X,'----',4X,'  --- ',2X))
 6200 FORMAT('0'//5X,' --- TYPE OF FLOW-IN CONCENTRATION ---'//5X,
     1 6('   MP CTYP  ')/5X,6('   -- ----  '))
 6300 FORMAT('0'/10X,' --- LIST OF VB-NODAL POINTS ---'//5X,
     1 6('   NP NPVB  ')/5X,6('   -- ----  '))
 6500 FORMAT('1'/5X,' ERROR IN READING RS-ELEMENT-SIDES')
 6600 FORMAT('0'///5X,' --- RS ELEMENT-SIDES INFORMATION ---'//6X,
     1 2('SIDE   ELEMENT   NODE1   NODE2      ')/6X,
     > 2('----   -------   -----   -----      '))
 6650 FORMAT(' ',6X,2(I3,5X,I5,3X,I4,3X,I4,5X))
 6800 FORMAT('0',5X,I5,'-TH RS SIDE IS NOT ONE OF THE BOUNDARY SIDES; I,
     1 J,NI,NJ,MI ='/25X,5I5)
 6900 FORMAT('1'//1X,' *** COMPUTED RAINFALL SEEPAGE ELEMENT SIDE INFORM
     1ATION ***'//5X,
     2 '   MP    M  NP1  NP2 L1 L2   DL(MP)  DCOSX(MP)  DCOSZ(MP)'/5X,
     > '   --    -  ---  --- -- --   ------  ---------  ---------')
 6950 FORMAT(' ',4X,4I5,2I3,3(1PD11.3),1X)
 7000 FORMAT('1'/1X,' **** DIRICHLET BOUNDARY CONDITIONS:  NDNP =',I5,
     1 ',   NDPR =',I5,',   NDDP =',I5)
 7100 FORMAT('0'//5X,' --- DIRICHLET CONCENTRATION PROFILES ---')
 7150 FORMAT('0'/10X,' PROFILE NO.',I2//15X,
     1 3(4X,'TIME',4X,' DCON ',2X)/15X,3(4X,'----',4X,' ---- ',2X))
 7200 FORMAT('0'//5X,' --- CONCENTRATION TYPE OF DIRICHLET NODES'//5X,
     1 6('   NP DTYP  ')/5X,6('   -- ----  '))
 7300 FORMAT('0'//5X,' --- NODE NUMBER OF DIRICHLET NODES'//5X,
     1 6('   NP NPDB  ')/5X,6('   -- ----  '))
C
 7800 FORMAT('0',5X,I5,'-TH CS SIDE IS NOT ONE OF THE BOUNDARY SIDES; I,
     1 J,NI,NJ,MI =',5I5)
C
 8000 FORMAT('1'/1X,' **** DIRICHLET BOUNDARY CONDITIONS:  NDNP =',I5,
     1 ',   NDPR =',I5,',   NDDP =',I5)
 8100 FORMAT('0'//5X,' --- CAUCHY CONCENTRATION PROFILES ---')
 8200 FORMAT('1'//1X,' *** COMPUTED CAUCHY ELEMENT SIDE INFORMATION ***'
     > //5X,'   MP    M  NP1  NP2 L1 L2   DL(MP)  DCOSX(MP)  DCOSZ(MP)')
 8300 FORMAT('0'/10X,' --- LIST OF CB-NODAL POINTS ---'//5X,
     1 6('   NP NPCB  ')/5X,6('   -- ----  '))
 8900 FORMAT('0'//5X,' --- CONCENTRATION TYPE OF NEUMANN NODES'//5X,
     1 6('   NP CTYP  ')/5X,6('   -- ----  '))
 8950 FORMAT(' ',4X,4(3I5,3X))
 9000 FORMAT('1'/1X,' **** NEUMANN BOUNDARY CONDITIONS:  NNES =',I5,
     1 ',   NNNP =',I5,',   NNPR =',I5/35X,'NNDP=',I5)
 9100 FORMAT('0'//5X,' --- NEUMANN CONCENTRATION PROFILES ---')
 9200 FORMAT('0'//5X,' --- CONCENTRATION TYPE OF NEUMANN NODES'//5X,
     1 6('   NP NTYP  ')/5X,6('   -- ----  '))
 9300 FORMAT('0'//5X,' --- NODE NUMBER OF NEUMANN NODES'//5X,
     1 6('   NP NPNB  ')/5X,6('   -- ----  '))
 9600 FORMAT('0'//10X,' NEUMANN ELEMENT SIDE DATA'//5X,
     1 3('   MP    M CNP1 CNP2  ')/5X,3('   --   - ---- ----  '))
 9800 FORMAT('0',5X,I5,'-TH NEUMANN SIDE IS NOT ONE OF THE BOUNDARY SI',
     1 'DES; I,J,NI,NJ,MI =',5I5)
 9900 FORMAT('1'//10X,'*** COMPUTED NEUMANN ELEMENT SIDE INFORMATION',
     1 ' ***'//5X,'   MP    M CNP1 CNP2 L1 L2  DL(MP)   DCOSXN(MP)',
     2 ' DCOSZN(MP) '/5X,'   --   - ---- ---- -- --  ------   ',
     > '---------- ---------- ')
      END
      SUBROUTINE ESSFCT(PR,TPRF,PRF,T,MXPR,MXDP,NPR,NDP,KANALY)
C
C ------- FIND PROFILE VALUE AT TIME T EITHER BY TABLUR INTERPORATION
C ------- OR BY ANALYTICAL EXPRESSION.  FOR THE LATTER CASE, THE USER
C ------- MUST SUPPLY THE FUNCTION AFTER LINE ESSF 175
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION PR(MXPR),TPRF(MXDP,MXPR),PRF(MXDP,MXPR)
C
      IF(KANALY.EQ.1) GO TO 200
C
C ------- THE PROFILE VALUE IS OBTAINED BY INTERPOLATION OF THE INPUT
C ------- TABULAR VALUES
C
      DO 160 I=1,NPR
      DO 140 J=2,NDP
      IF(TPRF(J-1,I).LE.T .AND. T.LE.TPRF(J,I)) GO TO 120
      GO TO 140
  120 RFJM1=PRF(J-1,I)
      TRFJM1=TPRF(J-1,I)
      RFJ=PRF(J,I)
      TRFJ=TPRF(J,I)
      ABC=RFJ-RFJM1
      ABCD=TRFJ-TRFJM1
      PR(I)=RFJM1+(T-TRFJM1)*ABC/ABCD
      GO TO 160
  140 CONTINUE
      PR(I)=0.0
  160 CONTINUE
      RETURN
C
C ------- PROFILE VALUE IS OBTAINED ANALYTICALLY, THE USER MUST SUPPLY
C ------- THE FUNCTION.
C
  200 DO 260 I=1,NPR
      A1=PRF(1,I)
      A2=PRF(2,I)
      A3=PRF(3,I)
      A4=PRF(4,I)
      A5=PRF(5,I)
      PR(I)=A1 + A2*T + A3*T*T + A4*T*T*T + A5*T*T*T*T
  260 CONTINUE
C
      RETURN
      END
      SUBROUTINE WSSFCT(PR,TPRF,PRF,T,MXPR,MXDP,NPR,NDP,KANALY)
C
C ------- FIND PROFILE VALUE AT TIME T EITHER BY TABLUR INTERPORATION
C ------- OR BY ANALYTICAL EXPRESSION.  FOR THE LATTER CASE, THE USER
C ------- MUST SUPPLY THE FUNCTION AFTER LINE WSSF 175
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION PR(MXPR),TPRF(MXDP,MXPR),PRF(MXDP,MXPR)
C
      IF(KANALY.EQ.1) GO TO 200
C
C ------- THE PROFILE VALUE IS OBTAINED BY INTERPOLATION OF THE INPUT
C ------- TABULAR VALUES
C
      DO 160 I=1,NPR
      DO 140 J=2,NDP
      IF(TPRF(J-1,I).LE.T .AND. T.LE.TPRF(J,I)) GO TO 120
      GO TO 140
  120 RFJM1=PRF(J-1,I)
      TRFJM1=TPRF(J-1,I)
      RFJ=PRF(J,I)
      TRFJ=TPRF(J,I)
      ABC=RFJ-RFJM1
      ABCD=TRFJ-TRFJM1
      PR(I)=RFJM1+(T-TRFJM1)*ABC/ABCD
      GO TO 160
  140 CONTINUE
      PR(I)=0.0
  160 CONTINUE
      RETURN
C
C ------- PROFILE VALUE IS OBTAINED ANALYTICALLY, THE USER MUST SUPPLY
C ------- THE FUNCTION.
C
  200 DO 260 I=1,NPR
      A1=PRF(1,I)
      A2=PRF(2,I)
      A3=PRF(3,I)
      A4=PRF(4,I)
      A5=PRF(5,I)
      PR(I)=A1 + A2*T + A3*T*T + A4*T*T*T + A5*T*T*T*T
  260 CONTINUE
C
      RETURN
      END
      SUBROUTINE DBVFCT(PR,TPRF,PRF,T,MXPR,MXDP,NPR,NDP,KANALY)
C
C ------- FIND PROFILE VALUE AT TIME T EITHER BY TABLUR INTERPORATION
C ------- OR BY ANALYTICAL EXPRESSION.  FOR THE LATTER CASE, THE USER
C ------- MUST SUPPLY THE FUNCTION AFTER LINE DBVF 175
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION PR(MXPR),TPRF(MXDP,MXPR),PRF(MXDP,MXPR)
C
      IF(KANALY.EQ.1) GO TO 200
C
C ------- THE PROFILE VALUE IS OBTAINED BY INTERPOLATION OF THE INPUT
C ------- TABULAR VALUES
C
      DO 160 I=1,NPR
      DO 140 J=2,NDP
      IF(TPRF(J-1,I).LE.T .AND. T.LE.TPRF(J,I)) GO TO 120
      GO TO 140
  120 RFJM1=PRF(J-1,I)
      TRFJM1=TPRF(J-1,I)
      RFJ=PRF(J,I)
      TRFJ=TPRF(J,I)
      ABC=RFJ-RFJM1
      ABCD=TRFJ-TRFJM1
      PR(I)=RFJM1+(T-TRFJM1)*ABC/ABCD
      GO TO 160
  140 CONTINUE
      PR(I)=0.0
  160 CONTINUE
      RETURN
C
C ------- PROFILE VALUE IS OBTAINED ANALYTICALLY, THE USER MUST SUPPLY
C ------- THE FUNCTION.
C
  200 DO 260 I=1,NPR
      A1=PRF(1,I)
      A2=PRF(2,I)
      A3=PRF(3,I)
      A4=PRF(4,I)
      A5=PRF(5,I)
      PR(I)=A1 + A2*T + A3*T*T + A4*T*T*T + A5*T*T*T*T
  260 CONTINUE
C
      RETURN
      END
      SUBROUTINE VBVFCT(PR,TPRF,PRF,T,MXPR,MXDP,NPR,NDP,KANALY)
C
C ------- FIND PROFILE VALUE AT TIME T EITHER BY TABLUR INTERPORATION
C ------- OR BY ANALYTICAL EXPRESSION.  FOR THE LATTER CASE, THE USER
C ------- MUST SUPPLY THE FUNCTION AFTER LINE VBVF 175
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION PR(MXPR),TPRF(MXDP,MXPR),PRF(MXDP,MXPR)
C
      IF(KANALY.EQ.1) GO TO 200
C
C ------- THE PROFILE VALUE IS OBTAINED BY INTERPOLATION OF THE INPUT
C ------- TABULAR VALUES
C
      DO 160 I=1,NPR
      DO 140 J=2,NDP
      IF(TPRF(J-1,I).LE.T .AND. T.LE.TPRF(J,I)) GO TO 120
      GO TO 140
  120 RFJM1=PRF(J-1,I)
      TRFJM1=TPRF(J-1,I)
      RFJ=PRF(J,I)
      TRFJ=TPRF(J,I)
      ABC=RFJ-RFJM1
      ABCD=TRFJ-TRFJM1
      PR(I)=RFJM1+(T-TRFJM1)*ABC/ABCD
      GO TO 160
  140 CONTINUE
      PR(I)=0.0
  160 CONTINUE
      RETURN
C
C ------- PROFILE VALUE IS OBTAINED ANALYTICALLY, THE USER MUST SUPPLY
C ------- THE FUNCTION.
C
  200 DO 260 I=1,NPR
      A1=PRF(1,I)
      A2=PRF(2,I)
      A3=PRF(3,I)
      A4=PRF(4,I)
      A5=PRF(5,I)
      PR(I)=A1 + A2*T + A3*T*T + A4*T*T*T + A5*T*T*T*T
  260 CONTINUE
C
      RETURN
      END
      SUBROUTINE CBVFCT(PR,TPRF,PRF,T,MXPR,MXDP,NPR,NDP,KANALY)
C
C ------- FIND PROFILE VALUE AT TIME T EITHER BY TABLUR INTERPORATION
C ------- OR BY ANALYTICAL EXPRESSION.  FOR THE LATTER CASE, THE USER
C ------- MUST SUPPLY THE FUNCTION AFTER LINE CBVF 175
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION PR(MXPR),TPRF(MXDP,MXPR),PRF(MXDP,MXPR)
C
      IF(KANALY.EQ.1) GO TO 200
C
C ------- THE PROFILE VALUE IS OBTAINED BY INTERPOLATION OF THE INPUT
C ------- TABULAR VALUES
C
      DO 160 I=1,NPR
      DO 140 J=2,NDP
      IF(TPRF(J-1,I).LE.T .AND. T.LE.TPRF(J,I)) GO TO 120
      GO TO 140
  120 RFJM1=PRF(J-1,I)
      TRFJM1=TPRF(J-1,I)
      RFJ=PRF(J,I)
      TRFJ=TPRF(J,I)
      ABC=RFJ-RFJM1
      ABCD=TRFJ-TRFJM1
      PR(I)=RFJM1+(T-TRFJM1)*ABC/ABCD
      GO TO 160
  140 CONTINUE
      PR(I)=0.0
  160 CONTINUE
      RETURN
C
C ------- PROFILE VALUE IS OBTAINED ANALYTICALLY, THE USER MUST SUPPLY
C ------- THE FUNCTION.
C
  200 DO 260 I=1,NPR
      A1=PRF(1,I)
      A2=PRF(2,I)
      A3=PRF(3,I)
      A4=PRF(4,I)
      A5=PRF(5,I)
      PR(I)=A1 + A2*T + A3*T*T + A4*T*T*T + A5*T*T*T*T
  260 CONTINUE
C
      RETURN
      END
      SUBROUTINE NBVFCT(PR,TPRF,PRF,T,MXPR,MXDP,NPR,NDP,KANALY)
C
C ------- FIND PROFILE VALUE AT TIME T EITHER BY TABLUR INTERPORATION
C ------- OR BY ANALYTICAL EXPRESSION.  FOR THE LATTER CASE, THE USER
C ------- MUST SUPPLY THE FUNCTION AFTER LINE NBVF 175
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION PR(MXPR),TPRF(MXDP,MXPR),PRF(MXDP,MXPR)
C
      IF(KANALY.EQ.1) GO TO 200
C
C ------- THE PROFILE VALUE IS OBTAINED BY INTERPOLATION OF THE INPUT
C ------- TABULAR VALUES
C
      DO 160 I=1,NPR
      DO 140 J=2,NDP
      IF(TPRF(J-1,I).LE.T .AND. T.LE.TPRF(J,I)) GO TO 120
      GO TO 140
  120 RFJM1=PRF(J-1,I)
      TRFJM1=TPRF(J-1,I)
      RFJ=PRF(J,I)
      TRFJ=TPRF(J,I)
      ABC=RFJ-RFJM1
      ABCD=TRFJ-TRFJM1
      PR(I)=RFJM1+(T-TRFJM1)*ABC/ABCD
      GO TO 160
  140 CONTINUE
      PR(I)=0.0
  160 CONTINUE
      RETURN
C
C ------- PROFILE VALUE IS OBTAINED ANALYTICALLY, THE USER MUST SUPPLY
C ------- THE FUNCTION.
C
  200 DO 260 I=1,NPR
      A1=PRF(1,I)
      A2=PRF(2,I)
      A3=PRF(3,I)
      A4=PRF(4,I)
      A5=PRF(5,I)
      PR(I)=A1 + A2*T + A3*T*T + A4*T*T*T + A5*T*T*T*T
  260 CONTINUE
C
      RETURN
      END
