C ********************************************************************
C *                                                                  *
C *                        2DFATMIC                                  *
C *                                                                  *
C ********************************************************************
C
C   Cheng, J. R., G. T. Yeh, and T. E. Short.  1995.  "2DFATMIC: Users'
C     Manual of a Two-Dimensional Subsurface Flow, Fate and Transport
C     of Microbes and Chemicals.  EPA/***/****, Department of Civl and
C     Environmental Engineering, The Pennsylvania State University,
C     University Park, PA 16802.
C
C   For any question, please contact Prof. G. T. Yeh at (814) 863-2931
C
C
C     4/12/95    (Cauchy & Neumann in Transport are nodal basis)
C
C ---- New tracking scheme, composing the whole region of interest by
C      "slave point" concept on the boundary between rough and smooth
C      regions, which means the points on the boundary between IE(M,7)
C      = -1 and IE(M,7)=0.
C
C ------  MAIN PROGRAM OF 2DFATMIC
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO DEFINE ARRAY SIZES AND PASS THE CONTROL TO HTMICH
C
C********1*********2*********3*********3*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
C ******* Parameter Specification for Example 1
C
c     PARAMETER(MAXELK=40,MAXNPK=82,MXBESK=82,MXBNPK= 82,MAXBWK=7)
c     PARAMETER(MXJBDK=9,MXKBDK=4,MXADNK=MAXNPK+1)
c     PARAMETER(MXMATK=1,MXSPPK=4,MXMPPK=10)
c     PARAMETER(MXNTIK=44,MXNDTK=3)
C
c     PARAMETER(MXSELF=1,MXSPRF=1,MXSDPF=1,MXWNPF=1,MXWPRF=1,MXWDPF=1)
c     PARAMETER(MXCNPF=1,MXCESF=1,MXCPRF=1,MXCDPF=1)
c     PARAMETER(MXNNPF=1,MXNESF=1,MXNPRF=1,MXNDPF=1)
c     PARAMETER(MXRESF=1,MXRNPF=2,MXRPRF=1,MXRDPF=4)
c     PARAMETER(MXDNPF=2,MXDPRF=1,MXDDPF=2)
C
c     PARAMETER(MXSELT=1,MXSPRT=1,MXSDPT=1,MXWNPT=1,MXWPRT=1,MXWDPT=1)
c     PARAMETER(MXCNPT=1,MXCEST=1,MXCPRT=1,MXCDPT=1)
c     PARAMETER(MXNNPT=1,MXNEST=1,MXNPRT=1,MXNDPT=1)
c     PARAMETER(MXVEST=1,MXVNPT=1,MXVPRT=1,MXVDPT=1)
c     PARAMETER(MXDNPT=1,MXDPRT=1,MXDDPT=1)
C
c     PARAMETER(MXNCCK=1)
C
c     PARAMETER(MXKGLDK=1,MXLSVK=1,MXMSVK=1,MXNDBK=1)
c     PARAMETER(MXNEPK=1,MXEPWK=1)
c     PARAMETER(MXNPWK=1,MXELWK=1,MXNPWS=1,MXELWS=1)
c     PARAMETER(MXNPFGK=1,MXKGLK=1)
C
C ******* Parameter Specification for Example 2
C
c      PARAMETER(MAXELK=100,MAXNPK=202,MXBESK=202,MXBNPK= 202,MAXBWK=11)
c      PARAMETER(MXJBDK=11,MXKBDK=4,MXADNK=MAXNPK+3000)
c      PARAMETER(MXMATK=1,MXSPPK=4,MXMPPK=10)
c      PARAMETER(MXNTIK= 80,MXNDTK=3)
C
c      PARAMETER(MXSELF=1,MXSPRF=1,MXSDPF=1,MXWNPF=1,MXWPRF=1,MXWDPF=1)
c      PARAMETER(MXCNPF=1,MXCESF=1,MXCPRF=1,MXCDPF=1)
c      PARAMETER(MXNNPF=1,MXNESF=1,MXNPRF=1,MXNDPF=1)
c      PARAMETER(MXRESF=1,MXRNPF=1,MXRPRF=1,MXRDPF=1)
c      PARAMETER(MXDNPF=1,MXDPRF=1,MXDDPF=1)
C
c      PARAMETER(MXSELT=1,MXSPRT=1,MXSDPT=1,MXWNPT=1,MXWPRT=1,MXWDPT=1)
c      PARAMETER(MXCNPT=1,MXCEST=1,MXCPRT=1,MXCDPT=1)
c      PARAMETER(MXNNPT=1,MXNEST=1,MXNPRT=1,MXNDPT=1)
c      PARAMETER(MXVEST=1,MXVNPT=2,MXVPRT=1,MXVDPT=2)
c      PARAMETER(MXDNPT=2,MXDPRT=6,MXDDPT=2)
C
c      PARAMETER(MXNCCK=7)
C
c      PARAMETER(MXKGLDK=3000,MXLSVK=1,MXMSVK=1,MXNDBK=1200)
c      PARAMETER(MXNEPK=1,MXEPWK=1)
c      PARAMETER(MXNPWK=36,MXELWK=25,MXNPWS=36,MXELWS=25)
c      PARAMETER(MXNPFGK=35000,MXKGLK=14000)
C
C ******* Parameter Specification for Example 3
C
c      PARAMETER(MAXELK=224,MAXNPK=255,MXBESK=60,MXBNPK=60,MAXBWK=33)
c      PARAMETER(MXJBDK=17,MXKBDK=4,MXADNK=MAXNPK+4200)
c      PARAMETER(MXMATK=8,MXSPPK=2,MXMPPK=10)
c      PARAMETER(MXNTIK=80,MXNDTK=3)
C
c      PARAMETER(MXSELF=1,MXSPRF=1,MXSDPF=1,MXWNPF=2,MXWPRF=2,MXWDPF=3)
c      PARAMETER(MXCNPF=1,MXCESF=1,MXCPRF=1,MXCDPF=1)
c      PARAMETER(MXNNPF=1,MXNESF=1,MXNPRF=1,MXNDPF=1)
c      PARAMETER(MXRESF=1,MXRNPF=1,MXRPRF=1,MXRDPF=1)
c      PARAMETER(MXDNPF=34,MXDPRF=2,MXDDPF=2)
C
c      PARAMETER(MXSELT=1,MXSPRT=1,MXSDPT=1,MXWNPT=2,MXWPRT=2,MXWDPT=3)
c      PARAMETER(MXCNPT=1,MXCEST=1,MXCPRT=1,MXCDPT=1)
c      PARAMETER(MXNNPT=1,MXNEST=1,MXNPRT=1,MXNDPT=1)
c      PARAMETER(MXVEST=16,MXVNPT=17,MXVPRT=1,MXVDPT=2)
c      PARAMETER(MXDNPT=17,MXDPRT=5,MXDDPT=2)
C
c      PARAMETER(MXNCCK=7)
C
c      PARAMETER(MXKGLDK=4200,MXLSVK=700,MXMSVK=150,MXNDBK=500)
c      PARAMETER(MXNEPK=1,MXEPWK=1)
c      PARAMETER(MXNPWK=36,MXELWK=25,MXNPWS=36,MXELWS=25)
c      PARAMETER(MXNPFGK=80500,MXKGLK=17500)
C
C ******* Parameter Specification for Example 4
C
       PARAMETER(MAXELK=40,MAXNPK=82,MXBESK=82,MXBNPK= 82,MAXBWK=20)
       PARAMETER(MXJBDK=20,MXKBDK=4,MXADNK=MAXNPK+1000)
       PARAMETER(MXMATK=1,MXSPPK=4,MXMPPK=10)
       PARAMETER(MXNTIK=44,MXNDTK=3)
C
       PARAMETER(MXSELF=1,MXSPRF=1,MXSDPF=1,MXWNPF=1,MXWPRF=1,MXWDPF=1)
       PARAMETER(MXCNPF=1,MXCESF=1,MXCPRF=1,MXCDPF=1)
       PARAMETER(MXNNPF=1,MXNESF=1,MXNPRF=1,MXNDPF=1)
       PARAMETER(MXRESF=1,MXRNPF=1,MXRPRF=1,MXRDPF=1)
       PARAMETER(MXDNPF=1,MXDPRF=1,MXDDPF=1)
C
       PARAMETER(MXSELT=1,MXSPRT=1,MXSDPT=1,MXWNPT=1,MXWPRT=1,MXWDPT=1)
       PARAMETER(MXCNPT=1,MXCEST=1,MXCPRT=1,MXCDPT=1)
       PARAMETER(MXNNPT=1,MXNEST=1,MXNPRT=1,MXNDPT=1)
       PARAMETER(MXVEST=1,MXVNPT=2,MXVPRT=1,MXVDPT=2)
       PARAMETER(MXDNPT=2,MXDPRT=1,MXDDPT=2)
C
       PARAMETER(MXNCCK=7)
C
       PARAMETER(MXKGLDK=1000,MXLSVK=100,MXMSVK=100,MXNDBK=500)
       PARAMETER(MXNEPK=1,MXEPWK=1)
       PARAMETER(MXNPWK=12,MXELWK=2,MXNPWS=1,MXELWS=1)
       PARAMETER(MXNPFGK=1000,MXKGLK=1000)
C
C ******* Parameter Specification for Example 5
C
c      PARAMETER(MAXELK=400,MAXNPK=451,MXBESK=100,MXBNPK=100,MAXBWK=9)
c      PARAMETER(MXJBDK=9,MXKBDK=4,MXADNK=MAXNPK+1000)
c      PARAMETER(MXMATK=1,MXSPPK=4,MXMPPK=10)
c      PARAMETER(MXNTIK=44,MXNDTK=3)
C
c      PARAMETER(MXSELF=1,MXSPRF=1,MXSDPF=1,MXWNPF=1,MXWPRF=1,MXWDPF=1)
c      PARAMETER(MXCNPF=1,MXCESF=1,MXCPRF=1,MXCDPF=1)
c      PARAMETER(MXNNPF=1,MXNESF=1,MXNPRF=1,MXNDPF=1)
c      PARAMETER(MXRESF=1,MXRNPF=1,MXRPRF=1,MXRDPF=1)
c      PARAMETER(MXDNPF=1,MXDPRF=1,MXDDPF=1)
C
c      PARAMETER(MXSELT=1,MXSPRT=1,MXSDPT=1,MXWNPT=1,MXWPRT=1,MXWDPT=1)
c      PARAMETER(MXCNPT=1,MXCEST=1,MXCPRT=1,MXCDPT=1)
c      PARAMETER(MXNNPT=1,MXNEST=1,MXNPRT=1,MXNDPT=1)
c      PARAMETER(MXVEST=10,MXVNPT=11,MXVPRT=1,MXVDPT=2)
c      PARAMETER(MXDNPT=11,MXDPRT=2,MXDDPT=2)
C
c      PARAMETER(MXNCCK=7)
C
c      PARAMETER(MXKGLDK=10000,MXLSVK=100,MXMSVK=100,MXNDBK=100)
c      PARAMETER(MXNEPK=1,MXEPWK=1)
c      PARAMETER(MXNPWK=9,MXELWK=4,MXNPWS=1,MXELWS=1)
c      PARAMETER(MXNPFGK=10000,MXKGLK=10000)
C
C
C ******* COMMON BLOCKS FOR HYDROLOGICAL AND TRANSPORT SIMULATIONS
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /SCMTL/ MAXMAT,MXSPPM,MXMPPM,NMAT,NSPPM,NMPPM
      COMMON /NINTR/ KPR0,KDSK0,NSTRH,NSTRT
C
      COMMON /TIMEI/ MAXNTI,MXNDTC,NTI,NDTCHG
      COMMON /TIMER/ DELT,CHNG,DELMAX,TMAX,DELT0,TIME
C
      COMMON /COUTP/ IITR,ICHNG,INTER,IBUG
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
C
C ******* COMMON BLOCKS FOR HYDROLOGICAL SIMULATIONS
C
      COMMON /HICNT/ NCYL,NITERH,NPITERH,KSTRH,KSSH,KSP,KGRAV
      COMMON /HRCNT/ TOLAH,TOLBH,Wf,OMEH,OMIH,CNSTKR
C
      COMMON /HELS/ MXSELH,MXSPRH,MXSDPH,NSELH,NSPRH,NSDPH,KSAIH
      COMMON /HNPS/ MXWNPH,MXWPRH,MXWDPH,NWNPH,NWPRH,NWDPH,KWAIH
C
      COMMON /HCBC/ MXCNPH,MXCESH,MXCPRH,MXCDPH,NCNPH,NCESH,NCPRH,
     >              NCDPH,KCAIH
      COMMON /HNBC/ MXNNPH,MXNESH,MXNPRH,MXNDPH,NNNPH,NNESH,NNPRH,
     >              NNDPH,KNAIH
      COMMON /HRBC/ MXRES,MXRNP,MXRPR,MXRDP,NRES,NRNP,NRPR,NRDP,KRAIH
      COMMON /HDBC/ MXDNPH,MXDPRH,MXDDPH,NDNPH,NDPRH,NDDPH,KDAIH
      COMMON /FFLOW/ FRATEH(10),FLOWH(10),TFLOWH(10)
C
C ******* COMMON BLOCKS FOR TRANSPORT SIMULATIONS
C
      COMMON /TICNT/ NITERt,NPITERt,KSTRt,KSSt,KVIT,MICONF
      COMMON /TRCNT/ TOLAt,TOLBt,Wt,Wv,OMEt,OMIt,APHAG
      COMMON /TADP/ ADPEPS,ADPARM,DLINP,NXG,NYG,NXD,NYD,NXW,NYW,IZOOM,
     >              IDZOOM,IEPC,IDETQ
C
      COMMON /SAZFM/ MXNPFG,MXKGL,MXKGLD,MXNEP,MXEPW,MXNPW,MXELW,MXNDB,
     >               mxnpww,mxelww
C
      COMMON /TELS/ MXSEL,MXSPR,MXSDP,NSEL,NSPR,NSDP,KSAI
      COMMON /TNPS/ MXWNP,MXWPR,MXWDP,NWNP,NWPR,NWDP,KWAI
C
      COMMON /TVBC/ MXVES,MXVNP,MXVPR,MXVDP,NVES,NVNP,NVPR,NVDP,KVAI
      COMMON /TCBC/ MXCNP,MXCES,MXCPR,MXCDP,NCNP,NCES,NCPR,NCDP,KCAI
      COMMON /TNBC/ MXNNP,MXNES,MXNPR,MXNDP,NNNP,NNES,NNPR,NNDP,KNAI
      COMMON /TDBC/ MXDNP,MXDPR,MXDDP,NDNP,NDPR,NDDP,KDAI
      COMMON /TFLUX/ MXLSV,MXMSV
C
      COMMON /CHEM/ MXNCC,NCC
      COMMON /MICROB/ GRATE,YCOEFF,RTARDS,RTARDO,RTARDN,SCOEFF,
     >                ECOEFF,DCOEFF,SATURC,PCOEFF,COFK
C
      COMMON /TFLOW/ FRATET(14),FLOWT(14),TFLOWT(14,7)
C
      COMMON /WET/ APHA1,APHA2,BETA1,BETA2
C
C ******* SPECIFICATION OF ARRAYS FOR HYDROLOGICAL AND TRANSPORT
C ******* SIMULATIONS
C
C
C ------- FOLLOWING ARRAYS DEFINE THE GEOMETRY: REGION AND BOUNDARY
C
      DIMENSION COORD(MAXNPK,2),IE(MAXELK,9),LRN(MXJBDK,MXADNK),
     >          LRL(MXKBDK,MAXNPK),IB(MXADNK),NLRL(MAXNPK),NLRN(MAXNPK)
      DIMENSION DLCSB(3,MXBESK),ISB(5,MXBESK), NPBB(MXBNPK)
C
C ------- FOLLOWING ARRAYS DEFINE THE MATERIALS OF THE REGION
C
      DIMENSION PROP(MXMATK,MXMPPK), SPP(MXSPPK,MXMATK,4)
C
C ------- FOLLOWING ARRAYS DEFINE OUTPUT CONTROL AS FUNCTION OF TIME
C
      DIMENSION KPR(MXNTIK),KDSK(MXNTIK),TDTCH(MXNDTK,2)
C
C ------- FOLLOWING ARRAYS ARE WORKING STORAGE
C
      DIMENSION CMATRX(MXADNK,MAXBWK),RLD(MXADNK),RL(MXADNK),
     >          RI(MXADNK),ND(MXADNK)
C
C ******* SPECIFICATIONS OF ARRAYS FOR HYDROLOGICAL SIMULATIONS
C
C ------- FOLLOWING ARRAYS DEFINE HYDROLOGICAL VARIABLES
C
      DIMENSION H(MAXNPK),HP(MAXNPK),HW(MAXNPK),HT(MAXNPK),DH(MAXNPK)
      DIMENSION TH(MAXELK,4),DTH(MAXELK,4),AKHC(4,MAXELK,3),
     >          THN(MAXNPK,2,MXNCCK)
      DIMENSION VELOC(MAXNPK,2),VELOCP(MAXNPK,2),VEAVG(MAXNPK,2,MXNCCK)
      DIMENSION BFLXH(MXBNPK,2)
C
C ------- FOLLOWING ARRAYS DEFINE HYDROLOGICAL SOURCE/SINK
C
      DIMENSION TSOSFH(MXSDPF,MXSPRF),SOSFH(MXSDPF,MXSPRF),
     >          SOSH(MXSPRF),ISTYPH(MXSELF,2)
      DIMENSION TWSSFH(MXWDPF,MXWPRF),WSSFH(MXWDPF,MXWPRF),
     >          WSSH(MXWPRF),IWTYPH(MXWNPF,2)
C
C ------- FOLLOWING ARRAYS DEFINE HYDROLOGICAL CAUCHY B. C.
C
      DIMENSION TQCBF(MXCDPF,MXCPRF),QCBF(MXCDPF,MXCPRF),QCB(MXCPRF)
      DIMENSION ICTYPH(MXCNPF,2),ISCH(5,MXCESF)
C
C ------- FOLLOWING ARRAYS DEFINE HYDROLOGICAL NEUMANN B. C.
C
      DIMENSION TQNBF(MXNDPF,MXNPRF),QNBF(MXNDPF,MXNPRF),QNB(MXNPRF)
      DIMENSION INTYPH(MXNNPF,2),ISNH(5,MXNESF), DLCSNH(3,MXNESF)
C
C ------- FOLLOWING ARRAYS DEFINE HYDROLOGICAL RAINFALL-SEEPAGE B. C.
C
      DIMENSION TRF(MXRDPF,MXRPRF),RF(MXRDPF,MXRPRF),RFALL(MXRPRF)
      DIMENSION IRTYP(MXRNPF,2),ISR(5,MXRESF), DLCSR(3,MXRESF)
      DIMENSION RSVAB(MXRNPF,4), INDRS(MXRNPF,3)
C
C ------- FOLLOWING ARRAYS DEFINE HYDROLOGICAL DIRICHLET B. C.
C
      DIMENSION THDBF(MXDDPF,MXDPRF),HDBF(MXDDPF,MXDPRF),HDB(MXDPRF),
     >          IDTYPH(MXDNPF,2)
C
C
C ******* SPECFICATIONS OF ARRAYS FOR TRANSPORT SIMULATIONS
C
C ------- FOLLOWING ARRAYS DEFINE THE FINE GRID COORDINATE, THE NUMBER
C ------- OF GLOBAL ELEMENT WHICH FINE GRIDS LOCATE AT, THE CON-
C ------- CENTRATIONS OF FINE GRIDS, WORKING ARRAYS FOR TRACKING, ETC.
C
      DIMENSION NLRND(MXADNK),XPFG(MXNPFGK),YPFG(MXNPFGK),MPLOC(MXNPFGK)
      DIMENSION XSFG(MXNPFGK),YSFG(MXNPFGK),MPLOCS(MXNPFGK)
      DIMENSION CPFG(MXNPFGK,MXNCCK),CSFG(MXNPFGK,MXNCCK),CMX(MXNCCK)
      DIMENSION XWFG(MXNPFGK),YWFG(MXNPFGK),CWFG(MXNPFGK,MXNCCK)
      DIMENSION XEFG(MXNEPK),YEFG(MXNEPK),CEFG(MXNEPK,MXNCCK)
      DIMENSION MPLOCW(MXNPFGK),MPLOCE(MXNPFGK)
      DIMENSION NEPWN(MXELWK),NEPW(MXELWK,MXEPWK),IBE(MAXELK)
      DIMENSION IBCHK(MAXELK),NCFG(MXNCCK+MXNCCK)
      DIMENSION NFGM(MAXELK),NFGMB(MAXELK),ISE(MXKGLK,4),ISED(MXKGLDK,5)
      DIMENSION NFGMBB(MAXELK),MWLOC(MXNPWK),CFG(MXADNK,MXNCCK)
      DIMENSION XW(MXNPWK),YW(MXNPWK),IEW(MXELWK,4,2),IBW(MXNPWK,2)
      DIMENSION VXW(MXNPWK),VYW(MXNPWK),NLRLW(MXNPWK,2),LRLW(6,MXNPWK,2)
      DIMENSION XWw(MXNPWs),YWw(MXNPWs),IEWw(MXELWs,4,2),IBWw(MXNPWs,2)
      DIMENSION VXWw(MXNPWs),VYWw(MXNPWs),NLRLWw(MXNPWs,2),
     >          LRLWw(6,MXNPWs,2)
      DIMENSION MAXFGW(MXELWK,MXNCCK),MINFGW(MXELWK,MXNCCK),CW(MXNPWK)
      DIMENSION CMAXFG(MXELWK,MXNCCK),CMINFG(MXELWK,MXNCCK)
C
      DIMENSION DTI(MXADNK,MXNCCK),RHOMU(MXNCCK),RHOM(4,MAXELK),
     >          DINTS(MXNCCK)
      DIMENSION NDBD(MXNDBK),MPLOCD(MXNDBK),DTIFG(MXNPFGK,MXNCCK)
C
C ------- FOLLOWING ARRAYS DEFINE TRANSPORT VARIABLES
C
      DIMENSION CP(MAXNPK,MXNCCK),CS(MAXNPK,MXNCCK)
      DIMENSION AKDC(4,MXKGLDK,6),F(MAXNPK,2,MXNCCK),
     >          BFLXT(MXBNPK,2,MXNCCK)
C
C ------- FOLLOWING ARRAYS DEFINE CHEMICAL VARIABLES
C
      DIMENSION TRANC(MXMATK,MXNCCK),GRATE(4),YCOEFF(4),RTARDS(4),
     >          RTARDO(4),RTARDN(4),SCOEFF(4),ECOEFF(4),DCOEFF(4),
     >          SATURC(4),PCOEFF(4),RKD(MXMATK,MXNCCK)
C
C ------- FOLLWING ARRAYS DEFINE ADDITIONAL HYDROLOGICAL VARIABLES
C
      DIMENSION WETAB(4,MAXELK),THP(MAXELK,4)
C
C ------- FOLLOWING ARRAYS DEFINE CHEMICAL SOURCE/SINKS
C
      DIMENSION TSOSF(MXSDPT,MXSPRT),SOSF(MXSDPT,MXSPRT,2),
     >          SOS(MXSPRT,2)
      DIMENSION ISTYP(MXSELT,MXNCCK), LES(MXSELT)
      DIMENSION TWSSF(MXWDPT,MXWPRT),WSSF(MXWDPT,MXWPRT,2),
     >          WSS(MXWPRT,2)
      DIMENSION IWTYP(MXWNPT,MXNCCK), NPW(MXWNPT)
C
C ------- FOLLOWING ARRAYS DEFINE TRANSPORT VARIABLE B. C.
C
      DIMENSION CVBF(MXVDPT,MXVPRT),TCVBF(MXVDPT,MXVPRT),
     >          CVB(MXVPRT),IVTYP(MXVEST,MXNCCK)
      DIMENSION DLCSV(3,MXVEST),ISV(5,MXVEST)
      DIMENSION NPVB(MXVNPT)
C
C ------ FOLLOWING ARRAYS DEFINE TRANSPORT CAUCHY B. C.
C
      DIMENSION TCCBF(MXCDPT,MXCPRT),CCBF(MXCDPT,MXCPRT),
     >          CCB(MXCPRT),NPCB(MXCNPT)
      DIMENSION ICTYP(MXCNPT,MXNCCK),ISC(5,MXCEST),DLCSC(3,MXCEST)
C
C ------- FOLLOWING ARRAYS DEFINE TRANSPORT NEUMANN B. C.
C
      DIMENSION TCNBF(MXNDPT,MXNPRT),CNBF(MXNDPT,MXNPRT),
     >          CNB(MXNPRT),NPNB(MXNNPT)
      DIMENSION INTYP(MXNNPT,MXNCCK),ISN(5,MXNEST), DLCSN(MXNEST,3)
C
C ------- FOLLOWING ARRAYS DEFINE TRANSPORT DIRICHELET B. C.
C
      DIMENSION CDBF(MXDDPT,MXDPRT),TCDBF(MXDDPT,MXDPRT),
     >          CDB(MXDPRT)
      DIMENSION IDTYP(MXDNPT,MXNCCK),NPDB(MXDNPT)
      DIMENSION ILSV(3,MXLSVK),IMSV(2,MXMSVK)
C
C
C ------- FOLLOWING ARRAYS DEFINE NODE INDICATOR FOR CHEMICAL PRINTOUT
C
      MAXEL=MAXELK
      MXADNP=MXADNK
      MAXNP=MAXNPK
      MAXBES=MXBESK
      MAXBNP=MXBNPK
      MAXBW=MAXBWK
      MXJBD=MXJBDK
      MXKBD=MXKBDK
      MAXMAT=MXMATK
      MXSPPM=MXSPPK
      MXMPPM=MXMPPK
      MAXNTI=MXNTIK
      MXNDTC=MXNDTK
      MXSELH=MXSELF
      MXSPRH=MXSPRF
      MXSDPH=MXSDPF
      MXWNPH=MXWNPF
      MXWPRH=MXWPRF
      MXWDPH=MXWDPF
      MXCNPH=MXCNPF
      MXCESH=MXCESF
      MXCPRH=MXCPRF
      MXCDPH=MXCDPF
      MXNNPH=MXNNPF
      MXNESH=MXNESF
      MXNPRH=MXNPRF
      MXNDPH=MXNDPF
      MXRES=MXRESF
      MXRNP=MXRNPF
      MXRPR=MXRPRF
      MXRDP=MXRDPF
      MXDNPH=MXDNPF
      MXDPRH=MXDPRF
      MXDDPH=MXDDPF
      MXSEL=MXSELT
      MXSPR=MXSPRT
      MXSDP=MXSDPT
      MXWNP=MXWNPT
      MXWPR=MXWPRT
      MXWDP=MXWDPT
      MXVES=MXVEST
      MXVNP=MXVNPT
      MXVPR=MXVPRT
      MXVDP=MXVDPT
      MXCNP=MXCNPT
      MXCES=MXCEST
      MXCPR=MXCPRT
      MXCDP=MXCDPT
      MXNNP=MXNNPT
      MXNES=MXNEST
      MXNPR=MXNPRT
      MXNDP=MXNDPT
      MXDNP=MXDNPT
      MXDPR=MXDPRT
      MXDDP=MXDDPT
      MXNCC=MXNCCK
      MXNPFG=MXNPFGK
      MXKGL=MXKGLK
      MXKGLD=MXKGLDK
      MXNEP=MXNEPK
      MXEPW=MXEPWK
      MXNPW=MXNPWK
      MXELW=MXELWK
      MXNPWw=MXNPWs
      MXELWw=MXELWs
      MXNDB=MXNDBK
      MXLSV=MXLSVK
      MXMSV=MXMSVK
C
C ******* PASS THE PROGRAM TO HTMICH
C
      CALL HTMICH
     > (COORD,IE,LRN,LRL,NLRL,NLRN,ND, DLCSB,ISB,NPBB,IB,  PROP,DINTS,
     > SPP,KPR,KDSK,TDTCH, CMATRX,RLD,RL,RI, H,HP,HW,HT,TH,DH,DTH,AKHC,
     > RHOMU,RHOM, VELOC,VELOCP,VEAVG,BFLXH, TSOSFH,SOSFH,SOSH,ISTYPH,
     > TWSSFH,WSSFH,WSSH,IWTYPH, TQCBF,QCBF,QCB,ICTYPH,ISCH,
     > TQNBF,QNBF,QNB,INTYPH,ISNH,DLCSNH, TRF,RF,RFALL,IRTYP,ISR,DLCSR,
     > RSVAB,INDRS, THDBF,HDBF,HDB,IDTYPH,  THP,WETAB,THN, TRANC,RKD,
     > AKDC,DTI,DTIFG, CP,XPFG,YPFG,CPFG,MPLOC,CS,XSFG,YSFG,CSFG,MPLOCS,
     > TSOSF,SOSF,SOS,ISTYP,LES, WSSF,TWSSF,WSS,IWTYP,NPW,
     > TCVBF,CVBF,CVB,IVTYP,DLCSV,ISV,NPVB, TCCBF,CCBF,CCB,ICTYP,ISC,
     > DLCSC,NPCB,  TCNBF,CNBF,CNB,INTYP,ISN,DLCSN,NPNB,TCDBF,CDBF,CDB,
     > IDTYP,NPDB, ILSV,IMSV, F,BFLXT, NFGM,NFGMB,NFGMBB,ISE, XEFG,
     > YEFG,CEFG,MPLOCE, NLRND,ISED, MAXFGW,MINFGW,CMAXFG,CMINFG,
     > NEPWN,NEPW,IBE,IBCHK, CMX,CFG,NCFG, XWFG,YWFG,CWFG,MPLOCW,
     > XW,YW,CW,VXW,VYW,IBW,IEW,NLRLW,LRLW,MWLOC, XWw,YWw,VXWw,VYWw,
     > IBWw,IEWw,NLRLWw,LRLWw,NDBD,MPLOCD)
C
      STOP
      END
c
c
c
      SUBROUTINE HTMICH
     > (COORD,IE,LRN,LRL,NLRL,NLRN,ND, DLCSB,ISB,NPBB,IB,  PROP,DINTS,
     > SPP,KPR,KDSK,TDTCH, CMATRX,RLD,RL,RI, H,HP,HW,HT,TH,DH,DTH,AKHC,
     > RHOMU,RHOM, VELOC,VELOCP,VEAVG,BFLXH, TSOSFH,SOSFH,SOSH,ISTYPH,
     > TWSSFH,WSSFH,WSSH,IWTYPH, TQCBF,QCBF,QCB,ICTYPH,ISCH,
     > TQNBF,QNBF,QNB,INTYPH,ISNH,DLCSNH, TRF,RF,RFALL,IRTYP,ISR,DLCSR,
     > RSVAB,INDRS, THDBF,HDBF,HDB,IDTYPH,  THP,WETAB,THN, TRANC,RKD,
     > AKDC,DTI,DTIFG, CP,XPFG,YPFG,CPFG,MPLOC,CS,XSFG,YSFG,CSFG,MPLOCS,
     > TSOSF,SOSF,SOS,ISTYP,LES, WSSF,TWSSF,WSS,IWTYP,NPW,
     > TCVBF,CVBF,CVB,IVTYP,DLCSV,ISV,NPVB, TCCBF,CCBF,CCB,ICTYP,ISC,
     > DLCSC,NPCB,  TCNBF,CNBF,CNB,INTYP,ISN,DLCSN,NPNB,TCDBF,CDBF,CDB,
     > IDTYP,NPDB, ILSV,IMSV, F,BFLXT, NFGM,NFGMB,NFGMBB,ISE, XEFG,
     > YEFG,CEFG,MPLOCE, NLRND,ISED, MAXFGW,MINFGW,CMAXFG,CMINFG,
     > NEPWN,NEPW,IBE,IBCHK, CMX,CFG,NCFG, XWFG,YWFG,CWFG,MPLOCW,
     > XW,YW,CW,VXW,VYW,IBW,IEW,NLRLW,LRLW,MWLOC, XWw,YWw,VXWw,VYWw,
     > IBWw,IEWw,NLRLWw,LRLWw,NDBD,MPLOCD)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO READ NECESSARY INPUT DATA, CONTROL STEADY STATE SOLUTION,
C ------- AND SCHEDULE TRANSEINT COMPUTATION SEQUENCE,  A TASK NORMALLY
C ------- PERFORMED BY THE MAIN PROGRAM.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER SUBHD*4, DATNAM*1
C
C ******* COMMON BLOCKS FOR HYDROLOGICAL AND TRANSPORT SIMULATIONS
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /SCMTL/ MAXMAT,MXSPPM,MXMPPM,NMAT,NSPPM,NMPPM
C
      COMMON /NINTR/ KPR0,KDSK0,NSTRH,NSTRT
      COMMON /TIMEI/ MAXNTI,MXNDTC,NTI,NDTCHG
      COMMON /TIMER/ DELT,CHNG,DELMAX,TMAX,DELT0,TIME
C
      COMMON /COUTP/ IITR,ICHNG,INTER,IBUG
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
C
C ******* COMMON BLOCKS FOR HYDROLOGICAL SIMULATIONS
C
      COMMON /HICNT/ NCYL,NITERH,NPITERH,KSTRH,KSSH,KSP,KGRAV
      COMMON /HRCNT/ TOLAH,TOLBH,WF,OMEH,OMIH,CNSTKR
C
      COMMON /HELS/ MXSELH,MXSPRH,MXSDPH,NSELH,NSPRH,NSDPH,KSAIH
      COMMON /HNPS/ MXWNPH,MXWPRH,MXWDPH,NWNPH,NWPRH,NWDPH,KWAIH
C
      COMMON /HCBC/ MXCNPH,MXCESH,MXCPRH,MXCDPH,NCNPH,NCESH,NCPRH,
     >              NCDPH,KCAIH
      COMMON /HNBC/ MXNNPH,MXNESH,MXNPRH,MXNDPH,NNNPH,NNESH,NNPRH,
     >              NNDPH,KNAIH
      COMMON /HRBC/ MXRES,MXRNP,MXRPR,MXRDP,NRES,NRNP,NRPR,NRDP,KRAIH
      COMMON /HDBC/ MXDNPH,MXDPRH,MXDDPH,NDNPH,NDPRH,NDDPH,KDAIH
      COMMON /FFLOW/ FRATEH(10),FLOWH(10),TFLOWH(10)
C
C ******* COMMON BLOCKS FOR TRANSPORT SIMULATIONS
C
      COMMON /TICNT/ NITERt,NPITERt,KSTRt,KSSt,KVIT,MICONF
      COMMON /TRCNT/ TOLAt,TOLBt,Wt,WV,OMEt,OMIt,APHAG
      COMMON /TADP/ ADPEPS,ADPARM,DLINP,NXG,NYG,NXD,NYD,NXW,NYW,IZOOM,
     >              IDZOOM,IEPC,IDETQ
C
      COMMON /SAZFM/ MXNPFG,MXKGL,MXKGLD,MXNEP,MXEPW,MXNPW,MXELW,MXNDB,
     >               mxnpww,mxelww
C
      COMMON /TELS/ MXSEL,MXSPR,MXSDP,NSEL,NSPR,NSDP,KSAI
      COMMON /TNPS/ MXWNP,MXWPR,MXWDP,NWNP,NWPR,NWDP,KWAI
C
      COMMON /TVBC/ MXVES,MXVNP,MXVPR,MXVDP,NVES,NVNP,NVPR,NVDP,KVAI
      COMMON /TCBC/ MXCNP,MXCES,MXCPR,MXCDP,NCNP,NCES,NCPR,NCDP,KCAI
      COMMON /TNBC/ MXNNP,MXNES,MXNPR,MXNDP,NNNP,NNES,NNPR,NNDP,KNAI
      COMMON /TDBC/ MXDNP,MXDPR,MXDDP,NDNP,NDPR,NDDP,KDAI
      COMMON /TFLUX/ MXLSV,MXMSV
C
      COMMON /CHEM/ MXNCC,NCC
      COMMON /MICROB/ GRATE,YCOEFF,RTARDS,RTARDO,RTARDN,SCOEFF,
     >                ECOEFF,DCOEFF,SATURC,PCOEFF,COFK
C
      COMMON /TFLOW/ FRATET(14),FLOWT(14),TFLOWT(14,7)
C
      COMMON /WET/ APHA1,APHA2,BETA1,BETA2
C
C ******* SPECIFICATION OF ARRAYS FOR HYDROLOGICAL AND TRANSPORT
C ******* SIMULATIONS
C
      DIMENSION COORD(MAXNP,2),IE(MAXEL,9),LRN(MXJBD,MXADNP),NLRN(MAXNP)
      DIMENSION LRL(MXKBD,MAXNP),NLRL(MAXNP),ND(MXADNP),IB(MXADNP)
      DIMENSION DLCSB(3,MAXBES),ISB(5,MAXBES),NPBB(MAXBNP)
C
      DIMENSION PROP(MAXMAT,MXMPPM),DINTS(MXNCC),SPP(MXSPPM,MAXMAT,4)
C
      DIMENSION KPR(MAXNTI),KDSK(MAXNTI),TDTCH(MXNDTC,2)
C
      DIMENSION CMATRX(MXADNP,MAXBW),RLD(MXADNP),RL(MXADNP),RI(MXADNP)
C
C ******* SPECIFICATIONS OF ARRAYS FOR HYDROLOGICAL SIMULATIONS
C
      DIMENSION H(MAXNP),HP(MAXNP),HW(MAXNP),HT(MAXNP)
      DIMENSION TH(MAXEL,4),DTH(MAXEL,4),AKHC(4,MAXEL,3),
     >          THN(MAXNP,2,MXNCC),DH(MAXNP)
      DIMENSION VELOC(MAXNP,2),VEAVG(MAXNP,2,MXNCC),VELOCP(MAXNP,2)
      DIMENSION BFLXH(MAXBNP,2)
C
      DIMENSION TSOSFH(MXSDPH,MXSPRH),SOSFH(MXSDPH,MXSPRH),
     >          SOSH(MXSPRH),ISTYPH(MXSELH,2)
      DIMENSION TWSSFH(MXWDPH,MXWPRH),WSSFH(MXWDPH,MXWPRH),
     >          WSSH(MXWPRH),IWTYPH(MXWNPH,2)
C
      DIMENSION TQCBF(MXCDPH,MXCPRH),QCBF(MXCDPH,MXCPRH),QCB(MXCPRH),
     >          ICTYPH(MXCNPH,2),ISCH(5,MXCESH)
C
      DIMENSION TQNBF(MXNDPH,MXNPRH),QNBF(MXNDPH,MXNPRH),QNB(MXNPRH),
     >          INTYPH(MXNNPH,2),DLCSNH(3,MXNESH),ISNH(5,MXNESH)
C
      DIMENSION TRF(MXRDP,MXRPR),RF(MXRDP,MXRPR),RFALL(MXRPR),
     >          IRTYP(MXRNP,2),DLCSR(3,MXRES),ISR(5,MXRES)
      DIMENSION RSVAB(MXRNP,4), INDRS(MXRNP,3)
C
      DIMENSION THDBF(MXDDPH,MXDPRH),HDBF(MXDDPH,MXDPRH),HDB(MXDPRH),
     >          IDTYPH(MXDNPH,2)
C
C ******* SPECFICATIONS OF ARRAYS FOR TRANSPORT SIMULATIONS
C
      DIMENSION NLRND(MXADNP),XPFG(MXNPFG),YPFG(MXNPFG),MPLOC(MXNPFG)
      DIMENSION XSFG(MXNPFG),YSFG(MXNPFG),MPLOCS(MXNPFG)
      DIMENSION CPFG(MXNPFG,MXNCC),CSFG(MXNPFG,MXNCC),CMX(MXNCC)
      DIMENSION XWFG(MXNPFG),YWFG(MXNPFG),CWFG(MXNPFG,MXNCC)
      DIMENSION XEFG(MXNEP),YEFG(MXNEP),CEFG(MXNEP,MXNCC)
      DIMENSION MPLOCW(MXNPFG),MPLOCE(MXNPFG)
      DIMENSION NEPWN(MXELW),NEPW(MXELW,MXEPW),IBE(MAXEL)
      DIMENSION IBCHK(MAXEL),NCFG(MXNCC+MXNCC)
      DIMENSION NFGM(MAXEL),NFGMB(MAXEL),ISE(MXKGL,4),ISED(MXKGLD,5)
      DIMENSION NFGMBB(MAXEL),MWLOC(MXNPW),CFG(MXADNP,MXNCC),CW(MXNPW)
      DIMENSION XW(MXNPW),YW(MXNPW),IEW(MXELW,4,2),IBW(MXNPW,2)
      DIMENSION VXW(MXNPW),VYW(MXNPW),NLRLW(MXNPW,2),LRLW(6,MXNPW,2)
      DIMENSION XWw(MXNPWw),YWw(MXNPWw),IEWw(MXELWw,4,2),IBWw(MXNPWw,2)
      DIMENSION VXWw(MXNPWw),VYWw(MXNPWw),NLRLWw(MXNPWw,2),
     >          LRLWw(6,MXNPWw,2)
      DIMENSION MAXFGW(MXELW,MXNCC),MINFGW(MXELW,MXNCC),
     >          CMAXFG(MXELW,MXNCC),CMINFG(MXELW,MXNCC)
C
      DIMENSION DTI(MXADNP,MXNCC),RHOMU(MXNCC),RHOM(4,MAXEL)
      DIMENSION NDBD(MXNDB),MPLOCD(MXNDB),DTIFG(MXNPFG,MXNCC)
C
      DIMENSION CP(MAXNP,MXNCC),CS(MAXNP,MXNCC),F(MAXNP,2,MXNCC)
      DIMENSION AKDC(4,MXKGLD,6),RKD(MAXMAT,MXNCC),BFLXT(MAXBNP,2,MXNCC)
C
      DIMENSION TRANC(MAXMAT,MXNCC),GRATE(4),YCOEFF(4),RTARDS(4),
     >          RTARDO(4),RTARDN(4),SCOEFF(4),ECOEFF(4),DCOEFF(4),
     >          SATURC(4),PCOEFF(4)
C
      DIMENSION WETAB(4,MAXEL),THP(MAXEL,4)
C
      DIMENSION TSOSF(MXSDP,MXSPR),SOSF(MXSDP,MXSPR,2),
     1          SOS(MXSPR,2)
      DIMENSION ISTYP(MXSEL,MXNCC), LES(MXSEL)
      DIMENSION TWSSF(MXWDP,MXWPR),WSSF(MXWDP,MXWPR,2),WSS(MXWPR,2)
      DIMENSION IWTYP(MXWNP,MXNCC),NPW(MXWNP)
C
      DIMENSION CVBF(MXVDP,MXVPR),TCVBF(MXVDP,MXVPR),CVB(MXVPR),
     >          IVTYP(MXVES,MXNCC)
      DIMENSION DLCSV(3,MXVES),ISV(5,MXVES)
      DIMENSION NPVB(MXVNP)
C
      DIMENSION TCCBF(MXCDP,MXCPR),CCBF(MXCDP,MXCPR),
     >          CCB(MXCPR),NPCB(MXCNP)
      DIMENSION ICTYP(MXCNP,MXNCC),ISC(5,MXCES),DLCSC(3,MXCES)
C
      DIMENSION TCNBF(MXNDP,MXNPR),CNBF(MXNDP,MXNPR),
     >          CNB(MXNPR),NPNB(MXNNP)
      DIMENSION INTYP(MXNNP,MXNCC),ISN(5,MXNES), DLCSN(3,MXNES)
C
      DIMENSION CDBF(MXDDP,MXDPR),TCDBF(MXDDP,MXDPR),CDB(MXDPR)
      DIMENSION IDTYP(MXDNP,MXNCC),NPDB(MXDNP)
      DIMENSION ILSV(3,MXLSV),IMSV(2,MXMSV)
C
      DIMENSION SUBHD(8,3)
C
      CHARACTER*72 TITLE
      CHARACTER*80 DATFL,OUTFL,STOFL,STOCN,BARFL,PARFL
C
      DATA SUBHD/'INPU','T IN','ITIA','L CO','NDIT','IONS','    ',
     1 '    ','STEA','DY-S','TATE',' INI','TIAL',' CON','DITI',
     2 'ONS ','    ','    ','    ','    ','    ','    ','    ',
     3 '    '/
      data epsx/1.0d-8/
C
      PRINT *,'PLEASE INPUT YOUR INPUT DATA FILE'
      READ(*,'(A80)')DATFL
      PRINT *,'THEN, INPUT YOUR OUTPUT FILE'
      READ(*,'(A80)')OUTFL
      PRINT *,'THEN, INPUT YOUR FLOW STORAGE FILE'
      READ(*,'(A80)')STOFL
      PRINT *,'THEN, INPUT YOUR CONCENTRATION STORAGE FILE'
      READ(*,'(A80)')STOCN
      PRINT *,'THEN, INPUT YOUR BOUNDARY ARRAY FILE'
      READ(*,'(A80)')BARFL
      PRINT *,'THEN, INPUT YOUR POINTER ARRAY FILE'
      READ(*,'(A80)')PARFL
      OPEN(15,FILE=DATFL,STATUS='OLD')
      OPEN(16,FILE=OUTFL,STATUS='UNKNOWN')
      OPEN(11,FILE=STOFL,FORM='UNFORMATTED')
      OPEN(12,FILE=STOCN,FORM='UNFORMATTED')
      OPEN(13,FILE=BARFL,FORM='UNFORMATTED')
      OPEN(14,FILE=PARFL,FORM='UNFORMATTED')
C
C ******* DATA SET 1: PROBLEM IDENTIFICATION AND DESCRIPTION
C
  100 READ(15,10) NPROB,TITLE
      IF (NPROB.LE.0) GO TO 990
      WRITE(16,1000) NPROB,TITLE
C
      READ(15,*) IITR,ICHNG,INTER,IBUG,IMOD,NITRHT,OMEHT,IGEOM
      WRITE(16,1100) IITR,ICHNG,INTER,IBUG,IMOD,NITRHT,OMEHT
C
C ******* DATA SET 2: OPTION PARAMETERS
C
      READ(15,5)DATNAM
      PRINT *, 'DATNAM in HTMICH =',DATNAM
      READ(15,*) IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,NSTRH,NSTRT,IQUAR,
     >           IDISP
      WRITE(16,2600) IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,NSTRH,NSTRT,IQUAR  
     >               ,IDISP
C
C ******* DATA SET 3 THROUGH DATA SET 7: REGION DATA INPUT-OUTPUT
C         INCLUDING COORDINATE, ELEMENT CONNECTIVITY, MATERIAL TYPE,
C         MATERIAL PROPERTIES, AND SOIL PROPERTIES
C
      CALL RDATIO
     I    (IGEOM,
     O     COORD,IE,LRN,LRL,NLRN,NLRL,ND, DLCSB,ISB,NPBB, PROP,SPP,RKD,
     O     TRANC,RHOMU,DINTS,IRXN)
C
C ----- PREPARE IB ARRAY, THE INDEX OF BOUNDARY OF EVERY NODAL POINT
C
      DO I=1,NNP
        IB(I)=0
      ENDDO
      DO I=1,NBNP
        NP=NPBB(I)
        IB(NP)=5
      ENDDO
C
C ----- PREPARE IBE ARRAY
C
      CALL IBE2D
     I    (IE,IB,NLRL,LRL,
     O     IBE)
C
C ******* DATA SET 8: TIME CONTROL PARAMETER
C
      READ(15,5)DATNAM
      READ(15,*) NTI,NDTCHG
      WRITE(16,2000) NTI,NDTCHG
C
      READ(15,*) DELT,CHNG,DELMAX,TMAX
      DELT0=DELT
      IF(TMAX.LE.0.0) TMAX=1.0E38
      WRITE(16,2100) DELT,CHNG,DELMAX,TMAX
C
      READ(15,30) KPR0,(KPR(ITM),ITM=1,NTI)
      WRITE(16,2200) KPR0,(KPR(ITM),ITM=1,NTI)
      READ(15,30) KDSK0,(KDSK(ITM),ITM=1,NTI)
      WRITE(16,2300) KDSK0,(KDSK(ITM),ITM=1,NTI)
      IF(NDTCHG.GT.0) READ(15,*) ((TDTCH(I,J),J=1,2),I=1,NDTCHG)
      NDTCHG=NDTCHG+1
      TDTCH(NDTCHG,1)=1.0D38
      TDTCH(NDTCHG,2)=DELT
      WRITE(16,2400) ((TDTCH(I,J),J=1,2),I=1,NDTCHG)
C
C ------ SET SIMULATION TIME TO ZERO
C
      TIME=0.0
      ITMITM=0
      KOUT=0
      KDIG=NSTRT
C
      IF(IBAND.GT.MAXBW .AND. IPNTS.EQ.0) THEN
        WRITE(16,9000) IBAND,MAXBW
        STOP
      ENDIF
C
C ******* DATA SET 9 THROUGH DATA SET 16: HYDROLOGY DATA INPUT-OUTPUT
C         INCLUDING CONTOL INTEGER AND REAL NUMBER, INITIAL OR
C         PRE-INITIAL PRESSURE HEAD, WATER SOURCE/SINK,
C         AND BOUNDARY CONDITIONS
C
      IF(IMOD.EQ.1) THEN
C       transport only
        KSSH=0
        DO NP=1,NNP
          H(NP)=0.0
          HP(NP)=0.0
        ENDDO
        GO TO 160
      ENDIF
C
      CALL FDATIO
     I           (NSTRH,DLCSB,ISB,
     M            HT,VELOC,TH,INDRS,ITMITM,TIME,
     O            H,  TSOSFH,SOSFH,ISTYPH, TWSSFH,WSSFH,IWTYPH,
     O            TQCBF,QCBF,ICTYPH,ISCH, TQNBF,QNBF,INTYPH,ISNH,DLCSNH,
     O            TRF,RF,IRTYP,ISR,DLCSR,RSVAB, THDBF,HDBF,IDTYPH)
C
C
C ******* DATA SET 17 THROUGH 25: TRANSPORT DATA INPUT-OUTPUT INCLUDING:
C         CONTROL INTEGER AND REAL NUMBERS, INITIAL OR PRE-INITIAL
C         CONCENTRATIONS, MICROBE-CHEMICAL INTERACTION CONSTANTS, SOURCE
C         /SINK, AND BOUNDARY CONDITIONS.
C
  160 CONTINUE
      DO I=1,NNP
        DO K=1,NCC
          CP(I,K)=0.0
        ENDDO
      ENDDO
C
C ----- IF FLOW ONLY
      IDZOOM=0
      IF(IMOD.EQ.10) GO TO 400
C
      CALL TDATIO
     I     (NSTRT,DLCSB,ISB,IB,
     M      ITMITM,TIME,NPFG,NEFG,F,XPFG,YPFG,CPFG,MPLOC,ISE,NFGMB,
     O      CP, TSOSF,SOSF,ISTYP,LES, TWSSF,WSSF,IWTYP,NPW, TCCBF,CCBF,
     O      ICTYP,ISC,DLCSC,NPCB, TCNBF,CNBF,INTYP,ISN,DLCSN,NPNB,
     O      TCVBF,CVBF,IVTYP,ISV,DLCSV,NPVB, TCDBF,CDBF,IDTYP,NPDB)
C
C
C     IF(KSSH.EQ.1 .AND. KSST.EQ.0)THEN
C       PRINT *,' ====> Error: illegal combination of KSSH and KSST.'
C       PRINT *,' Simulation halt.'
C       STOP
C     ENDIF
C
C ******* INPUT, OR SIMULATE, OR PREPARE INITIAL/PRE-INITIAL HYDROLOGY
C         VARIABLES
C
      IF(KVIT.GT.0) GO TO 400
C
C ------- DATA SET 26: INPUT HYDROLOGY VARIABLES IF KVIT .LE. 0.
C
C ####### READ INPUT VELOCITY.
C
      READ(15,5)DATNAM
      CALL READR(VELOC(1,1),MAXNP,NNP)
      CALL READR(VELOC(1,2),MAXNP,NNP)
C
C --------  PRINT INPUT VELOCITY.
C
      LINE=0
      DO 340 NP=1,NNP,2
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,3400)
      NJMN=NP
      NJMX=MIN0(NP+1,NNP)
      WRITE(16,3450) (NJ,(VELOC(NJ,I),I=1,2),NJ=NJMN,NJMX)
  340 CONTINUE
C
C ------- READ MOISTURE CONTENT.
C
      NELEM=0
  360 READ(15,*) NI,NSEQ,NAD,THNI,THNIAD
      IF(NI.EQ.0) GO TO 380
      NJ=NI+NSEQ
      DO NP=NI,NJ
        I=NI+(NP-NI)*NAD
        NELEM=NELEM+1
        DO IQ=1,4
          TH(I,IQ)=THNI+THNIAD*DBLE(NP-NI)
        ENDDO
      ENDDO
      GO TO 360
  380 CONTINUE
      IF(NELEM.NE.NEL)THEN
        WRITE(16,3800) NELEM,NEL
        STOP
      ENDIF
C
C ------- PRINT INPUT MOISTURE CONTENT
C
      LINE=0
      DO 390 NP=1,NEL
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,3900)
      WRITE(16,3950)  NP,(TH(NP,IQ),IQ=1,4)
  390 CONTINUE
      IMOD=1
C
C ####### PREPARE INITIAL/PRE-INITIAL HYDROLOGY VARIABLES IF KVIT .GT. 0
C ####### AND KSSH .NE. 0.
C
  400 CONTINUE
      IF(IMOD.EQ.10 .OR. IMOD.EQ.1)THEN
        IRHO=0
      ELSEIF(KVIT.EQ.1 .AND. KSST.EQ.1 .AND. KSSH.EQ.0)THEN
        IRHO=0
      ELSE
        IRHO=1
      ENDIF
      IF(IRHO.EQ.0)THEN
        DO NP=1,NEL
          DO I=1,4
            RHOM(I,NP)=1.0D0
          ENDDO
        ENDDO
      ENDIF
C
      IF(NSTRH.LE.0 .AND. IMOD.NE.1)THEN
C
C ------- PREPARE INITIAL OR PRE-INITIAL VARIABLES
C
        IF(NDNPH.NE.0) CALL DBVFCT(HDB,THDBF,HDBF,TIME,
     1                 MXDPRH,MXDDPH,NDPRH,NDDPH,KDAIH)
        IF(NRNP.NE.0) CALL VBVFCT(RFALL,TRF,RF,TIME,
     1                 MXRPR,MXRDP,NRPR,NRDP,KRAIH)
        IF(NCNPH.NE.0) CALL CBVFCT(QCB,TQCBF,QCBF,TIME,
     1                 MXCPRH,MXCDPH,NCPRH,NCDPH,KCAIH)
        IF(NNNPH.NE.0) CALL NBVFCT(QNB,TQNBF,QNBF,TIME,
     1                 MXNPRH,MXNDPH,NNPRH,NNDPH,KNAIH)
        IF(NSELH.NE.0) CALL ESSFCT(SOSH,TSOSFH,SOSFH,TIME,MXSPRH,
     1                 MXSDPH,NSPRH,NSDPH,KSAIH)
        IF(NWNPH.NE.0) CALL WSSFCT(WSSH,TWSSFH,WSSFH,TIME,MXWPRH,
     1                 MXWDPH,NWPRH,NWDPH,KWAIH)
      ENDIF
C
      IF(IMOD.NE.10 .AND. NSTRT.LE.0)THEN
C
C ----- COMPUTE BOUNDARY VALUES
C
        IF(NDNP.NE.0) CALL DBVFCT(CDB,TCDBF,CDBF,TIME,
     1                 MXDPR,MXDDP,NDPR,NDDP,KDAI)
        IF(NVNP.NE.0) CALL VBVFCT(CVB,TCVBF,CVBF,TIME,
     1                 MXVPR,MXVDP,NVPR,NVDP,KVAI)
        IF(NCNP.NE.0) CALL CBVFCT(CCB,TCCBF,CCBF,TIME,
     1                 MXCPR,MXCDP,NCPR,NCDP,KCAI)
        IF(NNNP.NE.0) CALL NBVFCT(CNB,TCNBF,CNBF,TIME,
     1                 MXNPR,MXNDP,NNPR,NNDP,KNAI)
        IF(NSEL.NE.0) CALL ESSFCT(SOS(1,1),TSOSF,
     >                 SOSF(1,1,1),TIME,MXSPR,MXSDP,NSPR,NSDP,KSAI)
        IF(NSEL.NE.0) CALL ESSFCT(SOS(1,2),TSOSF,
     >                 SOSF(1,1,2),TIME,MXSPR,MXSDP,NSPR,NSDP,KSAI)
        IF(NWNP.NE.0) CALL WSSFCT(WSS(1,1),TWSSF,
     >                 WSSF(1,1,1),TIME,MXWPR,MXWDP,NWPR,NWDP,KWAI)
        IF(NWNP.NE.0) CALL WSSFCT(WSS(1,2),TWSSF,
     >                 WSSF(1,1,2),TIME,MXWPR,MXWDP,NWPR,NWDP,KWAI)
        do i=1,nwnp
          np=npw(i)
          iprof=iwtyp(i,1)
          if(wss(iprof,1).gt.0.0d0)then
            ib(np)=-1
          else
            ib(np)=-2
          endif
        enddo
      ENDIF
C
      IF(NSTRH.LE.0 .AND. IMOD.NE.1)THEN
C
C ------- PUT DIRICHLET BOUNDARY VALUES TO INITIAL CONDITIONS
C
        DO 410 I=1,NDNPH
          NP=IDTYPH(I,2)
          ITYP=IDTYPH(I,1)
          H(NP)=HDB(ITYP)-COORD(NP,2)*DBLE(KGRAV)
  410   CONTINUE
C
C ***** INITIALIZE BFLXH AND HP ARRAY
C
        DO I=1,NBNP
          BFLXH(I,2)=0.0D0
        ENDDO
        DO I=1,NNP
          HP(I)=H(I)
        ENDDO
C
C ----- CALCULATE MOISTURE CONTENT, WATER CAPACITY AND HYDROLIC CONDUCT
C
        CALL SPROP
     I           (IE,H,CP, PROP,RHOMU,DINTS,SPP, 0,IQUAR,
     O            TH,DTH,AKHC,RHOM)
C
C ----- CALCULATE DARCY'S VELOCITY
C
        CALL VELT
     I           (COORD,IE,H,AKHC,RHOM,
     O            VELOC,HT,
     M            CMATRX)
C
C ----- CALCULATE MASS BALANCE
C
        KFLOW=-1
        CALL FSFLOW
     I    (COORD,IE,NLRL,LRL,DLCSB,ISB,NPBB, H,HP,VELOC,TH,DTH, DELT,
     I     KFLOW,RHOM,PROP,DINTS,RHOMU,ISTYP,SOS,IWTYP,WSS,CP,
     I     SOSH,ISTYPH,IRTYP(1,2),IDTYPH(1,2),ICTYPH(1,2),INTYPH(1,2),
     I     WSSH,IWTYPH, 0,
     M     BFLXH)
C
        DO I=1,9
          IF(I.NE.9) THEN
            FLOWH(I)=0.0
            TFLOWH(I)=0.0
          ENDIF
        ENDDO
        FLOWH(9)=0.0
C
C ------- PRINT AND STORE INITIAL/PRE-INITIAL HYDROLOGY VARIABLES
C
        ITM=-1
        CALL FPRINT(H,HT,TH,VELOC,NPBB,BFLXH,IRTYP(1,2),RSVAB,INDRS,
     >              SUBHD(1,1), KPR0,ITM,KOUT,KDIG)
C
        IF(KSTRH.EQ.1 .AND. KSSH.EQ.1 .AND. KDSK0.NE.0)
     1   CALL FSTORE(COORD,IE,DLCSB,ISB,NPBB,INDRS,H,HT,TH,VELOC,TITLE,
     >               NPROB,ITM)
      ENDIF
C
C ------- PRINT AND STORE INITIAL OR PRE-INITIAL TRANSPORT VARIABLES
C
      IF(IMOD.NE.10 .AND. NSTRT.LE.0)THEN
        KFLOW=-1
C
C ----- INITIALIZE PREVIOUS BOUNDARY FLUX
C
        DO K=1,NCC
          DO NP=1,NBNP
            BFLXT(NP,2,K)=0.0
          ENDDO
        ENDDO
C ------- SET DTH=0.0 AND PUT TH INTO THP
C
        DO M=1,NEL
          DO IQ=1,4
            DTH(M,IQ)=0.0
            THP(M,IQ)=TH(M,IQ)
          ENDDO
        ENDDO
C
C ----- PUT VELOC TO VELOCP
        DO NP=1,NNP
          VELOCP(NP,1)=VELOC(NP,1)
          VELOCP(NP,2)=VELOC(NP,2)
          DH(NP)=0.0
        ENDDO
C
C ----- APPLY DIRICHLET BOUNDARY CONDITION
C
        DO  NPP=1,NDNP
          NP=NPDB(NPP)
          DO K=1,NCC
            ITYP=IDTYP(NPP,K)
            IF(ITYP.NE.0)CP(NP,K)=CDB(ITYP)
          ENDDO
        ENDDO
C
C ----- CALCULATE DISPERSION COEFFICIENT
C
        CALL DISPC
     I   (COORD,IE,VELOC,VELOCP,TH,THP,H,HP,PROP,WT,KSST,XWFG,YWFG,
     I    NEL,ISED,1,MAXEL,3,KSP,KVIT,SPP,RHOMU,DINTS,IQUAR,CNSTKR,IRHO,
     O    AKHC)
C
C ----- CALCULATE UPSTREAM WEIGHTING FACTORS
C
        CALL AFABTA
     I           (COORD,IE, VELOC,VELOCP, AKHC, Wt,KSSt,IOPTIM,
     O            WETAB)
C
        DO 415 K=1,NCC
C
          CMX(K)=-1.0D38
          DO NP=1,NNP
            CMX(K)=DMAX1(CMX(K),CP(NP,K))
          ENDDO
C
C ----- CALCUATE RETARDATION FACTORS AND THETA VALUES AT GLOBAL NODES
C
          CALL THNODE
     I        (COORD(1,1),COORD(1,2),IE,PROP,RKD,TH,THP,HW,K,
     O         THN(1,1,K))
C
C----- CALCULATE CHEMICAL FLUXES
C
          CALL FLUX
     I             (COORD,IE, CMATRX, CP(1,K),VELOC,AKHC,
     O              F(1,1,K))
C
C ----- CALCULATE CHEMICAL MASS BALANCE
C
          CALL TSFLOW
     I    (COORD,IE,DLCSB,ISB,NPBB,WETAB, CP(1,K),F(1,1,K), DH,TH, PROP,
     I     RKD(1,K),TRANC(1,K),DELT, KFLOW, SOS,ISTYP, WSS,IWTYP,NPW,
     I     NPVB,NPDB,NPCB,NPNB, K,
     M     BFLXT(1,1,K))
C
          DO 413 I=1,14
            IF(I.EQ.8 .OR. I.EQ.9)GOTO 413
            FLOWT(I)=0.0
            TFLOWT(I,K)=0.0
  413     CONTINUE
          FLOWT(8)=0.0
          FLOWT(9)=0.0
C
C ***** PRINT STEADY VARIABLES
C
          KDIAG=-2
          CALL TPRINT(CP(1,K),F(1,1,K), TIME,DELT,KPR0,KOUT,KDIAG,MAXNP,
     1                NNP,IBAND,-1,K)
  415   CONTINUE
        IF(KSST.EQ.1 .AND. KDSK0.NE.0 .AND. NSTRT.EQ.0)CALL TSTORE
     >    (COORD,IE,CP,F,TITLE,NPROB,NNP,NEL,NTI,NCC,MXNCC,
     >     MAXNP,MAXEL,MXNPFG,MXKGL,TIME,ITM,NPFG,NEFG,ISE,XPFG,YPFG,
     >     CPFG,MPLOC,NFGMB)
C
      ENDIF
C
      IF(IMOD.EQ.11)THEN
        IF(KSSH.NE.0 .AND. KSST.NE.0) GO TO 600
      ENDIF
      IF(IMOD.EQ.0) RETURN
C
C
      IF(IMOD.NE.1)EPSS=TOLAH
      IF(IMOD.NE.10)EPST=TOLAT
C
C ####### SIMUALTE STEADY STATE HYDROLOGY VARIABLES IF KVIT .GT. 0
C
C ------- PREPARE SOURCE/SINK AND BOUNDARY CONDITIONS FOR STEADY STATE
C ------- HYDROLOGY SIMULATION
C
      IF(IMOD.NE.1 .AND. NSTRH.EQ.0)THEN
        IF(KSSH.EQ.0)THEN
          IF(NDNPH.NE.0) CALL DBVFCT(HDB,THDBF,HDBF,TIME,
     1                   MXDPRH,MXDDPH,NDPRH,NDDPH,KDAIH)
          IF(NRNP.NE.0) CALL VBVFCT(RFALL,TRF,RF,TIME,
     1                   MXRPR,MXRDP,NRPR,NRDP,KRAIH)
          IF(NCNPH.NE.0) CALL CBVFCT(QCB,TQCBF,QCBF,TIME,
     1                   MXCPRH,MXCDPH,NCPRH,NCDPH,KCAIH)
          IF(NNNPH.NE.0) CALL NBVFCT(QNB,TQNBF,QNBF,TIME,
     1                   MXNPRH,MXNDPH,NNPRH,NNDPH,KNAIH)
C
          IF(NSELH.NE.0) CALL ESSFCT(SOSH,TSOSFH,SOSFH,TIME,MXSPRH,
     1                   MXSDPH,NSPRH,NSDPH,KSAIH)
          IF(NWNPH.NE.0) CALL WSSFCT(WSSH,TWSSFH,WSSFH,TIME,MXWPRH,
     1                   MXWDPH,NWPRH,NWDPH,KWAIH)
C
          DO I=1,NDNPH
            NP=IDTYPH(I,2)
            ITYP=IDTYPH(I,1)
            H(NP)=HDB(ITYP)-COORD(NP,2)*DBLE(KGRAV)
          ENDDO
C
        ENDIF
      ENDIF
C
C
C ####### PREPARE INITIAL/PRE-INITIAL TRANSPORT VARIABLES
C
C
C ------- APPLY DIRICHLET BOUNDARY VALUES TO INITIAL CONDITIONS
C
C ------- PREPARE SOURCE/SINK AND BOUNDARY CONDITIONS AT ZERO TIME
C ------- FOR STEADY STATE TRANSPORT SIMULATION
C
      IF(IMOD.NE.10 .AND. NSTRT.EQ.0)THEN
        IF(KSST.EQ.0)THEN
          IF(NDNP.NE.0) CALL DBVFCT(CDB,TCDBF,CDBF,TIME,
     1                  MXDPR,MXDDP,NDPR,NDDP,KDAI)
          IF(NVNP.NE.0) CALL VBVFCT(CVB,TCVBF,CVBF,TIME,
     1                  MXVPR,MXVDP,NVPR,NVDP,KVAI)
          IF(NCNP.NE.0) CALL CBVFCT(CCB,TCCBF,CCBF,TIME,
     1                  MXCPR,MXCDP,NCPR,NCDP,KCAI)
          IF(NNNP.NE.0) CALL NBVFCT(CNB,TCNBF,CNBF,TIME,
     1                  MXNPR,MXNDP,NNPR,NNDP,KNAI)
C
          IF(NSEL.NE.0) CALL ESSFCT(SOS(1,1),TSOSF,
     >                  SOSF(1,1,1),TIME,MXSPR,MXSDP,NSPR,NSDP,KSAI)
          IF(NSEL.NE.0) CALL ESSFCT(SOS(1,2),TSOSF,
     >                  SOSF(1,1,2),TIME,MXSPR,MXSDP,NSPR,NSDP,KSAI)
          IF(NWNP.NE.0) CALL WSSFCT(WSS(1,1),TWSSF,
     >                  WSSF(1,1,1),TIME,MXWPR,MXWDP,NWPR,NWDP,KWAI)
          IF(NWNP.NE.0) CALL WSSFCT(WSS(1,2),TWSSF,
     >                  WSSF(1,1,2),TIME,MXWPR,MXWDP,NWPR,NWDP,KWAI)
C
C ----- APPLY DIRICHLET BOUNDARY CONDITION
C
          DO  NPP=1,NDNP
            NP=NPDB(NPP)
            DO K=1,NCC
              ITYP=IDTYP(NPP,K)
              IF(ITYP.NE.0)CP(NP,K)=CDB(ITYP)
            ENDDO
          ENDDO
C
        ENDIF
      ENDIF
C
C ------- INITIALIZE THE SYSTEM
C
      ITM=0
C
C ----- START STEADY-STATE ITERATION LOOP
C
      IF(IMOD.EQ.10)THEN
        IF(KSSH.NE.0)GOTO 600
      ENDIF
      IF(IMOD.EQ.1)THEN
        IF(KSST.NE.0)GOTO 600
      ENDIF
C
      DO 440 ITER=1,NITRHT
        IDON=0
        DO NP=1,NNP
          DH(NP)=H(NP)
        ENDDO
        DO K=1,NCC
          DO NP=1,NNP
            CS(NP,K)=CP(NP,K)
          ENDDO
        ENDDO
C
C ------- STEADY STATE HYDROLOGY SIMULATION
C
        IF(IMOD.NE.1 .AND. KSSH.EQ.0 .AND. NSTRH.EQ.0)THEN
          CALL HMCHYD(ITM,KPR0,EPSS,
     I    COORD,IE,LRN,NLRN,LRL,NLRL,ND, PROP,RHOMU,RHOM,
     I    DINTS,SPP, CP,HP,SOSH,ISTYPH, WSSH,IWTYPH, QCB,ICTYPH,ISCH,
     I    QNB,INTYPH,ISNH,DLCSNH, RFALL,IRTYP,ISR,DLCSR,RSVAB,INDRS,
     I    HDB,IDTYPH, IRHO, SOS,ISTYP,WSS,IWTYP,
     O    H,HT,TH,DTH,AKHC,VELOC,
     M    HW,CMATRX,RLD,RL,RI)
        ENDIF
C
        IF(NSTRH.GT.0 .OR. NSTRT.GT.0)GOTO 445
C
C ----- CHECK CONVERGENCE OF FLOW PART
C
        NPP=0
        RD=-1.0D0
        RES=-1.0D0
        DO 420 NP=1,NNP
        RESNP=DABS(H(NP)-DH(NP))
        RES=DMAX1(RES,RESNP)
        IF(DH(NP).NE.0.0D0) RD=DMAX1(RD,DABS(RESNP/DH(NP)))
        IF(RESNP .LE. EPSS) GO TO 420
        NPP=NPP+1
  420   CONTINUE
C
        NNCVN=NPP
C
        IF(IBUG.NE.0) WRITE(16,6300) ITER,RES,RD,NNCVN
        IF(RES.LT.EPSS .AND. ITER.GT.1) IDON=1
C
C ----- PUT VELOC TO VELOCP
        DO NP=1,NNP
          VELOCP(NP,1)=VELOC(NP,1)
          VELOCP(NP,2)=VELOC(NP,2)
        ENDDO
C
C ----- IF FLOW ONLY
        IF(IMOD.EQ.10 .OR. (IMOD.EQ.11 .AND. KSST.NE.0)) THEN
          DO NP=1,NNP
            DH(NP)=0.0D0
          ENDDO
          GOTO 445
        ENDIF
C
C ***** UPDTAE THE PRESSURE HEAD AT THIS ITERATION
C
        DO NP=1,NNP
          H(NP)=OMEHT*H(NP)+(1.0D0-OMEHT)*DH(NP)
          DH(NP)=0.0
        ENDDO
C
C
C ####### SIMULATE STEADY STATE TRANSPORT VARIABLES
C
C ------- STEADY STATE TRANSPORT SIMULATION
C
      IF(IMOD.NE.10 .AND. KSST.EQ.0 .AND. NSTRT.EQ.0)THEN
        CALL HMCTRN
     I    (KPR0, ITM,EPSX, IRHO,RHOM,RHOMU,DINTS, COORD,IE,
     I     LRN,LRL,NLRL,NLRN,ND, DLCSB,ISB,NPBB,IB, CMX,PROP,SPP,
     I     RKD,TRANC, CP,XPFG,YPFG,CPFG,MPLOC, VELOC,VELOCP, TH,THP,DH,
c     I     H,HP,DTH, SOS,ISTYP,LES,WSS,IWTYP,NPW, CVB,IVTYP,DLCSV,ISV,
     I     H,HP, SOS,ISTYP,LES,WSS,IWTYP,NPW, CVB,IVTYP,DLCSV,ISV,
     I     NPVB, CCB,ICTYP,ISC,DLCSC,NPCB, CNB,NPNB,INTYP,ISN,
     I     CDB,IDTYP,NPDB, ILSV,IMSV, NEFG,IRXN,
     O     CS,XSFG,YSFG,CSFG,MPLOCS,NCFG,DTI,DTIFG, KOUT,KDIG,NEFGS,
     M     NPFG,AKHC,AKDC,WETAB,VEAVG, ISE,NLRND,ISED, NFGMB,NFGM, F,
     M     BFLXT, CMATRX,RLD,RL,RI,HW, THN, XEFG,YEFG,CEFG,MPLOCE,
     M     MAXFGW,MINFGW,CMAXFG,CMINFG,NEPWN,NEPW,IBE,IBCHK, XWFG,YWFG,
     M     CWFG,MPLOCW, CFG, XW,YW,CW,VXW,VYW,IBW,IEW,NLRLW,LRLW,MWLOC,
     M     xww,yww,vxww,vyww,ibww,ieww,nlrlww,lrlww,
     M     NFGMBB,NDBD,MPLOCD)
       ENDIF
       IF(IMOD.EQ.1)GOTO 445
C
C ----- CHECK CONVERGENCE OF TRANPSORT PART
        DIFMAX=-1.0D38
        KMAX=1
        NPMAX=1
        DO 430 K=1,NCC
          DO 425 NP=1,NNP
            ERROR=DABS(CS(NP,K)-CP(NP,K))
            IF(ERROR.LT.1.0D-4*CMX(K))GOTO 425
            IF(CS(NP,K).EQ.0.0)GOTO 425
            DIF=ERROR/CS(NP,K)
            IF(DIF.GT.DIFMAX)THEN
              DIFMAX=DIF
              KMAX=K
              NPMAX=NP
            ENDIF
  425     CONTINUE
  430   CONTINUE
C
C ***** UPDATE THE NONLINEAR ITERATE
C
        DO 442 NP=1,NNP
          DO K=1,NCC
            CP(NP,K)=OMEHT*CP(NP,K)+(1.0D0-OMEHT)*CS(NP,K)
          ENDDO
  442   CONTINUE
C
        IF(IBUG.NE.0)THEN
          WRITE(16,7000)ITM,DELT
          WRITE(16,8010)ITER,KMAX,NPMAX,DIFMAX,EPST
        ENDIF
        IF(DIFMAX.LE.EPST .AND. ITER.GT.1 .AND. IDON.EQ.1)GOTO 445
C
c       print 432, iter,nncvn,npmax,res,difmax,epss,epst
c 432   format(3i3,4e12.5)
c       print 431,(i,hp(i),h(i),veloc(i,1),veloc(i,2),cs(i,1),
c    >             cp(i,1),i=1,nnp)
c 431   format(i4,1x,6e12.5)
C       write(11,*)'iter,npmax,kmax,difmax=',iter,npmax,kmax,difmax
C       write(11,444)(i,hp(i),h(i),veloc(i,1),veloc(i,2),cs(i,1),
C    >                cp(i,1),i=1,nnp)
C 444   format(i4,1x,6e12.4)
C
  440 CONTINUE
      WRITE(16,7500)ITM,ITER,NITERT,DIFMAX,EPST
C
  445 CONTINUE
C
      ITM=ITMITM
      IF(IMOD.NE.1)THEN
      KFLOW=0
      CALL FSFLOW
     I    (COORD,IE,NLRL,LRL,DLCSB,ISB,NPBB, H,HP,VELOC,TH,DTH, DELT,
     I     KFLOW,RHOM,PROP,DINTS,RHOMU,ISTYP,SOS,IWTYP,WSS,CP,
     I     SOSH,ISTYPH,IRTYP(1,2),IDTYPH(1,2),ICTYPH(1,2),INTYPH(1,2),
     I     WSSH,IWTYPH,IRHO,
     M     BFLXH)
C
       DO 450 I=1,9
         IF(I.EQ.9)GOTO 450
         FLOWH(I)=0.0
         TFLOWH(I)=0.0
  450  CONTINUE
       FLOWH(9)=0.0
C
C ------ PRINT AND STORE STEADY STATE HYDROLOGY VARIABLES
C
      CALL FPRINT(H,HT,TH,VELOC,NPBB,BFLXH,IRTYP(1,2),RSVAB,INDRS,
     >            SUBHD(1,2), KPR0,ITM,KOUT,KDIG)
C     write(11,498)(coord(i,1),coord(i,2),ht(i),i=1,nnp)
C 498 format(3e15.5)
C
      IF(KSTRH.EQ.1 .AND. KDSK0.NE.0 .AND. NSTRH.EQ.0)
     1 CALL FSTORE(COORD,IE,DLCSB,ISB,NPBB,INDRS,H,HT,TH,VELOC,
     2 TITLE,NPROB,ITM)
      ENDIF
C
C ----- IF FLOW ONLY
      IF(IMOD.EQ.10) GO TO 600
C
C ----- IF STEADY-STATE TRANSPORT HAS BEEN EXCUTED
C
      IF(KSST.EQ.0)THEN
        KFLOW=0
        DO 490 K=1,NCC
          CALL FLUX
     I           (COORD,IE, CMATRX, CP(1,K),VELOC,AKHC,
     O            F(1,1,K))
C
          CALL TSFLOW
     I    (COORD,IE,DLCSB,ISB,NPBB,WETAB, CP(1,K),F(1,1,K), DH,TH, PROP,
     I     RKD(1,K),TRANC(1,K), DELT, KFLOW,SOS,ISTYP, WSS,IWTYP,NPW,
     I     NPVB,NPDB,NPCB,NPNB, K,
     O     BFLXT(1,1,K))
C
          DO 460 I=1,14
            IF(I.EQ.8 .OR. I.EQ.9)GOTO 460
            FLOWt(I)=0.0
            TFLOWt(I,K)=0.0
  460     CONTINUE
          FLOWt(8)=0.0
          FLOWt(9)=0.0
C
C ***** PRINT STEADY VARIABLES
C
           KDIAG=-1
           CALL TPRINT(CP(1,K),F(1,1,K),TIME,DELT,KPR0,KOUT,KDIAG,MAXNP,
     1      NNP,IBAND,0,K)
  490   CONTINUE
        IF(KSTRT.EQ.1 .AND. KDSK0.NE.0 .AND. NSTRT.EQ.0)CALL TSTORE
     >   (COORD,IE,CP,F,TITLE,NPROB,NNP,NEL,NTI,NCC,MXNCC,
     >    MAXNP,MAXEL,MXNPFG,MXKGL,TIME,ITM,NPFG,NEFG,ISE,XPFG,YPFG,
     >    CPFG,MPLOC,NFGMB)
C
      ENDIF
C
C
      IF(IMOD.EQ.0) RETURN
      IF(KSST.EQ.1) GO TO 600
C
C ***** If KVIT.GE.0 and IMOD=01, no velocity and moisture fields were
C       read.  Print warning message, and use the velocity and moisture
C       fields calculated using initial pressure heads.
      IF(KVIT.GE.0 .AND. IMOD.EQ.1)THEN
        PRINT *,' ====> Warning: no card input velocity and moisture '
        PRINT *,'field.  The velocity and moisture field calculated '
        PRINT *,'using initial pressure heads will be used for '
        PRINT *,'transport simulations.'
      ENDIF
C
C %%%%%%% THE FIRST TIME STEP TRANSIENT STATE TRANSPORT COMPUTATION
C
  600 CONTINUE
      IF(IMOD.EQ.10)THEN
C------ flow only
        IF(NTI.EQ.0)GOTO 100
        KVIT=2
        GOTO 605
      ENDIF
C
      IF(NTI.EQ.0) GO TO 100
C
C ***** INITIALIZE IE(M,6),IE(M,7) AND NFGMB ARRAYS
C
      IF(NSTRT.EQ.0)THEN
        DO M=1,NEL
          DO J=6,9
            IE(M,J)=0
          ENDDO
          NFGMB(M)=0
        ENDDO
      ENDIF
      DO K=1,2*NCC
        NCFG(K)=0
      ENDDO
C
c     IF(ISHAPE.EQ.3 .OR. ISHAPE.EQ.4)
c
c ***** prepare information for in-element tracking
c
      CALL ADVWRK
     I             (MXNPW,MXELW,NXW,NYW,ISHAPE,EPSX,
     O              IBW,IEW,NLRLW,LRLW)
      if(nwnp.ne.0)then
        CALL ADVWRK
     I             (MXNPWw,MXELWw,NXg,NYg,ISHAPE,EPSX,
     O              IBWw,IEWw,NLRLWw,LRLWw)
      endif
C
C $$$$$$$ PERFORM TRANSIENT-STATE OR TRANSIENT COMPUTATION
C
  605 CONTINUE
      IF(KVIT.EQ.1)IMOD=1
      TIME=TIME+DELT
      IDELT=0
      IF(NSTRT.EQ.0)NPFG=0
      KSSH=1
      KSST=1
C
      IF(IMOD.EQ.1) GO TO 620
C
      IF(NRNP.EQ.0 .OR. NSTRH.GT.0) GO TO 610
      DO NPP=1,NRNP
        INDRS(NPP,1)=IRTYP(NPP,2)
        INDRS(NPP,2)=0
        INDRS(NPP,3)=0
      ENDDO
C
  610 CONTINUE
c      NCHG=-1
      DO NP=1,NNP
        HP(NP)=H(NP)
      ENDDO
  620 CONTINUE
      KFLOW=1
      DO K=1,NCC
        TFLOWT(8,K)=0.0D0
        TFLOWT(9,K)=0.0D0
      ENDDO
C
      IF(IMOD.NE.1)EPST=0.5D0*TOLBH
c     IF(IMOD.NE.10)THEN
c       IF(IZOOM.EQ.1 .AND. IDZOOM.EQ.1)IPNTS=1
c     ENDIF
C
      DO 890 ITM=ITMITM+1,NTI
      PRINT *,'ITM=',ITM
c     do np=1,nnp
c       xp=coord(np,1)
c       yp=coord(np,2)
c       do k=1,ncc
c         if(cp(np,k).lt.0.0d0)goto 630
c       enddo
c     enddo
c     do np=1,npfg
c       xp=xpfg(np)
c        yp=ypfg(np)
c       do k=1,ncc
c         if(cpfg(np,k).lt.0.0d0)goto 630
c       enddo
c     enddo
c     goto 640
c 630 continue
c     print *,xp,yp
c     print *,'negative concentration at np,k=',np,k
c     stop
c 640 continue
C
      IF(IMOD.NE.1)THEN
C
C ------- PREPARE INITIAL OR PRE-INITIAL VARIABLES
C
        IF(NDNPH.NE.0) CALL DBVFCT(HDB,THDBF,HDBF,TIME,
     1                 MXDPRH,MXDDPH,NDPRH,NDDPH,KDAIH)
        IF(NRNP.NE.0) CALL VBVFCT(RFALL,TRF,RF,TIME,
     1                 MXRPR,MXRDP,NRPR,NRDP,KRAIH)
        IF(NCNPH.NE.0) CALL CBVFCT(QCB,TQCBF,QCBF,TIME,
     1                 MXCPRH,MXCDPH,NCPRH,NCDPH,KCAIH)
        IF(NNNPH.NE.0) CALL NBVFCT(QNB,TQNBF,QNBF,TIME,
     1                 MXNPRH,MXNDPH,NNPRH,NNDPH,KNAIH)
        IF(NSELH.NE.0) CALL ESSFCT(SOSH,TSOSFH,SOSFH,TIME,MXSPRH,
     1                 MXSDPH,NSPRH,NSDPH,KSAIH)
        IF(NWNPH.NE.0) CALL WSSFCT(WSSH,TWSSFH,WSSFH,TIME,MXWPRH,
     1                 MXWDPH,NWPRH,NWDPH,KWAIH)
      ENDIF
C
      IF(IMOD.NE.10)THEN
C
C ----- COMPUTE BOUNDARY VALUES
C
        IF(NDNP.NE.0) CALL DBVFCT(CDB,TCDBF,CDBF,TIME,
     1                 MXDPR,MXDDP,NDPR,NDDP,KDAI)
        IF(NVNP.NE.0) CALL VBVFCT(CVB,TCVBF,CVBF,TIME,
     1                 MXVPR,MXVDP,NVPR,NVDP,KVAI)
        IF(NCNP.NE.0) CALL CBVFCT(CCB,TCCBF,CCBF,TIME,
     1                 MXCPR,MXCDP,NCPR,NCDP,KCAI)
        IF(NNNP.NE.0) CALL NBVFCT(CNB,TCNBF,CNBF,TIME,
     1                 MXNPR,MXNDP,NNPR,NNDP,KNAI)
        IF(NSEL.NE.0) CALL ESSFCT(SOS(1,1),TSOSF,
     >                 SOSF(1,1,1),TIME,MXSPR,MXSDP,NSPR,NSDP,KSAI)
        IF(NSEL.NE.0) CALL ESSFCT(SOS(1,2),TSOSF,
     >                 SOSF(1,1,2),TIME,MXSPR,MXSDP,NSPR,NSDP,KSAI)
        IF(NWNP.NE.0) CALL WSSFCT(WSS(1,1),TWSSF,
     >                 WSSF(1,1,1),TIME,MXWPR,MXWDP,NWPR,NWDP,KWAI)
        IF(NWNP.NE.0) CALL WSSFCT(WSS(1,2),TWSSF,
     >                 WSSF(1,1,2),TIME,MXWPR,MXWDP,NWPR,NWDP,KWAI)
        do i=1,nwnp
          np=npw(i)
          iprof=iwtyp(i,1)
          if(wss(iprof,1).gt.0.0d0)then
            ib(np)=-1
          else
            ib(np)=-2
          endif
        enddo
      ENDIF
C
      IF(KVIT.LT.0 .OR. IMOD.EQ.1)GOTO 750
C
      DO M=1,NEL
        DO IQ=1,4
          THP(M,IQ)=TH(M,IQ)
        ENDDO
      ENDDO
C
      DO I=1,NNP
        VELOCP(I,1)=VELOC(I,1)
        VELOCP(I,2)=VELOC(I,2)
      ENDDO
C
      IF(KVIT.NE.2) GO TO 750
C
C ------- UPDATA HP
C
      DO  NP=1,NNP
        HP(NP)=H(NP)
        RLD(NP)=H(NP)
      ENDDO
C
C ******* SIMULATE TRANSIENT STATE OR TRANSIENT HYDROLOGY VARIABLES
C
C ------- TRANSIENT STATE OR TRANSIENT HYDROLOGY SIMULATION
C
       CALL HMCHYD(ITM,KPR(ITM),EPST,
     I   COORD,IE,LRN,NLRN,LRL,NLRL,ND, PROP,RHOMU,RHOM,
     I   DINTS,SPP, CP,HP, SOSH,ISTYPH, WSSH,IWTYPH, QCB,ICTYPH,ISCH,
     I   QNB,INTYPH,ISNH,DLCSNH, RFALL,IRTYP,ISR,DLCSR,RSVAB,INDRS,
     I   HDB,IDTYPH, IRHO, SOS,ISTYP,WSS,IWTYP,
     O   H,HT,TH,DTH,AKHC,VELOC,
     M   HW,CMATRX,RLD,RL,RI)
C
      IF(IMID.NE.0)THEN
        DO I=1,NNP
          H(I)=2.0D0*H(I)-HP(I)
        ENDDO
        DO I=1,NDNPH
          NP=IDTYPH(I,2)
          ITYP=IDTYPH(I,1)
          H(NP)=HDB(ITYP)-COORD(NP,2)*DBLE(KGRAV)
        ENDDO
      ENDIF
C
C ----- COMPUTE FLUXES THROUGH ALL TYPES OF BOUNDARIES
C
      KDIG=KDIG+1
      KFLOW=1
      CALL FSFLOW
     I    (COORD,IE,NLRL,LRL,DLCSB,ISB,NPBB, H,HP,VELOC,TH,DTH, DELT,
     I     KFLOW,RHOM,PROP,DINTS,RHOMU,ISTYP,SOS,IWTYP,WSS,CP,
     I     SOSH,ISTYPH,IRTYP(1,2),IDTYPH(1,2),ICTYPH(1,2),INTYPH(1,2),
     I     WSSH,IWTYPH,IRHO,
     M     BFLXH)
C
C ------ PRINT AND STORE TRANSIENT VARIABLES
C
      CALL FPRINT(H,HT,TH,VELOC,NPBB,BFLXH,IRTYP(1,2),RSVAB,INDRS,
     >            SUBHD(1,3), KPR(ITM),ITM,KOUT,KDIG)
C
      IF(KSTRH.EQ.1 .AND. KDSK(ITM).NE.0)
     1 CALL FSTORE(COORD,IE,DLCSB,ISB,NPBB,INDRS,H,HT,TH,VELOC,
     2 TITLE,NPROB,ITM)
C
      IF(IMOD.EQ.10) GO TO 860
C
C ***** If KVIT.GE.0 and IMOD=01, no velocity and moisture fields were
C       read.  Print warning message, and use the velocity and moisture
C       fields calculated using initial pressure heads.
      IF(KVIT.GE.0 .AND. IMOD.EQ.1)THEN
        PRINT *,' ====> Warning: no card input velocity and moisture '
        PRINT *,'field.  The velocity and moisture field calculated '
        PRINT *,'using initial pressure heads will be used for '
        PRINT *,'transport simulations.'
      ENDIF
C
C ****** SIMULATE TRANSIENT STATE OR TRANSIENT TRANSPORT VARIABLES
C
C ------- PREPARE SOURCE/SINK AND BOUNDARY CONDITIONS AT PRESENT TIME
C ------- FOR TRANSPORT SIMULATION
C
  750 CONTINUE
      DO M=1,NEL
        DO IQ=1,4
          DTH(M,IQ)=(TH(M,IQ)-THP(M,IQ))/DELT
        ENDDO
      ENDDO
C
C
C ------ TRANSIENT STATE OR TRANSIENT TRANSPORT SIMULATION
C
      CALL HMCTRN
     I    (KPR(ITM), ITM,EPSX, IRHO,RHOM,RHOMU,DINTS, COORD,IE,
     I     LRN,LRL,NLRL,NLRN,ND, DLCSB,ISB,NPBB,IB, CMX,PROP,SPP,
     I     RKD,TRANC, CP,XPFG,YPFG,CPFG,MPLOC, VELOC,VELOCP, TH,THP,DH,
c     I     H,HP,DTH, SOS,ISTYP,LES,WSS,IWTYP,NPW, CVB,IVTYP,DLCSV,ISV,
     I     H,HP, SOS,ISTYP,LES,WSS,IWTYP,NPW, CVB,IVTYP,DLCSV,ISV,
     I     NPVB, CCB,ICTYP,ISC,DLCSC,NPCB, CNB,NPNB,INTYP,ISN,
     I     CDB,IDTYP,NPDB, ILSV,IMSV, NEFG,IRXN,
     O     CS,XSFG,YSFG,CSFG,MPLOCS,NCFG,DTI,DTIFG, KOUT,KDIG,NEFGS,
     M     NPFG,AKHC,AKDC,WETAB,VEAVG, ISE,NLRND,ISED, NFGMB,NFGM, F,
     M     BFLXT, CMATRX,RLD,RL,RI,HW, THN, XEFG,YEFG,CEFG,MPLOCE,
     M     MAXFGW,MINFGW,CMAXFG,CMINFG,NEPWN,NEPW,IBE,IBCHK, XWFG,YWFG,
     M     CWFG,MPLOCW, CFG, XW,YW,CW,VXW,VYW,IBW,IEW,NLRLW,LRLW,MWLOC,
     M     xww,yww,vxww,vyww,ibww,ieww,nlrlww,lrlww,
     M     NFGMBB,NDBD,MPLOCD)
C
        IF(KSTRt.EQ.1 .AND. KDSK(ITM).NE.0)CALL TSTORE
     >     (COORD,IE,CP,F,TITLE,NPROB,NNP,NEL,NTI,NCC,MXNCC,
     >      MAXNP,MAXEL,MXNPFG,MXKGL,TIME,ITM,NPFG,NEFGS,ISE,XSFG,YSFG,
     >      CSFG,MPLOCS,NFGMB)
C
C     PRINT *,'AFTER HMCTRN'
C     DO K=1,NCC
C     PRINT *,'K=',K
C     PRINT 755,(I,XSFG(I),YSFG(I),CPFG(I,K),I=1,NPFG)
C 755 FORMAT(I3,2X,3E12.6)
C     ENDDO
C
C ------- PREPARE FOR NEXT TIME STEP
C
  860 IF (TIME.GE.TMAX) GO TO 100
      DELT=DELT*(1.0D0+CHNG)
      DELT=DMIN1(DELT,DELMAX)
      IF(IDELT.EQ.0) GO TO 880
      IF(TIME.EQ.TDTCH(IDELT,1)) DELT=TDTCH(IDELT,2)
 880  CONTINUE
      TIME=TIME+DELT
      IF(TIME.GE.TDTCH(IDELT+1,1)) THEN
        IDELT=IDELT+1
        TIME=TIME-DELT
        DELT=TDTCH(IDELT,1)-TIME
        IF(DELT.LE.0.0) DELT=TDTCH(IDELT,2)
        TIME=TIME+DELT
      ENDIF
C
C ***** UPDATE XPFG,YPFG,IE(M,6),IE(M,7)
C     NPFG=NPFGS
      IF(IMOD.EQ.10)GOTO 890
      DO M=1,NEL
        IF(IE(M,7).EQ.-1)THEN
C ------  this number was set in SUB. DFPREP for connecting to a SF elmt
          IE(M,6)=0
        ELSE
          IE(M,6)=IE(M,7)
        ENDIF
        IE(M,8)=IE(M,9)
        IE(M,7)=0
        IE(M,9)=0
      ENDDO
      NEFG=NEFGS
      DO I=1,NPFG
        XPFG(I)=XSFG(I)
        YPFG(I)=YSFG(I)
        DO K=1,NCC
          CPFG(I,K)=CSFG(I,K)
        ENDDO
        MPLOC(I)=MPLOCS(I)
      ENDDO
C
  890 CONTINUE
C
C ------- END OF TIME LOOP, START A NEW JOB
C
      GO TO 100
C
C
  990 RETURN
C
    5 FORMAT(A1)
   10 FORMAT(I5,A72)
   15 FORMAT(16I5)
   20 FORMAT(8D10.3)
   30 FORMAT(80I1)
   40 FORMAT(3I5,5X,4F10.0)
C
 1000 FORMAT('1'//' PROB.',I2,' ',A71/)
 1100 FORMAT('0'/5X,
     1 'IS NONLINEAR CONVERGENCY TABLE INFORMATION PRINTED? .',I5/5X,
     2 'IS CYCLIC CHANGE OF RS NODE TO BE PRINTED? . . . . ..',I5/5X,
     3 'IS NONLINEAR ITERATE TO BE PRINTED? . . . . . . . . .',I5/5X,
     4 'IS DEBUG INFORMATION TO BE PRINTED? . . . . . . . . .',I5/5X,
     5 'IS HYDRO-CHEMICAL TO BE SIMULATED?  . . . . . . . . .',I5/5X,
     6 'NO. OF ITERATIONS ALLOWED FOR HYDRO-TRANSPORT ITERA..',I5/5X,
     > 'RELAXATION FACTOR FOR HYDRO-TRANSPORT ITERA.. . . . .',F5.2/)
 1200 FORMAT('0'/5X,
     1 'TOLERANCE FOR STEADY HYDRO-TRANSPORT ITERATION  .',D12.4/5X,
     2 'TOLERANCE FOR TRANSIENT HYDRO-TRANSPORT ITERA.  .',D12.4/)
 2000 FORMAT('0'/5X,
     1 'NO OF TIME STEPS NTI . . . . . . . . . . . . . . . . ',I5/5X,
     2 'NO. OF TIMES TO CHANGE TIME STEP SIZE NDTCHG . . . . ',I5)
 2100 FORMAT('0',/5X,
     1 'TIME STEP SIZE DELT . . . . . . . . . . . . . . .',1PD12.4/5X,
     2 'FRACTION TO CHANGE TIME STEP SIZE CHNG  . . . . .',1PD12.4/5X,
     3 'MAXIMUM TIME STEP SIZE ALLOWED DELMAX . . . . . .',1PD12.4/5X,
     4 'MAXIMUM SIMULATION TIME TMAX  . . . . . . . . . .',1PD12.4/)
 2200 FORMAT('0'/6X,'**** LIST OF OUTPUT CONTROL'/ (10X,35I2))
 2300 FORMAT('0'/6X,'**** LIST OF STORE CONTROL'/ (10X,35I2))
 2400 FORMAT('0'/6X,'**** TIME TO CHANGE DELT AND DELT ARE RESET TO'/ 
     1       (10X,6(1PD10.3)))
 2500 FORMAT('0',5X,'**** IMOD = 0, NO SIMULATION, STOP. ***')
 2600 FORMAT('0'/5X,
     1 'MID-DIFFERECE INDICATOR, IMID, 0 = N0, 1 = YES . . . ',I5/5X,
     1 'IS UPSTREAM WEIGHTING? IWET, 0 = N0, 1 = YES . . . . ',I5/5X,
     2 'IS MASS MATRIX TO BE LUMPED? ILUMP, 0 = NO, 1 = YES .',I5/5X,
     3 'IS WEIGHTING FACTOR TO BE OPTIMIZED? IOPTIM . . . . .',I5/5X,
     4 'IS POINTWISE SOLUTION TO BE USED? . . . . . . . . . .',I5/5X,
     5 'IS VELOCITY MATRIX TO BE LUMPED? IVML . . . . . . . .',I5/5X,
     6 'NUMBER OF RECORD OF RESTART, NSTRH. . . . . . . . . .',I5/5X,
     7 'NUMBER OF RECORDS OF RESTART, NSTRT . . . . . . . . .',I5/5X,
     8 'INDEX OF QUADRATURE FOR INTEGRATION . . . . . . . . .',I5/5X,
     9 'INDEX OF DISPERSION INCLUSION, IDISP  . . . . . . . .',I5/)
 3400 FORMAT('1'//' INPUTTED DARCYS VELOCITY (L/T)'/2X,
     1 2('NODE',9X,'VX',9X,'VZ',4X)/2X,
     2 2('**************************    '))
 3450 FORMAT(' ',I5,2D11.3,3X,I5,2D11.3)
 3800 FORMAT('1'//'**** ERROR IN READING MOISTURE CONTENT',
     1 ':  NELEM =',I5,'  WHICH IS NOT EQUAL TO  NNP =',I5,'  STOP')
 3900 FORMAT('1'//' INPUTTED MOISTURE CONTENT (L**3/L**3)'//)
 3950 FORMAT(' ',I5,4D12.4)
 5100 FORMAT('1'///1X,' **** TABLE OF WEIGHTING FACTORS ****'//)
 5110 FORMAT(' ',I5,1PD10.3,1PD10.3,1PD10.3,1PD10.3)
 6300 FORMAT(5X,'ITERATION',9X,'RES',12X,'RD',20X,'NNCVN'/
     >       5X,I10,3X,E12.4,3X,E12.4,15X,I10)
 7000 FORMAT('1'/' ITERATION INFORMATION IN TIME STEP =',I5,
     1 ', (DELT =',1PD12.4,')'///' TABLE OF ITERATION PARAMETERS'//6X,
     2 'ITERATION',7X,' MAX DIF',6X,'TOLERANCE')
 7100 FORMAT(5X,I10,D12.4,3X,D12.4)
 7500 FORMAT('0'/5X,'** WARNING: NO CONVERGENCE AT',I4,'-TH TIME STEP AF
     1TER',I4,' ITERATIONS'/8X,'NITER =',I4,' DIFMAX =',D12.4,' TOLB =',
     2 D12.4)
 8010 FORMAT(1X,3I6,1PD12.4,1PD12.4)
 9000 FORMAT(////' BANDWIDTH =',I4,' EXCEEDS MAX. ALLOWABLE =',I4///)
C
      END
