c
c
c
      SUBROUTINE BANSOL(KKK,C,R,NNP,IHBP,MXADNP,MAXBW,MAXTND)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO SOLVE A BANDED SYMMETRICAL MATRIX EQUATION
C
C********1*********2*********3*********4*********5*********6*********7**
C
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION C(MXADNP,MAXBW),R(MAXTND)
C
      IHALFB=IHBP-1
      NNP1=NNP-1
C
      IF (KKK.EQ.2) GO TO 50
C
C ******* TRIANGULARIZE MATRIX C
C
      NU=NNP-IHALFB
      DO 20 NI=1,NU
      NJ=NI-1
      PIVOTI=1.0D0/C(NI,1)
      DO 20 LB=2,IHBP
      A=C(NI,LB)*PIVOTI
      NK=NJ+LB
      JB=0
      DO 10 KB=LB,IHBP
      JB=JB+1
   10 C(NK,JB)=C(NK,JB)-A*C(NI,KB)
   20 C(NI,LB)=A
      NL=NU+1
      DO 40 NI=NL,NNP1
      NJ=NI-1
      MB=NNP-NJ
      PIVOTI=1.0D0/C(NI,1)
      DO 40 LB=2,MB
      A=C(NI,LB)*PIVOTI
      NK=NJ+LB
      JB=0
      DO 30 KB=LB,MB
      JB=JB+1
   30 C(NK,JB)=C(NK,JB)-A*C(NI,KB)
   40 C(NI,LB)=A
      RETURN
C
C ******* MODIFY LOAD VECTOR R
C
   50 NU=NNP-IHALFB
      DO 60 NI=1,NU
      NJ=NI-1
      A=R(NI)
      R(NI)=A/C(NI,1)
      DO 60 LB=2,IHBP
      NK=NJ+LB
   60 R(NK)=R(NK)-C(NI,LB)*A
      NL=NU+1
      DO 70 NI=NL,NNP1
      NJ=NI-1
      MB=NNP-NJ
      A=R(NI)
      R(NI)=A/C(NI,1)
      DO 70 LB=2,MB
      NK=NJ+LB
   70 R(NK)=R(NK)-C(NI,LB)*A
C
C ******* BACK-SOLVE
C
      R(NNP)=R(NNP)/C(NNP,1)
      DO 80 IB=1,IHALFB
      NI=NNP-IB
      NJ=NI-1
      MB=IB+1
      DO 80 KB=2,MB
      NK=NJ+KB
   80 R(NI)=R(NI)-C(NI,KB)*R(NK)
      DO 90 IB=IHBP,NNP1
      NI=NNP-IB
      NJ=NI-1
      DO 90 KB=2,IHBP
      NK=NJ+KB
   90 R(NI)=R(NI)-C(NI,KB)*R(NK)
      RETURN
      END
c
c
c
      SUBROUTINE PISS
     I        (MXTNOD,MXJBD,MAXBW,MXADNP, NNP,NITER, OMI,EPS,KTIM,
     I         IBUG, C,RI,RL,LRN,NLRN,ND, IDCS,
     O         R)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO SOLVE A MATRIX EQUATION WITH POINTWISE ITERATION SOLUTION
C ------- STRATEGIES.
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- INPUT: RI(NNP), RL(NNP), C(NNP,MXJBD), LRN(MXJBD,NNP),
C -------        OMI, EPS, NITER, IBUG, AND KTIM.
C
C ------- OUTPUT: R(NNP) - FINAL SOLUTION; AND RI(NNP)-ITERATE.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
C
      DIMENSION R(MXADNP),RI(MXADNP),NLRN(MXTNOD),ND(MXADNP)
      DIMENSION C(MXADNP,MAXBW),RL(MXADNP),LRN(MXJBD,MXADNP)
C
C ------- PRINT ITERATION INFORMATION IF DESIRED.
C
      IF(IBUG.NE.0 .AND. KTIM.NE.0) WRITE(16,1000)
C
      DO 290 IT=1,NITER
C
C ------- FOR EACH ITERATION, PUT THE LOAD VECTOR INTO R(MAXNP).
C
      DO 210 NP=1,NNP
  210 R(NP)=RI(NP)
C
      DO 230 NP=1,NNP
        S=0.0D0
        DO I=1,NLRN(NP)
          S=S+C(NP,I)*R(LRN(I,NP))
        ENDDO
        R(NP)=R(NP)+OMI*(RL(NP)-S)/C(NP,ND(NP))
  230 CONTINUE
C
C ------- START TO COMPUTE NEW ITERATE WITH POINTWISE ITERATIONS.
C
      DO 250 NP=NNP,1,-1
        S=0.0D0
        DO I=1,NLRN(NP)
          S=S+C(NP,I)*R(LRN(I,NP))
        ENDDO
        R(NP)=R(NP)+OMI*(RL(NP)-S)/C(NP,ND(NP))
  250 CONTINUE
c
C ------- CHECK IF A CONVERGENT SOLUTION IS OBTAINED?
C
        NNCVN=0
        RELERR=-1.0D0
        ABSERR=-1.0D0
        DO 260 NP=1,NNP
          ABSDIF=DABS(R(NP)-RI(NP))
          ABSERR=DMAX1(ABSERR,ABSDIF)
          IF(RI(NP).EQ.0.0D0 .AND. IDCS.EQ.2)GOTO 260
          IF(RI(NP).NE.0.0D0) RELERR=DMAX1(RELERR,DABS(ABSDIF/RI(NP)))
          IF(IDCS.EQ.1 .AND. ABSERR.LE.EPS)GOTO 260
          IF(IDCS.EQ.2 .AND. RELERR.LE.EPS)GOTO 260
          NNCVN=NNCVN+1
  260   CONTINUE
C
c       ERROR=0.0D0
c       DO 270 NP=1,NNP
c         ERROR=ERROR+(R(NP)-RI(NP))**2
c 270   CONTINUE
c       ABSERR=DSQRT(ERROR/DBLE(NNP))
C
C ------- UPDATE THE ITERATE.
C
      DO 280 NP=1,NNP
  280 RI(NP)=R(NP)
C
C -------  PRINT ITERATION INFORMATION IF DESIRED.
C
      IF(IBUG.NE.0 .AND. KTIM.NE.0) WRITE(16,1100) IT,ABSERR,RELERR,
     1 NNCVN
C
      IF(IT.EQ.1) GO TO 290
      IF(ABSERR .LE. EPS .AND. IDCS.EQ.1) GO TO 990
      IF(RELERR .LE. EPS .AND. IDCS.EQ.2) GO TO 990
C
  290 CONTINUE
C
      WRITE(16,2000) IT,NITER,ABSERR,RELERR,NNCVN
C
  990 CONTINUE
C
 1000 FORMAT(1H0/36X,'   IT   ABS ERR     REL ERR   NO. OF NODES'/36X,
     1 '   --   --- ---     --- ---   --- -- -----')
 1100 FORMAT(36X,I5,1PD12.4,1PD12.4,5X,I5)
 2000 FORMAT(1H0/18X,' ::: WARNING: NO CONVERGENCE IN PISS AFTER ',
     1 I4,' ITERATIONS'/18X,' NPITER =',I4,'   ABSERR =',1PD12.4/18X,
     2 '   RELERR =',1PD12.4,'    NNCVN =',I4)
C
      RETURN
      END
C
c
c
      SUBROUTINE SOLVE(KKK,C,R,NNP,IHALFB,MXADNP,MAXBW)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION C(MXADNP,MAXBW),R(MXADNP)
C
      IHBP=IHALFB+1
C
C  IF KKK = 1, THEN TRIANGULARIZE THE BAND MATRIX C(NP,IB), BUT
C  IF KKK = 2, THEN SIMPLY SOLVE WITH THE RIGHT-HAND SIDE R(NP)
C
      IF (KKK.EQ.2) GO TO 50
C
C  TRIANGULARIZE MATRIX C(NP,IB)
C
      NU=NNP-IHALFB
      DO 20 NI=1,NU
         PIVOTI=1.0D0/C(NI,IHBP)
         NJ=NI+1
         IB=IHBP
         NK=NI+IHALFB
         DO 10 NL=NJ,NK
            IB=IB-1
            A=-C(NL,IB)*PIVOTI
            C(NL,IB)=A
            JB=IB+1
            KB=IB+IHALFB
            LB=IHBP-IB
            DO 10 MB=JB,KB
               NB=LB+MB
   10          C(NL,MB)=C(NL,MB)+A*C(NI,NB)
   20    CONTINUE
      NR=NU+1
      NU=NNP-1
      NK=NNP
      DO 40 NI=NR,NU
         PIVOTI=1.0D0/C(NI,IHBP)
         NJ=NI+1
         IB=IHBP
         DO 30 NL=NJ,NK
            IB=IB-1
            A=-C(NL,IB)*PIVOTI
            C(NL,IB)=A
            JB=IB+1
            KB=IB+IHALFB
            LB=IHBP-IB
            DO 30 MB=JB,KB
               NB=LB+MB
   30          C(NL,MB)=C(NL,MB)+A*C(NI,NB)
   40    CONTINUE
      RETURN
C
C  MODIFY LOAD VECTOR R(NP)
C
   50 NU=NNP+1
      IBAND=2*IHALFB+1
      DO 70 NI=2,IHBP
         IB=IHBP-NI+1
         NJ=1
         SUM=0.0
         DO 60 JB=IB,IHALFB
            SUM=SUM+C(NI,JB)*R(NJ)
   60       NJ=NJ+1
   70    R(NI)=R(NI)+SUM
      IB=1
      NL=IHBP+1
      DO 90 NI=NL,NNP
         NJ=NI-IHBP+1
         SUM=0.0
         DO 80 JB=IB,IHALFB
            SUM=SUM+C(NI,JB)*R(NJ)
   80       NJ=NJ+1
   90    R(NI)=R(NI)+SUM
C
C  BACK SOLVE
C
      R(NNP)=R(NNP)/C(NNP,IHBP)
      DO 110 IB=2,IHBP
         NI=NU-IB
         NJ=NI
         MB=IHALFB+IB
         SUM=0.0
         DO 100 JB=NL,MB
            NJ=NJ+1
  100       SUM=SUM+C(NI,JB)*R(NJ)
  110    R(NI)=(R(NI)-SUM)/C(NI,IHBP)
      MB=IBAND
      DO 130 IB=NL,NNP
         NI=NU-IB
         NJ=NI
         SUM=0.0
         DO 120 JB=NL,MB
            NJ=NJ+1
  120       SUM=SUM+C(NI,JB)*R(NJ)
  130    R(NI)=(R(NI)-SUM)/C(NI,IHBP)
      RETURN
      END
