C     6/19/96   SUBROUTINE LOCQ2N
C
      SUBROUTINE XSI2D
     I                (X,Y,XP,YP,M,
     O                 XSI,ETA)
C
C $$$$$ TO COMPUTE LOCAL COORDINATES BASED ON THE GIVEN ORIGINAL
C       CARTESIAN COORDINATES.
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION X(4),Y(4)
C
      DATA NITER/100/,OMEGA/1.0D0/,EPSR/1.0D-6/
C
      X2=-1.0D38
      X1=1.0D38
      Y2=-1.0D38
      Y1=1.0D38
C
C ***** START CALCULATIONS
C
      DO 190 IQ=1,4
        X2=DMAX1(X2,X(IQ))
        Y2=DMAX1(Y2,Y(IQ))
        X1=DMIN1(X1,X(IQ))
        Y1=DMIN1(Y1,Y(IQ))
  190 CONTINUE
      DELX=X2-X1
      DELY=Y2-Y1
C
      A1=(X(1)+X(2)+X(3)+X(4))*0.25D0
      A2=(-X(1)+X(2)+X(3)-X(4))*0.25D0
      A3=(-X(1)+X(4)-X(2)+X(3))*0.25D0
      A4=(X(1)-X(4)-X(2)+X(3))*0.25D0
      B1=(Y(1)+Y(2)+Y(3)+Y(4))*0.25D0
      B2=(-Y(1)+Y(2)+Y(3)-Y(4))*0.25D0
      B3=(-Y(1)+Y(4)-Y(2)+Y(3))*0.25D0
      B4=(Y(1)-Y(4)-Y(2)+Y(3))*0.25D0
C
C *** MAKE INITIAL GUESS OF XSI AND ETA
C
      XSIO=(2.0D0*XP-(X1+X2))/DELX
      IF(XSIO.LT.-1.0D0)XSIO=-1.0D0
      IF(XSIO.GT.1.0D0)XSIO=1.0D0
      ETAO=(2.0D0*YP-(Y1+Y2))/DELY
      IF(ETAO.LT.-1.0D0)ETAO=-1.0D0
      IF(ETAO.GT.1.0D0)ETAO=1.0D0
      XSIW=XSIO
      XSI=XSIO
      ETAW=ETAO
      ETA=ETAO
C
C *** START NEWTON RALSON ITERATION LOOP
C
      DO 590 ITER=1,NITER
C
C *** COMPUTE RIGHT HAND SIDE AND THE JACOBIAN
C
        F1=XP-A1-A2*XSIW-A3*ETAW-A4*XSIW*ETAW
        F2=YP-B1-B2*XSIW-B3*ETAW-B4*XSIW*ETAW
        Z11=-A2-A4*ETAW
        Z12=-A3-A4*XSIW
        Z21=-B2-B4*ETAW
        Z22=-B3-B4*XSIW
C
C *** SOLVE FOR DELXSI AND DELETA
C
        DJAC=Z11*Z22 - Z21*Z12
        DELXSI=(F1*Z22-F2*Z12)/DJAC
        DELETA=(-F1*Z21+F2*Z11)/DJAC
C
C ***  COMPUTE FOR NEW XSI AND ETA
C
        XSI=XSIO-DELXSI
        ETA=ETAO-DELETA
C
C *** TEST CONVERGENCE
C
        DIFMAX=0.0D0
        DIFMAX1=0.0D0
        IF(XSIW.NE.0.)THEN
          DIF=DABS((XSI-XSIW)/XSIW)
          DIFMAX=DMAX1(DIF,DIFMAX)
          DIF1=DABS(XSI-XSIW)
          DIFMAX1=DMAX1(DIF1,DIFMAX1)
        ENDIF
        IF(ETAW.NE.0.)THEN
          DIF=DABS((ETA-ETAW)/ETAW)
          DIFMAX=DMAX1(DIF,DIFMAX)
          DIF1=DABS(ETA-ETAW)
          DIFMAX1=DMAX1(DIF1,DIFMAX1)
        ENDIF
        IF(DIFMAX.LE.EPSR .AND. ITER.GT.1)GOTO 600
C
C *** TAKE A NEW GUESS FOR XSI AND ETA
C
        IF(XSI.LT.-1.0D0)XSI=-1.0D0
        IF(XSI.GT.1.0D0)XSI=1.0D0
        IF(ETA.LT.-1.0D0)ETA=-1.0D0
        IF(ETA.GT.1.0D0)ETA=1.0D0
        XSIW=OMEGA*XSI+(1.0D0-OMEGA)*XSIO
        ETAW=OMEGA*ETA+(1.0D0-OMEGA)*ETAO
C
C *** UPDATE XSIO AND ETAO
C
        XSIO=XSI
        ETAO=ETA
  590 CONTINUE
C
C *** CONVERGENCE FAILS, STOP EXECUTION
C
      WRITE(16,2000)ITER,NITER,M,DIFMAX,DIFMAX1,EPSR
 2000 FORMAT('1','* FAIL TO CONVERGE IN COMPUTING XSI, ETA, AND ZTA:',
     > /1X,'ITER =',I3,',   NITER =',I3,',   M =',I4/1X,
     > 'DIFMAX =',D15.6,',  DIFMAX1=',D15.6,',   EPS =',D15.6)
      WRITE(16,*)'IT CAN NOT REACH CONVERGENCE ----- WARNING AT XSI2D'
      IF(DIFMAX1.GT.EPSR)THEN
        WRITE(16,997)XSI,ETA
        WRITE(16,998)XP,YP
        WRITE(16,*)'XX(I),YY(I) ARE AS THE FOLLOWING:'
        WRITE(16,999)(X(I),Y(I),I=1,4)
  997 FORMAT('XSI=',E15.8,3X,'ETA=',E15.8)
  998 FORMAT('XP=',E15.8,3X,'YP=',E15.8)
  999 FORMAT(2F15.8)
        STOP
      ENDIF
C
C ------- CONVERGENT SOLUTION FOR XSI AND ETA HAS BEEN ACHIEVED.
C
  600 CONTINUE
C
      IF(XSI.LT.-1.0D0)XSI=-1.0D0
      IF(XSI.GT.1.0D0)XSI=1.0D0
      IF(ETA.LT.-1.0D0)ETA=-1.0D0
      IF(ETA.GT.1.0D0)ETA=1.0D0
C
C ***** THIS IS THE END OF CALCULATIONS
C
      RETURN
      END
      SUBROUTINE TRACK1
c     I       (XP,YP,VXP,VYP,XX,YY,VXX,VYY,SDT,IME,IBF,NODE,M,IJUDGE,
     I       (XP,YP,VXP,VYP,XX,YY,VXX,VYY,SDT,IME,IBF,NODE,IJUDGE,
     O        EPSX,  XQ,YQ,VXQ,VYQ,SDT1,N1,N2)
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION XX(4),YY(4),VXX(4),VYY(4),IME(4)
C
      IF(VXP.EQ.0.0D0 .AND. VYP.EQ.0.0D0)THEN
        SDT1=0.0D0
        XQ=XP
        YQ=YP
        GOTO 600
      ENDIF
C
C ***** DETERMINE POINT Q WILL FALL INTO THIS ELEMENT OR NOT
C
      K1=1
      IF(NODE.EQ.3)THEN
        K2=2
        K3=0
      ELSE
        K2=3
        K3=2
      ENDIF
C
      A1=FCOS(XX,YY,VXX,VYY,XP,YP,VXP,VYP,K1,IJUDGE)
      A2=FCOS(XX,YY,VXX,VYY,XP,YP,VXP,VYP,K2,IJUDGE)
C
      IF(IBF.EQ.1)THEN
        IF(A1.LE.0.0D0 .AND. A2.GE.0.0D0)GOTO 100
      ELSE
        IF(A1.GE.0.0D0 .AND. A2.LE.0.0D0)GOTO 100
      ENDIF
      SDT1=SDT
      RETURN
C
  100 CONTINUE
      IF(K3.EQ.0)GOTO 200
      A3=FCOS(XX,YY,VXX,VYY,XP,YP,VXP,VYP,K3,IJUDGE)
      IF(IBF.EQ.1)THEN
        IF(A3.GE.0.0D0)THEN
          GOTO 200
        ELSE
          GOTO 300
        ENDIF
      ELSE
        IF(A3.GE.0.0D0)THEN
          GOTO 300
        ELSE
          GOTO 200
        ENDIF
      ENDIF
C
C ***** THE TARGET POINT IS LOCATED ON THE 1-2 SIDE
C
  200 CONTINUE
c     X1=XX(1)
c     Y1=YY(1)
c     VX1=VXX(1)
c     VY1=VYY(1)
c     X2=XX(2)
c     Y2=YY(2)
c     VX2=VXX(2)
c     VY2=VYY(2)
      NN1=1
      NN2=2
      N1=IME(1)
      N2=IME(2)
      GOTO 500
C
C ***** THE TARGET POINT IS LOCATED ON THE 2-3 SIDE
C
  300 CONTINUE
c     X1=XX(2)
c     Y1=YY(2)
c     VX1=VXX(2)
c     VY1=VYY(2)
c     X2=XX(3)
c     Y2=YY(3)
c     VX2=VXX(3)
c     VY2=VYY(3)
      NN1=2
      NN2=3
      N1=IME(2)
      N2=IME(3)
C
C
C ***** COMPUTE POSITION AND VELOCITY OF POINT Q AND NEW SDT
C
  500 CONTINUE
      CALL LOCQ2D
     I    (XX,YY,VXX,VYY,XP,YP,VXP,VYP,NN1,NN2,SDT,IBF,IJUDGE,
     O     EPSX,  XQ,YQ,VXQ,VYQ,SDT1)
C
  600 RETURN
      END
      SUBROUTINE TRACK2
c     I       (XP,YP,VXP,VYP,XX,YY,VXX,VYY,SDT,IME,IBF,NODE,M,IJUDGE,
     I       (XP,YP,VXP,VYP,XX,YY,VXX,VYY,SDT,IME,IBF,NODE,IJUDGE,
     O        EPSX,ID,  XQ,YQ,VXQ,VYQ,SDT1,N1,N2)
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION XX(4),YY(4),VXX(4),VYY(4),IME(4)
C
      N1=IME(1)
      N2=IME(NODE)
C
      IF(VXP.EQ.0.0D0 .AND. VYP.EQ.0.0D0)THEN
        SDT1=0.0D0
        XQ=XP
        YQ=YP
        RETURN
      ENDIF
C
      DO 100 I=1,NODE-ID
        I1=I+1
        IF(I1.GT.NODE)I1=1
        A1=FCOS(XX,YY,VXX,VYY,XP,YP,VXP,VYP,I,IJUDGE)
        A2=FCOS(XX,YY,VXX,VYY,XP,YP,VXP,VYP,I1,IJUDGE)
        IF(IBF.EQ.1)THEN
          IF(A1.LE.0.0D0 .AND. A2.GE.0.0D0)GOTO 200
        ELSE
          IF(A1.GE.0.0D0 .AND. A2.LE.0.0D0)GOTO 200
        ENDIF
  100 CONTINUE
      SDT1=SDT
      RETURN
C
  200 CONTINUE
c     X1=XX(I)
c     Y1=YY(I)
c     VX1=VXX(I)
c     VY1=VYY(I)
c     X2=XX(I1)
c     Y2=YY(I1)
c     VX2=VXX(I1)
c     VY2=VYY(I1)
      NN1=I
      NN2=I1
      N1=IME(I)
      N2=IME(I1)
C
C ***** COMPUTE POSITION AND VELOCITY OF POINT Q AND NEW SDT
C
      CALL LOCQ2D
     I    (XX,YY,VXX,VYY,XP,YP,VXP,VYP,NN1,NN2,SDT,IBF,IJUDGE,
     O     EPSX,  XQ,YQ,VXQ,VYQ,SDT1)
C
C ***** CHECK THE NEXT SIDE
C
  600 RETURN
      END
      FUNCTION FCOS(XX,YY,VXX,VYY,XP,YP,VPX,VPY,K,IJUDGE)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION XX(4),YY(4),VXX(4),VYY(4)
C
      P1X=XX(K)-XP
      P1Y=YY(K)-YP
      IF(IJUDGE.EQ.1)THEN
        VP1X=0.5D0*(VXX(K)+VPX)
        VP1Y=0.5D0*(VYY(K)+VPY)
      ELSE
        VP1X=VPX
        VP1Y=VPY
      ENDIF
      FCOS=P1X*VP1Y-P1Y*VP1X
      RETURN
      END

      SUBROUTINE LOCQ2D
     I     (XX,YY,VXX,VYY,XP,YP,VXP,VYP,N1,N2,SDT,IBF,IJUDGE,EPSX,
     O      XQ,YQ,VXQ,VYQ,SDT1)
C
C -----  2/19/96
C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C NOTE: IF IBF=1, BACKWARD TRACKING.                                   %
C       IF IBF=2, FORWARD TRACKING.                                    %
C       IF IJUDGE=1, USING THE AVERAGE-VELOCITY APPROACH.              %
C       IF IJUDGE=2, USING THE SINGLE-VELOCITY APPROACH.               %
C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION XX(4),YY(4),VXX(4),VYY(4)
C
      DATA NITER/500/, EPSR/1.0D-6/, OMEGA/1.0D0/
C
      SDT1=SDT
      MXNOD=4
      NSTART=N1
      NEND=N2
      NDIM=2
      NJUMP=N2-N1
C
      VXQ=0.0D0
      VYQ=0.0D0
C
C NOTE: THE COMPUTATION IN THIS SUBROUTINE IS ACHIEVED BASED ON
C       A FORWARD PARTICLE TRACKING.  THUS, VELOCITY SIGN NEEDS
C       TO BE CHANGED IF IBF=1.
C
      IF(IBF.EQ.1)THEN
        CALL CHNGSN
     I       (MXNOD,NSTART,NEND,NJUMP, NDIM,
     M        VXP,VYP,0.0D0,VXQ,VYQ,0.0D0,VXX,VYY,XX)
      ENDIF
C
C ***** WHEN THE SINGLE VELOCITY APPROACH IS USED, CALL SURE2D
C
      IF(IJUDGE.EQ.2)THEN
        CALL SURE2D
     I           (XX,YY,VXX,VYY,N1,N2, XP,YP,VXP,VYP, SDT,
     O            XQ,YQ,VXQ,VYQ, SDT1)
C
C === RESET VELOCITY BY CHANGING SIGN IF IBF=1
C
        IF(IBF.EQ.1)THEN
          CALL CHNGSN
     I         (MXNOD,NSTART,NEND,NJUMP, NDIM,
     M          VXP,VYP,0.0D0,VXQ,VYQ,0.0D0,VXX,VYY,XX)
        ENDIF
        RETURN
      ENDIF
C
C $$$$$ DETERMINE THE LOCATION OF Q WITH DIFFERENT APPROACHES.
C
C ***** CALCULATE THE COEFFICIENTS OF XP-XQ
C
      A1=XX(N2)-XP
      A2=XX(N1)-XX(N2)
C
C ***** CALCULATE THE COEFFICIENTS OF YP-YQ
C
      B1=YY(N2)-YP
      B2=YY(N1)-YY(N2)
C
      IF(IJUDGE.EQ.1)THEN
C
C ***** CALCULATE THE COEFFICIENTS OF VXP+VXQ
C
        C1=VXX(N2)+VXP
        C2=VXX(N1)-VXX(N2)
C
C ***** CALCULATE THE COEFFICIENTS OF VYQ+VYP
C
        D1=VYY(N2)+VYP
        D2=VYY(N1)-VYY(N2)
      ELSE
C
C ***** CALCULATE THE COEFFICIENTS OF VXP
C
        C1=2.0D0*VXP
        C2=0.0D0
C
C ***** CALCULATE THE COEFFICIENTS OF VYP
C
        D1=2.0D0*VYP
        D2=0.0D0
      ENDIF
C
C ***** CONSTRUCT FUNCTION FOF AND FUNCTION GOF FOR ITERATION
C
C ----- CALCULATE THE COEFFICIENTS OF DX
C
C     R1=A1**2+B1**2
      R2=2.0D0*(A1*A2+B1*B2)
      R3=A2**2+B2**2
C
C ----- CALCULATE THE COEFFICIENTS OF V
C
C     S1=C1**2+D1**2
      S2=2.0D0*(C1*C2+D1*D2)
      S3=C2**2+D2**2
C
C ***** SOLVE THE ABOVE TWO EQUATIONS BY NEWTON-RAPHSON
C
      ITEST=1
  100 CONTINUE
      IF(ITEST.EQ.1)THEN
        U1=A1
        U2=A2
        U3=C1
        U4=C2
      ELSE
        U1=B1
        U2=B2
        U3=D1
        U4=D2
      ENDIF
C
C NOTE: DIFFERENT INITIAL GUESSES CAN BE EMPLOYED IN CASE CONVERGENCE
C       CANNOT BE REACHED AFTER A DESIRED NUMBER OF ITERATIONS.
C
      INIGES=0
  105 CONTINUE
      IF(INIGES.EQ.0)THEN
        XSIO=0.5
      ELSEIF(INIGES.EQ.1)THEN
        XSIO=0.0D0
      ELSEIF(INIGES.EQ.2)THEN
        XSIO=1.0D0
      ENDIF
C
      XSI=XSIO
      XID=1.0D0
C
C ***** START NEWTON-RAPHSON
C
      DO 200 ITER=1,NITER
C
        XSIW=OMEGA*XSI+(1.0D0-OMEGA)*XSIO
        XSIO=XSI
        DN1=XSIW
        DN2=1.0D0-XSIW
C
        XQ=DN1*XX(N1)+DN2*XX(N2)
        YQ=DN1*YY(N1)+DN2*YY(N2)
        VXQ=DN1*VXX(N1)+DN2*VXX(N2)
        VYQ=DN1*VYY(N1)+DN2*VYY(N2)
C
        RR=(XQ-XP)*(XQ-XP)+(YQ-YP)*(YQ-YP)
        IF(IJUDGE.EQ.1)THEN
          SS=(VXQ+VXP)*(VXQ+VXP)+(VYQ+VYP)*(VYQ+VYP)
          IF(SS.EQ.0.0D0)THEN
C === RESET VELOCITY BY CHANGING SIGN IF IBF=1
            IF(IBF.EQ.1)THEN
              CALL CHNGSN
     I             (MXNOD,NSTART,NEND,NJUMP, NDIM,
     M              VXP,VYP,0.0D0,VXQ,VYQ,0.0D0,VXX,VYY,XX)
            ENDIF
            SDT1=SDT
            RETURN
          ENDIF
        ELSE
          SS=(VXP+VXP)*(VXP+VXP)+(VYP+VYP)*(VYP+VYP)
        ENDIF
        RR=DSQRT(RR)
        SS=DSQRT(SS)
        T1=U1+U2*XSIW
        T2=U3+U4*XSIW
        FOF=SS*T1-RR*T2
        IF(FOF.EQ.0.0D0)GOTO 500
C
        DFX=SS*U2+0.5D0*T1*(S2+2.0D0*S3*XSIW)/SS
     >      -RR*U4-0.5D0*T2*(R2+2.0D0*R3*XSIW)/RR
        IF(DFX.EQ.0.0D0)THEN
          XSI=XSIO+XID*0.05D0
        ELSE
          XSI=XSIO-FOF/DFX
        ENDIF
C
C ***** TEST CONVERGENCE
C
        DIFMAX=0.0D0
        DIFMAX1=0.0D0
        IF(XSIW.NE.0.)THEN
          DIF=DABS((XSI-XSIW)/XSIW)
          DIFMAX=DMAX1(DIF,DIFMAX)
          DIF1=DABS(XSI-XSIW)
          DIFMAX1=DMAX1(DIF1,DIFMAX1)
        ENDIF
        IF(XSIW.EQ.0.0D0)THEN
          DIF1=DABS(XSI-XSIW)
          DIFMAX1=DMAX1(DIF1,DIFMAX1)
        ENDIF
        IF(DIFMAX.LE.EPSR .AND. ITER.GT.1)THEN
          IF(DIFMAX1.LE.EPSR .AND. DABS(FOF).LE.EPSX)GOTO 500
        ENDIF
C
C ***** TAKE A NEW GUESS FOR XSI AND ETA
C
        IF(XSI.GT.1.0D0)THEN
          XSI=1.0D0
          XID=-1.0D0
        ENDIF
        IF(XSI.LT.0.0D0)THEN
          XSI=0.0D0
          XID=-1.0D0
        ENDIF
C
C ***** UPDATE XSIO,ETAO
C
  200 CONTINUE
C
      IF(ITEST.NE.2)THEN
        ITEST=ITEST+1
        GOTO 100
      ENDIF
C
      IF(DIFMAX1.GT.EPSR)THEN
        WRITE(16,*)'IN LOCQ2, DIFMAX1 =',DIFMAX1
C === RESET VELOCITY BY CHANGING SIGN IF IBF=1
        IF(IBF.EQ.1)THEN
          CALL CHNGSN
     I         (MXNOD,NSTART,NEND,NJUMP, NDIM,
     M          VXP,VYP,0.0D0,VXQ,VYQ,0.0D0,VXX,VYY,XX)
        ENDIF
        SDT1=SDT
        RETURN
      ENDIF
C
C ***** GET THE POSITION AND VELOCITY OF POINT Q
C
  500 CONTINUE
      IF(XSI.GT.1.0D0)XSI=1.0D0
      IF(XSI.LT.0.0D0)XSI=0.0D0
C
      DN1=XSI
      DN2=1.0D0-XSI
C
      XQ=DN1*XX(N1)+DN2*XX(N2)
      YQ=DN1*YY(N1)+DN2*YY(N2)
      VXQ=DN1*VXX(N1)+DN2*VXX(N2)
      VYQ=DN1*VYY(N1)+DN2*VYY(N2)
C
C ***** CALCULATE DT
C
      RR=(XQ-XP)*(XQ-XP)+(YQ-YP)*(YQ-YP)
      IF(IJUDGE.EQ.1)THEN
        SS=(VXQ+VXP)*(VXQ+VXP)+(VYQ+VYP)*(VYQ+VYP)
        IF(SS.EQ.0.0D0)THEN
C === RESET VELOCITY BY CHANGING SIGN IF IBF=1
          IF(IBF.EQ.1)THEN
            CALL CHNGSN
     I           (MXNOD,NSTART,NEND,NJUMP, NDIM,
     M            VXP,VYP,0.0D0,VXQ,VYQ,0.0D0,VXX,VYY,XX)
          ENDIF
          SDT1=SDT
          RETURN
        ENDIF
      ELSE
        SS=(VXP+VXP)*(VXP+VXP)+(VYP+VYP)*(VYP+VYP)
      ENDIF
      RR=DSQRT(RR)
      SS=DSQRT(SS)
      DT=2.0D0*RR/SS
C
C -----CHECK IF A CORRECT ANSWER HAS BEEN OBTAINED
C
      IF(RR.LE.1.0D-4)GOTO 510
      IF(IJUDGE.EQ.1)THEN
        VVX=0.5D0*(VXP+VXQ)
        VVY=0.5D0*(VYP+VYQ)
      ELSE
        VVX=VXP
        VVY=VYP
      ENDIF
      DIFFX=(XQ-XP)-VVX*DT
      DIFFY=(YQ-YP)-VVY*DT
      DIFF=DSQRT(DIFFX*DIFFX+DIFFY*DIFFY)
      IF(DIFF.GT.2.0D0*RR*1.0D-4)THEN
        INIGES=INIGES+1
        IF(INIGES.EQ.3)THEN
          IF(ITEST.NE.2)THEN
            ITEST=ITEST+1
            GOTO 100
          ELSE
C
            IF(IJUDGE.EQ.2)THEN
              CALL SURE2D
     I           (XX,YY,VXX,VYY,N1,N2, XP,YP,VXP,VYP, SDT,
     O            XQ,YQ,VXQ,VYQ, SDT1)
            ELSE
              SDT1=SDT
            ENDIF
C
C === RESET VELOCITY BY CHANGING SIGN IF IBF=1
            IF(IBF.EQ.1)THEN
              CALL CHNGSN
     I             (MXNOD,NSTART,NEND,NJUMP, NDIM,
     M              VXP,VYP,0.0D0,VXQ,VYQ,0.0D0,VXX,VYY,XX)
            ENDIF
C
            RETURN
          ENDIF
        ELSE
          GOTO 105
        ENDIF
      ENDIF
C
  510 CONTINUE
C
      IF(DT.GE.SDT)THEN
        SDT1=0.0D0
        XQ=XP+SDT*(XQ-XP)/DT
        YQ=YP+SDT*(YQ-YP)/DT
      ELSE
        SDT1=SDT-DT
        DX=DABS(VXQ*SDT1)
        DY=DABS(VYQ*SDT1)
        IF(DX.LE.EPSX .AND. DY.LE.EPSX) SDT1=0.0D0
C
C === RESET VELOCITY BY CHANGING SIGN IF IBF=1
        IF(IBF.EQ.1)THEN
          CALL CHNGSN
     I         (MXNOD,NSTART,NEND,NJUMP, NDIM,
     M          VXP,VYP,0.0D0,VXQ,VYQ,0.0D0,VXX,VYY,XX)
        ENDIF
      ENDIF
C
      RETURN
      END


      SUBROUTINE SURE2D
     I     (XX,YY,VXX,VYY,N1,N2, XP,YP,VXP,VYP, SDT,
     O      XQ,YQ,VXQ,VYQ, SDT1)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION XX(4),YY(4),VXX(4),VYY(4)
C
C ===== CONSTRUCT AX+BY+C=0
C
      A=YY(N2)-YY(N1)
      B=XX(N1)-XX(N2)
      C=XX(N1)*(YY(N1)-YY(N2))+YY(N1)*(XX(N2)-XX(N1))
C
C ===== CONSTRUCT X+DT+E=0
C
      D=-VXP
      E=-XP
C
C ===== CONSTRUCT Y+FT+G=0
C
      F=-VYP
      G=-YP
C
C ===== SOLVE THE ABOVE THREE EQUATIONS
C
      DENO=A*D+B*F
      IF(DENO.EQ.0.0D0)THEN
        WRITE(16,*)'DENO=0 IN 2DSURE'
        WRITE(16,*)'SOMETHING WRONG WITH THE DATA:'
        WRITE(16,*)'XP,YP,VXP,VYP='
        WRITE(16,100)XP,YP,VXP,VYP
        WRITE(16,*)'XX(N1),YY(N1),XX(N2),YY(N2)='
        WRITE(16,100)XX(N1),YY(N1),XX(N2),YY(N2)
  100   FORMAT(4F12.4)
        WRITE(16,*)'STOP SIMULATION'
        STOP
      ENDIF
C
      T=(C-A*E-B*G)/DENO
C
      IF(T.GE.SDT)THEN
        SDT1=0.0D0
        XQ=XP+VXP*SDT
        YQ=YP+VYP*SDT
        VXQ=VXP
        VYQ=VYP
        RETURN
      ELSE
        SDT1=SDT-T
        XQ=-E-D*T
        YQ=-G-F*T
      ENDIF
C
C ===== COMPUTE VXQ AND VYQ BY INTERPOLATION
C
      XSI=DSQRT((XQ-XX(N1))**2+(YQ-YY(N1))**2)/
     >    DSQRT((XX(N2)-XX(N1))**2+(YY(N2)-YY(N1))**2)
      VXQ=VXX(N1)*(1.0D0-XSI)+VXX(N2)*XSI
      VYQ=VYY(N1)*(1.0D0-XSI)+VYY(N2)*XSI
      RETURN
      END
C
C
C
      SUBROUTINE ADVWRK
     I                 (MXNPW,MXELW,NXW,NYW,ISHAPE,EPSX,
     O                  IBW,IEW,NLRLW,LRLW)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION IBW(MXNPW,2),IEW(MXELW,4,2),NLRLW(MXNPW,2)
c      DIMENSION LRLW(6,MXNPW,2),DL(4)
      DIMENSION LRLW(6,MXNPW,2)
C
      IF(ISHAPE.EQ.3 .OR. ISHAPE.EQ.0)THEN
C ----- FOR THE CASES OF TRIANGULAR ELEMENTS
        N=0
        DO 115 I=NXW+1,1,-1
          DL1=DBLE(I-1)/DBLE(NXW)
          DO 110 J=NXW+1,1,-1
            DL2=DBLE(J-1)/DBLE(NXW)
            IF(DL1+DL2.GT.1.0D0 .AND. DABS(DL1+DL2-1.0D0).GT.EPSX)
     >        GOTO 110
            DO 105 K=NXW+1,1,-1
              DL3=DBLE(K-1)/DBLE(NXW)
              IF(DABS(DL1+DL2+DL3-1.0D0).LE.1.0D-6)THEN
                N=N+1
c                DL(1)=DL1
c                DL(2)=DL2
c                DL(3)=DL3
                IF(DABS(DL1).LE.EPSX)THEN
                  IF(DABS(DL2).LE.EPSX)THEN
                    IBW(N,2)=13
                  ELSEIF(DABS(DL3).LE.EPSX)THEN
                    IBW(N,2)=12
                  ELSE
                    IBW(N,2)=2
                  ENDIF
                ELSEIF(DABS(DL2).LE.EPSX)THEN
                  IF(DABS(DL3).LE.EPSX)THEN
                    IBW(N,2)=11
                  ELSE
                    IBW(N,2)=3
                  ENDIF
                ELSEIF(DABS(DL3).LE.EPSX)THEN
                  IBW(N,2)=1
                ELSE
                  IBW(N,2)=0
                ENDIF
              ENDIF
  105       CONTINUE
  110     CONTINUE
  115   CONTINUE
C
        NC=0
        NI=0
        DO 120 I=1,NXW
          NT=2*I-1
          NII=NI
          DO J=NC+1,NC+NT,2
            NI=NI+1
            IEW(J,1,2)=NI
            IEW(J,2,2)=NI+I
            IEW(J,3,2)=NI+I+1
            IEW(J,4,2)=0
          ENDDO
          IF(I.GT.1)THEN
            DO J=NC+2,NC+NT-1,2
              NII=NII+1
              IEW(J,1,2)=NII
              IEW(J,2,2)=NII+I+1
              IEW(J,3,2)=NII+1
              IEW(J,4,2)=0
            ENDDO
          ENDIF
          NC=I**2
  120   CONTINUE
C
        NELW=NXW**2
        NNPW=(NXW**2+3*NXW+2)/2
        DO 140 I=1,NNPW
          NLRLW(I,2)=0
          DO 135 M1=1,NELW
            DO J=1,3
              IF(I.EQ.IEW(M1,J,2))THEN
                GOTO 130
              ENDIF
            ENDDO
            GOTO 135
  130       NLRLW(I,2)=NLRLW(I,2)+1
            K=NLRLW(I,2)
            LRLW(K,I,2)=M1
  135     CONTINUE
  140   CONTINUE
      ENDIF
C
      IF(ISHAPE.EQ.4 .OR. ISHAPE.EQ.0)THEN
C ----- FOR THE CASES OF QUADRALATERAL ELEMENTS
        DO 165 I=1,NYW+1
          YI=2.0*DBLE(I-1)/DBLE(NYW)-1.0
          DO 160 J=1,NXW+1
            XI=2.0*DBLE(J-1)/DBLE(NXW)-1.0
            N=J+(I-1)*(NXW+1)
            IF(DABS(XI+1.0D0).LE.EPSX)THEN
              IF(DABS(YI+1.0D0).LE.EPSX)THEN
                IBW(N,1)=11
              ELSEIF(DABS(YI-1.0D0).LE.EPSX)THEN
                IBW(N,1)=14
              ELSE
                IBW(N,1)=4
              ENDIF
            ELSEIF(DABS(YI+1.0D0).LE.EPSX)THEN
              IF(DABS(XI-1.0D0).LE.EPSX)THEN
                IBW(N,1)=12
              ELSE
                IBW(N,1)=1
              ENDIF
            ELSEIF(DABS(XI-1.0D0).LE.EPSX)THEN
              IF(DABS(YI-1.0D0).LE.EPSX)THEN
                IBW(N,1)=13
              ELSE
                IBW(N,1)=2
              ENDIF
            ELSEIF(DABS(YI-1.0D0).LE.EPSX)THEN
              IBW(N,1)=3
            ELSE
              IBW(N,1)=0
            ENDIF
  160     CONTINUE
  165   CONTINUE
C
        DO 170 I=1,NYW
          DO J=1,NXW
            MW=(I-1)*NXW+J
            IEW(MW,1,1)=(I-1)*(NXW+1)+J
            IEW(MW,2,1)=(I-1)*(NXW+1)+J+1
            IEW(MW,3,1)=I*(NXW+1)+J+1
            IEW(MW,4,1)=I*(NXW+1)+J
          ENDDO
 170    CONTINUE
C
        NELW=NXW*NYW
        NNPW=(NXW+1)*(NYW+1)
        DO 190 I=1,NNPW
          NLRLW(I,1)=0
          DO 185 M1=1,NELW
            DO J=1,4
              IF(I.EQ.IEW(M1,J,1))THEN
                GOTO 180
              ENDIF
            ENDDO
            GOTO 185
 180        NLRLW(I,1)=NLRLW(I,1)+1
            K=NLRLW(I,1)
            LRLW(K,I,1)=M1
 185      CONTINUE
 190    CONTINUE
      ENDIF
      RETURN
      END
      SUBROUTINE GNTRAK
     I      (MAXNP,MXADNP,MAXEL,MXNPFG,MXKGL,MXNPW,MXELW,MXKBD,
     I       NNP,NEL,NEFG,NXW,NYW, IDETQ,IBF,EPSX,DELT,IDTI,IZOOM,
     I       IE,IB,LRL,NLRL,ISE,NFGMB,X,CP,VXAVG,XPFG,YPFG,CPFG,IBCHK,
     I       IEW,IBW,LRLW,NLRLW, XW,YW,VXW,VYW,ieww,ibww,lrlww,nlrlww,
     I       xww,yww,vxww,vyww,mxnpww,mxelww,nxg,nyg,nwnp,npw,
     i       iwtyp,wss,mxwnp,mxwpr,
     M       NPFGS,DTIFG,
     O       CS,DTI,  XSFG,YSFG,CSFG,MPLOCS)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION IE(MAXEL,9),IB(MXADNP),LRL(MXKBD,MAXNP),NLRL(MAXNP)
      DIMENSION ISE(MXKGL,4),NFGMB(MAXEL)
      DIMENSION X(MAXNP,2),CP(MAXNP),VXAVG(MAXNP,2)
      DIMENSION XPFG(MXNPFG),YPFG(MXNPFG),CPFG(MXNPFG), IBCHK(MAXEL)
      DIMENSION IEW(MXELW,4,2),IBW(MXNPW,2),LRLW(6,MXNPW,2)
      DIMENSION XW(MXNPW),YW(MXNPW),VXW(MXNPW),VYW(MXNPW),NLRLW(MXNPW,2)
      DIMENSION CS(MAXNP),DTI(MXADNP),DTIFG(MXNPFG)
      DIMENSION XSFG(MXNPFG),YSFG(MXNPFG),CSFG(MXNPFG),MPLOCS(MXNPFG)
      DIMENSION IEWw(MXELWw,4,2),IBWw(MXNPWw,2),LRLWw(6,MXNPWw,2)
      DIMENSION XWw(MXNPWw),YWw(MXNPWw),VXWw(MXNPWw),VYWw(MXNPWw),
     >          NLRLWw(MXNPWw,2)
      dimension npw(mxwnp),iwtyp(mxwnp),wss(mxwpr)
C
      DIMENSION XX(4),YY(4),VXX(4),VYY(4),IME(4)
C
C ***** LOOP OVER EACH GLOBAL NODE
C
      DO 600 N=1,NNP
C
        idps=0
C
        IF(IBF.EQ.2)THEN
          DO I=1,NLRL(N)
            M=LRL(I,N)
            IF(IE(M,6).NE.0 .AND. IB(N).EQ.0)GOTO 600
          ENDDO
        ENDIF
C
        IF(IBF.EQ.1)DTI(N)=1.0D0/DELT
        SDT=DELT
c
        if(izoom.ne.0)then
          do 100 i=1,nwnp
            if(n.ne.npw(i))goto 100
            if(ibf.eq.1)then
              if(ib(n).eq.-1)then
                dti(n)=1.0d38
                iprof=iwtyp(i)
                cs(n)=wss(iprof)
                goto 600
              endif
              goto 110
            else
              if(ib(n).eq.-1)goto 600
              idps=1
              iprof=iwtyp(i)
              cps=wss(iprof)
              cpsp=cp(n)
              goto 110
            endif
  100     continue
        endif
C ----- PREPARE INFORMATION OF SOURCE POINT P
  110   continue
        CALL REPLAS(X(N,1),X(N,2),VXAVG(N,1),VXAVG(N,2),XP,YP,VPX,VPY)
C ----- CHECK THE VELOCITY OF POINT P
        IF(VPX.EQ.0.0D0 .AND. VPY.EQ.0.0D0)THEN
          IF(IBF.EQ.1)CS(N)=CP(N)
          GOTO 600
        ENDIF
C ----- PREPARE INFORMATION OF ARRAY XX,YY,VXX AND VYY
        NLRLN=NLRL(N)
        DO 150 I=1,NLRLN
          M=LRL(I,N)
          CALL ELENOD(IE(M,4),NODE)
          CALL WRKARY(J,IE,X(1,1),X(1,2),VXAVG(1,1),VXAVG(1,2),MAXEL,9,
     O                MAXNP,M,NODE,4,1,  IME,XX,YY,VXX,VYY)
C ----- DETERMINE TARGET POINT Q
          if(idps.eq.1)then
            CALL ELETRK
     I        (XP,YP,VPX,VPY,XX,YY,VXX,VYY,SDT,IBF,NODE,IDETQ,EPSX,
     I         MXNPWw,MXELWw,NXg,NYg,IBWw,NLRLWw,LRLWw,IEWw,IME,
     i         idps,cps,cpsp,delt,mxnpfg,M,
     M         XWw,YWw,VXWw,VYWw, N1,N2,
     O         XQ,YQ,VXQ,VYQ,SDT1,npfgs,xsfg,ysfg,csfg,mplocs)
          else
            CALL ELETRK
     I        (XP,YP,VPX,VPY,XX,YY,VXX,VYY,SDT,IBF,NODE,IDETQ,EPSX,
     I         MXNPW,MXELW,NXW,NYW,IBW,NLRLW,LRLW,IEW,IME,
     i         idps,cps,cpsp,delt,mxnpfg,M,
     M         XW,YW,VXW,VYW, N1,N2,
     O         XQ,YQ,VXQ,VYQ,SDT1,npfgs,xsfg,ysfg,csfg,mplocs)
          endif
C
          IF(SDT1.EQ.0.)GOTO 500
          IF(SDT.NE.SDT1)GOTO 250
C
  150   CONTINUE
C ----- CHECK IF THIS POINT IS A BOUNDARY NODE
        IFIX=1
        CALL FIXCHK
     I    (IFIX,IDTI,N,N,M,N1,N2,IBF,XP,YP,VPX,VPY,DELT,SDT,SDT1,
     I     X,IE,IB,VXAVG,LRL,NLRL,CP,MXKBD,MAXNP,MXADNP,MAXEL,MXNPFG,
     O     CS,CSFG,DTI,DTIFG,XQ,YQ,ICODE)
        IF(ICODE.EQ.1)GOTO 580
        IF(ICODE.EQ.0)GOTO 600
        WRITE(16,*)'ERROR IN FIXCHK, ICODE=',ICODE
        STOP
C
C ----- START THE NEXT TRACKING
C
  250   CONTINUE
C
        IF(IBF.EQ.2 .AND. (IB(N).NE.0 .AND. IB(N).LE.3))IBCHK(M)=M       1/06/95
        SDT=SDT1
        CALL REPLAS(XQ,YQ,VXQ,VYQ,XP,YP,VPX,VPY)
C ----- CHECK IF POINT P COINCIDES WITH A GLOBAL NODE
        CALL CKCOIN
     I            (X(1,1),X(1,2),XP,YP,NLRL,N1,N2,MAXNP,EPSX,
     O             NN,NLRLN)
        IF(NN.EQ.0)GOTO 400
C ----- FOR THE CASES THAT POINT P IS A GLOBAL NODE
        CALL REPLAS(X(NN,1),X(NN,2),VXAVG(NN,1),VXAVG(NN,2),
     >              XP,YP,VPX,VPY)
c
        if(izoom.ne.0)then
          do 300 i=1,nwnp
            if(nn.ne.npw(i))goto 300
            if(ibf.eq.1)then
              dtreal=delt-sdt
              xsi=(delt-dtreal)/delt
              iprof=iwtyp(i)
              cc=cp(nn)*xsi+wss(iprof)*(1.0d0-xsi)
              dti(n)=1.0d0/dtreal
              cs(n)=cc
            endif
            goto 600
  300     continue
        endif
c
  310   continue
c
        DO 350 I=1,NLRLN
          MM=LRL(I,NN)
          IF(MM.EQ.M)THEN
            GOTO 350
          ELSE
            M=MM
            CALL ELENOD(IE(M,4),NODE)
          ENDIF
C ----- CHECK IF ELEMENT M IS THE ELEMENT THAT THIS POINT WOULD FALL
C       ONTO
          CALL WRKARY(J,IE,X(1,1),X(1,2),VXAVG(1,1),VXAVG(1,2),MAXEL,9,
     O                MAXNP,M,NODE,4,1,  IME,XX,YY,VXX,VYY)
          if(idps.eq.1)then
            CALL ELETRK
     I        (XP,YP,VPX,VPY,XX,YY,VXX,VYY,SDT,IBF,NODE,IDETQ,EPSX,
     I         MXNPWw,MXELWw,NXg,NYg,IBWw,NLRLWw,LRLWw,IEWw,IME,
     i         idps,cps,cpsp,delt,mxnpfg,M,
     M         XWw,YWw,VXWw,VYWw, N1,N2,
     O         XQ,YQ,VXQ,VYQ,SDT1,npfgs,xsfg,ysfg,csfg,mplocs)
          else
            CALL ELETRK
     I        (XP,YP,VPX,VPY,XX,YY,VXX,VYY,SDT,IBF,NODE,IDETQ,EPSX,
     I         MXNPW,MXELW,NXW,NYW,IBW,NLRLW,LRLW,IEW,IME,
     i         idps,cps,cpsp,delt,mxnpfg,M,
     M         XW,YW,VXW,VYW, N1,N2,
     O         XQ,YQ,VXQ,VYQ,SDT1,npfgs,xsfg,ysfg,csfg,mplocs)
          endif
C
          IF(SDT1.EQ.0.)GOTO 500
          IF(SDT.NE.SDT1)GOTO 250
C
  350   CONTINUE
C ----- CHECK IF THIS POINT IS A BOUNDARY NODE
        IFIX=2
        CALL FIXCHK
     I    (IFIX,IDTI,N,NN,M,N1,N2,IBF,XP,YP,VPX,VPY,DELT,SDT,SDT1,
     I     X,IE,IB,VXAVG,LRL,NLRL,CP,MXKBD,MAXNP,MXADNP,MAXEL,MXNPFG,
     O     CS,CSFG,DTI,DTIFG,XQ,YQ,ICODE)
        IF(ICODE.EQ.1)GOTO 580
        IF(ICODE.EQ.0)GOTO 600
        WRITE(16,*)'ERROR OCCURRED IN FIXCHK, ICODE=',ICODE
        STOP
C
C ----- FOR THE CASES THAT POINT P IS NOT A GLOBAL NODE
  400   CONTINUE
        CALL ONLINE(X(1,1),X(1,2),N1,N2,MAXNP, XP,YP)
        NLRL1=NLRL(N1)
        NLRL2=NLRL(N2)
        DO 420 I1=1,NLRL1
          M1=LRL(I1,N1)
          DO I2=1,NLRL2
            M2=LRL(I2,N2)
            IF(M1.EQ.M2 .AND. M1.NE.M)GOTO 430
          ENDDO
  420   CONTINUE
        GOTO 450
C
  430   CONTINUE
        ME=M
        M=M1
C
  431   CONTINUE
        CALL ELENOD(IE(M,4),NODE)
        CALL WRKARY(J,IE,X(1,1),X(1,2),VXAVG(1,1),VXAVG(1,2),MAXEL,9,
     O              MAXNP,M,NODE,4,1,  IME,XX,YY,VXX,VYY)
C
  450   CONTINUE
C
        if(idps.eq.1)then
          CALL ELETRK
     I      (XP,YP,VPX,VPY,XX,YY,VXX,VYY,SDT,IBF,NODE,IDETQ,EPSX,
     I       MXNPWw,MXELWw,NXg,NYg,IBWw,NLRLWw,LRLWw,IEWw,IME,
     i       idps,cps,cpsp,delt,mxnpfg,M,
     M       XWw,YWw,VXWw,VYWw, N1,N2,
     O       XQ,YQ,VXQ,VYQ,SDT1,npfgs,xsfg,ysfg,csfg,mplocs)
        else
          CALL ELETRK
     I      (XP,YP,VPX,VPY,XX,YY,VXX,VYY,SDT,IBF,NODE,IDETQ,EPSX,
     I       MXNPW,MXELW,NXW,NYW,IBW,NLRLW,LRLW,IEW,IME,
     i       idps,cps,cpsp,delt,mxnpfg,M,
     M       XW,YW,VXW,VYW, N1,N2,
     O       XQ,YQ,VXQ,VYQ,SDT1,npfgs,xsfg,ysfg,csfg,mplocs)
        endif
C
        IF(SDT1.EQ.0.)GOTO 500
        IF(SDT.NE.SDT1)GOTO 250
C ----- CHECK IF THIS POINT IS ON A BOUNDARY SIDE
        CALL CKCNEL(N1,N2,M,NLRL,LRL,MAXNP,MXKBD, ME,KOUNT)
        IF(KOUNT.EQ.1)THEN
          IFIX=3
          CALL FIXCHK
     I    (IFIX,IDTI,N,N,M,N1,N2,IBF,XP,YP,VPX,VPY,DELT,SDT,SDT1,
     I     X,IE,IB,VXAVG,LRL,NLRL,CP,MXKBD,MAXNP,MXADNP,MAXEL,MXNPFG,
     O     CS,CSFG,DTI,DTIFG,XQ,YQ,ICODE)
          IF(ICODE.EQ.1)GOTO 580
          IF(ICODE.EQ.0)GOTO 600
        ENDIF
C
        IF(M.NE.ME)THEN
          M=ME
          GOTO 431
        ENDIF
C ----- ERROR OCCURRED
        WRITE(16,*)'ERROR 3 AT GNTRAK ----- N1=',N1,'N2=',N2
        STOP
C
C ***** DETERMINE CONCENTRATION
C
  500   CONTINUE
C
C ----- FOR THE CASES OF BACKWARD TRACKING
C
        IF(IBF.EQ.1)THEN
          CALL INTERP
     I        (MAXNP,MAXEL,MXNPFG,MXKGL,NODE,M,1,XQ,YQ,EPSX,NEL,
     I         NEFG,X(1,1),X(1,2),CP,IE,XPFG,YPFG,CPFG,ISE,NFGMB,
     O         CQ)
          CS(N)=CQ
          GOTO 600
        ENDIF
C
C ----- FOR THE CASES OF FORWARD TRACKING
C
  580   CONTINUE
        IF(IB(N).NE.0 .AND. IB(N).LE.3)IBCHK(M)=M                        1/06/95
        IE(M,7)=M
        NPFGS=NPFGS+1
        CALL WARMSG(NPFGS,MXNPFG,'GNTRAK','MXNPFG',1)
        XSFG(NPFGS)=XQ
        YSFG(NPFGS)=YQ
        CSFG(NPFGS)=CP(N)
        MPLOCS(NPFGS)=M
C
  600 CONTINUE
      RETURN
      END
      SUBROUTINE FIXCHK
     I    (IFIX,IDTI,N,NN,M,N1,N2,IBF,XP,YP,VPX,VPY,DELT,
     I     SDT,SDT1,X,IE,IB,VXAVG,LRL,NLRL,CP,
     I     MXKBD,MAXNP,MXADNP,MAXEL,MXNPFG,
     O     CS,CSFG,DTI,DTIFG,XQ,YQ,ICODE)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
C
C -------------------------------------------------------------------
C ***** THIS SUBROUTINE IS USED TO TAKE CARE THE POINT FIXED, I.E. IT
C       WON'T MOVE INTO THE REGION OF INTEREST
C $$$ IFIX: THE INDEX OF THE LOCATION IN GNTRAC OR HPTRAC CALLING
C            FIXCHK
C $$$ IDTI: THE INDEX DETERMINING DTI CALCUATIONS
C          -1 : DTI AND CS HAVE TO BE CALCULATED AND IS BACK TO GNTRAC
C           0 : ONLY CONC. BUT NO DTI AND BACK TO HPTRAC
C           1 : ONLY DTI   AND BACK TO HPTRAC
C           2 : BOTH DTIFG AND CSFG ARE BACK TO HPTRAC WHICH IS CALLED
C               BY FGDET
C --------------------------------------------------------------------
C
      LOGICAL BOUND,SPECFY
      DIMENSION CS(MAXNP),CP(MAXNP),X(MAXNP,2),VXAVG(MAXNP,2)
      DIMENSION IE(MAXEL,9),IB(MAXNP),LRL(MXKBD,MAXNP),NLRL(MAXNP)
      DIMENSION DTIFG(MXNPFG),CSFG(MXNPFG),DTI(MXADNP)
C
      BOUND=.FALSE.
      SPECFY=.FALSE.
      IF(IFIX.EQ.1 .OR. IFIX.EQ.2)THEN
        IF(IB(NN).NE.0)THEN
          BOUND=.TRUE.
          IGLOBL=1
          N1=NN
        ENDIF
        IF(IB(NN).LE.3)SPECFY=.TRUE.
      ELSEIF(IFIX.EQ.3)THEN
        BOUND=.TRUE.
        IF(IB(N1).LE.3 .AND. IB(N2).LE.3)SPECFY=.TRUE.
        IGLOBL=0
      ENDIF
C
      ICODE=-1
      IF(BOUND)THEN
        IF(SPECFY)THEN
          IF(IBF.EQ.1)THEN
            IF(IFIX.EQ.1)THEN
              DTI(N)=1.0D30
            ELSEIF(IFIX.EQ.2)THEN
              IF(IDTI.LT.0)THEN
                CS(N)=CP(NN)+(CS(NN)-CP(NN))*SDT1/DELT
                DTI(N)=1.0/(DELT-SDT1)
              ELSEIF(IDTI.EQ.1)THEN
                DTI(N)=1.0D0/(DELT-SDT1)
              ELSE
                CSFG(N)=CP(NN)+(CS(NN)-CP(NN))*SDT1/DELT
                IF(IDTI.EQ.2)DTIFG(N)=1.0D0/(DELT-SDT1)
              ENDIF
            ELSEIF(IFIX.EQ.3)THEN
              XSI=DSQRT((XP-X(N2,1))**2+(YP-X(N2,2))**2)/
     >            DSQRT((X(N1,1)-X(N2,1))**2+(X(N1,2)-X(N2,2))**2)
              C1=CP(N1)+(CS(N1)-CP(N1))*SDT1/DELT
              C2=CP(N2)+(CS(N2)-CP(N2))*SDT1/DELT
              IF(IDTI.NE.0)THEN
                DTREAL=DELT-SDT1
              ELSE
                DTREAL=0.0D0
              ENDIF
              IF(DTREAL.EQ.0.0D0)THEN
                DTIVS=1.0D30
              ELSE
                DTIVS=1.0D0/DTREAL
              ENDIF
              IF(IDTI.LT.0)THEN
                CS(N)=C1*XSI+C2*(1.0D0-XSI)
                DTI(N)=DTIVS
              ELSEIF(IDTI.EQ.1)THEN
                DTI(N)=DTIVS
              ELSE
                CSFG(N)=C1*XSI+C2*(1.0D0-XSI)
                IF(IDTI.EQ.2)DTIFG(N)=DTIVS
              ENDIF
            ENDIF
            ICODE=0
          ENDIF
         ELSE
          CALL ALGBDY
     I     (XP,YP,X(1,1),X(1,2),IE,NLRL,LRL,IB,IGLOBL,M,MXKBD,MAXNP,
     I      MAXEL,VPX,VPY,VXAVG(1,1),VXAVG(1,2),SDT,IBF,
     M      N1,N2,
     O      XQ,YQ,VQX,VQY,XSI,SDT1)
          IF(IBF.EQ.2)THEN
            IF(SDT1.EQ.0.0D0)THEN
              ICODE=1
            ELSE
              ICODE=0
            ENDIF
            RETURN
          ENDIF
          DTREAL=DELT-SDT1
          IF(DTREAL.EQ.0.0D0)THEN
            DTIVS=1.0D30
          ELSE
            DTIVS=1.0D0/DTREAL
          ENDIF
          IF(IDTI.EQ.1)THEN
            DTI(N)=DTIVS
            ICODE=0
            RETURN
          ELSEIF(IFIX.EQ.1)THEN
            DTI(N)=DTIVS
          ELSEIF(IDTI.EQ.2)THEN
            DTIFG(N)=DTIVS
          ENDIF
C
  50      CONTINUE
          IF(SDT1.EQ.0.0D0)THEN
            IF(XQ.EQ.XP .AND. YQ.EQ.YP .AND. IFIX.NE.3)THEN
              IF(IFIX.EQ.2)THEN
                IF(IDTI.EQ.-1)THEN
                  CS(N)=CP(NN)
                ELSE
                  CSFG(N)=CP(NN)
                ENDIF
              ENDIF
            ELSE
              IF(IDTI.EQ.-1)THEN
                CS(N)=CP(N1)*(1.0-XSI)+CP(N2)*XSI
              ELSE
                CSFG(N)=CP(N1)*(1.0-XSI)+CP(N2)*XSI
              ENDIF
            ENDIF
          ELSE
            IF(IDTI.EQ.-1)THEN
              CS(N)=CP(N1)+(CS(N1)-CP(N1))*SDT1/DELT
            ELSE
              CSFG(N)=CP(N1)+(CS(N1)-CP(N1))*SDT1/DELT
            ENDIF
          ENDIF
        ENDIF
        ICODE=0
        RETURN
      ENDIF
C ----- ERROR OCCURRED HERE
      IF(ICODE.EQ.-1 .AND. IFIX.NE.3)THEN
        WRITE(16,*)'ERROR OCCURRED AT FIXCHK, IFIX,NODE=',IFIX,N
        STOP
      ENDIF
C
      RETURN
      END
      SUBROUTINE HPTRAK
     I       (MAXNP,MAXEL,MXNPFG,MXKGL,MXNPW,MXELW,MXKBD,MXNODE,MXNODS,
     I        MXADNP,MXCSND,NEL,NEFG,NXW,NYW,IDETQ,IBF,EPSX,
     I        IDTI,DELT, IE,IB,LRL,NLRL,ISE,NFGMB,
     I        X,CP,CS,VXAVG,XPFG,YPFG,CPFG,MPLOC,
     I        IEW,IBW,LRLW,NLRLW,  XW,YW,VXW,VYW,  NINIT,NPFG,NPFGS,
     i        nwnp,npw,iwtyp,wss,mxwnp,mxwpr,
     M        DTI,DTIFG, NPFGEP,XEFG,YEFG,CEFG,MPLOCE,
     O        XSFG,YSFG,CSFG,MPLOCS)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION IE(MAXEL,9),IB(MXADNP),LRL(MXKBD,MAXNP),NLRL(MAXNP)
      DIMENSION ISE(MXKGL,4),NFGMB(MAXEL)
      DIMENSION X(MAXNP,2),CP(MAXNP),CS(MXCSND),VXAVG(MAXNP,2)
      DIMENSION XPFG(MXNPFG),YPFG(MXNPFG),CPFG(MXNPFG),MPLOC(MXNPFG)
      DIMENSION IEW(MXELW,4,2),IBW(MXNPW,2),LRLW(6,MXNPW,2)
      DIMENSION XW(MXNPW),YW(MXNPW),VXW(MXNPW),VYW(MXNPW),NLRLW(MXNPW,2)
      DIMENSION XSFG(MXNODS),YSFG(MXNODS),CSFG(MXNODS),MPLOCS(MXNPFG)
      DIMENSION DTI(MXADNP),DTIFG(MXNPFG)
      DIMENSION XEFG(MXNODE),YEFG(MXNODE),CEFG(MXNODE),MPLOCE(MXNPFG)
      dimension npw(mxwnp),iwtyp(mxwnp),wss(mxwpr)
C
      DIMENSION XX(4),YY(4),VXX(4),VYY(4),IME(4),DL(4)
C
C ----- if idti = 1 ==> calculate DTI array only in the subroutine
C                       used for diffusion zooming points
C ----- if idti = 2 ==> calculate both DTIFG and CSFG arrays
C                       used for generated regular fine grids
C ----- if idti = 0 ==> calculate CSFG array only
C                       used for forward tracked points and EPCOF points
C
C ***** TRACK HIDDEN POINTS
C
        IF(IBF.EQ.1)THEN
          NWFG=NPFGS
        ELSE
          NWFG=NPFG
        ENDIF
C
        DO 650 N=NINIT,NWFG
C
          idps=0
C
          IF(IBF.EQ.1)THEN
            CALL REP3RI(XSFG(N),YSFG(N),DELT,MPLOCS(N),XP,YP,SDT,M)
          ELSE
            CALL REP3RI(XPFG(N),YPFG(N),DELT,MPLOC(N),XP,YP,SDT,M)
          ENDIF
          MM=M
C
  120     CONTINUE
          SDT1=SDT
          CALL ELENOD(IE(MM,4),NODE)
C ----- CHECK IF THIS POINT IS A GLOBAL NODE
          DO I=1,NODE
            N1=IE(MM,I)
            IF(DABS(XP-X(N1,1)).LE.EPSX.AND. DABS(YP-X(N1,2)).LE.EPSX)
     >        THEN
              IF(IBF.EQ.1)THEN
                CALL REP3RI(X(N1,1),X(N1,2),CS(N1),MM,XSFG(N),YSFG(N),
     >                      CSFG(N),MPLOCS(N))
                IF(IDTI.EQ.1)DTI(N)=DTI(N1)
                IF(IDTI.EQ.2)DTIFG(N)=DTI(N1)
                GOTO 650
              ENDIF
              IF(IBF.EQ.2)THEN
                NN=N1
                NLRLN=NLRL(N1)
                SDT=DELT
                CALL REPLAS(X(N1,1),X(N1,2),VXAVG(N1,1),VXAVG(N1,2),
     >                      XP,YP,VPX,VPY)
                CALL MOVCHK
     I           (IBF,XP,YP,VPX,VPY,N,MM,X,CP,IE,XPFG,YPFG,CPFG,MXNPFG,
     I            MXKGL,MXNODE,MXNODS,MAXNP,MAXEL,NPFGS,NPFGEP,XSFG,
     I            YSFG,CSFG,MPLOCS,ISE,NFGMB,NEL,NEFG,IDTI,NODE,EPSX,
     M            XEFG,YEFG,CEFG,MPLOCE,DTIFG,ICODE)
                IF(ICODE.EQ.0)GOTO 650
C
                do ii=1,nwnp
                  if(n1.eq.npw(ii))goto 650
                enddo
c
                GOTO 349
              ENDIF
            ENDIF
          ENDDO
C
  130   CONTINUE
        CALL WRKARY(J,IE,X(1,1),X(1,2),VXAVG(1,1),VXAVG(1,2),MAXEL,9,
     O              MAXNP,MM,NODE,4,1,  IME,XX,YY,VXX,VYY)
        CALL BASE1
     I       (XX,YY,XP,YP,MM,NODE,
     O        DL)
        CALL VALBDL(VXX,VYY,DL,4,NODE,VPX,VPY)
C
        CALL MOVCHK
     I     (IBF,XP,YP,VPX,VPY,N,MM,X,CP,IE,XPFG,YPFG,CPFG,MXNPFG,MXKGL,
     I      MXNODE,MXNODS,MAXNP,MAXEL,NPFGS,NPFGEP,XSFG,YSFG,CSFG,
     I      MPLOCS,ISE,NFGMB,NEL,NEFG,IDTI,NODE,EPSX,
     O      XEFG,YEFG,CEFG,MPLOCE,DTIFG,ICODE)
        IF(ICODE.EQ.0)GOTO 650
C
        CALL ELETRK
     I      (XP,YP,VPX,VPY,XX,YY,VXX,VYY,SDT,IBF,NODE,IDETQ,EPSX,
     I       MXNPW,MXELW,NXW,NYW,IBW,NLRLW,LRLW,IEW,IME,
     i       idps,cps,cpsp,delt,mxnpfg,MM,
     M       XW,YW,VXW,VYW, N1,N2,
     O       XQ,YQ,VXQ,VYQ,SDT1,npfgs,xsfg,ysfg,csfg,mplocs)
C
          IF(SDT1.EQ.0.)GOTO 500
          IF(SDT.NE.SDT1)GOTO 250
C
          CALL CKSIDE
     I       (X(1,1),X(1,2),LRL,NLRL,IE,XP,YP,N1,N2,NODE,MM,MAXNP,MAXEL,
     O        9,MXKBD,EPSX,  M1,ICODE)
          IF(ICODE.EQ.1)THEN
            MM=M1
            GOTO 120
          ELSEIF(ICODE.EQ.0)THEN
            IFIX=3
            CALL FIXCHK
     I        (IFIX,IDTI,N,N,MM,N1,N2,IBF,XP,YP,VPX,VPY,DELT,SDT,SDT1,
     I        X,IE,IB,VXAVG,LRL,NLRL,CP,MXKBD,MAXNP,MXADNP,MAXEL,MXNPFG,
     O        CS,CSFG,DTI,DTIFG,XQ,YQ,ICODE)
            IF(ICODE.EQ.1)GOTO 146
            IF(ICODE.EQ.0)GOTO 650
          ENDIF
C
C ----- ERROR OCCURRED
          WRITE(16,*)'ERROR 1 AT HPTRAC, N=',N
          STOP
C
C ----- TRACK AGAIN
C
  250     CONTINUE
          SDT=SDT1
          CALL REPLAS(XQ,YQ,VXQ,VYQ,XP,YP,VPX,VPY)
C ----- CHECK IF POINT P COINCIDES WITH A GLOBAL NODE
          CALL CKCOIN
     I            (X(1,1),X(1,2),XP,YP,NLRL,N1,N2,MAXNP,EPSX,
     O             NN,NLRLN)
          IF(NN.EQ.0)GOTO 400
          CALL REPLAS(X(NN,1),X(NN,2),VXAVG(NN,1),VXAVG(NN,2),XP,YP,
     >                VPX,VPY)
c
          do 300 i=1,nwnp
            if(nn.ne.npw(i))goto 300
            if(ibf.eq.1)then
              dtreal=delt-sdt
              if(idti.eq.1 .or.idti.eq.2)dtifg(n)=1.0d0/dtreal
              if(idti.ne.1)then
                iprof=iwtyp(i)
                csfg(n)=wss(iprof)
              endif
            endif
            goto 650
  300     continue
C ----- FOR THE CASES THAT THIS POINT IS A GLOBAL NODE
  349     CONTINUE
C
          DO 350 I=1,NLRLN
            M1=LRL(I,NN)
c           IF(M1.EQ.MM)GOTO 350
            MM=M1
            CALL ELENOD(IE(MM,4),NODE)
C
            CALL WRKARY(J,IE,X(1,1),X(1,2),VXAVG(1,1),VXAVG(1,2),MAXEL,
     O                  9,MAXNP,MM,NODE,4,1,  IME,XX,YY,VXX,VYY)
            CALL ELETRK
     I          (XP,YP,VPX,VPY,XX,YY,VXX,VYY,SDT,IBF,NODE,IDETQ,EPSX,
     I           MXNPW,MXELW,NXW,NYW,IBW,NLRLW,LRLW,IEW,IME,
     i           idps,cps,cpsp,delt,mxnpfg,MM,
     M           XW,YW,VXW,VYW, N1,N2,
     O           XQ,YQ,VXQ,VYQ,SDT1,npfgs,xsfg,ysfg,csfg,mplocs)
C
            IF(SDT1.EQ.0.)GOTO 500
            IF(SDT.NE.SDT1)GOTO 250
C
  350     CONTINUE
C ----- CHECK IF THIS POINT IS A BOUNDARY NODE
          IFIX=2
          CALL FIXCHK
     I       (IFIX,IDTI,N,NN,MM,N1,N2,IBF,XP,YP,VPX,VPY,DELT,SDT,SDT1,
     I        X,IE,IB,VXAVG,LRL,NLRL,CP,MXKBD,MAXNP,MXADNP,MAXEL,MXNPFG,
     O        CS,CSFG,DTI,DTIFG,XQ,YQ,ICODE)
          IF(ICODE.EQ.1)GOTO 146
          IF(ICODE.EQ.0)GOTO 650
C ----- ERROR OCCURRED
          WRITE(16,*)'ERROR 2 AT HPTRAC, N=',N
          STOP
C ----- FOR THE CASES THAT THIS POINT IS NOT A GLOBAL NODE
  400     CONTINUE
          CALL ONLINE(X(1,1),X(1,2),N1,N2,MAXNP, XP,YP)
C ----- CHECK IF N1 AND N2 ARE BOUNDARY POINTS
          CALL CKCNEL(N1,N2,MM,NLRL,LRL,MAXNP,MXKBD, M1,KOUNT)
C
C ----- N1 AND N2 ARE BOUNDARY POINTS
          IF(KOUNT.EQ.1)GOTO 450
C ----- N1 OR N2 IS NOT BOUNDARY POINT
  430     CONTINUE
          MM=M1
          CALL ELENOD(IE(MM,4),NODE)
C
          CALL WRKARY(J,IE,X(1,1),X(1,2),VXAVG(1,1),VXAVG(1,2),MAXEL,9,
     O                MAXNP,MM,NODE,4,1,  IME,XX,YY,VXX,VYY)
C
  450     CONTINUE
C
          CALL ELETRK
     I        (XP,YP,VPX,VPY,XX,YY,VXX,VYY,SDT,IBF,NODE,IDETQ,EPSX,
     I         MXNPW,MXELW,NXW,NYW,IBW,NLRLW,LRLW,IEW,IME,
     i         idps,cps,cpsp,delt,mxnpfg,MM,
     M         XW,YW,VXW,VYW, N1,N2,
     O         XQ,YQ,VXQ,VYQ,SDT1,npfgs,xsfg,ysfg,csfg,mplocs)
C
          IF(SDT1.EQ.0.)GOTO 500
          IF(SDT1.NE.SDT)GOTO 250
C
          CALL CKCNEL(N1,N2,MM,NLRL,LRL,MAXNP,MXKBD, ME,KOUNT)
          IF(KOUNT.EQ.1)THEN
            IFIX=3
            CALL FIXCHK
     I       (IFIX,IDTI,N,N,MM,N1,N2,IBF,XP,YP,VPX,VPY,DELT,SDT,SDT1,
     I        X,IE,IB,VXAVG,LRL,NLRL,CP,MXKBD,MAXNP,MXADNP,MAXEL,MXNPFG,
     O        CS,CSFG,DTI,DTIFG,XQ,YQ,ICODE)
            IF(ICODE.EQ.1)GOTO 146
            IF(ICODE.EQ.0)GOTO 650
          ENDIF
C ----- ERROR OCCURRED
          WRITE(16,*)'ERROR 2 AT HPTRAC, N=',N
          STOP
C
  500     CONTINUE
C
C ----- RECORDING INFORMATION
C
C ----- FOR THE CASES OF BACKWARD TRACKING
C
        IF(IBF.EQ.1)THEN
          IF(IDTI.NE.1)THEN
            CALL INTERP
     I          (MAXNP,MAXEL,MXNPFG,MXKGL,NODE,MM,1,XQ,YQ,EPSX,NEL,
     I           NEFG,X(1,1),X(1,2),CP,IE,XPFG,YPFG,CPFG,ISE,NFGMB,
     O           CQ)
            CSFG(N)=CQ
            IF(IDTI.EQ.2)DTIFG(N)=1.0D0/DELT
          ELSE
            DTI(N)=1.0D0/DELT
          ENDIF
          GOTO 650
        ENDIF
C
C ----- FOR THE CASES OF FORWARD TRACKING
C
        IE(MM,7)=MM
C
        CALL ELENOD(IE(MM,4),NODE1)
        DO KK=1,NODE1
          IEMKK=IE(MM,KK)
          XR=X(IEMKK,1)
          YR=X(IEMKK,2)
          DIST=DSQRT((XQ-XR)**2+(YQ-YR)**2)
          IF(DIST.LT.EPSX)THEN
            CS(IEMKK)=CPFG(N)
            GOTO 146
          ENDIF
        ENDDO
C
  146   CONTINUE
        IF(MPLOCE(N).EQ.0)THEN
          NPFGS=NPFGS+1
          CALL WARMSG(NPFGS,MXNPFG,'HPTRAK','MXNPFG',1)
          CALL REP3RI(XQ,YQ,CPFG(N),MM,
     >                XSFG(NPFGS),YSFG(NPFGS),CSFG(NPFGS),MPLOCS(NPFGS))
        ELSE
          NPFGEP=NPFGEP+1
          CALL WARMSG(NPFGEP,MXNODE,'HPTRAK','MXNEP ',2)
          CALL REP3RI(XQ,YQ,CPFG(N),MM,  XEFG(NPFGEP),
     >                YEFG(NPFGEP),CEFG(NPFGEP),MPLOCE(NPFGEP))
        ENDIF
C
  650 CONTINUE
C
      RETURN
      END
      SUBROUTINE MOVCHK
     I    (IBF,XP,YP,VPX,VPY,N,MM,X,CP,IE,XPFG,YPFG,CPFG,MXNPFG,MXKGL,
     I     MXNODE,MXNODS,MAXNP,MAXEL,NPFGS,NPFGEP,XSFG,YSFG,CSFG,MPLOCS,
     I     ISE,NFGMB,NEL,NEFG,IDTI,NODE,EPSX,
     O     XEFG,YEFG,CEFG,MPLOCE,DTIFG, ICODE)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION X(MAXNP,2),CP(MAXNP),IE(MAXEL,9)
      DIMENSION XPFG(MXNPFG),YPFG(MXNPFG),CPFG(MXNPFG),DTIFG(MXNPFG)
      DIMENSION XSFG(MXNODS),YSFG(MXNODS),CSFG(MXNODS),MPLOCS(MXNODS)
      DIMENSION XEFG(MXNODE),YEFG(MXNODE),CEFG(MXNODE),MPLOCE(MXNPFG)
      DIMENSION ISE(MXKGL,4),NFGMB(MAXEL)
C
      ICODE=-1
      IF(VPX.EQ.0.0D0 .AND. VPY.EQ.0.0D0)THEN
        IF(IBF.EQ.1)THEN
          IF(IDTI.NE.1)THEN
            CALL INTERP
     I          (MAXNP,MAXEL,MXNPFG,MXKGL,NODE,MM,1,XP,YP,EPSX,NEL,
     I           NEFG,X(1,1),X(1,2),CP,IE,XPFG,YPFG,CPFG,ISE,NFGMB,
     O           CQ)
            CSFG(N)=CQ
            MPLOCS(N)=MM
            IF(IDTI.EQ.2)DTIFG(N)=1.0D30
          ENDIF
        ELSE
          IF(MPLOCE(N).EQ.0)THEN
            NPFGS=NPFGS+1
            CALL WARMSG(NPFGS,MXNPFG,'MOVCHK','MXNPFG',1)
            CALL REP3RI(XPFG(N),YPFG(N),CPFG(N),MM, XSFG(NPFGS),
     >                  YSFG(NPFGS),CSFG(NPFGS),MPLOCS(NPFGS))
          ELSE
            NPFGEP=NPFGEP+1
            CALL WARMSG(NPFGEP,MXNODE,'MOVCHK','MXNEP ',2)
            CALL REP3RI(XPFG(N),YPFG(N),CPFG(N),MM, XEFG(NPFGEP),
     >                  YEFG(NPFGEP),CEFG(NPFGEP),MPLOCE(NPFGEP))
          ENDIF
        ENDIF
        ICODE=0
      ENDIF
      RETURN
      END
      SUBROUTINE CKSIDE
     I    (X,Y,LRL,NLRL,IE,XP,YP,N1,N2,NODE,MM,MAXNP,MAXEL,NO2,MXKBD,
     O     EPSX,  M1,ICODE)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION X(MAXNP),Y(MAXNP),IE(MAXEL,NO2),NLRL(MAXNP)
      DIMENSION LRL(MXKBD,MAXNP)
C
      ICODE=-1
      EPSXX=10.0D0*EPSX
      DO 240 I=1,NODE
        I1=I+1
        IF(I1.GT.NODE)I1=I1-NODE
        IEM1=IE(MM,I)
        IEM2=IE(MM,I1)
C ----- JUDGE IF P IS ON THE SIDES OF ELEMENT M
        A=((XP-X(IEM1))*(Y(IEM2)-Y(IEM1))-(YP-Y(IEM1))*
     1    (X(IEM2)-X(IEM1)))/DSQRT((X(IEM2)-X(IEM1))**2+
     >    (Y(IEM2)-Y(IEM1))**2)
        IF(DABS(A).LE.EPSXX)THEN
C ----- CHECK IF THIS SIDE IS A BOUNDARY SIDE
c          KOUNT=0
          NLRL1=NLRL(N1)
          NLRL2=NLRL(N2)
          DO 202 I1=1,NLRL1
            M1=LRL(I1,N1)
            DO I2=1,NLRL2
              M2=LRL(I2,N2)
              IF(M1.EQ.M2 .AND. M2.NE.MM)THEN
                ICODE=1
                RETURN
              ENDIF
            ENDDO
  202     CONTINUE
          ICODE=0
          RETURN
        ENDIF
  240 CONTINUE
      RETURN
      END
      SUBROUTINE SFDET
     I              (MAXNP,MAXEL,MXNPFG,MXTNOD,KWB,KWE,
     I               ADPARM,ADPEPS,CMX,
     I               X,Y,CS,XSFG,YSFG,CSFG,MPLOCS,
     M               IE)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION X(MAXNP),Y(MAXNP),CS(MAXNP)
      DIMENSION XSFG(MXTNOD),YSFG(MXTNOD),CSFG(MXTNOD)
      DIMENSION MPLOCS(MXNPFG),IE(MAXEL,9)
      DIMENSION XX(4),YY(4),CC(4),DL(4)
C
C ***** DETERMINE SHARP FRONT
C
      DO 225 NP=KWB,KWE
        M=MPLOCS(NP)
        IF(IE(M,7).NE.0)GOTO 225
        XP=XSFG(NP)
        YP=YSFG(NP)
        CP=CSFG(NP)
        CALL ELENOD(IE(M,4),NODE)
        DO I=1,NODE
          IEM=IE(M,I)
          XX(I)=X(IEM)
          YY(I)=Y(IEM)
          CC(I)=CS(IEM)
        ENDDO
        CALL BASE1
     I           (XX,YY,XP,YP,M,NODE,
     O            DL)
        CIJFE=0.0D0
        DO I=1,NODE
          CIJFE=CIJFE+CC(I)*DL(I)
        ENDDO
        CDIF=CP-CIJFE
        IF(DABS(CDIF).GT.ADPARM*CP .AND. DABS(CDIF).GT.ADPEPS*
     >     CMX)IE(M,7)=M
  225 CONTINUE
C
      RETURN
      END
      SUBROUTINE FGDET
     I     (IE,IBCHK,X,IB,CP,CS,VXY,LRL,NLRL,ISE,NFGMB,
     I      XPFG,YPFG,CPFG,MPLOC,IEW,IBW,LRLW,NLRLW,XW,YW,CW,
c     I      MWLOC,VXW,VYW,DLINP,NEL,NPFG,NEFG,NXG,NYG,NPFGEP,NXW,
     I      MWLOC,VXW,VYW,NEL,NPFG,NEFG,NXG,NYG,NPFGEP,NXW,
     I      NYW, IDETQ,DELT,EPSX,ADPARM,ADPEPS,CMX,
     I      DTI,DTIFG,XEFG,YEFG,CEFG,MPLOCE,IBE,
     I      MAXNP,MAXEL,MXNPFG,MXKGL,MXNPW,MXELW,MXKBD,MXADNP,MXNEP,
     I      MXNCC,NCC, IEPC, MICONF,
     i      nwnp,npw,iwtyp,wss,mxwnp,mxwpr,
     O      NPFGS,XSFG,YSFG,CSFG,MPLOCS)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION XX(4),YY(4),DL(4),ips(4)
      DIMENSION IE(MAXEL,9),IBCHK(MAXEL),X(MAXNP,2),IB(MXADNP)
      DIMENSION CP(MAXNP,MXNCC),CS(MXADNP,MXNCC),VXY(MAXNP,2,MXNCC)
      DIMENSION LRL(MXKBD,MAXNP),NLRL(MAXNP),ISE(MXKGL,4),NFGMB(MAXEL)
      DIMENSION XPFG(MXNPFG),YPFG(MXNPFG),CPFG(MXNPFG,MXNCC),CMX(MXNCC)
      DIMENSION MPLOC(MXNPFG),MPLOCS(MXNPFG),NLRLW(MXNPW,2)
      DIMENSION IEW(MXELW,4,2),IBW(MXNPW,2),LRLW(6,MXNPW,2)
      DIMENSION XW(MXNPW),YW(MXNPW),CW(MXNPW),VXW(MXNPW),VYW(MXNPW)
      DIMENSION MWLOC(MXNPW),DTI(MXADNP,MXNCC),DTIFG(MXNPFG,MXNCC)
      DIMENSION XSFG(MXNPFG),YSFG(MXNPFG),CSFG(MXNPFG,MXNCC),IBE(MAXEL)
      DIMENSION XEFG(MXNEP),YEFG(MXNEP),CEFG(MXNEP,MXNCC),MPLOCE(MXNPFG)
      dimension npw(mxwnp),iwtyp(mxwnp),wss(mxwpr)
      LOGICAL BINDEX
C
      NPFGS=0
      DO 400 M=1,NEL
        IF(IEPC.EQ.1)THEN
          IF(IE(M,7).EQ.0 .AND. IBCHK(M).EQ.0)GOTO 400
        ELSE
          IF(IE(M,7).EQ.0)GOTO 400
        ENDIF
C
        CALL ELENOD(IE(M,4),NODE)
        DO I=1,NODE
          IEM=IE(M,I)
          XX(I)=X(IEM,1)
          YY(I)=X(IEM,2)
        ENDDO
C
        do i=1,4
          ips(i)=0
        enddo
        do 10 i=1,nwnp
          np=npw(i)
          do ii=1,node
            iem=ie(m,ii)
            if(iem.eq.np)then
              ips(ii)=ii
              goto 10
            endif
          enddo
  10    continue
c
c       DL1=0.0
c       DL2=0.0
c       DO I=1,NODE
c         I1=I+1
c         IF(I1.GT.NODE)I1=1
c         DLX=DABS(XX(I1)-XX(I))
c         DLY=DABS(YY(I1)-YY(I))
c         DL1=DMAX1(DL1,DLX)
c         DL2=DMAX1(DL2,DLY)
c       ENDDO
c       RATIO=(DL1+EPSX)/DLINP
c       IF(RATIO.LE.1.0D0)RATIO=1.0D0
c       NNXG=NXG*RATIO
c       RATIO=(DL2+EPSX)/DLINP
c       IF(RATIO.LE.1.0D0)RATIO=1.0D0
c       NNYG=NYG*RATIO
        nnxg=nxg
        nnyg=nyg
        NPTRI=(NNXG+1)*(NNXG+2)/2
c        NETRI=NNXG**2
        NPQRA=(NNXG+1)*(NNYG+1)
c        NEQRA=NNXG*NNYG
C
C ----- REFINE THIS SHARP-FRONT ELEMENT ===> XSFG(),YSFG(),MPLOCS()
C       FOR THE CASES OF QUADRALATERAL ELEMENTS
C
        NPS=NPFGS
        NEPP=NPFGEP
        IF(NODE.EQ.4)THEN
          DO 225 I=1,NNYG+1
            YI=2.0*DBLE(I-1)/DBLE(NNYG)-1.0
            DO 220 J=1,NNXG+1
              NEP=NPFGEP
              XI=2.0*DBLE(J-1)/DBLE(NNXG)-1.0
              N=J+(I-1)*(NNXG+1)+NPFGS
              CALL WARMSG(N,MXNPFG,'FGDET ','MXNPFG',1)
C
c             if(iepc.eq.1)then
              BINDEX=.FALSE.
              IF(IBE(M).EQ.1)THEN
                IF(I.EQ.1 .OR. I.EQ.2)BINDEX=.TRUE.  
              ELSEIF(IBE(M).EQ.2)THEN
                IF(J.EQ.NNXG .OR. J.EQ.NNXG+1)BINDEX=.TRUE.  
              ELSEIF(IBE(M).EQ.3)THEN
                IF(I.EQ.NNYG .OR. I.EQ.NNYG+1)BINDEX=.TRUE.   
              ELSEIF(IBE(M).EQ.4)THEN
                IF(J.EQ.1 .OR. J.EQ.2)BINDEX=.TRUE.   
              ELSEIF(IBE(M).EQ.12)THEN
                IF(I.EQ.1.OR.I.EQ.2 .OR. J.EQ.NNXG.OR.J.EQ.NNXG+1)
     >             BINDEX=.TRUE.   
              ELSEIF(IBE(M).EQ.23)THEN
                IF(I.EQ.NNYG.OR.I.EQ.NNYG+1 .OR.
     >            J.EQ.NNXG.OR.J.EQ.NNXG+1)BINDEX=.TRUE.   
              ELSEIF(IBE(M).EQ.34)THEN
                IF(I.EQ.NNYG.OR.I.EQ.NNYG+1 .OR.
     >             J.EQ.1.OR.J.EQ.2)BINDEX=.TRUE.   
              ELSEIF(IBE(M).EQ.14)THEN
                IF(I.EQ.1.OR.I.EQ.2 .OR. J.EQ.1.OR.J.EQ.2)
     >             BINDEX=.TRUE.   
              ENDIF
c             endif
c
              if(nwnp.ne.0 .AND. .NOT. BINDEX)then
                do 216 ij=1,4
                  if(ips(ij).eq.0)goto 216
                  if(ips(ij).eq.1)then
                    if(j.eq.1 .or. j.eq.2)then
                      if(i.eq.1 .or. i.eq.2)bindex=.true.   
                    endif
                  elseif(ips(ij).eq.2)then
                    if(j.eq.nnxg .or. j.eq.nnxg+1)then
                      if(i.eq.1 .or. i.eq.2)bindex=.true.   
                    endif
                  elseif(ips(ij).eq.3)then
                    if(j.eq.nnxg .or. j.eq.nnxg+1)then
                      if(i.eq.nnyg .or. i.eq.nnyg+1)bindex=.true.   
                    endif
                  elseif(ips(ij).eq.4)then
                    if(j.eq.1 .or. j.eq.2)then
                      if(i.eq.nnyg .or. i.eq.nnyg+1)bindex=.true.  
                    endif
                  endif
  216           continue
              endif
C
              DL(1)=0.25D0*(1.0D0-XI)*(1.0D0-YI)
              DL(2)=0.25D0*(1.0D0+XI)*(1.0D0-YI)
              DL(3)=0.25D0*(1.0D0+XI)*(1.0D0+YI)
              DL(4)=0.25D0*(1.0D0-XI)*(1.0D0+YI)
              MPLOCS(N)=M
              CALL VALBDL(XX,YY,DL,4,NODE,XSFG(N),YSFG(N))
C
              IF(BINDEX)NPFGEP=NPFGEP+1
C
              IF(NPFGEP.GT.NEP .AND. IEPC.NE.0)THEN
                CALL WARMSG(NPFGEP,MXNEP,'FGDET ','MXNEP ',2)
                XEFG(NPFGEP)=XSFG(N)
                YEFG(NPFGEP)=YSFG(N)
                MPLOCE(NPFGEP)=M
                MPLOC(NPFGEP)=N
              ENDIF
  220       CONTINUE
  225     CONTINUE
          NPFGS=NPFGS+NPQRA
          NPWRK=NPQRA
C----- FOR THE CASES OF TRIANGULAR ELEMENTS
        ELSE
          NN=0
          DO 275 I=NNXG+1,1,-1
            DL1=DBLE(I-1)/DBLE(NNXG)
            DO 270 J=NNXG+1,1,-1
              NEP=NPFGEP
              DL2=DBLE(J-1)/DBLE(NNXG)
              IF(DL1+DL2.GT.1.0D0 .AND. DABS(DL1+DL2-1.0D0).GT.EPSX)
     >          GOTO 270
              DO 265 K=NNXG+1,1,-1
                DL3=DBLE(K-1)/DBLE(NNXG)
                IF(DABS(DL1+DL2+DL3-1.0D0).LE.1.0D-6)THEN
                  NN=NN+1
                  N=NN+NPFGS
                  CALL WARMSG(N,MXNPFG,'FGDET ','MXNPFG',1)
C
c                 if(iepc.eq.1)then
                  BINDEX=.FALSE.
                  IF(IBE(M).EQ.1)THEN
                    IF(K.EQ.1 .OR. K.EQ.2)BINDEX=.TRUE.   
                  ELSEIF(IBE(M).EQ.2)THEN
                    IF(I.EQ.1 .OR. I.EQ.2)BINDEX=.TRUE.  
                  ELSEIF(IBE(M).EQ.3)THEN
                    IF(J.EQ.1 .OR. J.EQ.2)BINDEX=.TRUE.  
                  ELSEIF(IBE(M).EQ.12)THEN
                    IF(I.EQ.1.OR.I.EQ.2 .OR. K.EQ.1.OR.K.EQ.2)
     >                 BINDEX=.TRUE.   
                  ELSEIF(IBE(M).EQ.23)THEN
                    IF(I.EQ.1.OR.I.EQ.2 .OR. J.EQ.1.OR.J.EQ.2)
     >                 BINDEX=.TRUE.   
                  ELSEIF(IBE(M).EQ.13)THEN
                    IF(J.EQ.1.OR.J.EQ.2 .OR. K.EQ.1.OR.K.EQ.2)
     >              BINDEX=.TRUE.   
                  ENDIF
c                 endif
C
                  if(nwnp.ne.0 .AND. .NOT. BINDEX)then
                    do 256 ij=1,3
                      if(ips(ij).eq.0)goto 256
                      if(ips(ij).eq.1)then
                        IF(J.EQ.1.OR.J.EQ.2 .OR. K.EQ.1.OR.K.EQ.2)
     >                     BINDEX=.TRUE.   
                      elseif(ips(ij).eq.2)then
                        IF(I.EQ.1.OR.I.EQ.2 .OR. K.EQ.1.OR.K.EQ.2)
     >                     BINDEX=.TRUE.  
                      elseif(ips(ij).eq.3)then
                        IF(I.EQ.1.OR.I.EQ.2 .OR. J.EQ.1.OR.J.EQ.2)
     >                     BINDEX=.TRUE.   
                      endif
  256               continue
                  endif
C
                  DL(1)=DL1
                  DL(2)=DL2
                  DL(3)=DL3
                  MPLOCS(N)=M
                  CALL VALBDL(XX,YY,DL,4,NODE,XSFG(N),YSFG(N))
C
                  IF(BINDEX)NPFGEP=NPFGEP+1
C
                  IF(NPFGEP.GT.NEP .AND. IEPC.NE.0)THEN
                    CALL WARMSG(NPFGEP,MXNEP,'FGDET ','MXNEP ',2)
                    XEFG(NPFGEP)=XSFG(N)
                    YEFG(NPFGEP)=YSFG(N)
                    MPLOCE(NPFGEP)=M
                    MPLOC(NPFGEP)=N
                  ENDIF
                ENDIF
  265         CONTINUE
  270       CONTINUE
  275     CONTINUE
          NPFGS=NPFGS+NPTRI
          NPWRK=NPTRI
        ENDIF
C
        NPS1=NPS+1
        DO K=1,NCC
          DO NP=NPS1,NPFGS
            DTIFG(NP,K)=1.0D0/DELT
            IF(MICONF.EQ.1 .AND. K.LE.3)THEN
              IDTI=0
            ELSE
              IDTI=2
            ENDIF
          ENDDO
          CALL HPTRAK
     I      (MAXNP,MAXEL,MXNPFG,MXKGL,MXNPW,MXELW,MXKBD,MXNEP,MXNPFG,
     I       MXADNP,MXADNP,NEL,NEFG,NXW,NYW, IDETQ,1,EPSX,IDTI,
     I       DELT,IE,IB,LRL,NLRL,ISE,NFGMB, X,CP(1,K),CS(1,K),
     I       VXY(1,1,K),XPFG,YPFG,CPFG(1,K),MPLOC,IEW,IBW,LRLW,
     I       NLRLW,  XW,YW,VXW,VYW, NPS1,NPFG,NPFGS,
     I       nwnp,npw,iwtyp,wss,mxwnp,mxwpr,
     M       DTI(1,K),DTIFG(1,K), NPFGEP,XEFG,YEFG,CEFG(1,K),MPLOCE,
     O       XSFG,YSFG,CSFG(1,K),MPLOCS)
        ENDDO
C
C ----- CHECK IF ELEMENT M IS A SF ELEMENT DUE TO BOUNDARY SOURCES
C
c       if(iepc.eq.1)then
c       IF(IBCHK(M).NE.0 .AND. IE(M,7).EQ.0 .AND. NPFGEP.GT.NEPP)THEN
        IF(IBCHK(M).NE.0 .AND. IE(M,7).EQ.0)THEN
          DO I=1,NPWRK
            XW(I)=XSFG(NPS+I)
            YW(I)=YSFG(NPS+I)
            MWLOC(I)=MPLOCS(NPS+I)
          ENDDO
          DO K=1,NCC
            DO I=1,NPWRK
              CW(I)=CSFG(NPS+I,K)
            ENDDO
            CALL SFDET
     I          (MAXNP,MAXEL,MXNPW,MXNPW,1,NPWRK,ADPARM,ADPEPS,CMX(K),
     I           X(1,1),X(1,2),CS(1,K),XW,YW,CW,MWLOC,
     M           IE)
            IF(IE(M,7).NE.0)THEN
              IF(NPFGEP.GT.NEPP)THEN
                if(iepc.ne.0)then
                  DO N=NEPP+1,NPFGEP
                    N1=MPLOC(N)
                    DO IK=1,NCC
                      CEFG(N,IK)=CSFG(N1,IK)
                    ENDDO
                  ENDDO
                else
                  npfgep=nepp
                endif
              ENDIF
C             GOTO 400
            ELSE
              NPFGS=NPS
              NPFGEP=NEPP
            ENDIF
          ENDDO
        ELSE
          NPFGEP=NEPP
        ENDIF
c       endif
        IF(IE(M,7).NE.0)IE(M,7)=NNXG
        IE(M,9)=NNYG
  400 CONTINUE
      RETURN
      END
      SUBROUTINE ELETRK
     I     (XPP,YPP,VPPX,VPPY,XX,YY,VXX,VYY,SDTT,IBF,NODE,IDETQ,
     I      EPSX,MXNPW,MXELW,NXW,NYW,IBW,NLRLW,LRLW,IEW,IME1,
     i      idps,cps,cpsp,delt,mxnpfg,M,
     M      XW,YW,VXW,VYW, N1,N2,
     O      XQ,YQ,VXQ,VYQ,SDTT1,npfgs,xsfg,ysfg,csfg,mplocs)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION XX(4),YY(4),VXX(4),VYY(4),DL(4),IME(4),IME1(4)
      DIMENSION XW(MXNPW),YW(MXNPW),VXW(MXNPW),VYW(MXNPW),IBW(MXNPW,2)
      DIMENSION NLRLW(MXNPW,2),LRLW(6,MXNPW,2),IEW(MXELW,4,2)
      dimension xsfg(mxnpfg),ysfg(mxnpfg),csfg(mxnpfg),mplocs(mxnpfg)
      DIMENSION XXX(4),YYY(4),VXXX(4),VYYY(4),KIN(4)
C
      SDT=SDTT
      CALL REPLAS(XPP,YPP,VPPX,VPPY,XP,YP,VPX,VPY)
C
C***** PREPARE INFORMATION FOR ELEMENT TRACKING
C
C NOTE ||| IN THIS INFORMATION PREPARING BLOCK THOSE COMMENTED STATE-
C          MENT WOULD NOT BE ACTIVE UNTIL MIXED-TYPE ELEMENT CASES ARE
C          CONSIDERED.
C
C----- FOR THE CASES OF QUADRALATERAL ELEMENTS
      IF(NODE.EQ.4)THEN
        NELW=NXW*NYW
        IK=1
        DO 25 I=1,NYW+1
          YI=2.0*DBLE(I-1)/DBLE(NYW)-1.0
          DO 20 J=1,NXW+1
            XI=2.0*DBLE(J-1)/DBLE(NXW)-1.0
            N=J+(I-1)*(NXW+1)
C ----- DETERMINE WORKING ARRAYS XW, YW, VXW, AND VYW
            DL(1)=0.25D0*(1.0D0-XI)*(1.0D0-YI)
            DL(2)=0.25D0*(1.0D0+XI)*(1.0D0-YI)
            DL(3)=0.25D0*(1.0D0+XI)*(1.0D0+YI)
            DL(4)=0.25D0*(1.0D0-XI)*(1.0D0+YI)
            CALL VALBDL(XX,YY,DL,4,NODE,XW(N),YW(N))
            CALL VALBDL(VXX,VYY,DL,4,NODE,VXW(N),VYW(N))
  20      CONTINUE
  25    CONTINUE
C----- FOR THE CASES OF TRIANGULAR ELEMENTS
      ELSE
        NELW=NXW*NXW
        IK=2
        N=0
        DO 75 I=NXW+1,1,-1
          DL1=DBLE(I-1)/DBLE(NXW)
          DO 70 J=NXW+1,1,-1
            DL2=DBLE(J-1)/DBLE(NXW)
            IF(DL1+DL2.GT.1.0D0 .AND. DABS(DL1+DL2-1.0D0).GT.EPSX)
     >        GOTO 70
            DO 65 K=NXW+1,1,-1
              DL3=DBLE(K-1)/DBLE(NXW)
              IF(DABS(DL1+DL2+DL3-1.0D0).LE.1.0D-6)THEN
                N=N+1
C ----- DETERMINE WORKING ARRAYS XW, YW, VXW, AND VYW
                DL(1)=DL1
                DL(2)=DL2
                DL(3)=DL3
                CALL VALBDL(XX,YY,DL,4,NODE,XW(N),YW(N))
                CALL VALBDL(VXX,VYY,DL,4,NODE,VXW(N),VYW(N))
              ENDIF
  65        CONTINUE
  70      CONTINUE
  75    CONTINUE
      ENDIF
C
C *** NOTE ||| THE INFORMATION PREPARING BLOCK ENDS HERE
C----- DETERMINE WHERE TO START (THE LOCATION OF POINT P)
      CALL MMLOC
     I    (XW,YW,IEW(1,1,IK),NLRLW(1,IK),VXW,VYW,NELW,MXNPW,MXELW,EPSX,
     I     NODE,  XP,YP,VPX,VPY,
     O     KIN,MM,NN,NLRLN,ICODE)
C
C***** START TRACKINGS
C----- CHECK IF POINT P COINSIDES WITH ANY NODES OF WORKING ELEMENT MP
C
      IF(ICODE.EQ.0)GOTO 300
C
C----- CHECK IF POINT P IS ON ANY SIDE OF THIS WORKING ELEMENT
C
  129 CONTINUE
C
      DO 130 I=1,NODE
        IF(KIN(I).EQ.1)THEN
          KON=I
          ID=1
          GOTO 140
        ENDIF
  130 CONTINUE
      KON=0
      ID=0
C
  140 CONTINUE
C
      J=KON
      IF(KON.NE.0) THEN
        J1=J+1
        IF(J1.GT.NODE)J1=1
        N1=IEW(MM,J,IK)
        N2=IEW(MM,J1,IK)
        CALL CKCNEL(N1,N2,MM,NLRLW(1,IK),LRLW(1,1,IK),MXNPW,6,
     O              M1,KOUNT)
      ENDIF
C
  141 CONTINUE
      CALL WRKARY(J,IEW(1,1,IK),XW,YW,VXW,VYW,MXELW,4,MXNPW,MM,NODE,4,2,
     O            IME,XXX,YYY,VXXX,VYYY)
C
      IF(VPX.EQ.0.0D0 .AND. VPY.EQ.0.0D0)THEN
        SDTT1=0.0D0
        XQ=XP
        YQ=YP
        RETURN
      ENDIF
C
      IF(IDETQ.EQ.2)THEN
        IJUDGE=2
      ELSE
        IJUDGE=1
      ENDIF
C
  151 CONTINUE
C
      CALL TRACK2
c     I    (XP,YP,VPX,VPY,XXX,YYY,VXXX,VYYY,SDT,IME,IBF,NODE,MM,IJUDGE,
     I    (XP,YP,VPX,VPY,XXX,YYY,VXXX,VYYY,SDT,IME,IBF,NODE,IJUDGE,
     O     EPSX,ID,  XQ,YQ,VXQ,VYQ,SDT1,N1,N2)
C
      IF(SDT1.EQ.0.0D0)THEN
        SDTT1=0.0D0
        RETURN
      ENDIF
C
C ***** FOR THE CASES THAT SDT1 IS NOT EQUAL TO ZERO
C
      IF(SDT.EQ.SDT1)THEN
        IF(IJUDGE.EQ.1)THEN
          IJUDGE=2
          GOTO 151
        ENDIF
C***** CHECK IF THIS SIDE IS BOUNDARY SIDE
        IF(KON.NE.0)THEN
          IF(KOUNT.EQ.1)THEN
            CALL IBWCHK(0,NODE,IME1,IBW(1,IK),MXNPW, N1,N2)
            SDTT1=SDT
            CALL REPLAS(XP,YP,VPX,VPY,XQ,YQ,VXQ,VYQ)
            RETURN
          ELSE
            IF(MM.NE.M1)THEN
              MM=M1
              DO J=1,NODE
                IEM=IEW(MM,J,IK)
                IF(N1.EQ.IEM)GOTO 141
              ENDDO
            ENDIF
          ENDIF
        ENDIF
        WRITE(16,*)'ERROR OCCURRED AT ELETRK---1'
        STOP
C
      ENDIF
C
C ***** TRACK AGAIN
C
  250 CONTINUE
c
      if(idps.eq.1)then
        npfgs=npfgs+1
        xsfg(npfgs)=0.5d0*(xp+xq)
        ysfg(npfgs)=0.5d0*(yp+yq)
        mplocs(npfgs)=m
        dtreal=delt-0.5d0*(sdt+sdt1)
        xsi=(delt-dtreal)/delt
        csfg(npfgs)=cpsp*xsi+cps*(1.0d0-xsi)
      endif
      SDT=SDT1
      CALL REPLAS(XQ,YQ,VXQ,VYQ,XP,YP,VPX,VPY)
C
      CALL CKCOIN
     I            (XW,YW,XP,YP,NLRLW(1,IK),N1,N2,MXNPW,EPSX,
     O             NN,NLRLN)
      IF(NN.EQ.0)GOTO 400
C
  300 CONTINUE
      CALL REPLAS(XW(NN),YW(NN),VXW(NN),VYW(NN),XP,YP,VPX,VPY)
C
      IF(IDETQ.EQ.2)THEN
        IJUDGE=2
      ELSE
        IJUDGE=1
      ENDIF
C
  301 CONTINUE
C
      DO 350 I=1,NLRLN
        M1=LRLW(I,NN,IK)
        MM=M1
        DO 305 J=1,NODE
          IEM=IEW(MM,J,IK)
          IF(NN.EQ.IEM)GOTO 330
  305   CONTINUE
C
  330   CONTINUE
        CALL WRKARY(J,IEW(1,1,IK),XW,YW,VXW,VYW,MXELW,4,MXNPW,MM,NODE,
     O              4,2,  IME,XXX,YYY,VXXX,VYYY)
        CALL TRACK1
c     I      (XP,YP,VPX,VPY,XXX,YYY,VXXX,VYYY,SDT,IME,IBF,NODE,MM,IJUDGE,
     I      (XP,YP,VPX,VPY,XXX,YYY,VXXX,VYYY,SDT,IME,IBF,NODE,IJUDGE,
     O       EPSX,  XQ,YQ,VXQ,VYQ,SDT1,N1,N2)
C
        IF(SDT1.EQ.0.0D0)THEN
          SDTT1=0.0D0
          RETURN
        ENDIF
C ***** FOR THE CASED THAT SDT1 IS NOT EQUAL TO ZERO
        IF(SDT.NE.SDT1)GOTO 250
  350 CONTINUE
C
      IF(IJUDGE.EQ.1)THEN
        IJUDGE=2
        GOTO 301
      ENDIF
C
      IF(IBW(NN,IK).NE.0)THEN
        CALL IBWCHK(NN,NODE,IME1,IBW(1,IK),MXNPW, N1,N2)
        SDTT1=SDT
        CALL REPLAS(XP,YP,VPX,VPY,XQ,YQ,VXQ,VYQ)
        RETURN
      ENDIF
      WRITE(16,*)'ERROR OCCURRED AT ELETRK---2'
      STOP
C
  400 CONTINUE
      CALL ONLINE(XW,YW,N1,N2,MXNPW, XP,YP)
      CALL CKCOIN
     I            (XW,YW,XP,YP,NLRLW(1,IK),N1,N2,MXNPW,EPSX,
     O             NN,NLRLN)
      IF(NN.NE.0)GOTO 300
C
C ***** CHECK IF N1 AND N2 ARE BOUNDARY POINTS
C
      CALL CKCNEL(N1,N2,MM,NLRLW(1,IK),LRLW(1,1,IK),MXNPW,6,
     O            M1,KOUNT)
      IF(KOUNT.EQ.2 .AND. M1.NE.0)GOTO 430
C ***** N1 AND N2 ARE BOUNDARY POINTS
      DO 406 I=1,NODE
        IF(N2.EQ.IEW(MM,I,IK))THEN
          CALL WRKARY(I,IEW(1,1,IK),XW,YW,VXW,VYW,MXELW,4,MXNPW,MM,
     O                NODE,4,3,  IME,XXX,YYY,VXXX,VYYY)
          GOTO 450
        ENDIF
  406 CONTINUE
C
  430 CONTINUE
      ME=MM
      MM=M1
C
  431 CONTINUE
      DO 435 J=1,NODE
        IEM=IEW(MM,J,IK)
        IF(N1.EQ.IEM)GOTO 440
  435 CONTINUE
C
  440 CONTINUE
      CALL WRKARY(J,IEW(1,1,IK),XW,YW,VXW,VYW,MXELW,4,MXNPW,MM,NODE,4,3,
     O            IME,XXX,YYY,VXXX,VYYY)
C
  450 CONTINUE
C
      IF(IDETQ.EQ.2)THEN
        IJUDGE=2
      ELSE
        IJUDGE=1
      ENDIF
C
  451 CONTINUE
C
      CALL TRACK2
c     I    (XP,YP,VPX,VPY,XXX,YYY,VXXX,VYYY,SDT,IME,IBF,NODE,MM,IJUDGE,
     I    (XP,YP,VPX,VPY,XXX,YYY,VXXX,VYYY,SDT,IME,IBF,NODE,IJUDGE,
     O     EPSX,1,  XQ,YQ,VXQ,VYQ,SDT1,N1,N2)
C
      IF(SDT1.EQ.0.)THEN
        SDTT1=0.0D0
        RETURN
      ENDIF
C
      IF(SDT1.NE.SDT)GOTO 250
C
      IF(IJUDGE.EQ.1)THEN
        IJUDGE=2
        GOTO 451
      ENDIF
C
      CALL CKCNEL(N1,N2,MM,NLRLW(1,IK),LRLW(1,1,IK),MXNPW,6,
     O            M1,KOUNT)
      IF(KOUNT.EQ.1)THEN
        CALL IBWCHK(0,NODE,IME1,IBW(1,IK),MXNPW, N1,N2)
        SDTT1=SDT
        CALL REPLAS(XP,YP,VPX,VPY,XQ,YQ,VXQ,VYQ)
      ELSE
        IF(MM.NE.ME)THEN
          MM=ME
          N1=N2
          GOTO 431
        ENDIF
        WRITE(16,*)'ERROR OCCURRED AT ELETRK---3'
        STOP
      ENDIF
C
      RETURN
      END
      SUBROUTINE MMLOC
     I    (XW,YW,IEW,NLRLW,VXW,VYW,NELW,MXNPW,MXELW,EPSX,
     I     NODE,  XP,YP,VPX,VPY,
     O     KIN,MM,NN,NLRLN,ICODE)
C  10/14/93
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION XW(MXNPW),YW(MXNPW),IEW(MXELW,4),NLRLW(MXNPW)
      DIMENSION VXW(MXNPW),VYW(MXNPW),XXX(4),YYY(4),KIN(4)
C
      ICODE=-1
      DO 105 MP=1,NELW
        DO II=1,NODE
          IEM=IEW(MP,II)
          XXX(II)=XW(IEM)
          YYY(II)=YW(IEM)
          IF(DABS(XP-XXX(II)).LE.EPSX .AND. DABS(YP-YYY(II)).LE.EPSX)
     >      THEN
            CALL REPLAS(XXX(II),YYY(II),VXW(IEM),VYW(IEM),XP,YP,VPX,VPY)
            MM=MP
            NN=IEM
            NLRLN=NLRLW(IEM)
            ICODE=0
            RETURN
          ENDIF
        ENDDO
C
        DO 100 III=1,NODE
          I1=III+1
          IF(I1.GT.NODE)I1=1
          A1=XXX(I1)-XXX(III)
          AP=XP-XXX(III)
          B1=YYY(I1)-YYY(III)
          BP=YP-YYY(III)
          BB=A1*BP-AP*B1
          AA=DSQRT(A1**2+B1**2)
          IF(AA.EQ.0.0D0)THEN
            WRITE(16,*)'ERROR OCCURRED AT MMLOC, AA=0.0D0 --- STOP'
            STOP
          ENDIF
          CANG=BB/AA
          IF(CANG.LT.0.0D0 .AND. DABS(CANG).GT.EPSX)GOTO 105
          IF(DABS(CANG).LE.EPSX)THEN
            KIN(III)=1
          ENDIF
          IF(CANG.GT.0.0D0 .AND. DABS(CANG).GT.EPSX)KIN(III)=2
  100   CONTINUE
        MM=MP
        do iii=1,node
          if(kin(iii).eq.1)then
            i1=iii+1
            if(i1.gt.node)i1=1
            CALL ONLINE(XXX,YYY,III,I1,4, XP,YP)
            return
          endif
        enddo
        RETURN
  105 CONTINUE
C
      RETURN
      END
      SUBROUTINE IBWCHK(NN,NODE,IME1,IBW,MXNPW, N1,N2)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION IBW(MXNPW),IME1(4)
C
          IF(NODE.EQ.4)THEN
            I=4
            IF(NN.NE.0)THEN
              IF(IBW(NN).EQ.11 .OR. IBW(NN).EQ.1)I=1
              IF(IBW(NN).EQ.12 .OR. IBW(NN).EQ.2)I=2
              IF(IBW(NN).EQ.13 .OR. IBW(NN).EQ.3)I=3
            ELSE
              IF(IBW(N1).EQ.1 .OR. IBW(N2).EQ.1 .OR.
     >         (IBW(N1).EQ.11 .AND. IBW(N2).EQ.12) .OR.
     >         (IBW(N1).EQ.12 .AND. IBW(N2).EQ.11))I=1
              IF(IBW(N1).EQ.2 .OR. IBW(N2).EQ.2 .OR.
     >         (IBW(N1).EQ.12 .AND. IBW(N2).EQ.13) .OR.
     >         (IBW(N1).EQ.13 .AND. IBW(N2).EQ.12))I=2
              IF(IBW(N1).EQ.3 .OR. IBW(N2).EQ.3.OR.
     >         (IBW(N1).EQ.13 .AND. IBW(N2).EQ.14) .OR.
     >         (IBW(N1).EQ.14 .AND. IBW(N2).EQ.13))I=3
            ENDIF
          ELSE
            I=3
            IF(NN.NE.0)THEN
              IF(IBW(NN).EQ.11 .OR. IBW(NN).EQ.1)I=1
              IF(IBW(NN).EQ.12 .OR. IBW(NN).EQ.2)I=2
            ELSE
              IF(IBW(N1).EQ.1 .OR. IBW(N2).EQ.1 .OR.
     >         (IBW(N1).EQ.11 .AND. IBW(N2).EQ.12) .OR.
     >         (IBW(N1).EQ.12 .AND. IBW(N2).EQ.11))I=1
              IF(IBW(N1).EQ.2 .OR. IBW(N2).EQ.2 .OR.
     >         (IBW(N1).EQ.12 .AND. IBW(N2).EQ.13) .OR.
     >         (IBW(N1).EQ.13 .AND. IBW(N2).EQ.12))I=2
            ENDIF
          ENDIF
          I1=I+1
          IF(I1.GT.NODE)I1=1
          N1=IME1(I)
          N2=IME1(I1)
      RETURN
      END
      SUBROUTINE TRIANG
     I          (NEWRK,MAXFGW,MINFGW,XWFG,YWFG,CWFG,NFGMBM,NEPWN,NEPW,
c     I           NODE,MXELW,MXNPFG,MAXEL,MXKGL,MXEPW,MXNCC,M,NCC,EPSX,
     I           NODE,MXELW,MXNPFG,MXKGL,MXEPW,MXNCC,M,NCC,EPSX,
     M           XSFG,YSFG,CSFG,DTIFG,ISE,NE,NPFGS,MPLOCS,MPLOCE)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      PARAMETER (MXNPK=14,MXNEK=22)
      DIMENSION XWRK(MXNPK),YWRK(MXNPK),NWRK(MXNPK),IZE(MXNEK,6)
      DIMENSION XV(MXNEK),YV(MXNEK),XX(4),YY(4),DL(4),DDTT(4,7)
      DIMENSION MAXFGW(MXELW,MXNCC),MINFGW(MXELW,MXNCC)
      DIMENSION XWFG(MXNPFG),YWFG(MXNPFG),CWFG(MXNPFG,MXNCC)
      DIMENSION XSFG(MXNPFG),YSFG(MXNPFG),CSFG(MXNPFG,MXNCC)
      DIMENSION ISE(MXKGL,4),MPLOCS(MXNPFG),MPLOCE(MXNPFG)
      DIMENSION NEPWN(MXELW),NEPW(MXELW,MXEPW),DTIFG(MXNPFG,MXNCC)
C
      DO 400 MP=1,NEWRK
C ----- CHECK EPCOF POINTS AND THE HIGH AND LOW OF EVERY SUBELEMENT
        MPM=MP+NFGMBM
        NK=0
        IF(NEPWN(MP).NE.0)THEN
          DO 10 I=1,NEPWN(MP)
            J=NEPW(MP,I)
            DO II=1,NK
              IF(DABS(XWRK(II)-XWFG(J)).LE.EPSX .AND.
     >           DABS(YWRK(II)-YWFG(J)).LE.EPSX)GOTO 10
            ENDDO
            NK=NK+1
            CALL WARMSG(NK,MXNPK,'TRIANG','MXNPK ',1)
            NPFGS=NPFGS+1
            CALL WARMSG(NPFGS,MXNPFG,'TRIANG','MXNPFG',2)
            XSFG(NPFGS)=XWFG(J)
            YSFG(NPFGS)=YWFG(J)
            DO K=1,NCC
              CSFG(NPFGS,K)=CWFG(J,K)
            ENDDO
            MPLOCS(NPFGS)=M
            MPLOCE(NPFGS)=NPFGS
            XWRK(NK)=XSFG(NPFGS)
            YWRK(NK)=YSFG(NPFGS)
            NWRK(NK)=NPFGS
  10      CONTINUE
        ENDIF
C
        IDO=1
        K=0
  15    CONTINUE
          K=K+1
          IF(MAXFGW(MP,K).NE.0)IDO=0
        IF(IDO.EQ.1 .AND. K.LT.NCC)GOTO 15
        IF(IDO.EQ.0)THEN
          DO K=1,NCC
            J=MAXFGW(MP,K)
            DO I=1,NK
              IF(DABS(XWRK(I)-XWFG(J)).LE.EPSX .AND.
     >           DABS(YWRK(I)-YWFG(J)).LE.EPSX)GOTO 20
            ENDDO
            NK=NK+1
            NPFGS=NPFGS+1
            CALL WARMSG(NPFGS,MXNPFG,'TRIANG','MXNPFG',3)
            XSFG(NPFGS)=XWFG(J)
            YSFG(NPFGS)=YWFG(J)
C
C ---- Obtain DTIFG array by interpolation
C
            CALL ELENOD(ISE(MPM,4),NQ)
            DO IQ=1,NQ
              IEM=ISE(MPM,IQ)
              XX(IQ)=XSFG(IEM)
              YY(IQ)=YSFG(IEM)
              DO IK=1,NCC
                DDTT(IQ,IK)=DTIFG(IEM,IK)
              ENDDO
            ENDDO
            CALL BASE1
     I         (XX,YY,XSFG(NPFGS),YSFG(NPFGS),MP,NQ,
     O          DL)
            DO IK=1,NCC
              CSFG(NPFGS,IK)=CWFG(J,IK)
              DTIFG(NPFGS,IK)=0.0D0
              DO IQ=1,NQ
                DTIFG(NPFGS,IK)=DTIFG(NPFGS,IK)+DL(IQ)*DDTT(IQ,IK)
              ENDDO
            ENDDO
            MPLOCS(NPFGS)=M
            XWRK(NK)=XSFG(NPFGS)
            YWRK(NK)=YSFG(NPFGS)
            NWRK(NK)=NPFGS
          ENDDO
        ENDIF
C
  20    CONTINUE
        IDO=1
        K=0
  25    CONTINUE
          K=K+1
          IF(MINFGW(MP,K).NE.0)IDO=0
        IF(IDO.EQ.1 .AND. K.LT.NCC)GOTO 25
        IF(IDO.EQ.0)THEN
          DO K=1,NCC
            J=MINFGW(MP,K)
            DO I=1,NK
              IF(DABS(XWRK(I)-XWFG(J)).LE.EPSX .AND.
     >           DABS(YWRK(I)-YWFG(J)).LE.EPSX)GOTO 30
            ENDDO
            NK=NK+1
            NPFGS=NPFGS+1
            CALL WARMSG(NPFGS,MXNPFG,'TRIANG','MXNPFG',4)
            XSFG(NPFGS)=XWFG(J)
            YSFG(NPFGS)=YWFG(J)
C
C ---- Obtain DTIFG array by interpolation
C
            CALL ELENOD(ISE(MPM,4),NQ)
            DO IQ=1,NQ
              IEM=ISE(MPM,IQ)
              XX(IQ)=XSFG(IEM)
              YY(IQ)=YSFG(IEM)
              DO IK=1,NCC
                DDTT(IQ,IK)=DTIFG(IEM,IK)
              ENDDO
            ENDDO
            CALL BASE1
     I         (XX,YY,XSFG(NPFGS),YSFG(NPFGS),MP,NQ,
     O          DL)
            DO IK=1,NCC
              CSFG(NPFGS,IK)=CWFG(J,IK)
              DTIFG(NPFGS,IK)=0.0D0
              DO IQ=1,NQ
                DTIFG(NPFGS,IK)=DTIFG(NPFGS,IK)+DL(IQ)*DDTT(IQ,IK)
              ENDDO
            ENDDO
            MPLOCS(NPFGS)=M
            XWRK(NK)=XSFG(NPFGS)
            YWRK(NK)=YSFG(NPFGS)
            NWRK(NK)=NPFGS
          ENDDO
        ENDIF
C
  30    CONTINUE
        IF(NK.EQ.0)GOTO 400
C ----- WHEN THE HIGH OR THE LOW EXISTS, START TRIANGULATION IN THIS
C       SUBELEMENT
        NKK=NK
        IF(NODE.EQ.3)THEN
          DO J1=1,3
            NK=NK+1
            CALL WARMSG(NK,MXNPK,'TRIANG','MXNPK ',5)
            IEM=ISE(MPM,J1)
            XWRK(NK)=XSFG(IEM)
            YWRK(NK)=YSFG(IEM)
            NWRK(NK)=IEM
            IZE(1,J1)=NK
            XX(J1)=XWRK(NK)
            YY(J1)=YWRK(NK)
          ENDDO
          CALL CENTER
     I                 (XX,YY,
     O                  XCN,YCN)
          XV(1)=XCN
          YV(1)=YCN
          DO J1=4,6
            IZE(1,J1)=0
          ENDDO
          NV=1
        ELSE
          DO J1=1,4
            NK=NK+1
            CALL WARMSG(NK,MXNPK,'TRIANG','MXNPK ',6)
            IEM=ISE(MPM,J1)
            XWRK(NK)=XSFG(IEM)
            YWRK(NK)=YSFG(IEM)
            NWRK(NK)=IEM
          ENDDO
          NV=0
          DO 360 J1=1,2
            NV=NV+1
            IF(J1.EQ.1)THEN
              K1=1
              K2=2
              K3=3
            ELSE
              K1=1
              K2=3
              K3=4
            ENDIF
            DO J2=1,3
              IF(J2.EQ.1)J3=K1
              IF(J2.EQ.2)J3=K2
              IF(J2.EQ.3)J3=K3
              IZE(NV,J2)=NK-4+J3
              XX(J2)=XWRK(NK-4+J3)
              YY(J2)=YWRK(NK-4+J3)
            ENDDO
            CALL CENTER
     I                   (XX,YY,
     O                    XCN,YCN)
            XV(NV)=XCN
            YV(NV)=YCN
            IF(NV.EQ.1)THEN
              IZE(NV,4)=0
              IZE(NV,5)=0
              IZE(NV,6)=2
            ELSE
              IZE(NV,4)=1
              IZE(NV,5)=0
              IZE(NV,6)=0
            ENDIF
 360      CONTINUE
        ENDIF
C
        CALL GRID
     I              (NKK,XWRK,YWRK,MXNPK,MXNEK,EPSX,
     M               IZE,NV,XV,YV)
        NLNK=NKK+1
        DO NL=NPFGS,NPFGS-NKK+1,-1
          NLNK=NLNK-1
          XSFG(NL)=XWRK(NLNK)
          YSFG(NL)=YWRK(NLNK)
        ENDDO
C
        DO 380 NL=1,NV
          IF(NL.EQ.1)THEN
            DO I1=1,3
              IZEM=IZE(NL,I1)
              ISE(MPM,I1)=NWRK(IZEM)
            ENDDO
            ISE(MPM,4)=0
          ELSE
            NE=NE+1
            CALL WARMSG(NE,MXKGL,'TRIANG','MXKGLK',7)
            DO I1=1,3
              IZEM=IZE(NL,I1)
              ISE(NE,I1)=NWRK(IZEM)
            ENDDO
            ISE(NE,4)=0
          ENDIF
  380   CONTINUE
  400 CONTINUE
C
      RETURN
      END
      SUBROUTINE GRID
     I                  (KFN,XWRK,YWRK,MXNPFG,MXKGL,EPSX,
     M                   IZE,NV,XV,YV)
C
C ***** DEFINITION
C
C     XWRK(MXNPFG)      -  X-COORDINATE OF POINT CONTAINED IN S-F REGION
C     YWRK(MXNPFG)      -  Y-COORDINATE OF POINT CONTAINED IN S-F REGION
C     XX(3)             -  X-COORDINATE OF TRIANGLE NODES
C     YY(3)             -  Y-COORDINATE OF TRIANGLE NODES
C     XV(MXKGL)         -  X-COORDINATE OF VERTEX
C     YV(MXKGL)         -  Y-COORDINATE OF VERTEX
C     IZE(MXKGL,6)      -  INDEX OF TRIANGLE
C     KD(20)            -  INDEX OF DELETED TRIANGLE
C     JJ(10)            -  INDEX OF TRIANGLE CONNECTION
C     KK(10)            -  INDEX OF TRIANGLE CONNECTION
C     XVW(20)           -  X-COORDINATE OF NEW VERTEX
C     YVW(20)           -  Y-COORDINATE OF NEW VERTEX
C     IZEW(20,6)        -  INDEX OF NEW TRIANGLE
C
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (MXTANG=20)
C
      DIMENSION XWRK(MXNPFG),YWRK(MXNPFG),XV(MXKGL),YV(MXKGL)
      DIMENSION IZE(MXKGL,6),IZEW(MXTANG,6)
      DIMENSION JJ(MXTANG),KK(MXTANG),KD(MXTANG)
      DIMENSION XVW(MXTANG),YVW(MXTANG),KIN(4)
C
      DATA EPS/1.0D-6/
C
C ***** STEP 1
C
      DO 900 N=1,KFN
        ICHECK=0
        XPP=XWRK(N)
        YPP=YWRK(N)
C
C ***** STEP2 & STEP3
C
  40    CONTINUE
        L=0
        ND=0
        DO 60 I=1,NV
          XP=XPP
          YP=YPP
          J=NV-I+1
          DO 55 J1=1,3
            J2=J1+1
            IF(J2.EQ.4)J2=1
            N1=IZE(J,J1)
            N2=IZE(J,J2)
            A1=XWRK(N2)-XWRK(N1)
            AP=XP-XWRK(N1)
            B1=YWRK(N2)-YWRK(N1)
            BP=YP-YWRK(N1)
            AA=DSQRT(A1*A1+B1*B1)
            BB=A1*BP-AP*B1
            DET=BB/AA
            IF(DET.LT.0 .AND. DABS(DET).GT.EPSX)GOTO 60
            IF(DABS(DET).LE.EPSX)THEN
              KIN(J1)=1
            ELSE
              KIN(J1)=2
            ENDIF
  55      CONTINUE
          do j1=1,3
            if(kin(j1).eq.1)then
              J2=J1+1
              IF(J2.EQ.4)J2=1
              NN1=IZE(J,J1)
              NN2=IZE(J,J2)
              CALL ONLINE(XWRK,YWRK,NN1,NN2,MXNPFG, XP,YP)
            endif
          enddo
          D1=DSQRT((XP-XV(J))**2+(YP-YV(J))**2)
          D2=DSQRT((XWRK(N1)-XV(J))**2+(YWRK(N1)-YV(J))**2)
          IF(D1.LT.D2 .OR. DABS(D1-D2).LE.EPSX)GOTO 70
  60    CONTINUE
        WRITE(16,*)'ERROR OCCURRED AT STEP 3 ','N,XP,YP=',N,XP,YP
C       STOP
        GOTO 900
  70    CONTINUE
        XWRK(N)=XP
        YWRK(N)=YP
        ND=ND+1
        KD(ND)=J
C
        CALL NEWTRI
     I             (ND,KD,IZE,MXTANG,MXNPFG,MXKGL,N,EPSX,
     O              IZEW,XVW,YVW,XWRK,YWRK,NW)
        IF(NW.LT.ND+1)THEN
          WRITE(16,*)'WARNING AFTER NEWTRI !!!, N,XP,YP=',N,XP,YP
          GOTO 900
        ENDIF
        CALL CKTRI
     I            (NW,IZEW,XWRK,YWRK,XP,YP,MXTANG,MXNPFG,EPS,EPSX,
     O             KCK)
        IF(KCK.EQ.1)THEN
          PRINT *,'WARNING AFTER CKTRI !!!, N,XP,YP=',N,XP,YP
          GOTO 900
        ENDIF
C
        L=L+1
        JJ(L)=J
        JL=0
        JM=JJ(L)
        K=0
  80    CONTINUE
        IF(K.EQ.3)GOTO 100
        K=K+1
        KK(L)=K
        J1=IZE(JM,K+3)
        IF(J1.EQ.JL)GOTO 100
        IF(J1.EQ.0)GOTO 100
        J2=IZE(J1,1)
c        J3=IZE(J1,2)
c        J4=IZE(J1,3)
        D1=DSQRT((XP-XV(J1))**2+(YP-YV(J1))**2)
        D2=DSQRT((XWRK(J2)-XV(J1))**2+(YWRK(J2)-YV(J1))**2)
c        D3=DSQRT((XWRK(J3)-XV(J1))**2+(YWRK(J3)-YV(J1))**2)
c        D4=DSQRT((XWRK(J4)-XV(J1))**2+(YWRK(J4)-YV(J1))**2)
        IF(D1.GT.D2 .OR. DABS(D1-D2).LE.EPSX)GOTO 100
        DO IND=1,ND
          IF(KD(IND).EQ.J1)GOTO 100
        ENDDO
        ND=ND+1
        CALL WARMSG(ND,MXTANG,' GRID ','MXTANG',1)
        KD(ND)=J1
C
        IF(ICHECK.EQ.1)THEN
          CALL NEWTRI
     I                 (ND,KD,IZE,MXTANG,MXNPFG,MXKGL,N,EPSX,
     O                  IZEW,XVW,YVW,XWRK,YWRK,NW)
          IF(NW.LT.ND+1)THEN
            ND=ND-1
            GOTO 100
          ENDIF
          CALL CKTRI
     I                (NW,IZEW,XWRK,YWRK,XP,YP,MXTANG,MXNPFG,EPS,EPSX,
     O                 KCK)
          IF(KCK.EQ.1)THEN
            ND=ND-1
            GOTO 100
          ENDIF
        ENDIF
C
        L=L+1
        CALL WARMSG(L,MXTANG,' GRID ','MXTANG',2)
        JJ(L)=J1
        JM=JJ(L)
        IF(L.NE.1)THEN
          JL=JJ(L-1)
        ELSE
          JL=0
        ENDIF
        K=0
        GOTO 80
  100   CONTINUE
        IF(K.LT.3)THEN
          GOTO 80
        ELSEIF(L.EQ.1)THEN
          GOTO 200
        ELSE
          L=L-1
          K=KK(L)
          JM=JJ(L)
          IF(L.NE.1)THEN
            JL=JJ(L-1)
          ELSE
            JL=0
          ENDIF
          GOTO 80
        ENDIF
  200   CONTINUE
C
C ***** STEP 4,5,6
C
          CALL NEWTRI
     I                 (ND,KD,IZE,MXTANG,MXNPFG,MXKGL,N,EPSX,
     O                  IZEW,XVW,YVW,XWRK,YWRK,NW)
C
C ***** STEP 7
C
C
C ***** CHECK IF THERE ARE INAPPROPRIATE CONNECTIONS BETWEEN NEWLY
C       COMPOSED TRIANGLES ----- CHECK IF ANY TWO NEW TRIANGLES HAVE
C       UNUSUAL CONNECTION (I.E. THEY CONNECTS TO EACH OTHER WITH MORE
C       THAN ONE SIDE LINE)
C
          CALL CKTRI
     I                (NW,IZEW,XWRK,YWRK,XP,YP,MXTANG,MXNPFG,EPS,EPSX,
     O                 KCK)
        IF(KCK.EQ.1 .AND. ICHECK.EQ.1)THEN
          WRITE(16,*)'ERROR OCCURRED AFTER CKTRI, N=',N
          STOP
        ENDIF
        IF(ICHECK.EQ.0 .AND. KCK.EQ.1)THEN
          ICHECK=1
          GOTO 40
        ENDIF
C
C ***** DETERMINE IZEW(NW,4) AND IZEW(NW,6)
C
        DO 400 I=1,NW
          DO 390 I1=1,3,2
            I2=I1+1
            IF(I2.GT.3)I2=1
            N1=IZEW(I,I1)
            N2=IZEW(I,I2)
            DO 350 J=1,NW
              IF(J.EQ.I)GOTO 350
              DO 310 J1=1,3
                IF(N1.EQ.IZEW(J,J1))THEN
                  DO 320 J2=1,3
                    IF(N2.EQ.IZEW(J,J2))THEN
                      IZEW(I,I1+3)=J
                      GOTO 390
                    ENDIF
  320             CONTINUE
                  GOTO 350
                ENDIF
  310         CONTINUE
  350       CONTINUE
            IZEW(I,I1+3)=0
  390     CONTINUE
  400   CONTINUE
C
C ***** STEP 8 OVERWRITE
C
        NVV=NV
        IF(NW.LT.ND+1)GOTO 900
        DO 500 I=1,ND
          M1=KD(I)
          XV(M1)=XVW(I)
          YV(M1)=YVW(I)
          DO 410 I1=1,6
            IZE(M1,I1)=IZEW(I,I1)
            IF(I1.GE.4 .AND. I1.NE.5)THEN
              IF(IZE(M1,I1).EQ.0)GOTO 410
              IF(IZE(M1,I1).LE.ND)THEN
                MM=IZE(M1,I1)
                IZE(M1,I1)=KD(MM)
              ELSE
                MM=IZE(M1,I1)
                IZE(M1,I1)=NVV+MM-ND
              ENDIF
            ENDIF
  410     CONTINUE
          M2=IZE(M1,5)
          IF(M2.EQ.0)GOTO 500
          N1=IZE(M1,3)
          DO 420 I1=1,3
            IF(N1.EQ.IZE(M2,I1))THEN
              IZE(M2,I1+3)=M1
              GOTO 500
            ENDIF
  420     CONTINUE
  500   CONTINUE
        DO 600 I=ND+1,NW
          NV=NV+1
          CALL WARMSG(NV,MXKGL,' GRID ','MXKGL ',3)
          XV(NV)=XVW(I)
          YV(NV)=YVW(I)
          DO 510 I1=1,6
            IZE(NV,I1)=IZEW(I,I1)
            IF(I1.GE.4 .AND. I1.NE.5)THEN
              IF(IZE(NV,I1).EQ.0)GOTO 510
              IF(IZE(NV,I1).LE.ND)THEN
                MM=IZE(NV,I1)
                IZE(NV,I1)=KD(MM)
              ELSE
                MM=IZE(NV,I1)
                IZE(NV,I1)=NVV+MM-ND
              ENDIF
            ENDIF
  510     CONTINUE
          M2=IZE(NV,5)
          IF(M2.EQ.0)GOTO 600
          N1=IZE(NV,3)
          DO 520 I1=1,3
            IF(N1.EQ.IZE(M2,I1))THEN
              IZE(M2,I1+3)=NV
              GOTO 600
            ENDIF
  520     CONTINUE
  600   CONTINUE
C
C ***** STEP 9
C
  900 CONTINUE
  999 CONTINUE
      RETURN
      END
      SUBROUTINE CENTER
     I                   (XX,YY,
     O                    XCN,YCN)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION XX(4),YY(4)
C
      DATA EPS/1.0D-14/
C
      KX1=0
      KY1=0
      KX2=0
      KY2=0
C
C ***** FROM POINT 1 AND 2
C
      IF(DABS(XX(2)-XX(1)).GT.EPS)THEN
        DM1=(YY(2)-YY(1))/(XX(2)-XX(1))
        IF(DABS(DM1).LE.EPS)THEN
          XCN=(XX(1)+XX(2))/2.0D0
          KX1=1
        ELSE
          DM1R=-1.0D0/DM1
          XM1=(XX(1)+XX(2))/2.0D0
          YM1=(YY(1)+YY(2))/2.0D0
        ENDIF
      ELSE
        YCN=(YY(1)+YY(2))/2.0D0
        KY1=1
      ENDIF
C
C ***** FROM POINT 2 AND 3
C
      IF(DABS(XX(3)-XX(2)).GT.EPS)THEN
        DM2=(YY(3)-YY(2))/(XX(3)-XX(2))
        IF(DABS(DM2).LE.EPS)THEN
          XCN=(XX(2)+XX(3))/2.0D0
          KX2=1
        ELSE
          DM2R=-1.0D0/DM2
          XM2=(XX(2)+XX(3))/2.0D0
          YM2=(YY(2)+YY(3))/2.0D0
        ENDIF
      ELSE
        YCN=(YY(2)+YY(3))/2.0D0
        KY2=1
      ENDIF
C
C ***** CALCULATEION
C
      IF(KX1.EQ.1)THEN
        IF(KY2.EQ.1)RETURN
        YCN=DM2R*(XCN-XM2)+YM2
      ELSEIF(KY1.EQ.1)THEN
        IF(KX2.EQ.1)RETURN
        XCN=(YCN-YM2)/DM2R+XM2
      ELSEIF(KX2.EQ.1)THEN
        YCN=DM1R*(XCN-XM1)+YM1
      ELSEIF(KY2.EQ.1)THEN
        XCN=(YCN-YM1)/DM1R+XM1
      ELSE
        XCN=(YM1-YM2+DM2R*XM2-DM1R*XM1)/(DM2R-DM1R)
        YCN=(DM1R*(DM2R*XM2-YM2)-DM2R*(DM1R*XM1-YM1))/(DM2R-DM1R)
      ENDIF
      RETURN
      END
      SUBROUTINE NEWTRI
     I                 (ND,KD,IZE,MXTANG,MXNPFG,MXKGL,N,EPSX,
     O                  IZEW,XVW,YVW,XWRK,YWRK,NW)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION KD(MXTANG),XVW(MXTANG),YVW(MXTANG)
      DIMENSION XWRK(MXNPFG),YWRK(MXNPFG),IZE(MXKGL,6),IZEW(MXTANG,6)
      DIMENSION XX(4),YY(4)
C
        NW=0
        DO 250 I=1,ND
          M1=KD(I)
          DO 245 I1=1,3
            I2=I1+1
            IF(I2.GT.3)I2=1
            N1=IZE(M1,I1)
            N2=IZE(M1,I2)
            DO 230 J=1,ND
              M2=KD(J)
              IF(M2.EQ.M1)GOTO 230
              DO 210 J1=1,3
                IF(N1.EQ.IZE(M2,J1))THEN
                  DO 220 J2=1,3
                    IF(N2.EQ.IZE(M2,J2))GOTO 245
  220             CONTINUE
                  GOTO 230
                ENDIF
  210         CONTINUE
  230       CONTINUE
            NW=NW+1
            IZEW(NW,1)=N
            IZEW(NW,2)=N1
            IZEW(NW,3)=N2
            DO 235 K=1,3
              NN=IZEW(NW,K)
              XX(K)=XWRK(NN)
              YY(K)=YWRK(NN)
  235       CONTINUE
            D=(XX(3)-XX(2))*(YY(1)-YY(2))-(XX(1)-XX(2))*(YY(3)-YY(2))
            D=D/DSQRT((XX(3)-XX(2))**2+(YY(3)-YY(2))**2)
            IF(DABS(D).LE.EPSX)THEN
              NW=NW-1
              CALL ONLINE(XX,YY,2,3,4,XWRK(N),YWRK(N))
              GOTO 245
            ENDIF
            CALL CENTER
     I                   (XX,YY,
     O                    XCN,YCN)
            XVW(NW)=XCN
            YVW(NW)=YCN
C
C ***** DETERMINE IZEW(NW,5)
C
            DO 240 K=4,6
              MM=IZE(M1,K)
              IF(MM.EQ.0)GOTO 240
              DO 236 K1=1,3
                IF(N1.EQ.IZE(MM,K1))THEN
                  DO 237 K2=1,3
                    IF(N2.EQ.IZE(MM,K2))THEN
                      IZEW(NW,5)=MM
                      GOTO 245
                    ENDIF
  237             CONTINUE
                  GOTO 240
                ENDIF
  236         CONTINUE
  240       CONTINUE
            IZEW(NW,5)=0
  245     CONTINUE
  250   CONTINUE
      RETURN
      END
      SUBROUTINE CKTRI
     I                (NW,IZEW,XWRK,YWRK,XP,YP,MXTANG,MXNPFG,EPS,EPSX,
     O                 KCK)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION IZEW(MXTANG,6),XWRK(MXNPFG),YWRK(MXNPFG)
C
      KCK=0
        DO 777 I=1,NW
          N1=IZEW(I,2)
          IF(XP.EQ.XWRK(N1) .AND. YP.EQ.YWRK(N1))THEN
            WRITE(16,*)'ERROR IN CKTRI --- POINT P AND POINT N1 ARE ',
     >                 'THE SAME POINT'
            STOP
          ENDIF
C
C ***** EQUATION OF LINE 1 WHICH INCLUDES POINT P AND POINT N1:
C       A1*X+B1*Y=C1
C
          A1=YWRK(N1)-YP
          B1=-(XWRK(N1)-XP)
          C1=A1*XP+B1*YP
          DO 666 IK=1,NW
            IF(IK.EQ.I)GOTO 666
            N3=IZEW(IK,2)
            N4=IZEW(IK,3)
            D34=DSQRT((XWRK(N3)-XWRK(N4))**2+(YWRK(N3)-YWRK(N4))**2)
            IF(D34.LE.EPSX)THEN
              WRITE(16,*)'N3 AND N4 ARE THE SAME POINT'
              KCK=1
              RETURN
            ENDIF
C
C ***** EQUATION OF LINE 2 WHICH INCLUDES POINT N3 AND POINT N4:
C       D*X+E*Y=F
C
            D=YWRK(N3)-YWRK(N4)
            E=-(XWRK(N3)-XWRK(N4))
            F=D*XWRK(N4)+E*YWRK(N4)
C
C ***** FIND OUT THE INTERSECTION POINT, (XQQ,YQQ), OF LINE 1 & LINE 2
C
              DD=DSQRT(A1*A1+B1*B1)*DSQRT(D*D+E*E)
              EE=A1*E-B1*D
              IF(DABS(EE)/DD.GT.EPS)THEN
              XQQ=(C1*E-B1*F)/EE
              YQQ=(A1*F-C1*D)/EE
              IF(DABS(XQQ-XWRK(N1)).LE.EPSX .AND.
     >           DABS(YQQ-YWRK(N1)).LE.EPSX)GOTO 666
C
              Q1X=XQQ-XWRK(N1)
              P1X=XP-XWRK(N1)
              Q1Y=YQQ-YWRK(N1)
              P1Y=YP-YWRK(N1)
              DET=Q1X*P1X+Q1Y*P1Y
              IF(DET.GT.0.0D0)THEN
                D1=DSQRT(Q1X*Q1X+Q1Y*Q1Y)
                D2=DSQRT(P1X*P1X+P1Y*P1Y)
                IF(D1.GT.D2)GOTO 666
              ELSEIF(DET.LT.0.0D0)THEN
                D2=DSQRT(P1X*P1X+P1Y*P1Y)
                D3=DSQRT((XQQ-XP)**2+(YQQ-YP)**2)
                IF(D3.GT.D2)GOTO 666
              ELSE
                KCK=1
                RETURN
              ENDIF
              KCK=1
              RETURN
            ENDIF
  666     CONTINUE
  777   CONTINUE
      RETURN
      END
      SUBROUTINE ISEHIL
c     I    (MAXEL,MAXNP,MXKGL,MXNPFG,MXELW,MXNPW,MXEPW,MXNCC,
     I    (MAXEL,MXKGL,MXNPFG,MXELW,MXNPW,MXEPW,MXNCC,
     I     NEL,NCC,NPFGW,EPSX, NFGM,NFGMB,
c     I     MPLOCS,X,Y,CS,IE,XWFG,YWFG,CWFG,MPLOC,XSFG,YSFG,CSFG,
     I     MPLOCS,IE,XWFG,YWFG,CWFG,MPLOC,XSFG,YSFG,CSFG,
     M     NEPWN,NEPW,DTIFG,
     O     NPFGS,NEFGS,NLGELM,ISE,MAXFGW,MINFGW,CMAXFG,CMINFG,MPLOCE)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
c      DIMENSION NFGMB(MAXEL),IE(MAXEL,9),X(MAXNP),Y(MAXNP),
c     >          CS(MAXNP,MXNCC)
      DIMENSION NFGMB(MAXEL),IE(MAXEL,9)

      DIMENSION XWFG(MXNPFG),YWFG(MXNPFG),CWFG(MXNPFG,MXNCC)
      DIMENSION MPLOC(MXNPFG),ISE(MXKGL,4)
      DIMENSION XSFG(MXNPFG),YSFG(MXNPFG),CSFG(MXNPFG,MXNCC)
      DIMENSION MAXFGW(MXELW,MXNCC),MINFGW(MXELW,MXNCC)
      DIMENSION CMAXFG(MXELW,MXNCC),CMINFG(MXELW,MXNCC)
      DIMENSION NFGM(MAXEL),MPLOCS(MXNPFG),MPLOCE(MXNPFG)
      DIMENSION NEPWN(MXELW),NEPW(MXELW,MXEPW),DTIFG(MXNPFG,MXNCC)
c      DIMENSION XX(4),YY(4),CC(4,7),CQ(7)
      DIMENSION CQ(7)
C
C ----- DETERMINE ISE( , )
        NP=0
        NE=0
        NLGELM=0
        DO 400 M=1,NEL
c
C NOTE: THE FOLLOWING ARRAY NFGMB IS A WORKING ARRAY
c
          NB=NFGMB(M)
c
C NOTE: THE FOLLOWING ARRAY NFGMB IS NOT A WORKING ARRAY
          NFGMB(M)=NE
          IF(IE(M,7).EQ.0)GOTO 400
          NLGELM=NLGELM+1
          NNXG=IE(M,7)
          NNYG=IE(M,9)
          IF(IE(M,4).EQ.0)THEN
            NODE=3
            NPWRK=(NNXG+1)*(NNXG+2)/2
            NEWRK=NNXG**2
          ELSE
            NODE=4
            NPWRK=(NNXG+1)*(NNYG+1)
            NEWRK=NNXG*NNYG
          ENDIF
          CALL WARMSG(NEWRK,MXELW,'ISEHIL','MXELW ',1)
          CALL WARMSG(NPWRK,MXNPW,'ISEHIL','MXNPW ',2)
          DO I=1,NEWRK
            NEPWN(I)=0
            DO J=1,MXEPW
              NEPW(I,J)=0
            ENDDO
          ENDDO
C ----- FOR THE CASES OF QUADRALATERAL ELEMENTS
          IF(NODE.EQ.4)THEN
            DO 335 I=1,NNYG
              DO J=1,NNXG
                MW=(I-1)*NNXG+J+NE
                CALL WARMSG(MW,MXKGL,'ISEHIL','MXKGL ',3)
                ISE(MW,1)=(I-1)*(NNXG+1)+J+NP
                ISE(MW,2)=(I-1)*(NNXG+1)+J+1+NP
                ISE(MW,3)=I*(NNXG+1)+J+1+NP
                ISE(MW,4)=I*(NNXG+1)+J+NP
              ENDDO
  335       CONTINUE
C----- FOR THE CASES OF TRIANGULAR ELEMENTS
          ELSE
            NC=0
            NI=0
            DO 390 I=1,NNXG
              NT=2*I-1
              NII=NI
              DO 380 J=NC+1,NC+NT,2
                MW=J+NE
                NI=NI+1
                ISE(MW,1)=NI+NP
                ISE(MW,2)=NI+I+NP
                ISE(MW,3)=NI+I+1+NP
                ISE(MW,4)=0
  380         CONTINUE
              IF(I.GT.1)THEN
                DO 385 J=NC+2,NC+NT-1,2
                  NII=NII+1
                  MW=J+NE
                  ISE(MW,1)=NII+NP
                  ISE(MW,2)=NII+I+1+NP
                  ISE(MW,3)=NII+1+NP
                  ISE(MW,4)=0
  385           CONTINUE
              ENDIF
              NC=I**2
  390       CONTINUE
          ENDIF
          NP=NP+NPWRK
          CALL WARMSG(NP,MXNPFG,'ISEHIL','MXNPFG',4)
          NE=NE+NEWRK
          CALL WARMSG(NE,MXKGL,'ISEHIL','MXKGL ',5)
C ----- START CHECKING THE HIGH AND LOW OF SUBELEMENTS
          DO I=1,MXELW
            DO K=1,NCC
              MAXFGW(I,K)=0
              MINFGW(I,K)=0
              CMAXFG(I,K)=-1.0D38
              CMINFG(I,K)=1.0D38
            ENDDO
          ENDDO
c          DO I=1,NODE
c            IEM=IE(M,I)
c            XX(I)=X(IEM)
c            YY(I)=Y(IEM)
c            DO K=1,NCC
c              CC(I,K)=CS(IEM,K)
c            ENDDO
c          ENDDO
C CHECK EVERY FORWARD-TRACKED POINTS, WHICK FELL IN THIS ELEMENT, ONE
C BY ONE
          DO 398 N=1,NFGM(M)
            NM=N+NB
C NOTE: ARRAY MPLOC IN THE NEXT LINE IS THE WORKING ARRAY GENERATED JUST
C       NOW
            NN=MPLOC(NM)
            M1=NFGMB(M)+1
            M2=NE
            CALL KGLOC
     I        (XSFG,YSFG,CSFG,ISE,M1,M2,MXNPFG,MXKGL,4,MXNCC,EPSX,
     I         1,1,XWFG(NN),YWFG(NN),
     O         MP1,NODE,CQ,ICODE)
            XP=XWFG(NN)
            YP=YWFG(NN)
            MP=MP1-NFGMB(M)
C
            IF(NN.GT.NPFGW)THEN
C ------------- EPCOF point
              DO I=1,NODE
                IEM=ISE(MP1,I)
                IF(DABS(XP-XSFG(IEM)).LE.EPSX .AND.
     >               DABS(YP-YSFG(IEM)).LE.EPSX)THEN
                  MPLOCE(IEM)=IEM
                  GOTO 398
                ENDIF
              ENDDO
              NEPWN(MP)=NEPWN(MP)+1
              CALL WARMSG(NEPWN(MP),MXEPW,'ISEHIL','MXEPW ',6)
              NBN=NEPWN(MP)
              NEPW(MP,NBN)=NN
              GOTO 398
            ENDIF
C
C ----- DETERMINE HIGH-LOW POINTS
            DO K=1,NCC
              CCP=CWFG(NN,K)
              MXK=0
              MNK=0
              DO I=1,NODE
                IEM=ISE(MP1,I)
                IF(DABS(XP-XSFG(IEM)).LE.EPSX .AND.
     >            DABS(YP-YSFG(IEM)).LE.EPSX)GOTO 398
                IF(CCP.GE.CSFG(IEM,K))MXK=MXK+1
                IF(CCP.LE.CSFG(IEM,K))MNK=MNK+1
              ENDDO
              IF(MXK.EQ.NODE)THEN
                IF(CCP.GT.CMAXFG(MP,K))THEN
                  DO KK=1,NCC
                    MAXFGW(MP,KK)=NN
                    CMAXFG(MP,KK)=CWFG(NN,KK)
                  ENDDO
                  GOTO 398
                ENDIF
              ENDIF
              IF(MNK.EQ.NODE)THEN
                IF(CCP.LT.CMINFG(MP,K))THEN
                  DO KK=1,NCC
                    MINFGW(MP,KK)=NN
                    CMINFG(MP,KK)=CWFG(NN,KK)
                  ENDDO
                  GOTO 398
                ENDIF
              ENDIF
            ENDDO
  398     CONTINUE
C ----- CHECK IF THOSE HIGHS AND LOWS ARE REALLY NEEDED
          DO 399 I=1,NEWRK
            IDO=1
            DO K=1,NCC
              IF(MAXFGW(I,K).NE.0 .AND. CMAXFG(I,K).GT.1.0D-20)IDO=0
            ENDDO
            IF(IDO.EQ.1)THEN
              DO K=1,NCC
                MAXFGW(I,K)=0
                CMAXFG(I,K)=-1.0D38
              ENDDO
            ENDIF
            IDO=1
            DO K=1,NCC
              IF(MINFGW(I,K).NE.0)THEN
                DO J=1,NODE
                  IEM=ISE(NFGMB(M)+I,J)
                  IF(CSFG(IEM,K).GT.1.0D-20)IDO=0
                ENDDO
              ENDIF
            ENDDO
            IF(IDO.EQ.1)THEN
              DO K=1,NCC
                MINFGW(I,K)=0
                CMINFG(I,K)=1.0D38
              ENDDO
            ENDIF
  399     CONTINUE
c         PRINT *,'M=',M
C
          CALL TRIANG
     I        (NEWRK,MAXFGW,MINFGW,XWFG,YWFG,CWFG,NFGMB(M),NEPWN,NEPW,
c     I         NODE,MXELW,MXNPFG,MAXEL,MXKGL,MXEPW,MXNCC,M,NCC,EPSX,
     I         NODE,MXELW,MXNPFG,MXKGL,MXEPW,MXNCC,M,NCC,EPSX,
     M         XSFG,YSFG,CSFG,DTIFG,ISE,NE,NPFGS,MPLOCS,MPLOCE)
          CALL WARMSG(NE,MXKGL,'ISEHIL','MXKGL ',7)
  400   CONTINUE
      NEFGS=NE
      RETURN
      END
      SUBROUTINE KGLOC
     I    (XPFG,YPFG,CPFG,ISE,M1,M2,MXNPFG,MXKGL,NO2,MXNCC,EPSX,
     I     KINIT,KEND,XP,YP,
     O     MM,NODE,CQ,ICODE)
C  10/14/93
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION XPFG(MXNPFG),YPFG(MXNPFG),ISE(MXKGL,NO2)
      DIMENSION CPFG(MXNPFG,MXNCC),XXX(4),YYY(4),CQ(7),KIN(4)
C
      ICODE=-1
      DO 105 MP=M1,M2
        CALL ELENOD(ISE(MP,4),NODE)
        DO II=1,NODE
          IEM=ISE(MP,II)
          XXX(II)=XPFG(IEM)
          YYY(II)=YPFG(IEM)
          IF(DABS(XP-XXX(II)).LE.EPSX .AND. DABS(YP-YYY(II)).LE.EPSX)
     >      THEN
            DO KK=KINIT,KEND
              CQ(KK)=CPFG(IEM,KK)
            ENDDO
            XP=XXX(II)
            YP=YYY(II)
            MM=MP
            ICODE=0
            RETURN
          ENDIF
        ENDDO
C
        DO 100 III=1,NODE
          I1=III+1
          IF(I1.GT.NODE)I1=1
          A1=XXX(I1)-XXX(III)
          AP=XP-XXX(III)
          B1=YYY(I1)-YYY(III)
          BP=YP-YYY(III)
          BB=A1*BP-AP*B1
          AA=DSQRT(A1**2+B1**2)
          IF(AA.EQ.0.0D0)THEN
            WRITE(16,*)'ERROR OCCURRED AT KGLOC, AA=0.0D0 --- STOP'
            STOP
          ENDIF
          CANG=BB/AA
          IF(CANG.LT.0.0D0 .AND. DABS(CANG).GT.EPSX)GOTO 105
          IF(DABS(CANG).LE.EPSX)THEN
            KIN(III)=1
          ELSE
            KIN(III)=2
          ENDIF
  100   CONTINUE
        MM=MP
        do iii=1,node
          if(kin(iii).eq.1)then
            i1=iii+1
            if(i1.gt.node)i1=1
            CALL ONLINE(XXX,YYY,III,I1,4, XP,YP)
            return
          endif
        enddo
        RETURN
  105 CONTINUE
C
      RETURN
      END
C *****  2/7/94 : for implementing the concept of slave point
c        8/22/94
C
      SUBROUTINE DFPREP
c     I  (MAXNP,MAXEL,MXNPFG,MXKGL,MXKGLD,MXNPW,MXADNP,MAXBW,MXKBD,
     I  (MAXNP,MAXEL,MXNPFG,MXKGL,MXKGLD,MXNPW,MXADNP,MXKBD,
c     I   MXJBD,MXNCC,MXNDB,MXMSV,MXLSV,NCC,IDZOOM,NEL,NNP,ID,NXD,NYD,
     I   MXJBD,MXNCC,MXNDB,MXMSV,MXLSV,NCC,IDZOOM,NEL,NNP,NXD,NYD,
c     I   EPSX,IPNTS, X,Y,CS,IB,IE,NLRN,LRL,NLRL,XSFG,YSFG,CSFG,
     I   EPSX, X,Y,CS,IB,IE,NLRN,LRL,NLRL,XSFG,YSFG,CSFG,
     M   ISE,NFGMB,NEFGS,NDBD,MPLOCD,
c     M   NFGM,IBCHK,XW,YW,MWLOC,MPLOCW,XWFG,YWFG,CWFG,
     M   NFGM,XW,YW,MWLOC,MPLOCW,XWFG,YWFG,CWFG,
     O   MPLOC,ISED,NDFG,NEFGD,NDB, NLRND,LRN,ND,NELD,NLS,ILSV,IMSV)
C
C
      IMPLICIT REAL*8(A-H,O-Z)
C
c     COMMON /TVBC/ MXVES,MXVNP,MXVPR,MXVDP,NVES,NVNP,NVPR,NVDP,KVAI
c     COMMON /TCBC/ MXCNP,MXCES,MXCPR,MXCDP,NCNP,NCES,NCPR,NCDP,KCAI
c     COMMON /TNBC/ MXNNP,MXNES,MXNPR,MXNDP,NNNP,NNES,NNPR,NNDP,KNAI
c     COMMON /TDBC/ MXDNP,MXDPR,MXDDP,NDNP,NDPR,NDDP,KDAI
C
      DIMENSION X(MAXNP),Y(MAXNP),CS(MAXNP,MXNCC),IE(MAXEL,9)
      DIMENSION IB(MXADNP),NLRN(MAXNP),NLRL(MAXNP)
C     DIMENSION IDTYP(MXDNP,MXNCC)
C     DIMENSION NPDB(MXDNP),NPVB(MXVNP),NPCB(MXCNP),NPNB(MXNNP)
C
      DIMENSION LRL(MXKBD,MAXNP),XSFG(MXNPFG),YSFG(MXNPFG)
c      DIMENSION ISE(MXKGL,4),NFGMB(MAXEL),NFGM(MAXEL),IBCHK(MAXEL)
      DIMENSION ISE(MXKGL,4),NFGMB(MAXEL),NFGM(MAXEL)
      DIMENSION XW(MXNPW),YW(MXNPW),MWLOC(MXNPW)
      DIMENSION MPLOCW(MXNPFG),XWFG(MXNPFG),YWFG(MXNPFG)
      DIMENSION CWFG(MXNPFG,MXNCC),CSFG(MXNPFG,MXNCC)
      DIMENSION MPLOC(MXNPFG),ISED(MXKGLD,5),NLRND(MXADNP)
      DIMENSION LRN(MXJBD,MXADNP),ND(MXADNP)
C
      DIMENSION NDBD(MXNDB),MPLOCD(MXNDB),ILSV(3,MXLSV),IMSV(2,MXMSV)
      DIMENSION MCON(4),DL(4),XX(4),YY(4),MCB(2)
C
      NDFG=NNP
      DO I=1,NNP
        XWFG(I)=X(I)
        YWFG(I)=Y(I)
        DO K=1,NCC
          CWFG(I,K)=CS(I,K)
        ENDDO
      ENDDO
      IF(IDZOOM.EQ.0)THEN
        GOTO 501
      ENDIF
      DO I=1,NNP
        MPLOC(I)=LRL(1,I)
      ENDDO
C
      NEFGD=0
      NDB=0
      NMS=0
      NLS=0
c     NDNPT=NDNP
c     NVNPT=NVNP
c     NCNPT=NCNP
c     NNNPT=NNNP
C
C ----- FIND OUT ALL THE NON SF ELEMENTS WHICH SURROUND SF REGIONS      6/24/93
C                                                                       6/24/93
      DO 10 M=1,NEL                                                     6/24/93
        IF(IE(M,7).EQ.0 .OR. IE(M,7).EQ.-1)GOTO 10                      6/24/93
        CALL ELENOD(IE(M,4),NODE)
        DO I=1,NODE                                                     6/24/93
          NP=IE(M,I)                                                    6/24/93
          DO J=1,NLRL(NP)                                               6/24/93
            MJ=LRL(J,NP)                                                6/24/93
            IF(IE(MJ,7).EQ.0)IE(MJ,7)=-1                                6/24/93
          ENDDO                                                         6/24/93
        ENDDO                                                           6/24/93
  10  CONTINUE                                                          6/24/93
c
      nlgelm=0
      do m=1,nel
        if(ie(m,7).ne.0)nlgelm=nlgelm+1
      enddo
      print *,'no. of extended rough elements is ',nlgelm
C
C ----- IN THE FOLLOWING, ARRAY NFGM(M) REPRESENTS THE DIFFUSION
C       FINE GRIDS IN THE FIRST M ELEMENTS
      DO M=1,NEL
        NFGM(M)=0
      ENDDO
      DO 490 M=1,NEL
        IF(IE(M,7).EQ.0)THEN
          IF(M.EQ.1)NFGM(M)=NNP
          IF(M.NE.1)NFGM(M)=NFGM(M-1)
          GOTO 490
        ENDIF
c
        CALL ELENOD(IE(M,4),NODE)
        DO I=1,NODE
          IEM=IE(M,I)
          XX(I)=X(IEM)
          YY(I)=Y(IEM)
        ENDDO
C
c       IF(ID.EQ.1)THEN
C -------   concide with regular generated fine grids
c         NNXG=IE(M,7)
c         NNYG=IE(M,9)
c       ELSE
          NNXG=NXD
          NNYG=NYD
c       ENDIF
C
C ----- CHECK THE ELEMENTS CONNECTING TO ELEMENT M, AND STORE THE
C       INFORMATION INTO ARRAY MCON(4)
        DO 420 I=1,NODE
          MCON(I)=0
          I1=I+1
          IF(I1.GT.NODE)I1=I1-NODE
          N1=IE(M,I)
          N2=IE(M,I1)
          DO 415 J1=1,NLRL(N1)
            M1=LRL(J1,N1)
            DO J2=1,NLRL(N2)
              M2=LRL(J2,N2)
              IF(M1.EQ.M2 .AND. M1.NE.M)THEN
                MCON(I)=M1
                GOTO 420
              ENDIF
            ENDDO
  415     CONTINUE
          MCON(I)=0
  420   CONTINUE
C ----- CHECK THOSE DIFFUSION FINE GRIDS WHICH LOCATE ON THE BOUNDARY OF
C       EACH ELEMENTS
        IF(NODE.EQ.4)THEN
          DO 440 I=1,NNYG+1
            YI=2.0D0*DBLE(I-1)/DBLE(NNYG)-1.0D0
            DO 435 J=1,NNXG+1
              XI=2.0D0*DBLE(J-1)/DBLE(NNXG)-1.0D0
              N=(I-1)*(NNXG+1)+J
              DL(1)=0.25D0*(1.0D0-XI)*(1.0D0-YI)
              DL(2)=0.25D0*(1.0D0+XI)*(1.0D0-YI)
              DL(3)=0.25D0*(1.0D0+XI)*(1.0D0+YI)
              DL(4)=0.25D0*(1.0D0-XI)*(1.0D0+YI)
              CALL VALBDL(XX,YY,DL,4,NODE,XW(N),YW(N))
              IF(I.EQ.1 .OR. I.EQ.NNYG+1 .OR. J.EQ.1 .OR.
     >           J.EQ.NNXG+1) THEN
C ------------    check those points on the boundary with s-f elements
C ------------    and the intermost non-sf elements
C
                CALL GLBCHK
     I           (N,NNP,NEL,NEFGS,NODE,EPSX,NCC,XW(N),YW(N),MCON,M,
     I            NNXG,NNYG,MAXNP,MAXEL,MXNPFG,MXKGL,MXNDB,MXNCC,MXKBD,
     I            MXNPW,MXADNP,I,J,NFGM,X,Y,IE,IB,
     I            NLRL,LRL,CS,XSFG,YSFG,CSFG,ISE,NFGMB,
     M            NDB,NDFG,NDBD,MPLOCW,MPLOCD,XWFG,YWFG,CWFG,MPLOC,
     M            MWLOC,MCB)
              ELSE
                CALL FPLUS1
c     I            (MAXNP,MAXEL,MXNPFG,MXKGL,MXNCC,MXNPW,MXADNP,NODE,
     I            (MAXNP,MAXEL,MXNPFG,MXKGL,MXNCC,MXNPW,NODE,
     I             EPSX,NCC,N,M,XW(N),YW(N),X,Y,CS,IE,
     I             XSFG,YSFG,CSFG,NEL,NEFGS,ISE,NFGMB,
     O             NDFG,XWFG,YWFG,CWFG,MPLOC,MWLOC)
              ENDIF
 435          CONTINUE
 440        CONTINUE
            NFGM(M)=NDFG
C ----- DETERMINE THE DIFFUSION SUBELEMENTS FOR THE CURRENT TIME STEP
            CALL GRISED
     I          (NNXG,NNYG,MXKGLD,MXNPW,NODE,M,MAXNP,MAXEL,MXLSV,
     I           MXMSV,IE,IB,MCON,
     O           NEFGD,MWLOC,ISED,NMS,NLS,ILSV,IMSV)
          ELSE
C
C ***** THE FOLLOWING BLOCKS ARE FOR TRIANGULAR ELEMENTS
C
            N=0
            DO 460 I=NNXG+1,1,-1
              DL1=DBLE(I-1)/DBLE(NNXG)
              DO 455 J=NNXG+1,1,-1
                DL2=DBLE(J-1)/DBLE(NNXG)
                IF(DL1+DL2.GT.1.0D0 .AND. DABS(DL1+DL2-1.0D0).GT.EPSX)
     >            GOTO 455
                DO 450 K=NNXG+1,1,-1
                  DL3=DBLE(K-1)/DBLE(NNXG)
                  IF(DABS(DL1+DL2+DL3-1.0D0).LE.1.0D-6)THEN
                    N=N+1
                    DL(1)=DL1
                    DL(2)=DL2
                    DL(3)=DL3
                    CALL VALBDL(XX,YY,DL,4,NODE,XW(N),YW(N))
                    IF(DABS(DL1).LE.EPSX .OR. DABS(DL2).LE.EPSX .OR.
     >                 DABS(DL3).LE.EPSX)THEN
C ------------    check those points on the boundary with s-f elements
                      CALL GLBCHK
     I                 (N,NNP,NEL,NEFGS,NODE,EPSX,NCC,XW(N),YW(N),MCON,
     I                  M,NNXG,NNYG,MAXNP,MAXEL,MXNPFG,MXKGL,MXNDB,
     I                  MXNCC,MXKBD,MXNPW,MXADNP,I,J,NFGM,X,Y,IE,
     I                  IB,NLRL,LRL,CS,XSFG,YSFG,CSFG,ISE,NFGMB,
     M                  NDB,NDFG,NDBD,MPLOCW,MPLOCD,XWFG,YWFG,CWFG,
     M                  MPLOC,MWLOC,MCB)
                    ELSE
                      CALL FPLUS1
c     I                  (MAXNP,MAXEL,MXNPFG,MXKGL,MXNCC,MXNPW,MXADNP,
     I                  (MAXNP,MAXEL,MXNPFG,MXKGL,MXNCC,MXNPW,
     I                   NODE,EPSX,NCC,N,M,XW(N),YW(N),X,Y,CS,IE,
     I                   XSFG,YSFG,CSFG,NEL,NEFGS,ISE,NFGMB,
     O                   NDFG,XWFG,YWFG,CWFG,MPLOC,MWLOC)
                    ENDIF
                  ENDIF
  450           CONTINUE
  455         CONTINUE
  460       CONTINUE
            NFGM(M)=NDFG
            CALL GRISED
     I          (NNXG,NNYG,MXKGLD,MXNPW,NODE,M,MAXNP,MAXEL,MXLSV,
     I           MXMSV,IE,IB,MCON,
     O           NEFGD,MWLOC,ISED,NMS,NLS,ILSV,IMSV)
          ENDIF
          CALL WARMSG(NEFGD,MXKGLD,'DFPREP','MXKGLD',16)
  490   CONTINUE
        NELD=NEFGD
c
        print *,'NMS=',nms
        print *,'NLS=',nls
C
C ----- CHECK THOSE NON-SF ELEMENTS TO WHICH SF ELEMENTS CONNECTED.
C       IN THE FOLLOWING, ARRAY NFGM(M) REPRESENTS THE NUMBER OF
C       DIFFUSION POINTS IN NON-SF ELEMENT M.  THUS, M IS TO BE TRI-
C       ANGULATED.  IBCHK(M) IS A WORKING ARRAY HERE.
C
C       DO M=1,NEL
C         NFGM(M)=0
C         IBCHK(M)=0
C       ENDDO
C       DO I=1,NDB
C         M=MPLOCW(I)
C         NFGM(M)=NFGM(M)+1
C       ENDDO
C       DO M=1,NEL
C         IF(M.EQ.1)THEN
C           NFGM(M)=NFGM(M)
C         ELSE
C           NFGM(M)=NFGM(M)+NFGM(M-1)
C         ENDIF
C       ENDDO
C       DO I=1,NDB
C         M=MPLOCW(I)
C         IBCHK(M)=IBCHK(M)+1
C         IF(M.EQ.1)THEN
C           NM=IBCHK(M)
C         ELSE
C           NM=IBCHK(M)+NFGM(M-1)
C         ENDIF
C         MPLOCD(NM)=I
C       ENDDO
C
C       DO 500 M=1,NEL
C         IF(IE(M,7).NE.0)GOTO 500
C         IF(IBCHK(M).EQ.0)GOTO 500
C
C         NK=0
C         IE(M,7)=MXNPFG
C         DO I=1,IBCHK(M)
C           IF(M.EQ.1)THEN
C             NM=I
C           ELSE
C             NM=NFGM(M-1)+I
C           ENDIF
C           NN=MPLOCD(NM)
C           NP=NDBD(NN)
C           NK=NK+1
C           XWRK(NK)=XWFG(NP)
C           YWRK(NK)=YWFG(NP)
C           NWRK(NK)=NP
C         ENDDO
C         NKK=NK
C         IF(NODE.EQ.3)THEN
C           DO J1=1,3
C             NK=NK+1
C             IEM=IE(M,J1)
C             XWRK(NK)=XWFG(IEM)
C             YWRK(NK)=YWFG(IEM)
C             NWRK(NK)=IEM
C             IZE(1,J1)=NK
C             XX(J1)=XWRK(NK)
C             YY(J1)=YWRK(NK)
C           ENDDO
C           CALL CENTER
C    I                   (XX,YY,
C    O                    XCN,YCN)
C           XV(1)=XCN
C           YV(1)=YCN
C           DO J1=4,6
C             IZE(1,J1)=0
C           ENDDO
C           NV=1
C         ELSE
C           DO J1=1,4
C             NK=NK+1
C             IEM=IE(M,J1)
C             XWRK(NK)=XWFG(IEM)
C             YWRK(NK)=YWFG(IEM)
C             NWRK(NK)=IEM
C           ENDDO
C           NV=0
C           DO 491 J1=1,2
C             NV=NV+1
C             IF(J1.EQ.1)THEN
C               K1=1
C               K2=2
C               K3=3
C             ELSE
C               K1=1
C               K2=3
C               K3=4
C             ENDIF
C             DO J2=1,3
C               IF(J2.EQ.1)J3=K1
C               IF(J2.EQ.2)J3=K2
C               IF(J2.EQ.3)J3=K3
C               IZE(NV,J2)=NK-4+J3
C               XX(J2)=XWRK(NK-4+J3)
C               YY(J2)=YWRK(NK-4+J3)
C             ENDDO
C             CALL CENTER
C    I                     (XX,YY,
C    O                      XCN,YCN)
C             XV(NV)=XCN
C             YV(NV)=YCN
C             IF(NV.EQ.1)THEN
C               IZE(NV,4)=0
C               IZE(NV,5)=0
C               IZE(NV,6)=2
C             ELSE
C               IZE(NV,4)=1
C               IZE(NV,5)=0
C               IZE(NV,6)=0
C             ENDIF
C491        CONTINUE
C         ENDIF
C
C         CALL GRID
C    I                (NKK,XWRK,YWRK,20,34,EPSX,
C    M                 IZE,NV,XV,YV)
C         NK=0
C         DO I=1,IBCHK(M)
C           IF(M.EQ.1)THEN
C             NM=I
C           ELSE
C             NM=NFGM(M-1)+I
C           ENDIF
C           NN=MPLOCD(NM)
C           NP=NDBD(NN)
C           NK=NK+1
C           XWFG(NP)=XWRK(NK)
C           YWFG(NP)=YWRK(NK)
C         ENDDO
C
C         DO 495 NL=1,NV
C           NEFGD=NEFGD+1
C           DO I1=1,3
C             IZEM=IZE(NL,I1)
C             ISED(NEFGD,I1)=NWRK(IZEM)
C           ENDDO
C           ISED(NEFGD,4)=0
C           ISED(NEFGD,5)=M
C 495     CONTINUE
C         IE(M,7)=IE(M,7)+NV
C
C 500   CONTINUE
  501   CONTINUE
C ----- CREATE ARRAY NLRND(NNP) FOR DIFFUSION
        DO I=1,NNP
          NLRND(I)=NLRN(I)
        ENDDO
        IF(IDZOOM.NE.0)THEN
          DO I=NNP+1,NDFG
            NLRND(I)=0
          ENDDO
          mxnlrn=0
          DO 505 M=1,NEFGD
            CALL ELENOD(ISED(M,4),NODE)
            DO 504 I=1,NODE
              IEM=ISED(M,I)
              DO 503 J=1,NODE
                IEMJ=ISED(M,J)
                IF(NLRND(IEM).EQ.0)THEN
                  NLRND(IEM)=NLRND(IEM)+1
                  LRN(1,IEM)=IEMJ
                ELSE
                  DO K=1,NLRND(IEM)
                    N=LRN(K,IEM)
                    IF(N.EQ.IEMJ)GOTO 503
                  ENDDO
                  NLRND(IEM)=NLRND(IEM)+1
                  CALL WARMSG(NLRND(IEM),MXJBD,'DFPREP','MXJBD ',17)
                  NLRNN=NLRND(IEM)
                  mxnlrn=max0(mxnlrn,nlrnn)
                  LRN(NLRNN,IEM)=IEMJ
                ENDIF
 503          CONTINUE
 504        CONTINUE
 505      CONTINUE
c
          print *,'MXJBD=',mxnlrn
C
C
C ------ PREPARE ND ARRAY
C
c         IF(IPNTS.NE.0)THEN
            DO NP=1,NDFG
              DO I=1,NLRND(NP) 
                IF(LRN(I,NP).EQ.NP)ND(NP)=I
              ENDDO
            ENDDO
c         ENDIF
C
c       IF(IPNTS.EQ.3)THEN
C
C ----- REARRANGE LRN IN ACENDING ORDER AND COMPUTE ND IF IPNTST=3
C
c         DO 550 NP=1,NDFG
c           NCOUNT=0
c           IF(NP.LE.NNP)THEN
c             I1=NLRN(NP)+1
c           ELSE
c             I1=1
c           ENDIF
c           DO 540 I=I1,NLRND(NP)
c             NI=LRN(I,NP)
c             IF(NCOUNT.EQ.0)THEN
c               KK(1)=I
c               KJ(1)=NI
c               NCOUNT=NCOUNT+1
c             ELSE
c               DO J=NCOUNT,1,-1
c                 NJ=KJ(J)
c                 IF(J.EQ.1)THEN
c                   IF(NI.LT.NJ)GOTO 510
c                 ELSE
c                   NK=KJ(J-1)
c                   IF(NI.LT.NJ .AND. NI.GT.NK)GOTO 510
c                 ENDIF
c               ENDDO
c               NCOUNT=NCOUNT+1
c               CALL WARMSG(NCOUNT,100,'DFPREP','  100 ',2)
c               KK(NCOUNT)=I
c               KJ(NCOUNT)=NI
c               GOTO 540
c 510           CONTINUE
c               NCOUNT=NCOUNT+1
c               DO JJ=NCOUNT,J+1,-1
c                 KK(JJ)=KK(JJ-1)
c                 KJ(JJ)=KJ(JJ-1)
c               ENDDO
c               KK(J)=I
c               KJ(J)=NI
c             ENDIF
c 540       CONTINUE
C
c           DO I=I1,NLRND(NP)
c             II1=I-I1+1
c             LRN(I,NP)=KJ(II1)
c             IF(NP.GT.NNP .AND. KJ(II1).EQ.NP)ND(NP)=I
c           ENDDO
C
c 550     CONTINUE
c       ENDIF
C ----- IN THE FOLLOWING, NFGM(M) REPRESENTS THE TOTAL NUMBER OF
C       DIFFUSION SUBELEMENTS IN THE FIRST M-1 ELEMENTS
          NFGM(1)=0
          DO M=2,NEL
            IF(IE(M-1,7).EQ.0)THEN
              NFGM(M)=NFGM(M-1)
            ELSE
              IF(IE(M-1,4).NE.0)THEN
                NXYG=NXD*NYD
              ELSE
                NXYG=NXD*NXD
              ENDIF
              NFGM(M)=NFGM(M-1)+NXYG
            ENDIF
          ENDDO
        ENDIF
        RETURN
        END
      SUBROUTINE GLBCHK
     I     (N,NNP,NEL,NEFGS,NODE,EPSX,NCC,XW1,YW1,MCON,M,NNXG,NNYG,
     I      MAXNP,MAXEL,MXNPFG,MXKGL,MXNDB,MXNCC,MXKBD,MXNPW,MXADNP,
     I      I,J,NFGM,X,Y,IE,IB,NLRL,LRL,CS,XSFG,YSFG,CSFG,
     I      ISE,NFGMB,
     M      NDB,NDFG,NDBD,MPLOCW,MPLOCD,XWFG,YWFG,CWFG,MPLOC,MWLOC,MCB)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION X(MAXNP),Y(MAXNP),CS(MAXNP,MXNCC),IE(MAXEL,9),IB(MAXNP)
      DIMENSION LRL(MXKBD,MAXNP),NLRL(MAXNP),ISE(MXKGL,4)
      DIMENSION XSFG(MXNPFG),YSFG(MXNPFG),CSFG(MXNPFG,MXNCC),NDBD(MXNDB)
      DIMENSION MPLOCW(MXNPFG),MPLOCD(MXNDB),MPLOC(MXNPFG),MWLOC(MXNPW)
      DIMENSION XWFG(MXNPFG),YWFG(MXNPFG),CWFG(MXNPFG,MXNCC)
      DIMENSION NFGMB(MAXEL),NFGM(MAXEL)
      DIMENSION MCON(4),MCB(2),CQ(7)
C
      DO 431 K=1,NODE
        MP=MCON(K)
        IF(MP.EQ.0)GOTO 431
        IF(IE(MP,7).NE.0)THEN
          IF(MP.EQ.1)THEN
            NM1=NNP
            NM2=NFGM(MP)
          ELSE
            NM1=NFGM(MP-1)
            NM2=NFGM(MP)
          ENDIF
          IF(NM2.NE.0)THEN
            DO KK=NM1+1,NM2
              IF(DABS(XW1-XWFG(KK)).LE.EPSX .AND.
     >           DABS(YW1-YWFG(KK)).LE.EPSX)THEN
C ----- MWLOC(N)=KK MEANS THE N-TH DIFFUSION FINE GRID IN ELEMENT M IS
C       THE KK-TH DIFFUSION POINT OF ALL DIFFUSION POINTS
                MWLOC(N)=KK
                GOTO 435
              ENDIF
            ENDDO
          ENDIF
        ENDIF
  431 CONTINUE
      DO JI=1,4
        IEMP=IE(M,JI)
        IF(IEMP.NE.0)THEN
C
C ----- THE N-TH DIFFUSION POINT IN THE M-TH ELEMENT IS LOCATED ON THE
C       GLOBAL NODE
C
          IF(DABS(XW1-X(IEMP)).LE.EPSX .AND.
     >       DABS(YW1-Y(IEMP)).LE.EPSX)THEN
            MWLOC(N)=IEMP
            IF(IB(IEMP).EQ.0)THEN
              DO KM=1,NLRL(IEMP)
                MK=LRL(KM,IEMP)
                IF(IE(MK,7).NE.0 .AND. IE(MK,7).NE.-1)
     >             GOTO 435
              ENDDO
            ENDIF
C
C ----- BOUNDARY POINT OR THE MOST OUTSIDE LAYER OF THE ROUGH REGION
C
            DO KM=1,NLRL(IEMP)
              MK=LRL(KM,IEMP)
              IF(MK.LT.M .AND. IE(MK,7).NE.0)GOTO 435
            ENDDO
C
            NDB=NDB+1
            CALL WARMSG(NDB,MXNDB ,'DFPREP','MXNDB ',1)
C
C -----  STORE THE DIFFUSION BOUNDARY POINT
C
            NDBD(NDB)=IEMP
            MPLOCW(NDB)=M                                               6/24/93
C
C ---- STORE WHICH ELEMENT SIDE THE DIFFUSION POINT IS LOCATED ON
C
            MPLOCD(NDB)=JI                                              6/24/93
            GOTO 435
          ENDIF
        ENDIF
      ENDDO
      NDFG=NDFG+1
      CALL WARMSG(NDFG,MXADNP,'DFPREP','MXADNP',2)
      MWLOC(N)=NDFG
C ----- DETERMINE THE CONCENTRATION OF THIS DIFFUSION FINE GRID BY
C       INTERPOLATION FROM CS AND CSFG
      CALL INTERPK
     I    (MAXNP,MAXEL,MXNPFG,MXKGL,4,MXNCC,NCC,NODE,M,2,XW1,YW1,
     I     EPSX,NEL,NEFGS,X,Y,CS,IE,XSFG,YSFG,CSFG,ISE,NFGMB,
     O     CQ)
      XWFG(NDFG)=XW1
      YWFG(NDFG)=YW1
      DO K=1,NCC
        CWFG(NDFG,K)=CQ(K)
      ENDDO
      MPLOC(NDFG)=M
C
C ----- CHECK THOSE POINTS ON THE BOUNDARY WITH NON-SF ELEMENTS OR ON
C       THE GLOBAL BOUNDARIES
C
      NCB=0
      MP1=-10
      MP2=-10
      IEMP1=-100
      IEMP2=-100
      IF(I.EQ.1)THEN
        NCB=NCB+1
        MCB(NCB)=1
      ENDIF
      IF(I.EQ.NNYG+1)THEN
        NCB=NCB+1
        MCB(NCB)=3
      ENDIF
      IF(J.EQ.1)THEN
        NCB=NCB+1
        MCB(NCB)=4
      ENDIF
      IF(J.EQ.NNXG+1)THEN
        NCB=NCB+1
        MCB(NCB)=2
      ENDIF
      IF(NCB.GE.1)THEN
        KK1=MCB(1)
        MP1=MCON(KK1)
        IF(MP1.EQ.0)GOTO 32
        IEMP1=IE(MP1,7)
        IF(NCB.EQ.2)THEN
          KK2=MCB(2)
          MP2=MCON(KK2)
          IF(MP2.EQ.0)GOTO 32
          IEMP2=IE(MP2,7)
        ENDIF
      ENDIF
  32  CONTINUE
      IF(MP1.EQ.0 .OR. MP2.EQ.0 .OR. IEMP1.EQ.0
     >   .OR. IEMP2.EQ.0)THEN
        NDB=NDB+1
        CALL WARMSG(NDB,MXNDB ,'DFPREP','MXNDB ',3)
        NDBD(NDB)=NDFG
        MPLOCW(NDB)=M                                                   6/24/93
        MPLOCD(NDB)=KK1                                                 6/24/93
      ENDIF
C
C ----- CHECK IF THIS DIFFUSION FINE GRID IS ON THE BOUNDARY
c     DO 434 II=1,NODE
c       II1=II+1
c       IF(II1.GT.NODE)II1=II1-NODE
c       N1=IE(M,II)
c       N2=IE(M,II1)
c       IF(IB(N1).EQ.0 .OR. IB(N2).EQ.0)GOTO 434
c       DLNTH=DSQRT((X(N2)-X(N1))**2+(Y(N2)-Y(N1))**2)
c       DET=(X(N2)-X(N1))*(YQ-Y(N1))-(Y(N2)-Y(N1))*
c    >       (XQ-X(N1))/DLNTH
c       IF(DABS(DET).LE.EPSX)THEN
c         DO 433 JJ=1,NLRL(N1)
c           M1=LRL(JJ,N1)
c           DO KK=1,NLRL(N2)
c             M2=LRL(KK,N2)
c             IF(M1.EQ.M2 .AND. M1.NE.M)GOTO 434
c           ENDDO
c 433     CONTINUE
c         NBDYD=NBDYD+1
c         NBNPT=NBNP+NBDYD
c         CALL WARMSG(NBNPT,MAXBNP,'DFPREP','MAXBNP',4)
c         NPBB(NBNPT)=NDFG
c         IF(IB(N1).EQ.1 .AND. IB(N2).EQ.1)THEN
c           NDNPT=NDNPT+1
c           CALL WARMSG(NDNPT,MXDNP,'DFPREP','MXDNP ',5)
c           IB(NDFG)=1
c           NPDB(NDNPT)=NDFG
c           DO INP=1,NDNP
c             IF(NPDB(INP).EQ.N1)GOTO 422
c           ENDDO
c           WRITE(16,*)'ERROR IN BDY BLOCK OF DFPREP'
c           STOP
c 422       CONTINUE
c           DO K=1,NCC
c             IDTYP(NDNPT,K)=IDTYP(INP,K)
c           ENDDO
c         ELSEIF(IB(N1).EQ.2 .AND. IB(N2).EQ.2)THEN
c           NVNPT=NVNPT+1
c           CALL WARMSG(NVNPT,MXVNP,'DFPREP','MXVNP ',6)
c           IB(NDFG)=2
c           NPVB(NVNPT)=NDFG
c         ELSEIF(IB(N1).EQ.3 .AND. IB(N2).EQ.3)THEN
c           NCNPT=NCNPT+1
c           CALL WARMSG(NCNPT,MXCNP,'DFPREP','MXCNP ',7)
c           IB(NDFG)=3
c           NPCB(NCNPT)=NDFG
c         ELSEIF(IB(N1).EQ.4 .AND. IB(N2).EQ.4)THEN
c           NNNPT=NNNPT+1
c           CALL WARMSG(NNNPT,MXNNP,'DFPREP','MXNNP ',8)
c           IB(NDFG)=4
c           NPNB(NNNPT)=NDFG
c         ELSE
c           IB(NDFG)=5
c         ENDIF
c       ENDIF
c 434 CONTINUE
  435 RETURN
      END
      SUBROUTINE FPLUS1
c     I    (MAXNP,MAXEL,MXNPFG,MXKGL,MXNCC,MXNPW,MXADNP,NODE,EPSX,NCC,
     I    (MAXNP,MAXEL,MXNPFG,MXKGL,MXNCC,MXNPW,NODE,EPSX,NCC,
     I     N,M,XW1,YW1,X,Y,CS,IE,XSFG,YSFG,CSFG,NEL,NEFGS,ISE,NFGMB,
     O     NDFG,XWFG,YWFG,CWFG,MPLOC,MWLOC)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION X(MAXNP),Y(MAXNP),CS(MAXNP,MXNCC),IE(MAXEL,9)
      DIMENSION XSFG(MXNPFG),YSFG(MXNPFG),CSFG(MXNPFG,MXNCC)
      DIMENSION XWFG(MXNPFG),YWFG(MXNPFG),CWFG(MXNPFG,MXNCC)
      DIMENSION NFGMB(MAXEL),ISE(MXKGL,4),MPLOC(MXNPFG),MWLOC(MXNPW)
      DIMENSION CQ(7)
C
      NDFG=NDFG+1
      CALL WARMSG(NDFG,MXNPFG,'FPLUS1','MXNPFG',9)
      MWLOC(N)=NDFG
C ----- DETERMINE THE CONCENTRATION OF THIS DIFFUSION FINE GRID BY
C       INTERPOLATION FROM CS AND CSFG
      CALL INTERPK
     I    (MAXNP,MAXEL,MXNPFG,MXKGL,4,MXNCC,NCC,NODE,M,2,XW1,YW1,
     I     EPSX,NEL,NEFGS,X,Y,CS,IE,XSFG,YSFG,CSFG,ISE,NFGMB,
     O     CQ)
      XWFG(NDFG)=XW1
      YWFG(NDFG)=YW1
      DO K=1,NCC
        CWFG(NDFG,K)=CQ(K)
      ENDDO
      MPLOC(NDFG)=M
      RETURN
      END
      SUBROUTINE GRISED
     I    (NNXG,NNYG,MXKGLD,MXNPW,NODE,M,MAXNP,MAXEL,MXLSV,MXMSV,
     I     IE,IB,MCON,
     O     NEFGD,MWLOC,ISED,NMS,NLS,ILSV,IMSV)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION MWLOC(MXNPW),ISED(MXKGLD,5),IE(MAXEL,9),IB(MAXNP)
      DIMENSION ILSV(3,MXLSV),IMSV(2,MXMSV)
      DIMENSION MCON(4)
C
      IF(NODE.EQ.4)THEN
        DO 441 I=1,NNYG
          DO J=1,NNXG
            MD=(I-1)*NNXG+J+NEFGD
            CALL WARMSG(MD,MXKGLD,'DFPREP','MXKGLD',8)
            ISED(MD,1)=MWLOC((I-1)*(NNXG+1)+J)
            ISED(MD,2)=MWLOC((I-1)*(NNXG+1)+J+1)
            ISED(MD,3)=MWLOC(I*(NNXG+1)+J+1)
            ISED(MD,4)=MWLOC(I*(NNXG+1)+J)
            ISED(MD,5)=M
          ENDDO
  441   CONTINUE
C
C ----- Prepare information for intra-boundary sides       1/27/94
C
        DO 445 MS=1,NODE
          MCONMS=MCON(MS)
          IF(MCONMS.EQ.0 .OR. IE(M,7).NE.-1) GOTO 445
          MS1=MS+1
          IF(MS1.GT.NODE)MS1=1
          N1=IE(M,MS)
          N2=IE(M,MS1)
C
C ----- Check if this intra-boundary is a global boundary
C
          IF(IB(N1).NE.0 .AND. IB(N2).NE.0) GOTO 445
          NMS=NMS+1
          CALL WARMSG(NMS,MXMSV,'DFPREP','MXMSV ',10)
          IMSV(1,NMS)=N1
          IMSV(2,NMS)=N2
C
C ----- Create local arrays for storing intra-boundary points
C
          I1=1
          I2=NNYG
          J1=1
          J2=NNXG
          IF(MS.EQ.3)I1=NNYG
          IF(MS.EQ.1)I2=1
          IF(MS.EQ.2)J1=NNXG
          IF(MS.EQ.4)J2=1
          DO I=I1,I2
            DO J=J1,J2
              MD=(I-1)*NNXG+J+NEFGD
              NLS=NLS+1
              CALL WARMSG(NLS,MXLSV,'DFPREP','MXLSV ',11)
              ILSV(1,NLS)=ISED(MD,MS)
              ILSV(2,NLS)=ISED(MD,MS1)
              ILSV(3,NLS)=NMS
            ENDDO
          ENDDO
  445   CONTINUE
C                                                         1/27/94
        NEFGD=NEFGD+NNXG*NNYG
      ELSEIF(NODE.EQ.3)THEN
        NC=0
        NI=0
        DO 482 I=1,NNXG
          NT=2*I-1
          NII=NI
          DO J=NC+1,NC+NT,2
            MW=J+NEFGD
            NI=NI+1
            ISED(MW,1)=MWLOC(NI)
            ISED(MW,2)=MWLOC(NI+I)
            ISED(MW,3)=MWLOC(NI+I+1)
            ISED(MW,4)=0
            ISED(MW,5)=M
          ENDDO
          IF(I.GT.1)THEN
            DO J=NC+2,NC+NT-1,2
              NII=NII+1
              MW=J+NEFGD
              ISED(MW,1)=MWLOC(NII)
              ISED(MW,2)=MWLOC(NII+I+1)
              ISED(MW,3)=MWLOC(NII+1)
              ISED(MW,4)=0
              ISED(MW,5)=M
            ENDDO
          ENDIF
          NC=I**2
  482   CONTINUE
C
C
C ----- Prepare information for intra-boundary sides       1/27/94
C
        DO 485 MS=1,NODE
          MCONMS=MCON(MS)
          IF(MCONMS.EQ.0 .OR. IE(M,7).NE.-1) GOTO 485
          MS1=MS+1
          IF(MS1.GT.NODE)MS1=1
          N1=IE(M,MS)
          N2=IE(M,MS1)
C
C ----- Check if this intra-boundary is a global boundary
C
          IF(IB(N1).NE.0 .AND. IB(N2).NE.0) GOTO 485
          NMS=NMS+1
          CALL WARMSG(NMS,MXMSV,'DFPREP','MXMSV ',21)
          IMSV(1,NMS)=N1
          IMSV(2,NMS)=N2
C
C ----- Create local arrays for storing intra-boundary points
C
          I1=1
          I2=NNXG
          IF(MS.EQ.2)I1=NNXG
          NC=0
          DO I=I1,I2
            NT=2*I-1
            NC=(I-1)*(I-1)
            J1=NC+1
            J2=NC+NT
            IF(MS.EQ.3)THEN
              J1=NC+NT
              J2=J1
            ELSEIF(MS.EQ.1)THEN
              J1=NC+1
              J2=J1
            ENDIF
            DO J=J1,J2,2
              MD=J+NEFGD
              NLS=NLS+1
              CALL WARMSG(NLS,MXLSV,'DFPREP','MXLSV ',22)
              ILSV(1,NLS)=ISED(MD,MS)
              ILSV(2,NLS)=ISED(MD,MS1)
              ILSV(3,NLS)=NMS
            ENDDO
          ENDDO
  485   CONTINUE
C
        NEFGD=NEFGD+NNXG**2
      ENDIF
      RETURN
      END
      SUBROUTINE INTERP
     I        (MAXNP,MAXEL,MXNPFG,MXKGL,NODE,M,IBF,XQ,YQ,EPSX,
     I         NEL,NEFG,X,Y,CP,IE,XPFG,YPFG,CPFG,ISE,NFGMB,
     O         CQ)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION X(MAXNP),Y(MAXNP),CP(MAXNP),IE(MAXEL,9),NFGMB(MAXEL)
      DIMENSION XPFG(MXNPFG),YPFG(MXNPFG),CPFG(MXNPFG),ISE(MXKGL,4)
      DIMENSION XX(4),YY(4),CC(4),DL(4),CQQ(7)
C
      DO KK=1,NODE
        K=IE(M,KK)
        IF(DABS(XQ-X(K)).LE.EPSX.AND. DABS(YQ-Y(K)).LE.EPSX)THEN
          CQ=CP(K)
          GOTO 600
        ENDIF
      ENDDO
C
      DO J=1,NODE
        IEM=IE(M,J)
        XX(J)=X(IEM)
        YY(J)=Y(IEM)
        CC(J)=CP(IEM)
      ENDDO
C
      CALL BASE1
     I         (XX,YY,XQ,YQ,M,NODE,
     O          DL)
      IF(IBF.EQ.1)THEN
        IEM6=IE(M,6)
      ELSE
        IEM6=IE(M,7)
      ENDIF
C
C ***** FOR THE CASE OF NON-SF ELEMENT
C
      IF(IEM6.EQ.0)THEN
        CQ=0.0D0
        DO J=1,NODE
          CQ=CQ+DL(J)*CC(J)
        ENDDO
        GOTO 600
      ENDIF
C
C ***** FOR THE CASE OF S-F ELEMENT
C
c      IF(IBF.EQ.1)THEN
c        NXG=IE(M,6)
c        NYG=IE(M,8)
c      ELSE
c        NXG=IE(M,7)
c        NYG=IE(M,9)
c      ENDIF
C
      M1=NFGMB(M)+1
      IF(M.EQ.NEL)THEN
        M2=NEFG
      ELSE
        M2=NFGMB(M+1)
      ENDIF
      CALL KGLOC
     I        (XPFG,YPFG,CPFG,ISE,M1,M2,MXNPFG,MXKGL,4,1,EPSX,
     I         1,1,XQ,YQ,
     O         KGL,NODES,CQQ,ICODE)
c      MP=KGL-NFGMB(M)
C
      IF(ICODE.EQ.0)THEN
        CQ=CQQ(1)
        RETURN
      ENDIF
C
C ***** POINT Q IS IN THIS SUBELEMENT
C
c      IF(NODE.EQ.3)THEN
c        NKW=NXG**2
c      ELSE
c        NKW=NXG*NYG
c      ENDIF
C ----- ALL RIGHT|  HERE WE GO.
  550 CONTINUE
      DO J=1,NODES
        ISEM=ISE(KGL,J)
        XX(J)=XPFG(ISEM)
        YY(J)=YPFG(ISEM)
        CC(J)=CPFG(ISEM)
      ENDDO
      CALL BASE1
     I         (XX,YY,XQ,YQ,KGL,NODES,
     O          DL)
      CQ=0.0
      DO J=1,NODES
        CQ=CQ+DL(J)*CC(J)
      ENDDO
C
  600 CONTINUE
      RETURN
      END
      SUBROUTINE INTERPK
     I     (MAXNP,MAXEL,MXNPFG,MXKGL,NO2,MXNCC,NON,NODE,M,IBF,XQ,YQ,
     I      EPSX,NEL,NEFG,X,Y,CP,IE,XPFG,YPFG,CPFG,ISE,NFGMB,
     O      CQ)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION X(MAXNP),Y(MAXNP),CP(MAXNP,MXNCC),IE(MAXEL,9)
      DIMENSION XPFG(MXNPFG),YPFG(MXNPFG),CPFG(MXNPFG,MXNCC)
      DIMENSION NFGMB(MAXEL),ISE(MXKGL,NO2)
      DIMENSION XX(4),YY(4),CC(4),DL(4),CQ(7),ISEMI(4)
C
      DO KK=1,NODE
        K=IE(M,KK)
        IF(DABS(XQ-X(K)).LE.EPSX.AND. DABS(YQ-Y(K)).LE.EPSX)THEN
          DO IK=1,NON
            CQ(IK)=CP(K,IK)
          ENDDO
          GOTO 600
        ENDIF
      ENDDO
C
      DO J=1,NODE
        IEM=IE(M,J)
        XX(J)=X(IEM)
        YY(J)=Y(IEM)
      ENDDO
C
      CALL BASE1
     I         (XX,YY,XQ,YQ,M,NODE,
     O          DL)
      IF(IBF.EQ.1)THEN
        IEM6=IE(M,6)
      ELSE
        IEM6=IE(M,7)
      ENDIF
C
C ***** FOR THE CASE OF NON-SF ELEMENT
C
      IF(IEM6.LE.0)THEN
        DO K=1,NON
          DO J=1,NODE
            IEM=IE(M,J)
            CC(J)=CP(IEM,K)
          ENDDO
          CQ(K)=0.0
          DO J=1,NODE
            CQ(K)=CQ(K)+DL(J)*CC(J)
          ENDDO
        ENDDO
        GOTO 600
      ENDIF
C
C ***** FOR THE CASE OF S-F ELEMENT
C
c      IF(IBF.EQ.1)THEN
c        NXG=IE(M,6)
c        NYG=IE(M,8)
c      ELSE
c        NXG=IE(M,7)
c       NYG=IE(M,9)
c      ENDIF
C
      M1=NFGMB(M)+1
      IF(M.EQ.NEL)THEN
        M2=NEFG
      ELSE
        M2=NFGMB(M+1)
      ENDIF
      CALL KGLOC
     I        (XPFG,YPFG,CPFG,ISE,M1,M2,MXNPFG,MXKGL,NO2,MXNCC,EPSX,
     I         1,non,XQ,YQ,
     O         KGL,NODES,CQ,ICODE)
c      MP=KGL-NFGMB(M)
C
      IF(ICODE.EQ.0)RETURN
C
C ***** POINT Q IS IN THIS SUBELEMENT
C
c      IF(NODE.EQ.3)THEN
c        NKW=NXG**2
c      ELSE
c        NKW=NXG*NYG
c      ENDIF
C ----- CHECK IF POINT Q IS REALLY IN THIS SUBELEMENT
C ----- ALL RIGHT|  HERE WE GO.
  550 CONTINUE
      DO J=1,NODES
        ISEM=ISE(KGL,J)
        ISEMI(J)=ISEM
        XX(J)=XPFG(ISEM)
        YY(J)=YPFG(ISEM)
      ENDDO
      CALL BASE1
     I         (XX,YY,XQ,YQ,KGL,NODES,
     O          DL)
      DO K=1,NON
        CQ(K)=0.0
        DO J=1,NODES
          ISEM=ISEMI(J)
          CC(J)=CPFG(ISEM,K)
          CQ(K)=CQ(K)+DL(J)*CC(J)
        ENDDO
      ENDDO
C
  600 CONTINUE
      RETURN
      END
      SUBROUTINE ALGBDY
     I     (XP,YP,X,Y,IE,NLRL,LRL,IB,IGLOBL,MM,MXKBD,MAXNP,MAXEL,
     I      VPX,VPY,VX,VY,SDT,IBF,
     M      N1,N2,
     O      XQ,YQ,VQX,VQY,XSI,SDT1)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION X(MAXNP),Y(MAXNP),NLRL(MAXNP),LRL(MXKBD,MAXNP)
      DIMENSION IE(MAXEL,9),IB(MAXNP),VX(MAXNP),VY(MAXNP)
      DIMENSION NT(2),MT(2),D(2),VQ(2),XX(2),YY(2)
C
      IF(IGLOBL.EQ.1)THEN
C
C ***** IF THIS IS A GLOBAL NODE, THE NEIGHBOR POINTS, N1 AND N2 ARE
C       GONNA BE FOUND OUT AND STORED IN NT ARRAY, AND THE ASSOCIATED
C       ELEMENT NUMBERS ARE STORED IN MT ARRAY.
C
        IMP=0
        N=N1
        DO I=1,NLRL(N)
          M=LRL(I,N)
          CALL ELENOD(IE(M,4),NODE)
          DO II=1,NODE
            I1=II+1
            IF(I1.GT.NODE)I1=1
            N1=IE(M,II)
            N2=IE(M,I1)
            IF(N1.EQ.N .OR. N2.EQ.N)THEN
              IF(IB(N1).NE.0 .AND. IB(N2).NE.0)THEN
                NCON=0
                DO I2=1,NLRL(N1)
                  M1=LRL(I2,N1)
                  DO J=1,NLRL(N2)
                    M2=LRL(J,N2)
                    IF(M1.EQ.M2)NCON=NCON+1
                  ENDDO
                ENDDO
                IF(NCON.LT.2)THEN
                  IMP=IMP+1
                  MT(IMP)=M
                  IF(N1.EQ.N)NT(IMP)=N2
                  IF(N2.EQ.N)NT(IMP)=N1
                ENDIF
              ENDIF
            ENDIF
          ENDDO
        ENDDO
      ELSE
C
C ----- THIS POINT IS NOT A GLOBAL NODE BUT ON A BOUNDARY SEGMENT
C
        NT(1)=N1
        NT(2)=N2
        MT(1)=MM
        MT(2)=MM
      ENDIF
C
C ***** DECIDE THE DIRECTION OF POINT Q, I.E., TO N1 DIRCTION OR TO N2
C       DIRECTION
C
      DO I=1,2
        II=NT(I)
        XX(I)=X(II)
        YY(I)=Y(II)
      ENDDO
C
C ----- BY USING THE INNER PRODUCT, AND CROSS PRODUCT (IF NECESSARY) TO
C       DECIDE THE DIRECTION
C
      XP1=XX(1)-XP
      YP1=YY(1)-YP
      XP2=XX(2)-XP
      YP2=YY(2)-YP
c     D(1)=DSQRT(XP1**2+YP1**2)
c     D(2)=DSQRT(XP2**2+YP2**2)
      d(1)=dsqrt((xp1-xp2)**2+(yp1-yp2)**2)
      d(2)=d(1)
      VQ(1)=(VPX*XP1+VPY*YP1)/D(1)
      VQ(2)=(VPX*XP2+VPY*YP2)/D(2)
C
C ----- FOR THE CASES OF BACKWARD TRACKING
C
      IF(IBF.EQ.1)THEN
        IF(VQ(1).LT.0.0D0 .AND. VQ(2).LT.0.0D0)THEN
          VQ1=(VPX*YP1-VPY*XP1)/D(1)
          VQ2=(VPX*YP2-VPY*XP2)/D(2)
          IF(VQ1.LT.VQ2)THEN
            INN=1
          ELSE
            INN=2
          ENDIF
        ELSEIF(VQ(1).GT.0.0D0 .AND. VQ(2).GT.0.0D0)THEN
C         WRITE(16,*)'ERROR OCCURRED IN ALGBDY: BOTH VQ(1) AND VQ(2)',
C    >               ' ARE GREATER THAN ZERO.'
C         WRITE(16,*)' ----- STOP -----'
C         STOP
          XQ=XP
          YQ=YP
          SDT1=0.0D0
          GOTO 600
        ELSE
          IF(VQ(1).LT.0.0D0)THEN
            INN=1
            INN1=2
          ELSEIF(VQ(2).LT.0.0D0)THEN
            INN=2
            INN1=1
          ELSEIF(VQ(1).EQ.0.0D0)THEN
            XQ=XX(1)
            YQ=YY(1)
            SDT1=SDT
            GOTO 600
          ELSEIF(VQ(2).EQ.0.0D0)THEN
            XQ=XX(2)
            YQ=YY(2)
            SDT1=SDT
            GOTO 600
          ENDIF
        ENDIF
C
C ----- FOR THE CASES OF FORWARD TRACKING
C
      ELSE
        IF(VQ(1).GT.0.0D0 .AND. VQ(2).GT.0.0D0)THEN
          VQ1=(VPX*YP1-VPY*XP1)/D(1)
          VQ2=(VPX*YP2-VPY*XP2)/D(2)
          IF(VQ1.LT.VQ2)THEN
            INN=1
          ELSE
            INN=2
          ENDIF
        ELSEIF(VQ(1).LT.0.0D0 .AND. VQ(2).LT.0.0D0)THEN
C         WRITE(16,*)'ERROR OCCURRED IN ALGBDY: BOTH VQ(1) AND VQ(2)',
C    >               ' ARE LESS THAN ZERO.'
C         WRITE(16,*)' ----- STOP -----'
C         STOP
          XQ=XP
          YQ=YP
          SDT1=0.0D0
          GOTO 600
        ELSE
          IF(VQ(1).GT.0.0D0)THEN
            INN=1
            INN1=2
          ELSEIF(VQ(2).GT.0.0D0)THEN
            INN=2
            INN1=1
          ELSEIF(VQ(1).EQ.0.0D0)THEN
            XQ=XX(1)
            YQ=YY(1)
            SDT1=0.0D0
            GOTO 600
          ELSEIF(VQ(2).EQ.0.0D0)THEN
            XQ=XX(2)
            YQ=YY(2)
            SDT1=0.0D0
            GOTO 600
          ENDIF
        ENDIF
      ENDIF
      NN=NT(INN)
      MM=MT(INN)
      VVP=VQ(INN)*d(inn)
      D(1)=DSQRT(XP1**2+YP1**2)
      D(2)=DSQRT(XP2**2+YP2**2)
      vvp=vvp/d(inn)
C
C ----- COMPUTE THE AVERAGE VELOCITY ALONG THE BOUNDARY WE ARE DEALING
C       WITH
C
      VNX=VX(NN)
      VNY=VY(NN)
      IF(INN.EQ.1)THEN
        VVN=(VNX*XP1+VNY*YP1)/D(INN)
      ELSE
        VVN=(VNX*XP2+VNY*YP2)/D(INN)
      ENDIF
      VAVG=0.5D0*(VVP+VVN)
C
C ----- COMPUTE THE TIME NEEDED TO GO OVER THE PRESENT BOUNDARY SIDE
C
      IJG=1
  50  CONTINUE
      IF(VAVG.EQ.0.0D0)THEN
        IF(IBF.EQ.1)TT=-1.0D38
        IF(IBF.EQ.2)TT=1.0D38
      ELSE
        TT=D(INN)/VAVG
      ENDIF
C
      IF((TT.GT.0.0D0 .AND. IBF.EQ.1) .OR. (TT.LT.0.0D0 .AND. IBF.EQ.2))
     >   THEN
C       WRITE(16,*)'ERROR OCCURRED IN COMPUTING VAVG AND TT --- STOP'
C       STOP
        IF(IJG.EQ.1)THEN
          IJG=2
          VAVG=VVP
          GOTO 50
        ENDIF
        XQ=XP
        YQ=YP
        SDT1=0.0D0
        GOTO 600
      ENDIF
      TT=DABS(TT)
C
C ----- DETERMINE XQ,YQ,VQX,VQY AND XSI
C
      IF(TT.GT.SDT)THEN
        SDT1=0.0D0
        XSI=SDT/TT
        XQ=X(NN)*XSI+XP*(1.0D0-XSI)
        YQ=Y(NN)*XSI+YP*(1.0D0-XSI)
        VQX=VX(NN)*XSI+VPX*(1.0D0-XSI)
        VQY=VY(NN)*XSI+VPY*(1.0D0-XSI)
        IF(IGLOBL.EQ.1)THEN
          N1=N
          N2=NN
        ELSE
          N1=NT(INN1)
          N2=NT(INN)
          XSI=DSQRT((XQ-X(N1))**2+(YQ-Y(N1))**2)/
     >        DSQRT((X(N1)-X(N2))**2+(Y(N1)-Y(N2))**2)
        ENDIF
        RETURN
      ENDIF
C
C ---- TRY THE NEXT BOUNDARY SEGMENT
C
      DTRES=SDT-TT
      XP=XX(INN)
      YP=YY(INN)
      VPX=VNX
      VPY=VNY
      NN1=NT(INN1)
C
 100  CONTINUE
      IF(IB(NN).LE.3)THEN
        N1=NN
        SDT1=DTRES
        RETURN
      ENDIF
C
      DO 200 I=1,NLRL(NN)
        M=LRL(I,NN)
        IF(NLRL(NN).GT.1 .AND. M.EQ.MM)GOTO 200
        IF(IE(M,4).EQ.0)THEN
          NODE=3
        ELSE
          NODE=4
        ENDIF
        DO 190 II=1,NODE
          I1=II+1
          IF(I1.GT.NODE)I1=1
          N1=IE(M,II)
          N2=IE(M,I1)
          IF(N1.EQ.NN .AND. N2.EQ.NN1)GOTO 190
          IF(N1.EQ.NN1 .AND. N2.EQ.NN)GOTO 190
          IF(N1.EQ.NN .OR. N2.EQ.NN)THEN
            IF(IB(N1).NE.0 .AND. IB(N2).NE.0)THEN
              IF(N1.EQ.NN)N1=N2
              GOTO 210
            ENDIF
          ENDIF
 190    CONTINUE
 200  CONTINUE
C
      PRINT *,'ERROR OCCURRED AT ALGBDY ---- NO NEXT BDY. SEG.'
      STOP
C
 210  CONTINUE
      XP1=X(N1)-XP
      YP1=Y(N1)-YP
      D(1)=DSQRT(XP1**2+YP1**2)
      VVP=(VPX*XP1+VPY*YP1)/D(1)
      NN1=NN
      NN=N1
      MM=M
C
C ----- COMPUTE THE AVERAGE VELOCITY ALONG THE BOUNDARY WE ARE DEALING
C       WITH
C
      VNX=VX(NN)
      VNY=VY(NN)
      VVN=(VNX*XP1+VNY*YP1)/D(1)
      VAVG=0.5D0*(VVP+VVN)
C
C ----- COMPUTE THE TIME NEEDED TO GO OVER THE PRESENT BOUNDARY SIDE
C
      IJG=1
  220 CONTINUE
      IF(VAVG.EQ.0.0D0)THEN
        IF(IBF.EQ.1)TT=-1.0D38
        IF(IBF.EQ.2)TT=1.0D38
      ELSE
        TT=D(1)/VAVG
      ENDIF
C
      IF((TT.GT.0.0D0 .AND. IBF.EQ.1) .OR. (TT.LT.0.0D0 .AND. IBF.EQ.2))
     >   THEN
C       WRITE(16,*)'ERROR OCCURRED IN COMPUTING VAVG AND TT --- STOP'
C       STOP
        IF(IJG.EQ.1)THEN
          IJG=2
          VAVG=VVP
          GOTO 220
        ENDIF
        XQ=XP
        YQ=YP
        SDT1=0.0D0
        GOTO 600
      ENDIF
      TT=DABS(TT)
C
C ----- DETERMINE XQ,YQ,VQX,VQY AND XSI
C
      IF(TT.GT.DTRES)THEN
        SDT1=0.0D0
        XSI=DTRES/TT
        XQ=X(NN)*XSI+XP*(1.0D0-XSI)
        YQ=Y(NN)*XSI+YP*(1.0D0-XSI)
        VQX=VX(NN)*XSI+VPX*(1.0D0-XSI)
        VQY=VY(NN)*XSI+VPY*(1.0D0-XSI)
        N1=NN
        N2=NN1
        RETURN
      ELSE
        XP=X(NN)
        YP=Y(NN)
        VPX=VNX
        VPY=VNY
        DTRES=DTRES-TT
        GOTO 100
      ENDIF
C
  600 RETURN
      END
      SUBROUTINE REPLAS(XW,YW,VXW,VYW,XP,YP,VPX,VPY)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      XP=XW
      YP=YW
      VPX=VXW
      VPY=VYW
      RETURN
      END
      SUBROUTINE REP3RI(XW,YW,CSW,MPLOC,XP,YP,CSP,M)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      XP=XW
      YP=YW
      CSP=CSW
      M=MPLOC
      RETURN
      END
      SUBROUTINE ELENOD(IEM1,NODE)
C
      IF(IEM1.EQ.0)THEN
        NODE=3
      ELSE
        NODE=4
      ENDIF
      RETURN
      END
      SUBROUTINE WRKARY(J,IE,X,Y,VX,VY,MAXEL,NO2,MAXNP,M,NODE,MXNODE,ID,
     O                  IME,XX,YY,VXX,VYY)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION IE(MAXEL,NO2),X(MAXNP),Y(MAXNP),VX(MAXNP),VY(MAXNP)
      DIMENSION XX(MXNODE),YY(MXNODE),VXX(MXNODE),VYY(MXNODE),IME(4)
C
          DO I1=1,NODE
            IF(ID.EQ.2)THEN
              J1=J+I1
              IF(J1.GT.NODE)J1=J1-NODE
            ELSEIF(ID.EQ.3)THEN
              J1=J+I1-1
              IF(J1.GT.NODE)J1=J1-NODE
            ELSE
              J1=I1
            ENDIF
            II=IE(M,J1)
            IME(I1)=II
            XX(I1)=X(II)
            YY(I1)=Y(II)
            VXX(I1)=VX(II)
            VYY(I1)=VY(II)
          ENDDO
C
      RETURN
      END
      SUBROUTINE CKCOIN
     I            (X,Y,XP,YP,NLRL,N1,N2,MAXNP,EPSX,
     O             NN,NLRLN)
C       10/22/93
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION X(MAXNP),Y(MAXNP),NLRL(MAXNP)
C
      EPSXX=10.0D0*EPSX
C
      IF(DABS(XP-X(N1)).LE.EPSXX .AND. DABS(YP-Y(N1)).LE.EPSXX)THEN
        NN=N1
        NLRLN=NLRL(N1)
      ELSEIF(DABS(XP-X(N2)).LE.EPSXX .AND. DABS(YP-Y(N2)).LE.EPSXX)THEN
        NN=N2
        NLRLN=NLRL(N2)
      ELSE
        NN=0
      ENDIF
      RETURN
      END
      SUBROUTINE WARMSG
     I      (N,MAXN,SUBNAM,VARNAM,NO)
C
      CHARACTER*6 SUBNAM,VARNAM
C
      IF(N.GT.MAXN)THEN
        WRITE(16,10)N,VARNAM,SUBNAM,NO
  10    FORMAT(I8,' .GT.',A6,' IN SUB. ',A6,' ----->',I2)
        STOP
      ENDIF
      RETURN
      END
      SUBROUTINE VALBDL(VXX,VYY,DL,MXNODE,NODE,VPX,VPY)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION VXX(MXNODE),VYY(MXNODE),DL(4)
C
        VPX=0.0
        VPY=0.0
        DO I1=1,NODE
          VPX=VPX+DL(I1)*VXX(I1)
          VPY=VPY+DL(I1)*VYY(I1)
        ENDDO
      RETURN
      END
      SUBROUTINE CKCNEL(N1,N2,M,NLRL,LRL,MAXNP,MXKBD, ME,KOUNT)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION NLRL(MAXNP),LRL(MXKBD,MAXNP)
C
        KOUNT=0
        ME=0
        NLRL1=NLRL(N1)
        NLRL2=NLRL(N2)
        DO 470 I1=1,NLRL1
          M1=LRL(I1,N1)
          DO I2=1,NLRL2
            M2=LRL(I2,N2)
            IF(M1.EQ.M2)THEN
              IF(M1.NE.M)THEN
                ME=M1
                KOUNT=2
                RETURN
              ENDIF
            ENDIF
          ENDDO
  470   CONTINUE
        KOUNT=1
      RETURN
      END
      SUBROUTINE ONLINE(XW,YW,J1,J2,MXNPW, XP,YP)
C
       IMPLICIT REAL*8(A-H,O-Z)
C
       DIMENSION XW(MXNPW),YW(MXNPW)
C
       D1=DSQRT((XW(J2)-XW(J1))**2+(YW(J2)-YW(J1))**2)
       D2=DSQRT((XP-XW(J1))**2+(YP-YW(J1))**2)
       XSI=D2/D1
       IF(XSI.GT.1.0D0)XSI=1.0D0
       IF(XSI.LT.0.0D0)XSI=0.0D0
       XP=XW(J1)*(1.0D0-XSI)+XW(J2)*XSI
       YP=YW(J1)*(1.0D0-XSI)+YW(J2)*XSI
C
       RETURN
       END

      SUBROUTINE CHNGSN
     I   (MXNOD,NSTART,NEND,NJUMP, NDIM,
     M    VXP,VYP,VZP,VXQ,VYQ,VZQ,VXX,VYY,VZZ)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION VXX(MXNOD),VYY(MXNOD),VZZ(MXNOD)
C
      VXP=-VXP
      VYP=-VYP
      VXQ=-VXQ
      VYQ=-VYQ
      IF(NDIM.EQ.3)THEN
        VZP=-VZP
        VZQ=-VZQ
      ENDIF
      DO I=NSTART,NEND,NJUMP
        VXX(I)=-VXX(I)
        VYY(I)=-VYY(I)
        IF(NDIM.EQ.3)VZZ(I)=-VZZ(I)
      ENDDO
      RETURN
      END
